import sys
sys.path.insert(1, '../../')

from TextPart.textalinea import textalinea
from TextPart.masterrule import texttype
from TextPart.enum_type import enum_type

def hardcodedalineas_Christiaan_PhD_Thesis() -> list[textalinea]:
    """
    This code holds the content of the textalineas-array in the textsplitter-class
    for the document Christiaan PhD Thesis
    It is generated with the printcode()-functions of textsplitter & textalinea
    and it is supposed to be used only after a complete document analysis
    the outcome of this analysis (this script) can then be efficiently used
    for running regression-tests in the future.

    # Parameters: None (everything is hardcoded)
    # Return: list[textalinea] the hardcoded textalineas-array.
    """

    alineas = []

    thisalinea = textalinea()
    thisalinea.textlevel = 0
    thisalinea.texttitle = "Christiaan PhD Thesis"
    thisalinea.nativeID = 0
    thisalinea.parentID = -1
    thisalinea.alineatype = texttype.TITLE
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "1 Introduction 1 1.1 Nuclear Physics . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 1 1.2 Fermi and Gamow-Teller transitions . . . . . . . . . . . . . . . . . . . . 2 1.3 The nuclear many-body problem . . . . . . . . . . . . . . . . . . . . . . 3 1.4 Neutrino Physics . . . . "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "Contents"
    thisalinea.nativeID = 1
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "1 Introduction 1 1.1 Nuclear Physics . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 1 1.2 Fermi and Gamow-Teller transitions . . . . . . . . . . . . . . . . . . . . 2 1.3 The nuclear many-body problem . . . . . . . . . . . . . . . . . . . . . . 3 1.4 Neutrino Physics . . . . "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("1 Introduction")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("1.1 Nuclear Physics . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 1")
    thisalinea.textcontent.append("1.2 Fermi and Gamow-Teller transitions . . . . . . . . . . . . . . . . . . . . 2")
    thisalinea.textcontent.append("1.3 The nuclear many-body problem . . . . . . . . . . . . . . . . . . . . . . 3")
    thisalinea.textcontent.append("1.4 Neutrino Physics . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 3")
    thisalinea.textcontent.append("1.5 Nucleosynthesis . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 4")
    thisalinea.textcontent.append("1.6 Thesis layout . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 7")
    thisalinea.textcontent.append("2 Theoretical models for the diﬀerential cross sections")
    thisalinea.textcontent.append("9")
    thisalinea.textcontent.append("2.1 Characterization of Gamow-Teller strength . . . . . . . . . . . . . . . . . 9")
    thisalinea.textcontent.append("2.2 The nuclear shell model . . . . . . . . . . . . . . . . . . . . . . . . . . . 12")
    thisalinea.textcontent.append("2.3 Normal-modes calculation . . . . . . . . . . . . . . . . . . . . . . . . . . 15")
    thisalinea.textcontent.append("2.4 Calculation of the form factor . . . . . . . . . . . . . . . . . . . . . . . . 19")
    thisalinea.textcontent.append("2.5 The Distorted-Wave Born Approximation . . . . . . . . . . . . . . . . . 21")
    thisalinea.textcontent.append("2.6 Smearing . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 25")
    thisalinea.textcontent.append("2.7 Extrapolation to q = 0 . . . . . . . . . . . . . . . . . . . . . . . . . . . . 28")
    thisalinea.textcontent.append("3 Experimental Methods")
    thisalinea.textcontent.append("29")
    thisalinea.textcontent.append("3.1 Overview of the Experiment . . . . . . . . . . . . . . . . . . . . . . . . . 29")
    thisalinea.textcontent.append("3.2 The Grand Raiden Spectrometer . . . . . . . . . . . . . . . . . . . . . . 30")
    thisalinea.textcontent.append("3.3 Focal-Plane Readout system . . . . . . . . . . . . . . . . . . . . . . . . . 33")
    thisalinea.textcontent.append("3.4 Design of the beam proﬁle . . . . . . . . . . . . . . . . . . . . . . . . . . 35")
    thisalinea.textcontent.append("3.5 Optical properties of the Spectrometer . . . . . . . . . . . . . . . . . . . 39")
    thisalinea.textcontent.append("3.6 Trigger signal and Data-Acquisition System . . . . . . . . . . . . . . . . 42")
    thisalinea.textcontent.append("3.7 Conversion of the data to ROOT . . . . . . . . . . . . . . . . . . . . . . 44")
    thisalinea.textcontent.append("4 Data Analysis")
    thisalinea.textcontent.append("46")
    thisalinea.textcontent.append("4.1 Merging of the runs . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 46")
    thisalinea.textcontent.append("4.2 Track reconstruction . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 47")
    thisalinea.textcontent.append("4.3 Sieve-slit analysis . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 52")
    thisalinea.textcontent.append("4.4 Computation of the diﬀerential cross sections . . . . . . . . . . . . . . . 59")
    thisalinea.textcontent.append("4.4.1 Relevant formulas for the extraction of the cross sections . . . . . 59")
    thisalinea.textcontent.append("4.4.2 Extraction of peaks, acceptance and eﬃciency . . . . . . . . . . . . 61")
    thisalinea.textcontent.append("4.4.3 Cross-section results . . . . . . . . . . . . . . . . . . . . . . . . . . 67")
    thisalinea.textcontent.append("4.5 Multipole decomposition analysis . . . . . . . . . . . . . . . . . . . . . . 69")
    thisalinea.textcontent.append("5 Results and Discussion")
    thisalinea.textcontent.append("76")
    thisalinea.textcontent.append("5.1 Results . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 76")
    thisalinea.textcontent.append("5.2 Comparison to previous results . . . . . . . . . . . . . . . . . . . . . . . 83")
    thisalinea.textcontent.append("5.2.1 Extrapolation to α = 0 and q = 0 . . . . . . . . . . . . . . . . . . . 83")
    thisalinea.textcontent.append("5.2.2 Determination of the Gamow-Teller unit cross sections . . . . . . . 87")
    thisalinea.textcontent.append("5.2.3 Comparison to Ref. [28] . . . . . . . . . . . . . . . . . . . . . . . . 92")
    thisalinea.textcontent.append("5.3 Comparison to the Gamow-Teller sum rule . . . . . . . . . . . . . . . . . 97")
    thisalinea.textcontent.append("5.4 Error analysis . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 102")
    thisalinea.textcontent.append("5.5 Comparison to QRPA+QPVC calculations . . . . . . . . . . . . . . . . . 104")
    thisalinea.textcontent.append("6 Passive Cooling Veriﬁcation for the X-slit system 110")
    thisalinea.textcontent.append("6.1 The Super Fragment Separator . . . . . . . . . . . . . . . . . . . . . . . 110")
    thisalinea.textcontent.append("6.2 The X- and Y-slit systems . . . . . . . . . . . . . . . . . . . . . . . . . . 112")
    thisalinea.textcontent.append("6.3 Cooling options . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 114")
    thisalinea.textcontent.append("6.4 Passive cooling by stainless steel ribs . . . . . . . . . . . . . . . . . . . . 115")
    thisalinea.textcontent.append("6.5 Simulation veriﬁcation . . . . . . . . . . . . . . . . . . . . . . . . . . . . 116")
    thisalinea.textcontent.append("6.6 Experimental veriﬁcation with AGOR . . . . . . . . . . . . . . . . . . . 119")
    thisalinea.textcontent.append("6.7 Experimental veriﬁcation with heating elements . . . . . . . . . . . . . . 124")
    thisalinea.textcontent.append("6.8 Conclusion . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 127")
    thisalinea.textcontent.append("7 Design of the VETO detector for NeuLAND 128")
    thisalinea.textcontent.append("7.1 Overview of the R3B experiment . . . . . . . . . . . . . . . . . . . . . . 128")
    thisalinea.textcontent.append("7.2 The R3B setup and the role of the VETO detector . . . . . . . . . . . . 129")
    thisalinea.textcontent.append("7.3 Simulation procedure . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 131")
    thisalinea.textcontent.append("7.4 Choice of the Geant4 Physics List . . . . . . . . . . . . . . . . . . . . . . 141")
    thisalinea.textcontent.append("7.5 The Detector Design . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 145")
    thisalinea.textcontent.append("7.5.1 The optimal distance between the VETO and NeuLAND . . . . . 146")
    thisalinea.textcontent.append("7.5.2 The optimal bar thickness . . . . . . . . . . . . . . . . . . . . . . . 148")
    thisalinea.textcontent.append("7.5.3 The optimal number of scintillator bars . . . . . . . . . . . . . . . 149")
    thisalinea.textcontent.append("7.5.4 Other options for a VETO detector . . . . . . . . . . . . . . . . . 152")
    thisalinea.textcontent.append("7.6 Eﬃciency of the VETO detector . . . . . . . . . . . . . . . . . . . . . . 153")
    thisalinea.textcontent.append("7.7 Conclusion . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 163")
    thisalinea.textcontent.append("8 Conclusions and Outlook")
    thisalinea.textcontent.append("165")
    thisalinea.textcontent.append("8.1 The topics of this work . . . . . . . . . . . . . . . . . . . . . . . . . . . . 165")
    thisalinea.textcontent.append("8.2 Suggestions for follow-up experiments . . . . . . . . . . . . . . . . . . . 167")
    thisalinea.textcontent.append("Nederlandse Samenvatting")
    thisalinea.textcontent.append("172")
    thisalinea.textcontent.append("1 Inleiding . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . 172")
    thisalinea.textcontent.append("2 Bepaling van de Gamow-Teller overgangen in Sn-isotopen . . . . . . . . 173")
    thisalinea.textcontent.append("3 Controle van de passieve koeling van het X-slit systeem . . . . . . . . . 175")
    thisalinea.textcontent.append("4 Het ontwerp van de NeuLAND VETO detector . . . . . . . . . . . . . . 177")
    thisalinea.textcontent.append("Acknowledgements")
    thisalinea.textcontent.append("List of Figures")
    thisalinea.textcontent.append("List of Tables")
    thisalinea.textcontent.append("Bibliography")
    thisalinea.textcontent.append("180")
    thisalinea.textcontent.append("182")
    thisalinea.textcontent.append("187")
    thisalinea.textcontent.append("189")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "Abstract"
    thisalinea.nativeID = 2
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "This thesis consists of three separate topics. The ﬁrst topic is the measurement of the Gamow-teller states in the 116,122Sn(3He, t)116,122Sb charge-exchange reactions. Measurements were done with the Grand Raiden spectrometer. The Gamow-Teller strengths were extracted from the data by a Multipole Decomposition Analysis. For 116Sb, 38 ± 7% of the Ikeda sum-rule was measured below an excitation energy 28 MeV. For 122Sb, this was 48 ± 6%. These results are in agreement with the quench- ing phenomenon of Gamow-teller strength (generally around 50%) and with previous results (though with an improved accuracy). Diﬀerent contributions of the quasi-free charge-exchange background "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("This thesis consists of three separate topics. The ﬁrst topic is the measurement of")
    thisalinea.textcontent.append("the Gamow-teller states in the 116,122Sn(3He, t)116,122Sb charge-exchange reactions.")
    thisalinea.textcontent.append("Measurements were done with the Grand Raiden spectrometer. The Gamow-Teller")
    thisalinea.textcontent.append("strengths were extracted from the data by a Multipole Decomposition Analysis.")
    thisalinea.textcontent.append("For 116Sb, 38 ± 7% of the Ikeda sum-rule was measured below an excitation energy")
    thisalinea.textcontent.append("28 MeV. For 122Sb, this was 48 ± 6%. These results are in agreement with the quench-")
    thisalinea.textcontent.append("ing phenomenon of Gamow-teller strength (generally around 50%) and with previous")
    thisalinea.textcontent.append("results (though with an improved accuracy). Diﬀerent contributions of the quasi-free")
    thisalinea.textcontent.append("charge-exchange background could be the reason why the percentages are diﬀerent")
    thisalinea.textcontent.append("and a follow-up experiment is needed to determine that. Apart from a predicted peak")
    thisalinea.textcontent.append("near 3 MeV − 5 MeV, our results were also in fair agreement with QRPA+QPVC")
    thisalinea.textcontent.append("calculations. Hence, these measurements have helped us to improve our knowledge")
    thisalinea.textcontent.append("on Gamow-Teller states in these isotopes and to reﬁne the QRPA+QPVC model. The")
    thisalinea.textcontent.append("second topic is the veriﬁcation of the passive cooling of the X-slit system by stainless")
    thisalinea.textcontent.append("steel ribs through thermal simulations. Based on the simulations and on experimental")
    thisalinea.textcontent.append("veriﬁcation, we conclude that the temperature of the electronics which are around the")
    thisalinea.textcontent.append("X-slit will not exceed 55 ◦C, while the limit for the electronics is generally around")
    thisalinea.textcontent.append("80 ◦C. The third topic is the design of the NeuLAND VETO detector. Although the")
    thisalinea.textcontent.append("optimal design of the detector has been established, our simulations show that the")
    thisalinea.textcontent.append("use of a VETO detector is not advantageous, unless the scattering chamber and its")
    thisalinea.textcontent.append("adjacent beam pipe contain air.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "1 Introduction"
    thisalinea.nativeID = 3
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "In 1911, Ernest Rutherford proposed the existence of a positively charged atomic nucleus [1]. Subsequently, James Chadwick discovered the existence of neutrons in 1932. Based on these discoveries, Dmitri Ivanenko suggested that the nucleus was entirely composed of only protons and neutrons and he even published the ﬁrst version of a nuclear shell model [2]. Shortly after, Yukawa proposed his famous pion-exchange model in 1935 [1]. Yukawa’s model was the ﬁrst attempt to describe the so-called strong nuclear force: the force that was proposed as an explanation to why nuclei do not disintegrate under their Coulomb repulsion. Today, it is "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "1.1 Nuclear Physics"
    thisalinea.nativeID = 4
    thisalinea.parentID = 3
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "In 1911, Ernest Rutherford proposed the existence of a positively charged atomic nucleus [1]. Subsequently, James Chadwick discovered the existence of neutrons in 1932. Based on these discoveries, Dmitri Ivanenko suggested that the nucleus was entirely composed of only protons and neutrons and he even published the ﬁrst version of a nuclear shell model [2]. Shortly after, Yukawa proposed his famous pion-exchange model in 1935 [1]. Yukawa’s model was the ﬁrst attempt to describe the so-called strong nuclear force: the force that was proposed as an explanation to why nuclei do not disintegrate under their Coulomb repulsion. Today, it is "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In 1911, Ernest Rutherford proposed the existence of a positively charged atomic")
    thisalinea.textcontent.append("nucleus [1]. Subsequently, James Chadwick discovered the existence of neutrons in")
    thisalinea.textcontent.append("1932. Based on these discoveries, Dmitri Ivanenko suggested that the nucleus was")
    thisalinea.textcontent.append("entirely composed of only protons and neutrons and he even published the ﬁrst version")
    thisalinea.textcontent.append("of a nuclear shell model [2]. Shortly after, Yukawa proposed his famous pion-exchange")
    thisalinea.textcontent.append("model in 1935 [1]. Yukawa’s model was the ﬁrst attempt to describe the so-called")
    thisalinea.textcontent.append("strong nuclear force: the force that was proposed as an explanation to why nuclei do")
    thisalinea.textcontent.append("not disintegrate under their Coulomb repulsion. Today, it is known that Yukawa’s")
    thisalinea.textcontent.append("theory is only an eﬀective ﬁeld theory of the more fundamental strong force: the force")
    thisalinea.textcontent.append("that binds quarks into hadrons [3]. However, Yukawa’s idea of pion-exchange still")
    thisalinea.textcontent.append("remains a powerful concept to describe the interactions between individual nucleons,")
    thisalinea.textcontent.append("although the precise mathematical descriptions have been updated over time [1, 4].")
    thisalinea.textcontent.append("As such, nuclear physics became a ﬁeld that studies the many-body problem with")
    thisalinea.textcontent.append("the interaction mediated by the strong force. The complex interactions in this many-")
    thisalinea.textcontent.append("body problem give rise to many interesting phenomena such as nuclear binding energy,")
    thisalinea.textcontent.append("shape and charge distribution [1, 3], but also nuclear excitations. For example, such")
    thisalinea.textcontent.append("excitations may give rise to collective motions of the nucleons known as giant reso-")
    thisalinea.textcontent.append("nances [5, 6]. The complexity of the nuclear many-body problem also manifests itself")
    thisalinea.textcontent.append("during nuclear decay. Nuclei can decay into other nuclei during a variety of processes,")
    thisalinea.textcontent.append("such as α-decay, proton or neutron emission, and ﬁssion. β-decay is a special type of")
    thisalinea.textcontent.append("nuclear decay, as it is mediated by the weak force, but takes place in the presence of")
    thisalinea.textcontent.append("the strong nuclear force.")
    thisalinea.textcontent.append("Nuclear physics theoreticians attempt to describe these phenomena from ﬁrst prin-")
    thisalinea.textcontent.append("ciples. Given the complexity of the nuclear many-body problem and the variety of")
    thisalinea.textcontent.append("phenomena to describe, this is no simple task. Theoreticians still face many challenges")
    thisalinea.textcontent.append("in this area [7, 8], such as how to describe the limits of nuclear binding energy, the")
    thisalinea.textcontent.append("emergence of collective phenomena, and halo nuclei. In an attempt to test, guide and")
    thisalinea.textcontent.append("constrain the theoretical models, nuclear physics experimentalists use accelerators")
    thisalinea.textcontent.append("and nuclear reactions to study these aspects [9]. A few examples of these reactions")
    thisalinea.textcontent.append("are knock-out reactions, ﬁssion and fragmentation reactions, elastic scattering exper-")
    thisalinea.textcontent.append("iments, total-absorption measurements and charge-exchange reactions [10].")
    thisalinea.textcontent.append("Charge-exchange reactions are an interesting type of nuclear reactions. During such")
    thisalinea.textcontent.append("a reaction, a collision between nuclei is used to exchange a proton for a neutron, or")
    thisalinea.textcontent.append("vice versa. Therefore, it is a powerful tool to study the isospin dependence of the")
    thisalinea.textcontent.append("nuclear many-body problem. Moreover, since the resulting daughter nucleus of a")
    thisalinea.textcontent.append("charge-exchange reaction is the same as that of a β-decay, charge-exchange reactions")
    thisalinea.textcontent.append("provide us with the opportunity to study the nuclear structure aspects of β-decay [11].")
    thisalinea.textcontent.append("An accurate description of these aspects ﬁnds an important application in nuclear")
    thisalinea.textcontent.append("astrophysics, where they (and other aspects of nuclear structure) are used to explain")
    thisalinea.textcontent.append("the origin of the elements heavier than iron (see Section 1.5).")
    thisalinea.textcontent.append("In this thesis, we will focus on a special kind of charge-exchange reactions, namely")
    thisalinea.textcontent.append("the (3He, t) reaction. In this reaction, a 3He-beam bombards a ﬁxed target and")
    thisalinea.textcontent.append("events are selected where a 3H-nucleus (called triton, or t) is ejected. This results in")
    thisalinea.textcontent.append("switching a neutron with a proton in the target nucleus. This process might leave")
    thisalinea.textcontent.append("the recoil nucleus in an excited state. Because both the 3He-beam and the ejected")
    thisalinea.textcontent.append("triton are charged, they can be easily detected. This allows for a precise kinematical")
    thisalinea.textcontent.append("reconstruction of the collision, and, hence, the excited state of the recoil nucleus.")
    thisalinea.textcontent.append("Therefore, the (3He, t) reaction is a powerful tool in studying nuclear structure.")
    thisalinea.textcontent.append("In this introduction, we will ﬁrst start with a general introduction on Gamow-Teller")
    thisalinea.textcontent.append("transitions in Section 1.2. Subsequently, we will discuss the reasons for studying")
    thisalinea.textcontent.append("Gamow-Teller transitions in Sections 1.3 - 1.5. Finally, we will discuss the rest of the")
    thisalinea.textcontent.append("layout of this thesis in Section 1.6.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "1.2 Fermi and Gamow-Teller transitions"
    thisalinea.nativeID = 5
    thisalinea.parentID = 3
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "When calculating observables related to nuclear decays or reactions where the weak force mediates the transition, the size of the weak coupling constant allows the use of perturbation theory. Since, in nuclear physics, the momenta of the particles involved are usually much smaller than the masses of the W and Z bosons, only the lowest- order approximation of the perturbation is relevant. This reduces the calculation to a nuclear structure problem. When the nuclear states are assumed to be eigenstates of angular momentum, parity and isospin, this nuclear structure problem can be subdivided into diﬀerent contributions by means of a "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("When calculating observables related to nuclear decays or reactions where the weak")
    thisalinea.textcontent.append("force mediates the transition, the size of the weak coupling constant allows the use of")
    thisalinea.textcontent.append("perturbation theory. Since, in nuclear physics, the momenta of the particles involved")
    thisalinea.textcontent.append("are usually much smaller than the masses of the W and Z bosons, only the lowest-")
    thisalinea.textcontent.append("order approximation of the perturbation is relevant. This reduces the calculation to")
    thisalinea.textcontent.append("a nuclear structure problem. When the nuclear states are assumed to be eigenstates")
    thisalinea.textcontent.append("of angular momentum, parity and isospin, this nuclear structure problem can be")
    thisalinea.textcontent.append("subdivided into diﬀerent contributions by means of a multipole expansion. If the")
    thisalinea.textcontent.append("momentum transferred in the weak process is suﬃciently small (meaning that the")
    thisalinea.textcontent.append("product of the momentum transfer q and the nuclear radius R is, in natural units,")
    thisalinea.textcontent.append("much smaller than unity), the calculation can also be expanded in powers of qR. The")
    thisalinea.textcontent.append("leading order contributions, after these expansions, are the Fermi and Gamow-Teller")
    thisalinea.textcontent.append("transitions [12].")
    thisalinea.textcontent.append("A Fermi transition is the conversion of a neutron into a proton or vice versa under the")
    thisalinea.textcontent.append("conditions that the total orbital angular momentum of the nucleus does not change")
    thisalinea.textcontent.append("(denoted as ∆L = 0) and that the total nuclear spin remains the same (denoted as")
    thisalinea.textcontent.append("∆S = 0). Likewise, a Gamow-Teller transition is a proton-neutron conversion under")
    thisalinea.textcontent.append("the conditions ∆L = 0 and ∆S = 1 [13]. The ∆L = 0 shows that the Fermi and")
    thisalinea.textcontent.append("Gamow-Teller transitions are indeed the zero-th order contributions to the multipole")
    thisalinea.textcontent.append("expansion. Other contributions to the multipole expansion are known as forbidden")
    thisalinea.textcontent.append("transitions [12], because their probability of occurring only slightly deviates from zero.")
    thisalinea.textcontent.append("When the nuclear weak process under investigation is a β-decay, the conditions of a")
    thisalinea.textcontent.append("Fermi-transition (∆L = 0 and ∆S = 0) require that the emitted leptons have anti-")
    thisalinea.textcontent.append("parallel spins. Similarly, the conditions of a Gamow-Teller transition (∆L = 0 and")
    thisalinea.textcontent.append("∆S = 1) require that the emitted leptons have parallel spins.")
    thisalinea.textcontent.append("Evaluating the relevant nuclear matrix elements is relatively straightforward for Fermi")
    thisalinea.textcontent.append("transitions [12]. Such a calculation does require the nuclear wave functions from both")
    thisalinea.textcontent.append("the parent and the daughter nucleus. However, the Fermi operator only involves a")
    thisalinea.textcontent.append("change in isospin, while the Gamow-Teller operator also contains a change in spin.")
    thisalinea.textcontent.append("This is what makes the calculation of a Fermi matrix element relatively straightfor-")
    thisalinea.textcontent.append("ward, while the calculation of a Gamow-Teller matrix element is more challenging. For")
    thisalinea.textcontent.append("this reason, the investigations presented in this thesis focus on determining Gamow-")
    thisalinea.textcontent.append("Teller matrix elements.")
    thisalinea.textcontent.append("There are three main arguments for the importance of accurately measuring Gamow-")
    thisalinea.textcontent.append("Teller transitions: the nuclear many-body problem, neutrino physics and nucleosyn-")
    thisalinea.textcontent.append("thesis. These three arguments will be discussed in the following sections in more")
    thisalinea.textcontent.append("detail.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "1.3 The nuclear many-body problem"
    thisalinea.nativeID = 6
    thisalinea.parentID = 3
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "Formally, the nuclear many-body problem is deﬁned as solving the Schr¨odinger equa- tion for a system of A strongly interacting nucleons [14]. Tremendous progress has been made in this area during recent years [12], but the nuclear many-body problem still remains challenging (see Section 1.1). When measuring Gamow-Teller transitions, the observable of interest is the so-called B(GT ) value. This is a dimensionless number that describes the strength of the transition. Quantum mechanically, it is deﬁned as the absolute square of the transition matrix element, reduced in angular momentum (see equation (2.1)). The B(GT ) value can be extracted from "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Formally, the nuclear many-body problem is deﬁned as solving the Schr¨odinger equa-")
    thisalinea.textcontent.append("tion for a system of A strongly interacting nucleons [14]. Tremendous progress has")
    thisalinea.textcontent.append("been made in this area during recent years [12], but the nuclear many-body problem")
    thisalinea.textcontent.append("still remains challenging (see Section 1.1).")
    thisalinea.textcontent.append("When measuring Gamow-Teller transitions, the observable of interest is the so-called")
    thisalinea.textcontent.append("B(GT ) value. This is a dimensionless number that describes the strength of the")
    thisalinea.textcontent.append("transition. Quantum mechanically, it is deﬁned as the absolute square of the transition")
    thisalinea.textcontent.append("matrix element, reduced in angular momentum (see equation (2.1)). The B(GT ) value")
    thisalinea.textcontent.append("can be extracted from the diﬀerential cross section or the decay rate of the nuclear")
    thisalinea.textcontent.append("weak process [11] and is, therefore, a measurable observable.")
    thisalinea.textcontent.append("Since the B(GT ) value involves the Gamow-Teller transition matrix element, it can")
    thisalinea.textcontent.append("provide information about the nuclear wave functions before and after the transition.")
    thisalinea.textcontent.append("After all, these nuclear wave functions appear in the matrix element. Therefore,")
    thisalinea.textcontent.append("measurements of B(GT ) values can help us to test, guide and constrain the theoretical")
    thisalinea.textcontent.append("approaches to solving the nuclear many-body problem [7, 12].")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "1.4 Neutrino Physics"
    thisalinea.nativeID = 7
    thisalinea.parentID = 3
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "A very important process within the ﬁeld of neutrino physics is the so-called neutrino- less double-beta decay [15]. A double-beta decay process means that a nucleus un- dergoes two beta decay processes simultaneously, and, therefore, changes its atomic number by 2. This can either be done by emitting 2 real neutrinos (the so-called two-neutrino double-beta decay, or 2νββ-decay), or by exchanging one virtual neu- trino internally and emitting no neutrinos (the neutrino-less double-beta decay, or 0νββ-decay) [16]. The 2νββ-decay has been observed in a number of nuclei [16], but the 0νββ-decay has not yet been observed. Even a single observation "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("A very important process within the ﬁeld of neutrino physics is the so-called neutrino-")
    thisalinea.textcontent.append("less double-beta decay [15]. A double-beta decay process means that a nucleus un-")
    thisalinea.textcontent.append("dergoes two beta decay processes simultaneously, and, therefore, changes its atomic")
    thisalinea.textcontent.append("number by 2. This can either be done by emitting 2 real neutrinos (the so-called")
    thisalinea.textcontent.append("two-neutrino double-beta decay, or 2νββ-decay), or by exchanging one virtual neu-")
    thisalinea.textcontent.append("trino internally and emitting no neutrinos (the neutrino-less double-beta decay, or")
    thisalinea.textcontent.append("0νββ-decay) [16]. The 2νββ-decay has been observed in a number of nuclei [16], but")
    thisalinea.textcontent.append("the 0νββ-decay has not yet been observed.")
    thisalinea.textcontent.append("Even a single observation of the 0νββ-decay would have major consequences in nu-")
    thisalinea.textcontent.append("clear and particle physics, as the 0νββ-decay can only occur if the neutrino is a")
    thisalinea.textcontent.append("Majorana particle [16]. According to the Standard Model in particle physics, neu-")
    thisalinea.textcontent.append("trinos are believed to be Dirac particles. However, this is not yet experimentally")
    thisalinea.textcontent.append("proven [17]. However, if 0νββ-decay was ever observed, we would know that the")
    thisalinea.textcontent.append("neutrino is a Majorana particle and the Standard Model itself would have to be re-")
    thisalinea.textcontent.append("vised. Moreover, observations of 0νββ-decay could provide hints for SuperSymmetry")
    thisalinea.textcontent.append("(SUSY) and Grand Uniﬁcation Theories (GUT) [15, 18] and can help to constrain the")
    thisalinea.textcontent.append("neutrino mass to the level of meV precision [15]. Finally, since 0νββ-decay violates")
    thisalinea.textcontent.append("the conservation of lepton number, it may help to understand the matter/antimatter")
    thisalinea.textcontent.append("asymmetry in the universe [17].")
    thisalinea.textcontent.append("However, to extract the useful information from the data, both theoretical and exper-")
    thisalinea.textcontent.append("imental challenges have to be faced [16]. From an experimental point of view, one has")
    thisalinea.textcontent.append("to cope with very large backgrounds. From a theoretical point of view, the description")
    thisalinea.textcontent.append("of 0νββ-decay is very diﬃcult since the nuclear structure has to be described accu-")
    thisalinea.textcontent.append("rately. Nuclear matrix elements, and especially the Gamow-Teller ones, frequently")
    thisalinea.textcontent.append("enter the calculations [16, 18]. Therefore, as theoretical descriptions of Gamow-Teller")
    thisalinea.textcontent.append("transitions may involve substantial uncertainties [7, 12, 19], direct measurements of")
    thisalinea.textcontent.append("the relevant B(GT ) values can help us reﬁne the theoretical predictions of the 0νββ")
    thisalinea.textcontent.append("matrix elements.")
    thisalinea.textcontent.append("Another important issue within the ﬁeld of neutrino physics is trying to understand")
    thisalinea.textcontent.append("the origin of solar neutrinos. Accurate knowledge on Gamow-Teller matrix elements")
    thisalinea.textcontent.append("can be very useful when designing new detection techniques for these solar neutrinos")
    thisalinea.textcontent.append("[20]. Their detection is important, because measurements of solar neutrinos can help")
    thisalinea.textcontent.append("to understand the internal structure of the sun [7]. Hence, measuring Gamow-Teller")
    thisalinea.textcontent.append("matrix elements is important for the theoretical understanding of 0νββ-decay and")
    thisalinea.textcontent.append("for the detection of solar neutrinos. Both of these ﬁelds have the potential to answer")
    thisalinea.textcontent.append("many important questions in physics.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "1.5 Nucleosynthesis"
    thisalinea.nativeID = 8
    thisalinea.parentID = 3
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "Nucleosynthesis is the generation of diﬀerent chemical elements through nuclear re- actions. The issue of how this nucleosynthesis has happened and happens today still has many open questions. Nevertheless, the current understanding of nucleosynthesis is that light elements up to iron are produced within stars through fusion reactions [7, 12]. Since up to iron, the binding energy per nucleon roughly increases with the atomic number [21], the production of these elements is energetically favourable and powers the star. However, the generation of elements heavier than iron is not energetically favourable. Yet, these elements are known to exist in nature as "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Nucleosynthesis is the generation of diﬀerent chemical elements through nuclear re-")
    thisalinea.textcontent.append("actions. The issue of how this nucleosynthesis has happened and happens today still")
    thisalinea.textcontent.append("has many open questions. Nevertheless, the current understanding of nucleosynthesis")
    thisalinea.textcontent.append("is that light elements up to iron are produced within stars through fusion reactions")
    thisalinea.textcontent.append("[7, 12]. Since up to iron, the binding energy per nucleon roughly increases with the")
    thisalinea.textcontent.append("atomic number [21], the production of these elements is energetically favourable and")
    thisalinea.textcontent.append("powers the star.")
    thisalinea.textcontent.append("However, the generation of elements heavier than iron is not energetically favourable.")
    thisalinea.textcontent.append("Yet, these elements are known to exist in nature as well. Hence, several diﬀerent")
    thisalinea.textcontent.append("processes have been proposed to describe how these elements may have been generated")
    thisalinea.textcontent.append("[7]. An overview of these processes is given in Figure 1.1.")
    thisalinea.textcontent.append("Figure 1.1: Overview of the known processes today that are responsible for the gen-")
    thisalinea.textcontent.append("eration of nuclei beyond iron [7]; ﬁgure used with permission.")
    thisalinea.textcontent.append("The orange line in Figure 1.1 represents the generation of the light elements up to")
    thisalinea.textcontent.append("iron through fusion reactions in stars. The magenta line represents the s-process.")
    thisalinea.textcontent.append("According to the model of the s-process, it is believed that nuclei undergo a series")
    thisalinea.textcontent.append("of neutron captures and β-decays, resulting in a gradual increase of their atomic")
    thisalinea.textcontent.append("number Z [12]. The important characteristic of the s-process is that the time between")
    thisalinea.textcontent.append("succeeding neutron captures is larger than the lifetimes of the β-decays. Hence, the")
    thisalinea.textcontent.append("name ‘slow neutron capture’ process, or s-process. Because the β-decay occurs faster")
    thisalinea.textcontent.append("than the neutron capture, the involved nuclei remain close to the valley of stability.")
    thisalinea.textcontent.append("This process is believed to take place in red giant stars and astronomical observations")
    thisalinea.textcontent.append("have conﬁrmed this [7].")
    thisalinea.textcontent.append("The violet line represents the ‘rapid neutron capture’ process, or r-process. Like the")
    thisalinea.textcontent.append("s-process, this is a process of neutron captures followed by β-decays to synthesize")
    thisalinea.textcontent.append("heavier nuclei. However, during the r-process, the time between successive neutron")
    thisalinea.textcontent.append("captures is much shorter than the β-decay lifetimes (hence, the word ‘rapid’). As a")
    thisalinea.textcontent.append("result, nuclei capture many neutrons before a β-decay can occur, which means that")
    thisalinea.textcontent.append("most of the involved nuclei are extremely neutron-rich and unstable. This process is")
    thisalinea.textcontent.append("believed to be responsible for about half of the total amount of elements in nature")
    thisalinea.textcontent.append("heavier than iron [7]. The r-process is believed to take place in merging neutron stars")
    thisalinea.textcontent.append("and the core-collapse of supernovae. In the autumn of 2017, gravitational waves from")
    thisalinea.textcontent.append("a neutron star merger were detected [22], which provided strong suggestions that the")
    thisalinea.textcontent.append("model of the r-process in neutron-star mergers is correct.")
    thisalinea.textcontent.append("The p-process (blue line) shown Figure 1.1 is the photo-dissociation-driven process.")
    thisalinea.textcontent.append("Originally, the p-process referred to proton-capture reactions that synthesize proton-")
    thisalinea.textcontent.append("rich nuclei. Later it was realized that proton capture could not explain the natural")
    thisalinea.textcontent.append("abundance of proton-rich nuclei (p-nuclei). The process refers now more generally to")
    thisalinea.textcontent.append("any process that can produce p-nuclei, and, in particular, photo-dissociation of heavier")
    thisalinea.textcontent.append("nuclei synthesized by other mechanisms (like the s and r-process), which then undergo")
    thisalinea.textcontent.append("neutron emission or ﬁssion. This process is induced by photons, which explains the")
    thisalinea.textcontent.append("name photo-dissociation-driven process, or p-process. Obviously, this process cannot")
    thisalinea.textcontent.append("synthesize heavy nuclei itself, but it can generate the proton-rich isotopes of some of")
    thisalinea.textcontent.append("the less heavy nuclei. Since the measured abundance of these isotopes is larger than")
    thisalinea.textcontent.append("the predictions of these abundances based on the s and r-processes, the p-process is")
    thisalinea.textcontent.append("expected to account for this diﬀerence. The p-process is believed to take place in the")
    thisalinea.textcontent.append("core-collapse of supernovae [7].")
    thisalinea.textcontent.append("Finally, there is the rp-process in Figure 1.1 (the red line); rp stands for ‘rapid proton")
    thisalinea.textcontent.append("capture’. In this process, the nuclei capture protons before undergoing β-decay. The")
    thisalinea.textcontent.append("time between successive proton captures is shorter than the β-decay lifetimes. Hence,")
    thisalinea.textcontent.append("this process involves very proton-rich and, therefore, usually unstable nuclei. This")
    thisalinea.textcontent.append("process is believed to take place in accreting neutron stars [12, 23] and to be responsi-")
    thisalinea.textcontent.append("ble for the X-ray bursts [12, 19]. The rp-process is also the key to understanding the")
    thisalinea.textcontent.append("composition of the crust of accreting neutron starts, which determines the thermal")
    thisalinea.textcontent.append("and electrical conductivity of such a star [24].")
    thisalinea.textcontent.append("From the discussion above it follows that, for all of the discussed processes responsible")
    thisalinea.textcontent.append("for nucleosynthesis beyond iron, β-decay is a crucial aspect. Hence, if we wish to")
    thisalinea.textcontent.append("understand the precise dynamics of these processes, we need to understand β-decay")
    thisalinea.textcontent.append("across the full nuclear chart. In Section 1.2, it was argued that the Fermi and Gamow-")
    thisalinea.textcontent.append("Teller transitions are the main contributions to β-decay. Since a calculation of the")
    thisalinea.textcontent.append("Fermi transitions is relatively straightforward (see Section 1.2) while a calculation")
    thisalinea.textcontent.append("of Gamow-Teller transition is still a major challenge [12], this means that accurate")
    thisalinea.textcontent.append("measurements of Gamow-Teller transitions (B(GT ) values) are required to model")
    thisalinea.textcontent.append("nucleosynthesis processes [25].")
    thisalinea.textcontent.append("Apart from B(GT ) values, other observables like proton- and neutron-separation en-")
    thisalinea.textcontent.append("ergies and nuclear masses are of vital importance to understand nucleosynthesis pro-")
    thisalinea.textcontent.append("cesses [12, 19, 26]. For the s-, r- and rp-processes, it is important that B(GT ) values")
    thisalinea.textcontent.append("are known with a suﬃcient accuracy [27]. In particular, the rp-process starts with")
    thisalinea.textcontent.append("nuclear hydrogen burning [26] and ends in a closed cycle of the neutron-deﬁcient el-")
    thisalinea.textcontent.append("ements Sn, Sb and Te near a mass of A = 100 [24]. The rp-process cannot generate")
    thisalinea.textcontent.append("nuclei beyond these elements due to the low α-separation energies of the involved Te")
    thisalinea.textcontent.append("isotopes, but its presence has major implications on the resulting X-ray bursts [24].")
    thisalinea.textcontent.append("However, many nuclei that are important for nucleosynthesis processes are highly un-")
    thisalinea.textcontent.append("stable (see Figure 1.1), making it diﬃcult to measure B(GT ) values. This means that")
    thisalinea.textcontent.append("models for nucleosynthesis processes nowadays must rely on theoretical predictions of")
    thisalinea.textcontent.append("B(GT ), which introduce substantial uncertainties in those models [7, 12, 19]. New")
    thisalinea.textcontent.append("accelerator facilities like FAIR (see Chapters 6 and 7), FRIB and RIBF are supposed")
    thisalinea.textcontent.append("to solve this problem. With these facilities, secondary beams of highly unstable nuclei")
    thisalinea.textcontent.append("can be generated, which will allow us to directly measure observables like B(GT ) for")
    thisalinea.textcontent.append("these nuclei.")
    thisalinea.textcontent.append("Unfortunately, these next-generation accelerator facilities were not yet available to")
    thisalinea.textcontent.append("us for performing experiments at the time of this work. Therefore, we could not")
    thisalinea.textcontent.append("measure B(GT ) values on highly unstable nuclei. Instead, we chose to pursue three")
    thisalinea.textcontent.append("closely related topics in this thesis. As a ﬁrst topic, we chose to do a measurement of")
    thisalinea.textcontent.append("B(GT ) values on some nuclei that are accessible with the equipment available today.")
    thisalinea.textcontent.append("For the other two topics, we chose to work on the development of parts of the FAIR")
    thisalinea.textcontent.append("facility, so that B(GT ) values can be measured for highly unstable nuclei in the near")
    thisalinea.textcontent.append("future. Speciﬁcally, we worked on the thermal simulations of the X-slit system, a")
    thisalinea.textcontent.append("beam collimator used in the generation of the highly unstable secondary beams, and")
    thisalinea.textcontent.append("on the design of the VETO detector, which is used to eliminate the background in the")
    thisalinea.textcontent.append("NeuLAND neutron detector. NeuLAND is used to detect neutrons that are generated")
    thisalinea.textcontent.append("in nuclear reactions with the highly unstable secondary beams.")
    thisalinea.textcontent.append("We chose to measure B(GT ) values of the 116,122Sn → 116,122Sb Gamow-Teller tran-")
    thisalinea.textcontent.append("sitions by using the (3He, t) charge-exchange reaction (see Section 1.1) as they could")
    thisalinea.textcontent.append("provide benchmarks for theoretical studies of nucleosynthesis processes in the Sn re-")
    thisalinea.textcontent.append("gion. These transitions have already been studied [28] at a bombarding energy of")
    thisalinea.textcontent.append("67 MeV/u and with an energy resolution of 80 keV (FWHM). However, since our in-")
    thisalinea.textcontent.append("terest in B(GT ) values is partly motivated by our aim to understand nucleosynthesis")
    thisalinea.textcontent.append("processes, it is important to improve upon the energy resolution as much as possible")
    thisalinea.textcontent.append("and to have data at multiple bombarding energies. Hence, we chose to complement")
    thisalinea.textcontent.append("the measurements in Ref. [28] by measuring B(GT ) values at 140 MeV/u and with a")
    thisalinea.textcontent.append("better energy resolution.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "1.6 Thesis layout"
    thisalinea.nativeID = 9
    thisalinea.parentID = 3
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "As discussed in Section 1.5, this thesis is divided into three diﬀerent topics. The ﬁrst topic is the measurement of the B(GT ) values of the 116,122Sn → 116,122Sb Gamow- Teller transitions by using the (3He, t) charge-exchange reaction. Chapters 2 − 5 are devoted to this topic. In Chapter 2, the theory to extract B(GT ) from the measured data is discussed. Subsequently, the experimental setup used for the measurements is discussed in Chapter 3. The analysis techniques that were used to extract the diﬀerential cross sections and, subsequently, the B(GT ) values, were discussed in Chapter 4. Finally, "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As discussed in Section 1.5, this thesis is divided into three diﬀerent topics. The ﬁrst")
    thisalinea.textcontent.append("topic is the measurement of the B(GT ) values of the 116,122Sn → 116,122Sb Gamow-")
    thisalinea.textcontent.append("Teller transitions by using the (3He, t) charge-exchange reaction. Chapters 2 − 5 are")
    thisalinea.textcontent.append("devoted to this topic. In Chapter 2, the theory to extract B(GT ) from the measured")
    thisalinea.textcontent.append("data is discussed. Subsequently, the experimental setup used for the measurements")
    thisalinea.textcontent.append("is discussed in Chapter 3. The analysis techniques that were used to extract the")
    thisalinea.textcontent.append("diﬀerential cross sections and, subsequently, the B(GT ) values, were discussed in")
    thisalinea.textcontent.append("Chapter 4. Finally, the obtained B(GT ) values are shown and discussed in Chapter")
    thisalinea.textcontent.append("5.")
    thisalinea.textcontent.append("The second topic is the safety study of the X-slit system through thermal simulations.")
    thisalinea.textcontent.append("The X-slit system is a beam collimator used at the FAIR accelerator facility [29] in the")
    thisalinea.textcontent.append("production of secondary beams consisting of highly unstable nuclei. These unstable")
    thisalinea.textcontent.append("nuclei are ﬁrst produced by impinging a stable primary beam onto a ﬁxed target.")
    thisalinea.textcontent.append("Subsequently, the produced nuclei are separated in-ﬂight by stopping the unwanted")
    thisalinea.textcontent.append("ones with beam collimators like the X-slit system [30]. Stopping that many nuclei")
    thisalinea.textcontent.append("with a beam collimator will heat up the equipment. In Chapter 6, we explore through")
    thisalinea.textcontent.append("thermal simulations and benchmarking whether this heating poses any problems for")
    thisalinea.textcontent.append("a safe and stable operation of the X-slit system.")
    thisalinea.textcontent.append("The third topic is the design of the VETO detector for the NeuLAND neutron detec-")
    thisalinea.textcontent.append("tor. After a secondary beam of highly unstable nuclei is produced, it can be guided")
    thisalinea.textcontent.append("to diﬀerent experimental setups [30]. One of these setups is the R3B experiment [10].")
    thisalinea.textcontent.append("R3B stands for Reactions with Relativistic Radioactive Beams. In this experiment,")
    thisalinea.textcontent.append("the produced secondary beam bombards a ﬁxed target and the products of the re-")
    thisalinea.textcontent.append("sulting nuclear reactions are measured through diﬀerent detectors. NeuLAND is the")
    thisalinea.textcontent.append("fast-neutron detector of the R3B setup. A VETO detector may be used to eliminate")
    thisalinea.textcontent.append("the background signals measured by NeuLAND. In Chapter 7, the optimal design and")
    thisalinea.textcontent.append("the eﬀectiveness of such a VETO detector are discussed.")
    thisalinea.textcontent.append("Finally, the thesis is concluded in Chapter 8. A Dutch summary is included at the")
    thisalinea.textcontent.append("end of the thesis.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "2 Theoretical models for the diﬀerential cross sections"
    thisalinea.nativeID = 10
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "As explained in Chapter 1, the goal of our experiment is to measure the strength of the Gamow-Teller transitions in 116Sn → 116Sb and 122Sn → 122Sb at a bombarding energy of 140 MeV/u. The strength of Gamow-Teller transitions is characterized by a so-called B(GT ) value. A B(GT ) value is a dimensionless number and its deﬁnition is given by [13], [31]: B(GT±) = 1 2Ji + 1 (cid:12) (cid:12) (cid:12) (cid:12) (cid:12) (cid:12) (cid:104)Ψf (cid:107) (cid:88) (cid:12) (cid:12) (cid:12) σjτ ±,j(cid:107)Ψi(cid:105) (cid:12) (cid:12) (cid:12) , (2.1) where Ji is the total angular momentum quantum number of the parent "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.1 Characterization of Gamow-Teller strength"
    thisalinea.nativeID = 11
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "As explained in Chapter 1, the goal of our experiment is to measure the strength of the Gamow-Teller transitions in 116Sn → 116Sb and 122Sn → 122Sb at a bombarding energy of 140 MeV/u. The strength of Gamow-Teller transitions is characterized by a so-called B(GT ) value. A B(GT ) value is a dimensionless number and its deﬁnition is given by [13], [31]: B(GT±) = 1 2Ji + 1 (cid:12) (cid:12) (cid:12) (cid:12) (cid:12) (cid:12) (cid:104)Ψf (cid:107) (cid:88) (cid:12) (cid:12) (cid:12) σjτ ±,j(cid:107)Ψi(cid:105) (cid:12) (cid:12) (cid:12) , (2.1) where Ji is the total angular momentum quantum number of the parent "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As explained in Chapter 1, the goal of our experiment is to measure the strength of")
    thisalinea.textcontent.append("the Gamow-Teller transitions in 116Sn → 116Sb and 122Sn → 122Sb at a bombarding")
    thisalinea.textcontent.append("energy of 140 MeV/u. The strength of Gamow-Teller transitions is characterized by")
    thisalinea.textcontent.append("a so-called B(GT ) value. A B(GT ) value is a dimensionless number and its deﬁnition")
    thisalinea.textcontent.append("is given by [13], [31]:")
    thisalinea.textcontent.append("B(GT±) =")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("2Ji + 1")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:104)Ψf (cid:107)")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("σjτ ±,j(cid:107)Ψi(cid:105)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append(", (2.1)")
    thisalinea.textcontent.append("where Ji is the total angular momentum quantum number of the parent (target) nu-")
    thisalinea.textcontent.append("cleus [32]. Ψi is the full nuclear wave function of the parent (target) nucleus and")
    thisalinea.textcontent.append("Ψf is the full nuclear wave function of the daughter (recoil) nucleus [13]. τ ±,j is")
    thisalinea.textcontent.append("the isospin raising/lowering operator for the j-th nucleon in those wave functions:")
    thisalinea.textcontent.append("τ ±,j = 1")
    thisalinea.textcontent.append("sitions, and the lowering operator applies for neutron to proton transitions. σj is the")
    thisalinea.textcontent.append("spin operator. It is deﬁned as σj = σx,j + σy,j + σz,j where σx,j, σy,j and σz,j are")
    thisalinea.textcontent.append("the three Pauli spin matrices of the j-th nucleon. Since both the isospin raising/low-")
    thisalinea.textcontent.append("ering operator and the spin operator are present in the matrix element while no other")
    thisalinea.textcontent.append("operators are present, this matrix element will produce a ∆L = 0, ∆S = 1, ∆T = 1")
    thisalinea.textcontent.append("transition, which is a Gamow-Teller transition [34, 35].")
    thisalinea.textcontent.append("The B(GT ) values were obtained from the measured diﬀerential cross sections of a")
    thisalinea.textcontent.append("(3He, t) charge-exchange reaction. Since a (3He, t) charge-exchange reaction induces")
    thisalinea.textcontent.append("a neutron-to-proton transition in the target nucleus, a B(GT ) value obtained through")
    thisalinea.textcontent.append("such a reaction is always a B(GT−) value of Equation (2.1). Hence, from now on, we")
    thisalinea.textcontent.append("shall refer to B(GT−) values simply as B(GT ) values. For a (3He, t) charge-exchange")
    thisalinea.textcontent.append("reaction, the measured cross section at zero degrees of a Gamow-Teller transition can")
    thisalinea.textcontent.append("be formally related to its B(GT ) value (its B(GT−) value) [11, 13, 28, 32, 35–37].")
    thisalinea.textcontent.append("The relation between the B(GT ) value of a certain transition in the excitation-energy")
    thisalinea.textcontent.append("spectrum of the daughter (recoil) nucleus and the diﬀerential cross section of that")
    thisalinea.textcontent.append("same transition is given by [11] (the (α = 0, q = 0) point is discussed later on in this")
    thisalinea.textcontent.append("section):")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)GT")
    thisalinea.textcontent.append("(α = 0, q = 0) = ˆσGT · B(GT ) with ˆσGT = K · N D")
    thisalinea.textcontent.append("where α is the scattering angle, namely the angle between the incoming 3He2+-particle")
    thisalinea.textcontent.append("and the outgoing 3H+-particle in the centre-of-mass frame, q is the linear momentum")
    thisalinea.textcontent.append("transfer from the 3He2+-particle onto the recoil nucleus and ˆσGT is the so-called")
    thisalinea.textcontent.append("Gamow-Teller unit cross section. It consists of the product of a kinematic factor")
    thisalinea.textcontent.append("K, a Gamow-Teller distortion factor N D")
    thisalinea.textcontent.append("the square of Jστ , which is the volume integral of the central στ -component of the")
    thisalinea.textcontent.append("eﬀective nucleon-nucleon interaction between the projectile and target nucleons [11,")
    thisalinea.textcontent.append("13]. A model-dependent method for calculating N D")
    thisalinea.textcontent.append("distorted-wave diﬀerential cross section to the Gamow-Teller plane-wave diﬀerential")
    thisalinea.textcontent.append("cross section (see Section 2.5). The GT -label of the diﬀerential cross section dσ/dΩ")
    thisalinea.textcontent.append("denotes that the cross section corresponds to a Gamow-Teller transition.")
    thisalinea.textcontent.append("At a beam energy of 140 MeV/u, the unit cross section (ˆσGT ) of Equation (2.2) is de-")
    thisalinea.textcontent.append("termined to be ˆσGT = 109 mb/sr · A−0.65 with a relative accuracy better than 5% (A")
    thisalinea.textcontent.append("is the target mass number) [35]. This result was determined directly from experimen-")
    thisalinea.textcontent.append("tal data without any dependence on nuclear structure models. Although tremendous")
    thisalinea.textcontent.append("progress has been made in this area, these models may still yield substantial uncer-")
    thisalinea.textcontent.append("tainties [7, 12, 14, 19, 38]. For example, a theoretical evaluation of N D may contain")
    thisalinea.textcontent.append("uncertainties up to 20% [13]. Hence, by using the result from Ref. [35] in Equation")
    thisalinea.textcontent.append("(2.2), the obtained B(GT ) values will be free from these substantial uncertainties.")
    thisalinea.textcontent.append("This advantage is the reason why a beam energy of 140 MeV/u was selected for our")
    thisalinea.textcontent.append("experiment.")
    thisalinea.textcontent.append("The transitions that were studied in Ref. [35] all had a daughter (recoil) nucleus with")
    thisalinea.textcontent.append("a ground-state that could undergo Gamow-Teller β-decay [21]. In that situation, it")
    thisalinea.textcontent.append("was possible to determine the unit cross section from the lifetime of the daughter")
    thisalinea.textcontent.append("(recoil) nucleus [11]. Since our recoil nuclei of interest (116Sb and 122Sb) do not have")
    thisalinea.textcontent.append("such a ground-state [21], it is more practical to use ˆσGT = 109 mb/sr · A−0.65 from")
    thisalinea.textcontent.append("Ref. [35] than a theoretical calculation of the unit cross section.")
    thisalinea.textcontent.append("However, deducing B(GT ) by using Equation (2.2) faces one major challenge. A")
    thisalinea.textcontent.append("diﬀerential cross section can only be measured over a small region around α = 0, not")
    thisalinea.textcontent.append("exactly at α = 0. Moreover, our (3He, t) reaction cannot occur at zero momentum")
    thisalinea.textcontent.append("transfer. Hence, if Equation (2.2) is to be used to obtain B(GT ) from the diﬀerential")
    thisalinea.textcontent.append("cross section, a method for extrapolating the measured data to q = 0 and α = 0 is")
    thisalinea.textcontent.append("required. The basic idea for this extrapolation is to ﬁt the experimental data on")
    thisalinea.textcontent.append("the diﬀerential cross section to a theoretical model and then use that model for the")
    thisalinea.textcontent.append("extrapolation. In this chapter, we discuss exactly how this theoretical model can be")
    thisalinea.textcontent.append("obtained and how it can be used to extrapolate the diﬀerential cross section to α = 0")
    thisalinea.textcontent.append("and q = 0. The actual extrapolation is then discussed in Section 2.7.")
    thisalinea.textcontent.append("Any theoretical model for a diﬀerential cross section must depend on the structure")
    thisalinea.textcontent.append("of the nuclei involved. That is why a nuclear structure model will be discussed in")
    thisalinea.textcontent.append("Section 2.2. In Section 2.3 it will be discussed how the full nuclear wave functions")
    thisalinea.textcontent.append("before and after the (3He, t) charge-exchange reaction can be constructed within the")
    thisalinea.textcontent.append("framework of this model. Subsequently, Section 2.4 will treat the calculation of the")
    thisalinea.textcontent.append("so-called form factor, which is needed to compute the theoretical diﬀerential cross")
    thisalinea.textcontent.append("sections in Section 2.5. In Section 2.6 it will further be discussed how the results from")
    thisalinea.textcontent.append("Section 2.5 can be corrected for the angular resolution of the detector.")
    thisalinea.textcontent.append("Before we start explaining these topics, we want to discuss the issue that extrapo-")
    thisalinea.textcontent.append("lation of the measured cross section by a theoretical model is, obviously, not model")
    thisalinea.textcontent.append("independent. So, how can we be sure that reliable B(GT ) values are obtained? The")
    thisalinea.textcontent.append("ﬁrst answer to this question is that as long as the overall normalization of the dif-")
    thisalinea.textcontent.append("ferential cross section is known (which can be determined from the data) and one is")
    thisalinea.textcontent.append("only interested in reaction dynamics near q = 0 (the Gamow-Teller domain), many")
    thisalinea.textcontent.append("shortcomings of nuclear structure models do not matter too much [13]. This might")
    thisalinea.textcontent.append("sound counter-intuitive to what has been discussed in Section 1.2, but it is not. The")
    thisalinea.textcontent.append("challenging part of Section 1.2 is the overall normalization, which is, in our situation,")
    thisalinea.textcontent.append("not calculated, but determined from the data.")
    thisalinea.textcontent.append("The second answer is that we will show in Tables 4.2 and 4.3 that variations of many")
    thisalinea.textcontent.append("input parameters of the theoretical model will not result in signiﬁcant deviations of")
    thisalinea.textcontent.append("our ﬁnal answer. Therefore, Tables 4.2 and 4.3 will provide a strong indication that,")
    thisalinea.textcontent.append("although our extrapolation method is not model-independent, the obtained B(GT )")
    thisalinea.textcontent.append("values, are (to a large extent).")
    thisalinea.textcontent.append("Tables 4.2 and 4.3 present B(F ) values instead of B(GT ) values. A B(F )-value")
    thisalinea.textcontent.append("characterizes the strength of a Fermi transition in the same way as a B(GT ) value")
    thisalinea.textcontent.append("characterizes the strength of a Gamow-Teller transition. The deﬁnition of B(F ) is")
    thisalinea.textcontent.append("given in Equation (2.3) [13] and its relation to (3He, t) charge-exchange reaction cross")
    thisalinea.textcontent.append("sections is given in Equation (2.4). Ref. [35] also provides a model for the Fermi unit")
    thisalinea.textcontent.append("cross section: ˆσF = 72 mb/sr · A−1.06.")
    thisalinea.textcontent.append("B(F±) =")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("2Ji + 1")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:104)Ψf |")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("τ ±,j|Ψi(cid:105)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append(",")
    thisalinea.textcontent.append("(2.3)")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)F")
    thisalinea.textcontent.append("(α = 0, q = 0) = ˆσF · B(F ) with ˆσF = K · N D")
    thisalinea.textcontent.append("From now on, we shall refer to B(F−) values as B(F ) values, similar to our convention")
    thisalinea.textcontent.append("on B(GT ) values. From Equations (2.3) and (2.4) it is clear that the dynamics and")
    thisalinea.textcontent.append("principles of Fermi and Gamow-Teller transitions are analogue (K is the same quantity")
    thisalinea.textcontent.append("as in Equation (2.2)). Therefore, one can assume that conclusions from Tables 4.2")
    thisalinea.textcontent.append("and 4.3 about B(F ) are applicable to B(GT ) values. However, the Fermi transitions")
    thisalinea.textcontent.append("listed in Tables 4.2 and 4.3 have much higher statistics than any of the Gamow-Teller")
    thisalinea.textcontent.append("transitions that were measured (this will be discussed in Chapter 4 in more detail).")
    thisalinea.textcontent.append("Therefore, mismatches between the theoretical model and the experimental data are")
    thisalinea.textcontent.append("much less likely to fall in the range of statistical errors for this Fermi transition. This")
    thisalinea.textcontent.append("is the reason why a Fermi transition was chosen in Tables 4.2 and 4.3 instead of a")
    thisalinea.textcontent.append("Gamow-Teller transition.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.2 The nuclear shell model"
    thisalinea.nativeID = 12
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "To fully describe the internal structure of a nucleus, one would have to solve the Schr¨odinger equation for a system of A strongly interacting nucleons [14]. Solving this equation is known as the nuclear many-body problem [39]. This problem presents a formidable task [39] because the interaction potential between two nucleons is very complicated [4, 39, 40] and because the total potential of a system of A nucleons is not a simple sum of the interaction potentials of each pair of nucleons [39]. There is experimental evidence that the so-called three-nucleon force should also be included [41–43]. Moreover, solving such "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("To fully describe the internal structure of a nucleus, one would have to solve the")
    thisalinea.textcontent.append("Schr¨odinger equation for a system of A strongly interacting nucleons [14]. Solving this")
    thisalinea.textcontent.append("equation is known as the nuclear many-body problem [39]. This problem presents a")
    thisalinea.textcontent.append("formidable task [39] because the interaction potential between two nucleons is very")
    thisalinea.textcontent.append("complicated [4, 39, 40] and because the total potential of a system of A nucleons is")
    thisalinea.textcontent.append("not a simple sum of the interaction potentials of each pair of nucleons [39]. There is")
    thisalinea.textcontent.append("experimental evidence that the so-called three-nucleon force should also be included")
    thisalinea.textcontent.append("[41–43]. Moreover, solving such a complicated Schr¨odinger equation for A nucleons is")
    thisalinea.textcontent.append("extremely diﬃcult and computer-intensive [38, 39].")
    thisalinea.textcontent.append("The challenges mentioned above remain as obstacles today, which can only be over-")
    thisalinea.textcontent.append("come for some of the lighter nuclei [38, 39]. Therefore, the nuclear many-body problem")
    thisalinea.textcontent.append("can only be solved assuming some simpliﬁcations. A powerful simpliﬁcation technique")
    thisalinea.textcontent.append("is the Independent Particle Model (IPM), also called the (naive) shell model. This")
    thisalinea.textcontent.append("model dates back to 1949 [38] and assumes that each nucleon experiences a ﬁxed")
    thisalinea.textcontent.append("external potential that is generated by all the other nucleons [14, 38]. This poten-")
    thisalinea.textcontent.append("tial is known as the mean ﬁeld [14] and by deﬁning this potential as external, the")
    thisalinea.textcontent.append("nuclear many-body problem is transformed into a set of A 1-body problems: a set of")
    thisalinea.textcontent.append("A Schr¨odinger equations that all deal with just one single nucleon. Obviously, this")
    thisalinea.textcontent.append("means a major simpliﬁcation and the problem becomes solvable.")
    thisalinea.textcontent.append("The ﬁrst attempts to describe the nucleus with a shell model proposed a radial har-")
    thisalinea.textcontent.append("monic oscillator potential plus a strong attractive spin-orbit coupling [14, 38]. The")
    thisalinea.textcontent.append("reason that a spin-orbit coupling has to be included is that the realistic interaction")
    thisalinea.textcontent.append("potential between two nucleons includes a signiﬁcant spin-orbit coupling [4, 40, 44].")
    thisalinea.textcontent.append("The energy levels of such a shell model description are illustrated in Figure 2.1.")
    thisalinea.textcontent.append("The energy levels in Figure 2.1 are labeled analogously to atomic physics. Just like in")
    thisalinea.textcontent.append("the hydrogen atom, the energy levels in the nuclear shell model are described by three")
    thisalinea.textcontent.append("quantum numbers: n, l and m. The principal quantum number n refers to the number")
    thisalinea.textcontent.append("of oscillator quanta (the number of nodes in the wave function) and s, p, d, etc. refer")
    thisalinea.textcontent.append("to the orbital quantum number l in the usual way. Just like in atomic physics, the")
    thisalinea.textcontent.append("energy levels are degenerate in the magnetic quantum number m, which can take")
    thisalinea.textcontent.append("values m = −l, ..., l [44]. However, there is one important diﬀerence in convention")
    thisalinea.textcontent.append("with atomic physics: in nuclear physics n only refers to the number of radial nodes")
    thisalinea.textcontent.append("Figure 2.1: Illustration of the energy levels in the nuclear shell model when a radial")
    thisalinea.textcontent.append("harmonic-oscillator potential plus a strong attractive spin-orbit coupling is considered")
    thisalinea.textcontent.append("as the mean ﬁeld; ﬁgure used with permission [14].")
    thisalinea.textcontent.append("in the wave function, while in atomic physics, n refers to the total number of nodes.")
    thisalinea.textcontent.append("As a result, l is limited to n − 1 in atomic physics, but not in nuclear physics.")
    thisalinea.textcontent.append("The spin-orbit coupling is also present in atomic physics, but unless Z becomes large,")
    thisalinea.textcontent.append("the eﬀects are very small. In the nuclear shell model on the other hand, a strong")
    thisalinea.textcontent.append("spin-orbit coupling was introduced (with a sign opposite to the situation of atomic")
    thisalinea.textcontent.append("physics) and the degeneracy in j is broken (see Figure 2.1). Hence, the energy of a")
    thisalinea.textcontent.append("level in the shell model depends on n, l and the resulting j (total angular momentum)")
    thisalinea.textcontent.append("from the spin-orbit coupling. This j is included in the labels of the energy levels in")
    thisalinea.textcontent.append("Figure 2.1. The remaining degeneracy per level is then 2j + 1 [44].")
    thisalinea.textcontent.append("Diﬀerent nuclei can now be described by the shell model illustrated in Figure 2.1 by")
    thisalinea.textcontent.append("choosing a speciﬁc mean-ﬁeld potential appropriate to that nucleus and then to ﬁll")
    thisalinea.textcontent.append("the energy levels with nucleons from the bottom up. However, since protons and")
    thisalinea.textcontent.append("neutrons are diﬀerent nucleons, one has to consider a shell model like Figure 2.1 for")
    thisalinea.textcontent.append("each of them. The levels that lie close together in Figure 2.1 can then be thought")
    thisalinea.textcontent.append("of as a shell (hence, the name shell model) and by adding the degeneracies of the")
    thisalinea.textcontent.append("diﬀerent levels within a shell, one can derive the famous magic numbers for closed")
    thisalinea.textcontent.append("shell conﬁgurations [38].")
    thisalinea.textcontent.append("The shell model can be made more realistic by using a so-called Woods-Saxon poten-")
    thisalinea.textcontent.append("tial (see Equation (2.5) and Figure 2.2) plus a strong spin-orbit coupling as the mean")
    thisalinea.textcontent.append("ﬁeld [14, 44]. All the properties of Figure 2.1 discussed so far, including the quantum")
    thisalinea.textcontent.append("numbers, degeneracies and magic numbers, remain valid [44, 45]. The only diﬀerence")
    thisalinea.textcontent.append("is that the energy levels are slightly displaced [44].")
    thisalinea.textcontent.append("fW S(r) = Vdepth ·")
    thisalinea.textcontent.append("−1")
    thisalinea.textcontent.append("1 + e")
    thisalinea.textcontent.append("(2.5)")
    thisalinea.textcontent.append("Figure 2.2: Comparison of a Woods-Saxon potential with a harmonic-oscillator po-")
    thisalinea.textcontent.append("tential as a nuclear mean ﬁeld; ﬁgure based on information from Ref. [46].")
    thisalinea.textcontent.append("The parameter Vdepth in Equation (2.5) models the depth of the Woods-Saxon poten-")
    thisalinea.textcontent.append("tial (see Figure 2.2). R is the radius of the nucleus of interest and a is the so-called")
    thisalinea.textcontent.append("diﬀusion parameter, which has the same dimension as R and determines how much")
    thisalinea.textcontent.append("the Woods-Saxon looks like a square box.")
    thisalinea.textcontent.append("In the following, we chose to compute the diﬀerential cross sections from a pure shell")
    thisalinea.textcontent.append("model with a radial Woods-Saxon potential plus a spin-orbit coupling. As a ﬁrst")
    thisalinea.textcontent.append("step in this calculation, the single-particle binding energies (the heights of the energy")
    thisalinea.textcontent.append("levels in Figure 2.1) were obtained using the program OXBASH [47, 48] with the")
    thisalinea.textcontent.append("SK20 interaction [49] (using default input parameters). This computation was done")
    thisalinea.textcontent.append("separately for protons and neutrons and was done for 116Sn, 116Sb, 122Sn and 122Sb.")
    thisalinea.textcontent.append("The calculation was truncated after the ﬁrst 25 energy levels. These levels include")
    thisalinea.textcontent.append("all the (partially) occupied states of the ground state of the target nucleus, all the")
    thisalinea.textcontent.append("(partially) occupied states of the ground state of the recoil nucleus and all the states")
    thisalinea.textcontent.append("of the recoil nucleus that can be reached from the ground state of the target nucleus")
    thisalinea.textcontent.append("through a Gamow-Teller transition. In fact, these levels even include all states of the")
    thisalinea.textcontent.append("recoil nucleus that can be reached through any ∆n = 0 transition.")
    thisalinea.textcontent.append("Subsequently, we calculated the spatial distributions of the single-particle wave func-")
    thisalinea.textcontent.append("tions using the WSAW-module of the FOLD-program. The program FOLD was")
    thisalinea.textcontent.append("developed by Cook and Carr [50], based on the work of Petrovich and Stanley [51]")
    thisalinea.textcontent.append("and then modiﬁed as described in Refs. [52] and [53].")
    thisalinea.textcontent.append("The WSAW-module requires the Woods-Saxon potential shape (the mean ﬁeld) and")
    thisalinea.textcontent.append("the binding energies from OXBASH as input parameters. For the Woods-Saxon")
    thisalinea.textcontent.append("shape (see Equation (2.5)), the following parameters were used: Vdepth = 60 MeV,")
    thisalinea.textcontent.append("R = 1.25 · A1/3 fm and a = 0.65 fm. For Vdepth, the WSAW-module only needs a rea-")
    thisalinea.textcontent.append("sonable initial guess, since this parameter is ﬁtted to the binding energies provided.")
    thisalinea.textcontent.append("R and a are close to typical textbook values [44] and are the same numbers that were")
    thisalinea.textcontent.append("used during the calculations in Ref. [35]. A spin-orbit coupling strength of 7.0 MeV")
    thisalinea.textcontent.append("was also assumed in agreement with these calculations. These values are diﬀerent")
    thisalinea.textcontent.append("than what was used in OXBASH, but in Tables 4.2 and 4.3, it is argued that the")
    thisalinea.textcontent.append("ﬁnal answer is not very sensitive to these parameters. For the nuclei 3He and 3H,")
    thisalinea.textcontent.append("the single-particle energy levels and single-particle wave functions were obtained from")
    thisalinea.textcontent.append("Variational Monte Carlo simulations [54]. Since a Woods-Saxon potential cannot de-")
    thisalinea.textcontent.append("scribe such light systems accurately, using the wave functions from Ref. [54] instead")
    thisalinea.textcontent.append("will improve the quality of the calculation.")
    thisalinea.textcontent.append("Subsequently, the full nuclear wave function was assumed to be an antisymmetrized")
    thisalinea.textcontent.append("direct product of the A occupied single-particle wave functions. The purpose of an-")
    thisalinea.textcontent.append("tisymmetrizing the wave function is to make sure that the Pauli-exclusion principle")
    thisalinea.textcontent.append("remains intact. Antisymmetrization should be done separately for protons and neu-")
    thisalinea.textcontent.append("trons using Slater-determinants [39].")
    thisalinea.textcontent.append("In the situation that the binding energy computed by OXBASH was smaller than")
    thisalinea.textcontent.append("2 MeV, a binding energy of 2 MeV was supplied as input parameter to the WSAW-")
    thisalinea.textcontent.append("module. This was done because the FOLD-module (see Section 2.4) can only handle")
    thisalinea.textcontent.append("wave functions that are in a suﬃciently bound state as inputs. Therefore, we need to")
    thisalinea.textcontent.append("make sure that the WSAW-module does not produce wave functions that will not be")
    thisalinea.textcontent.append("accepted in subsequent steps of the calculation.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.3 Normal-modes calculation"
    thisalinea.nativeID = 13
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "In this section, we will use the method of Section 2.2 to construct the full nuclear wave functions of all nuclei involved in the present experiment using the (3He, t) charge-exchange reaction. Prior to the reaction, the target nucleus is in its ground state, which can be described by ﬁlling the levels of Figure 2.1 (calculated with OXBASH, see previous section) from the bottom. Once it is known which energy levels are occupied by the nucleons, the full nuclear wave function for the ground-state can be constructed as an antisymmetrized direct product of the single-particle wave functions of the A "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this section, we will use the method of Section 2.2 to construct the full nuclear")
    thisalinea.textcontent.append("wave functions of all nuclei involved in the present experiment using the (3He, t)")
    thisalinea.textcontent.append("charge-exchange reaction.")
    thisalinea.textcontent.append("Prior to the reaction, the target nucleus is in its ground state, which can be described")
    thisalinea.textcontent.append("by ﬁlling the levels of Figure 2.1 (calculated with OXBASH, see previous section) from")
    thisalinea.textcontent.append("the bottom. Once it is known which energy levels are occupied by the nucleons, the full")
    thisalinea.textcontent.append("nuclear wave function for the ground-state can be constructed as an antisymmetrized")
    thisalinea.textcontent.append("direct product of the single-particle wave functions of the A occupied states. Let us")
    thisalinea.textcontent.append("denote this ground-state wave function by |0(cid:105).")
    thisalinea.textcontent.append("The recoil nucleus after the (3He, t) charge-exchange reaction can be described by")
    thisalinea.textcontent.append("removing one neutron from this ground-state wave function and adding an additional")
    thisalinea.textcontent.append("proton to it. In principle, any neutron can be removed from any of the occupied")
    thisalinea.textcontent.append("levels and the new proton can then be put in any of the energy levels that are not yet")
    thisalinea.textcontent.append("fully occupied. This might leave the recoil nucleus in an excited state. Removing one")
    thisalinea.textcontent.append("neutron from a speciﬁc level and adding a proton to another speciﬁc level is denoted")
    thisalinea.textcontent.append("as a one-particle-one-hole transition (1p1h-transition) [5].")
    thisalinea.textcontent.append("When the speciﬁc 1p1h-transition is known, the energy levels occupied after the re-")
    thisalinea.textcontent.append("action will also be known. This would allow us to construct the full nuclear wave")
    thisalinea.textcontent.append("function of the recoil nucleus. For an illustration of the (3He, t) charge-exchange")
    thisalinea.textcontent.append("reaction on a 122Sn target modeled as a 1p1h-transition, see Figure 2.3.")
    thisalinea.textcontent.append("Figure 2.3: Illustration of a 1p1h-transition in the 122Sn(3He, t)122Sb charge-exchange")
    thisalinea.textcontent.append("reaction.")
    thisalinea.textcontent.append("In reality, a (3He, t) charge-exchange reaction does not lead to a unique 1p1h-transition.")
    thisalinea.textcontent.append("It would be more realistic to describe the (3He, t) charge-exchange reaction as leading")
    thisalinea.textcontent.append("to a superposition of 1p1h-transitions. We chose to model the coeﬃcients in this su-")
    thisalinea.textcontent.append("perposition according to the so-called normal-modes formalism [5, 55]. This approach")
    thisalinea.textcontent.append("is a useful simpliﬁcation for calculating the transition densities projected on a 1p1h-")
    thisalinea.textcontent.append("basis for the purpose of describing transition strengths and cross sections of multipole")
    thisalinea.textcontent.append("excitations and Giant Resonances in particular by using the existing codes such as")
    thisalinea.textcontent.append("the FOLD-program. The reason for why this simpliﬁcation is so useful is discussed")
    thisalinea.textcontent.append("at the end of this section.")
    thisalinea.textcontent.append("With the normal-modes formalism, the wave function of the recoil nucleus is con-")
    thisalinea.textcontent.append("structed from the transition operator ˆO that is associated with the experimentally")
    thisalinea.textcontent.append("observed transition. For Fermi and Gamow-Teller transitions, the transition operators")
    thisalinea.textcontent.append("already appeared in Equations (2.1) and (2.3):")
    thisalinea.textcontent.append("ˆOF =")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("τ i ˆOGT =")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("σiτ i (2.6)")
    thisalinea.textcontent.append("Other transition types have diﬀerent operators ˆO. This poses no limitations. The")
    thisalinea.textcontent.append("normal-modes formalism can be exploited for any transition operator ˆO (see Section")
    thisalinea.textcontent.append("4.5).")
    thisalinea.textcontent.append("Next, let us denote the full nuclear wave function after one speciﬁc 1p1h-transition")
    thisalinea.textcontent.append("as |np, lp, mp, sp, nh, lh, mh, sh(cid:105). This wave function is deﬁned to be identical to the")
    thisalinea.textcontent.append("ground-state wave function |0(cid:105) of the target nucleus, except that one neutron (the")
    thisalinea.textcontent.append("hole) is removed from the level characterized by main quantum number nh, orbital")
    thisalinea.textcontent.append("quantum number lh, magnetic quantum number mh and magnetic spin quantum")
    thisalinea.textcontent.append("number sh and that one proton (the particle) is added to the level characterized by")
    thisalinea.textcontent.append("main quantum number np, orbital quantum number lp, magnetic quantum number")
    thisalinea.textcontent.append("mp and magnetic spin quantum number sp.")
    thisalinea.textcontent.append("The normal-modes formalism then prescribes the full nuclear wave function of the")
    thisalinea.textcontent.append("recoil nucleus as [5]:")
    thisalinea.textcontent.append("|Ψrecoil(cid:105) =")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("√")
    thisalinea.textcontent.append("N")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("X np,lp,mp,sp")
    thisalinea.textcontent.append("· |np, lp, mp, sp, nh, lh, mh, sh(cid:105) (2.7)")
    thisalinea.textcontent.append("X np,lp,mp,sp")
    thisalinea.textcontent.append("= (cid:104)np, lp, mp, sp, nh, lh, mh, sh| ˆO|0(cid:105)")
    thisalinea.textcontent.append("N =")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("|X np,lp,mp,sp")
    thisalinea.textcontent.append("|2")
    thisalinea.textcontent.append("The X-coeﬃcients from Equation (2.7) are known as One-Body Transition Densities")
    thisalinea.textcontent.append("(OBTDs) [55] and were computed with the program NORMOD [55–57]. We would")
    thisalinea.textcontent.append("like to emphasize that the sum in Equation (2.7), in principle, runs over all quantum")
    thisalinea.textcontent.append("numbers, but that we limited the sum to the 25 energy levels computed with WSAW")
    thisalinea.textcontent.append("(see Section 2.2). As input parameters, the program NORMOD requires the quan-")
    thisalinea.textcontent.append("tum numbers ∆L, ∆S and ∆J associated with the experimentally observed transition")
    thisalinea.textcontent.append("and a description of the ground-state wave function |0(cid:105) of the target nucleus. This")
    thisalinea.textcontent.append("description should contain all quantum numbers of all single-particle shell model en-")
    thisalinea.textcontent.append("ergy levels of Figure 2.1 taken along in the sum of Equation (2.7) and an occupation")
    thisalinea.textcontent.append("number for each of these energy levels [5] (the so-called fullness of that level).")
    thisalinea.textcontent.append("The occupation numbers are dimensionless numbers between 0 and 1 where 1 repre-")
    thisalinea.textcontent.append("sents a fully occupied level and 0 represents an empty level. One could describe |0(cid:105) by")
    thisalinea.textcontent.append("simply ﬁlling all levels in Figure 2.1 from the bottom up and therefore provide either 1")
    thisalinea.textcontent.append("or 0 for each energy level except possibly the partially ﬁlled top level. For the proton")
    thisalinea.textcontent.append("levels, this description could be used, because Sn-nuclei have a closed-shell conﬁgu-")
    thisalinea.textcontent.append("ration of 50 protons. Due to the large energy gap to the next level, the ground-state")
    thisalinea.textcontent.append("correlations of the nucleons are small and one could assume that they are absent.")
    thisalinea.textcontent.append("However, for the neutrons, ground-state correlations should be included in the de-")
    thisalinea.textcontent.append("scription of |0(cid:105) (which was not done prior to this point). Including the ground-state")
    thisalinea.textcontent.append("correlations in the description of |0(cid:105) for neutrons was done by using the occupation")
    thisalinea.textcontent.append("numbers from Ref. [58] for the neutron levels. These numbers are listed in Table 2.1.")
    thisalinea.textcontent.append("We would like to note that the two numbers marked by a ∗ were extrapolated from")
    thisalinea.textcontent.append("the data in Ref. [58]. All levels below the ones in Table 2.1 were given occupation")
    thisalinea.textcontent.append("numbers 1 and all other levels were given occupation numbers 0.")
    thisalinea.textcontent.append("Table 2.1: Occupation numbers for the highest non-empty neutron shell-model levels")
    thisalinea.textcontent.append("in 116Sn and 122Sn [58].")
    thisalinea.textcontent.append("Shell-model state Occupation number for 116Sn Occupation number for 122Sn")
    thisalinea.textcontent.append("1g7/2 0.88 0.80∗")
    thisalinea.textcontent.append("2d5/2 0.81 0.86")
    thisalinea.textcontent.append("2d3/2 0.32 0.51")
    thisalinea.textcontent.append("3s1/2 0.52 0.73")
    thisalinea.textcontent.append("0h11/2 0.15 0.58∗")
    thisalinea.textcontent.append("With the X-coeﬃcients of Equation (2.7) (calculated by NORMOD), the wave func-")
    thisalinea.textcontent.append("tion of the recoil nucleus can be speciﬁed. Since the target nucleus is described by")
    thisalinea.textcontent.append("|0(cid:105) (including the occupation numbers of Table 2.1), the ﬁnal pieces needed are the")
    thisalinea.textcontent.append("wave functions of the 3He beam particle and the 3H ejectile. These wave functions")
    thisalinea.textcontent.append("were taken to be the 0s model space of Ref. [54]. Since our interest is mainly in the")
    thisalinea.textcontent.append("nuclear structure of the target and the recoil nucleus, this limitation to the 0s model")
    thisalinea.textcontent.append("space can be aﬀorded. This limitation was also used in the computations of Ref. [35].")
    thisalinea.textcontent.append("The normal-modes formalism provides amplitudes (X-coeﬃcients in Equation (2.7))")
    thisalinea.textcontent.append("that represent the most coherent superposition of 1p1h states. As a result, the")
    thisalinea.textcontent.append("excitation-energy spectrum of the recoil nucleus is basically assumed to consist of one")
    thisalinea.textcontent.append("single state containing the maximal non-energy weighted strength associated with")
    thisalinea.textcontent.append("the operator ˆO and with the model space provided. This maximal strength is usually")
    thisalinea.textcontent.append("described by a (non-energy-weighted) sum rule for ˆO [5].")
    thisalinea.textcontent.append("Obviously, this normal-modes formalism is a simpliﬁcation of reality. The excitation-")
    thisalinea.textcontent.append("energy spectrum will usually contain (many) diﬀerent states associated with ˆO. The")
    thisalinea.textcontent.append("sum-rules for Fermi and Gamow-Teller transitions are given by the following equa-")
    thisalinea.textcontent.append("tions: [13].")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("BE∗ (F−) −")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("BE∗ (F+) = |N − Z|, (2.8)")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("BE∗ (GT−) −")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("BE∗ (GT+) = 3|N − Z|, (2.9)")
    thisalinea.textcontent.append("where the sum (cid:80)")
    thisalinea.textcontent.append("excitation-energy spectrum of the recoil nucleus. Note that for our (3He, t) charge-")
    thisalinea.textcontent.append("exchange reactions, the contribution of B(F+) values is zero and the contribution of")
    thisalinea.textcontent.append("B(GT+) values is small [13]. See Section 5.3 for how small these numbers actually")
    thisalinea.textcontent.append("are for the isotopes of interest in this work.")
    thisalinea.textcontent.append("Since we are only interested in ﬁtting the experimental data to a theoretical distri-")
    thisalinea.textcontent.append("bution of the diﬀerential cross section (see Section 2.1), it is possible to construct")
    thisalinea.textcontent.append("the recoil wave function according to the normal-modes formalism and, hence, obtain")
    thisalinea.textcontent.append("a diﬀerential cross section corresponding to 100% of the sum rule. This diﬀerential")
    thisalinea.textcontent.append("cross section can then be normalized to the experimental data, so that the B(GT )")
    thisalinea.textcontent.append("values for the populated level can be deduced.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.4 Calculation of the form factor"
    thisalinea.nativeID = 14
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "Now that the full nuclear wave functions for all nuclei in the (3He, t) charge-exchange reaction have been constructed as outlined in Section 2.3, we can construct the in- teraction potential of the reaction. This is done by double folding the interaction potential between individual nucleons over all nuclei involved [35]. To model the interaction potential between two individual nucleons, the Love and Franey nucleon-nucleon potential with tensor interaction and with the zero-range ex- change approximation was used [4, 40]. The double folding is now done by projecting this potential on the full nuclear wave functions involved in the reaction "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Now that the full nuclear wave functions for all nuclei in the (3He, t) charge-exchange")
    thisalinea.textcontent.append("reaction have been constructed as outlined in Section 2.3, we can construct the in-")
    thisalinea.textcontent.append("teraction potential of the reaction. This is done by double folding the interaction")
    thisalinea.textcontent.append("potential between individual nucleons over all nuclei involved [35].")
    thisalinea.textcontent.append("To model the interaction potential between two individual nucleons, the Love and")
    thisalinea.textcontent.append("Franey nucleon-nucleon potential with tensor interaction and with the zero-range ex-")
    thisalinea.textcontent.append("change approximation was used [4, 40]. The double folding is now done by projecting")
    thisalinea.textcontent.append("this potential on the full nuclear wave functions involved in the reaction [5]. This")
    thisalinea.textcontent.append("projection is described by:")
    thisalinea.textcontent.append("F ((cid:126)r) =")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("(cid:104)3H ⊗ Ψrecoil|V (i, j)|3He ⊗ 0(cid:105) , (2.10)")
    thisalinea.textcontent.append("where (cid:126)r is the distance between the projectile (ejectile) and the target (recoil) nucleus,")
    thisalinea.textcontent.append("V (i, j) is the Love and Franey interaction potential between the i-th and j-th nucleon.")
    thisalinea.textcontent.append("Note that the interaction potential described by Equation (2.10) assumes that the")
    thisalinea.textcontent.append("charge-exchange reaction occurs as a one-step process [5]. In reality, this is only an")
    thisalinea.textcontent.append("accurate description when the beam energy is above 100 MeV/u [5], but this poses no")
    thisalinea.textcontent.append("problem, since our reaction occurs at 140 MeV/u. The sum runs over the A nucleons")
    thisalinea.textcontent.append("of the target and the 3 nucleons of the beam. |3He ⊗ 0(cid:105) is the direct product of the")
    thisalinea.textcontent.append("wave function of the beam |3He(cid:105) and the ground-state wave function of the target |0(cid:105)")
    thisalinea.textcontent.append("(with the ground-state correlations for neutrons included), both introduced in Section")
    thisalinea.textcontent.append("2.3. Likewise, |3H ⊗ Ψrecoil(cid:105) is the direct product of the ejectile wave function and the")
    thisalinea.textcontent.append("recoil wave function constructed in Equation (2.7). If the operator V (i, j) is applied")
    thisalinea.textcontent.append("to the wave function |3He ⊗ 0(cid:105) and the matrix element is computed, all coordinates")
    thisalinea.textcontent.append("of all involved nucleons are integrated out, except the position vector (cid:126)r (introduced")
    thisalinea.textcontent.append("at the beginning of this paragraph) from the centre of the target nucleus to the centre")
    thisalinea.textcontent.append("of the beam nucleus [5].")
    thisalinea.textcontent.append("The resulting quantity F ((cid:126)r) is known as the form factor of the reaction [5]. The")
    thisalinea.textcontent.append("computation of the form factor was performed by the FOLD-module, which requires")
    thisalinea.textcontent.append("the single-particle wave functions computed by the WSAW-module for the target")
    thisalinea.textcontent.append("and recoil nucleus, the single-particle wave functions of the beam and ejectile, the")
    thisalinea.textcontent.append("X-coeﬃcients of the normal-modes formalism, computed by the program NORMOD,")
    thisalinea.textcontent.append("and the quantum numbers ∆L, ∆S, ∆J, ∆T and ∆Tz of the transition as inputs.")
    thisalinea.textcontent.append("A description of the Love and Franey nucleon-nucleon potential is included into the")
    thisalinea.textcontent.append("FOLD-module, which computes F ((cid:126)r) with (cid:126)r deﬁned in the centre-of-mass frame.")
    thisalinea.textcontent.append("Since a neutron is exchanged for a proton, our form factors will always have ∆Tz = −1.")
    thisalinea.textcontent.append("However, for (3He, t) charge-exchange reactions, all possible changes in the total")
    thisalinea.textcontent.append("isospin ∆T = 1, 0, −1 contribute to the reaction [13]. Therefore, we repeated the")
    thisalinea.textcontent.append("calculation of the form factor using the FOLD-module for all three possible changes")
    thisalinea.textcontent.append("in total isospin ∆T and observed that the diﬀerences in the ﬁnal answers were neg-")
    thisalinea.textcontent.append("ligible. Therefore, we decided to take only the dominant contribution along in our")
    thisalinea.textcontent.append("further analysis. This dominant contribution is ∆T = ∆Tz, except in the situation of")
    thisalinea.textcontent.append("the Isobaric Analogue State (a Fermi transition) discussed in the end of Section 4.3.")
    thisalinea.textcontent.append("There, it is ∆T = 0 [13].")
    thisalinea.textcontent.append("The form factor is required to compute the diﬀerential cross section of the (3He, t)")
    thisalinea.textcontent.append("charge-exchange reaction. This will be discussed in the next section in the frame-")
    thisalinea.textcontent.append("work of the Distorted-Wave Born Approximation (DWBA). Since the form factor")
    thisalinea.textcontent.append("involves the wave function |Ψrecoil(cid:105), which was constructed from the transition opera-")
    thisalinea.textcontent.append("tor ˆO through the normal-modes formalism, diﬀerent transition types will all require")
    thisalinea.textcontent.append("a computation of their own form factor.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.5 The Distorted-Wave Born Approximation"
    thisalinea.nativeID = 15
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "The simplest method to compute the diﬀerential cross section from the form factor F ((cid:126)r) is the Plane-Wave Born Approximation (PWBA) [45]. In the PWBA, the form factor F ((cid:126)r) is projected onto an incoming and an outgoing plane wave to compute the transfer matrix element T . The transfer matrix element is deﬁned as: [5, 45]. T = (cid:104)φf ((cid:126)kf , (cid:126)r)|F ((cid:126)r)|φi((cid:126)ki, (cid:126)r)(cid:105) , (2.11) where φi and φf are plane waves describing the incoming beam nucleus and the outgoing ejectile, respectively. Their expressions are given by: φi((cid:126)ki, (cid:126)r) = ei(cid:126)ki·(cid:126)r, φf ((cid:126)kf , (cid:126)r) = ei(cid:126)kf ·(cid:126)r, "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The simplest method to compute the diﬀerential cross section from the form factor")
    thisalinea.textcontent.append("F ((cid:126)r) is the Plane-Wave Born Approximation (PWBA) [45]. In the PWBA, the form")
    thisalinea.textcontent.append("factor F ((cid:126)r) is projected onto an incoming and an outgoing plane wave to compute")
    thisalinea.textcontent.append("the transfer matrix element T . The transfer matrix element is deﬁned as: [5, 45].")
    thisalinea.textcontent.append("T = (cid:104)φf ((cid:126)kf , (cid:126)r)|F ((cid:126)r)|φi((cid:126)ki, (cid:126)r)(cid:105) , (2.11)")
    thisalinea.textcontent.append("where φi and φf are plane waves describing the incoming beam nucleus and the")
    thisalinea.textcontent.append("outgoing ejectile, respectively. Their expressions are given by:")
    thisalinea.textcontent.append("φi((cid:126)ki, (cid:126)r) = ei(cid:126)ki·(cid:126)r, φf ((cid:126)kf , (cid:126)r) = ei(cid:126)kf ·(cid:126)r, (2.12)")
    thisalinea.textcontent.append("where (cid:126)ki is the momentum vector (in reduced mass) of the incident beam divided by")
    thisalinea.textcontent.append("(cid:126) and (cid:126)kf is the momentum vector (in reduced mass) of the outgoing ejectile divided")
    thisalinea.textcontent.append("by (cid:126). The computation of T will then integrate out any dependence on (cid:126)r, but will still")
    thisalinea.textcontent.append("depend on (cid:126)ki and (cid:126)kf . We chose to evaluate the result in the centre-of-mass frame in")
    thisalinea.textcontent.append("which (cid:126)ki // ˆz. In this frame, (cid:126)ki is completely described by the incident beam energy Ei.")
    thisalinea.textcontent.append("Conservation of momentum then prescribes that (cid:126)kf is fully speciﬁed by its azimuthal")
    thisalinea.textcontent.append("angle φ, its polar angle θ and the excitation energy E∗ of the recoil nucleus. Hence,")
    thisalinea.textcontent.append("for a speciﬁc transition in a speciﬁc experiment, Ei and E∗ are known and T only")
    thisalinea.textcontent.append("depends on θ and φ.")
    thisalinea.textcontent.append("Once the transition matrix element T is known, the diﬀerential cross section is given")
    thisalinea.textcontent.append("by:")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("=")
    thisalinea.textcontent.append("EEnt · Eexit")
    thisalinea.textcontent.append("4π2(cid:126)4c4 ·")
    thisalinea.textcontent.append("|(cid:126)kf |")
    thisalinea.textcontent.append("|(cid:126)ki|")
    thisalinea.textcontent.append("· |T |2, (2.13)")
    thisalinea.textcontent.append("where EEnt is the reduced total energy of the beam nucleus and the target nucleus")
    thisalinea.textcontent.append("and Eexit is the reduced total energy of the recoil and ejectile nucleus (total energy")
    thisalinea.textcontent.append("being the time component of the particles 4-momentum). In the limit of low beam")
    thisalinea.textcontent.append("energy, both reduced energies approach µc2 where µ is the reduced mass of the beam")
    thisalinea.textcontent.append("and the target. This low-energy form of Equation (2.13) can be found in Ref. [5], but")
    thisalinea.textcontent.append("the FOLD-program uses the general formulation, which is identical to our Equation")
    thisalinea.textcontent.append("(2.13).")
    thisalinea.textcontent.append("In the situation that the beam and the target are unpolarized, the whole system of")
    thisalinea.textcontent.append("the reaction is symmetric in φ and the diﬀerential cross section will only depend on")
    thisalinea.textcontent.append("the scattering angle α, which is equivalent to the polar angle θ introduced above.")
    thisalinea.textcontent.append("However, we choose to denote this angle with α from now on, since in Chapter 4, θ")
    thisalinea.textcontent.append("will be used to label a diﬀerent angle.")
    thisalinea.textcontent.append("The computation of T through the plane waves of Equation (2.12) will only give a")
    thisalinea.textcontent.append("realistic description of the diﬀerential cross section in the case that the beam and the")
    thisalinea.textcontent.append("ejectile can be described by plane waves, which is generally not the case. The wave")
    thisalinea.textcontent.append("function of the beam will be distorted by the presence of the target and the wave")
    thisalinea.textcontent.append("function of the ejectile will be distorted by the presence of the recoil nucleus. The")
    thisalinea.textcontent.append("Distorted-Wave Born Approximation (DWBA) is a method to take these distortions")
    thisalinea.textcontent.append("into account through the so-called optical model [5].")
    thisalinea.textcontent.append("The DWBA method is completely identical to the PWBA method, except that the")
    thisalinea.textcontent.append("wave functions φi((cid:126)ki, (cid:126)r) and φf ((cid:126)kf , (cid:126)r) are no longer described by Equation (2.12), but")
    thisalinea.textcontent.append("are now deﬁned as solutions of the Sch¨odinger equations:")
    thisalinea.textcontent.append("(cid:18) −(cid:126)2")
    thisalinea.textcontent.append("2µi")
    thisalinea.textcontent.append("(cid:126)∇2 + Ui((cid:126)r)")
    thisalinea.textcontent.append("(cid:19)")
    thisalinea.textcontent.append("φi = Ei · φi,")
    thisalinea.textcontent.append("(cid:18) −(cid:126)2")
    thisalinea.textcontent.append("2µf")
    thisalinea.textcontent.append("(cid:126)∇2 + Uf ((cid:126)r)")
    thisalinea.textcontent.append("(cid:19)")
    thisalinea.textcontent.append("φf = Ef · φf , (2.14)")
    thisalinea.textcontent.append("where µi is the reduced mass of the beam and the target and µf is the reduced mass of")
    thisalinea.textcontent.append("the ejectile and the recoil nucleus. The optical model now states that the distortions")
    thisalinea.textcontent.append("can be taken into account through the eﬀects of the optical potentials Ui((cid:126)r) and Uf ((cid:126)r)")
    thisalinea.textcontent.append("in Equation (2.14) [5]. In the case that both of these optical potentials (including")
    thisalinea.textcontent.append("Coulomb eﬀects) equal zero, the DWBA reduces to the PWBA.")
    thisalinea.textcontent.append("In our calculations, cross sections were computed with optical potentials as described")
    thisalinea.textcontent.append("by the following:")
    thisalinea.textcontent.append("U ((cid:126)r) = VC(r) +")
    thisalinea.textcontent.append("−VR")
    thisalinea.textcontent.append("1 + e(r−rRA1/3)/aR")
    thisalinea.textcontent.append("+")
    thisalinea.textcontent.append("−iVI")
    thisalinea.textcontent.append("1 + e(r−rI A1/3)/aI")
    thisalinea.textcontent.append("+ (2.15)")
    thisalinea.textcontent.append("−4iWse(r−rI A1/3)/aI")
    thisalinea.textcontent.append("(1 + e(r−rI A1/3)/aI )2")
    thisalinea.textcontent.append("ZpZT e2")
    thisalinea.textcontent.append("4π(cid:15)0")
    thisalinea.textcontent.append("3")
    thisalinea.textcontent.append("2rCA1/3")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("r")
    thisalinea.textcontent.append("· (")
    thisalinea.textcontent.append("−")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("ZpZT e2")
    thisalinea.textcontent.append("4π(cid:15)0")
    thisalinea.textcontent.append("VC(r) =")
    thisalinea.textcontent.append("VC(r) =")
    thisalinea.textcontent.append("with r = |(cid:126)r|,")
    thisalinea.textcontent.append("if r > rCA1/3 and")
    thisalinea.textcontent.append("r2")
    thisalinea.textcontent.append("2ArC")
    thisalinea.textcontent.append("where Zp is the number of protons of the beam (projectile) nucleus, ZT is the number")
    thisalinea.textcontent.append("of protons in the target nucleus, A is the mass number of the target nucleus, e is the")
    thisalinea.textcontent.append("elementary charge and 1/4π(cid:15)0 is the electromagnetic constant. The precise optical")
    thisalinea.textcontent.append("potential is then described by a total set of parameters {rC, VR, rR, aR, VI , rI , aI , WS}.")
    thisalinea.textcontent.append("The parameters {VR, VI , WS} have the dimension of energy (usually MeV) and the")
    thisalinea.textcontent.append("other parameters have the dimension of distance (usually fm).")
    thisalinea.textcontent.append("The ﬁrst term in Equation (2.15) is the Coulomb term. It takes the eﬀects of the")
    thisalinea.textcontent.append("Coulomb repulsion between the nuclei into account. Hence, this term is positive.")
    thisalinea.textcontent.append("The second and third terms are real and imaginary Woods-Saxon potentials that take")
    thisalinea.textcontent.append("the eﬀects of the strong nuclear force into account. These terms are attractive and")
    thisalinea.textcontent.append("absorptive, respectively, which is why these terms are negative. Optical potentials")
    thisalinea.textcontent.append("containing only the ﬁrst three terms of Equation (2.15) have been established to")
    thisalinea.textcontent.append("provide a reasonable agreement with experimental data [5, 11, 13, 35, 59]. The fourth")
    thisalinea.textcontent.append("term in Equation (2.15) is known as an imaginary surface potential and will be used")
    thisalinea.textcontent.append("to ﬁne-tune the agreement with our data, as this agreement is usually not perfect")
    thisalinea.textcontent.append("[13].")
    thisalinea.textcontent.append("The parameters of the optical potential are usually obtained by an optical-model")
    thisalinea.textcontent.append("ﬁt to elastic scattering cross sections [46]. However, much of these measurements")
    thisalinea.textcontent.append("for 3He beams were performed in the energy regime below 73 MeV/u (see Ref. [46]")
    thisalinea.textcontent.append("and references therein), while our experiment was performed at 140 MeV/u. At this")
    thisalinea.textcontent.append("energy, optical potentials have only been obtained for a 3He beam and for a few")
    thisalinea.textcontent.append("diﬀerent target nuclei [60, 61]. Unfortunately, the nuclei of interest (116Sn and 122Sn)")
    thisalinea.textcontent.append("are not among them. Therefore, the parameters of the optical potential were obtained")
    thisalinea.textcontent.append("by interpolating the known parameters of the nuclei measured in Refs. [60] and [61].")
    thisalinea.textcontent.append("These parameters are listed in Table 2.2.")
    thisalinea.textcontent.append("We would like to emphasize at this point, that a calculation of the distortion factors")
    thisalinea.textcontent.append("N D")
    thisalinea.textcontent.append("this choice of the optical potential and its parameters. The distortion factors N D")
    thisalinea.textcontent.append("and N D")
    thisalinea.textcontent.append("them as the ratio of the DWBA result to the PWBA result (at α = 0) is not model-")
    thisalinea.textcontent.append("independent. This is the reason why calculated values of distortion factors may carry")
    thisalinea.textcontent.append("uncertainties up to 20% [13].")
    thisalinea.textcontent.append("Table 2.2: Optical-potential parameters for various nuclei; used with permission [60,")
    thisalinea.textcontent.append("61]. rC = 1.25 fm in all cases.")
    thisalinea.textcontent.append("Nucleus A1/3 VR[MeV] rR[fm] aR[fm] VI [MeV] rI [fm] aI [fm] Ws[MeV]")
    thisalinea.textcontent.append("regression line for the parameter of interest versus A1/3.")
    thisalinea.textcontent.append("The interpolation illustrated in Table 2.2 was performed by plotting A1/3 against")
    thisalinea.textcontent.append("the parameter of interest and ﬁtting a straight line through the data-points. This")
    thisalinea.textcontent.append("procedure has proven successful in Refs. [13, 35, 59]. The parameters of the nuclei")
    thisalinea.textcontent.append("of Ref. [35] by reﬁtting the optical potential to the data of Ref. [60]. This is marked")
    thisalinea.textcontent.append("by a b in Table 2.2. The other parameters (marked by an a) were taken directly from")
    thisalinea.textcontent.append("Ref. [61]. The parameters interpolated for the nuclei of interest are marked with a c")
    thisalinea.textcontent.append("in Table 2.2. A Coulomb radius rC = 1.25 fm was assumed for all of our calculations")
    thisalinea.textcontent.append("in agreement with the analysis procedures of Ref. [35].")
    thisalinea.textcontent.append("During the ﬁtting procedures used to obtain the optical potential parameters in the")
    thisalinea.textcontent.append("ﬁrst ﬁve rows of Table 2.2, Ws was ﬁxed to zero (see the references of Table 2.2 for")
    thisalinea.textcontent.append("more details). However, since a pure interpolation of those parameters could not")
    thisalinea.textcontent.append("provide a good agreement with our data, we chose to ﬁt Ws to our data and obtained")
    thisalinea.textcontent.append("a value of Ws = 12 MeV (see Chapter 4). The other optical potential parameters")
    thisalinea.textcontent.append("were kept ﬁxed at their interpolation values during this ﬁtting, because not enough")
    thisalinea.textcontent.append("data-points were available for a combined ﬁt.")
    thisalinea.textcontent.append("Note that adjusting the value of Ws to match our data will only aﬀect the position")
    thisalinea.textcontent.append("of the minima in the computed angular distributions. The reason for this is, that")
    thisalinea.textcontent.append("the overall normalization of the computed distribution is scaled (ﬁtted) to the ex-")
    thisalinea.textcontent.append("perimental data. Since these minima are not located at α = 0 for the Gamow-Teller")
    thisalinea.textcontent.append("distributions and since we used the unit cross sections from Ref. [35], the obtained")
    thisalinea.textcontent.append("B(GT ) values will be largely unaﬀected by the value of Ws (this is demonstrated")
    thisalinea.textcontent.append("in Tables 4.2 and 4.3). However, we do need to adjust Ws to obtain a reasonable")
    thisalinea.textcontent.append("agreement with our data in the full range of α where measurements were performed")
    thisalinea.textcontent.append("(0 ≤ α ≤ 4.5◦).")
    thisalinea.textcontent.append("Table 2.2 only provides parameters for the optical potential Ui((cid:126)r) of the incoming wave")
    thisalinea.textcontent.append("φi((cid:126)ki, (cid:126)r). No data are available for optical potentials for a 3H beam in our energy")
    thisalinea.textcontent.append("regime, so we will follow the procedures of Refs. [5, 13, 35, 59] and take the same")
    thisalinea.textcontent.append("parameters for the optical potential Uf ((cid:126)r) of the outgoing wave φf ((cid:126)kf , (cid:126)r) with the")
    thisalinea.textcontent.append("only diﬀerence that VI and VR (and Ws) are scaled by a factor 0.85. This procedure")
    thisalinea.textcontent.append("was ﬁrst suggested in Ref. [62].")
    thisalinea.textcontent.append("The DWBA calculation was performed by the DWHI-module of the FOLD program")
    thisalinea.textcontent.append("introduced earlier. The DWHI-module requires the parameters of the optical potential")
    thisalinea.textcontent.append("as inputs, the form factor calculated by the FOLD module, the incident beam energy")
    thisalinea.textcontent.append("and the sum of the Q-value of the ground state (which only depends on the masses")
    thisalinea.textcontent.append("of the nuclei involved) and the excitation energy E∗ of the recoil nucleus. Outcomes")
    thisalinea.textcontent.append("of the DWBA calculation will be illustrated in Figure 2.5 of the next section.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.6 Smearing"
    thisalinea.nativeID = 16
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "From the DWBA calculation of Section 2.5, the diﬀerential cross section dσ/dΩ versus the scattering angle α is obtained. However, the eﬀects of a detector will ‘blur’ the outcomes of the DWBA calculation. In this section, we discuss how this eﬀect should be taken into account. Mathematically, any detector output is a convolution of the physical signal with the characteristics of the detector. In our situation, the physical signal is the diﬀerential cross section as computed in DWBA and the characteristics of the detector are rep- resented by an angular resolution. Since the diﬀerential cross section represents the count rate "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("From the DWBA calculation of Section 2.5, the diﬀerential cross section dσ/dΩ versus")
    thisalinea.textcontent.append("the scattering angle α is obtained. However, the eﬀects of a detector will ‘blur’ the")
    thisalinea.textcontent.append("outcomes of the DWBA calculation. In this section, we discuss how this eﬀect should")
    thisalinea.textcontent.append("be taken into account.")
    thisalinea.textcontent.append("Mathematically, any detector output is a convolution of the physical signal with the")
    thisalinea.textcontent.append("characteristics of the detector. In our situation, the physical signal is the diﬀerential")
    thisalinea.textcontent.append("cross section as computed in DWBA and the characteristics of the detector are rep-")
    thisalinea.textcontent.append("resented by an angular resolution. Since the diﬀerential cross section represents the")
    thisalinea.textcontent.append("count rate of the reaction, projected onto the unit sphere, convoluting the diﬀerential")
    thisalinea.textcontent.append("cross section with a 2D Gaussian for each point on this unit sphere will take the")
    thisalinea.textcontent.append("angular resolution of the detector into account (when the angular resolution is indeed")
    thisalinea.textcontent.append("Gaussian, which is what we have assumed). This procedure is illustrated in Figure")
    thisalinea.textcontent.append("2.4.")
    thisalinea.textcontent.append("Figure 2.4: Illustration of the smearing procedure for the DWBA result.")
    thisalinea.textcontent.append("The convolution of Figure 2.4 was evaluated in Cartesian coordinates x = α cos ξ and")
    thisalinea.textcontent.append("y = α sin ξ, where α is the polar angle and ξ is the azimuthal angle. The precise")
    thisalinea.textcontent.append("computation of the convolution is given by:")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)smeared")
    thisalinea.textcontent.append("(α) =")
    thisalinea.textcontent.append("(cid:90) ∞")
    thisalinea.textcontent.append("(cid:90) ∞")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)DWBA")
    thisalinea.textcontent.append("(x(cid:48)2 + y(cid:48)2) ·")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)smeared")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("2πσ2 · e− 1")
    thisalinea.textcontent.append("(x2 + y2) = (2.16)")
    thisalinea.textcontent.append("dx(cid:48)dy(cid:48),")
    thisalinea.textcontent.append("where dσ/dΩ|DWBA is the diﬀerential cross section computed with DWBA, which")
    thisalinea.textcontent.append("depends only on the polar angle α in the case of ﬁxed beam energy and excitation")
    thisalinea.textcontent.append("energy and in the case of unpolarized beams. Hence, dσ/dΩ|DWBA has no dependence")
    thisalinea.textcontent.append("on the azimuthal angle.")
    thisalinea.textcontent.append("It should be noted that in Equation (2.16), it was assumed that the horizontal and")
    thisalinea.textcontent.append("vertical angle resolutions are equal. We have also investigated scenarios where these")
    thisalinea.textcontent.append("resolutions are diﬀerent, but it appears to be possible to obtain the same smeared")
    thisalinea.textcontent.append("output with only one angular resolution (and with about 100 times faster CPU-time).")
    thisalinea.textcontent.append("This is a consequence of the symmetry in azimuthal angle discussed above and of the")
    thisalinea.textcontent.append("choice to use donut-shaped α-bins in our analysis procedure (see Figure 4.7c).")
    thisalinea.textcontent.append("We also would like to emphasize that when dσ/dΩ|DWBA has no dependence on the")
    thisalinea.textcontent.append("azimuthal angle and when only one angular resolution is considered (both assumptions")
    thisalinea.textcontent.append("are true for the present experiment), it can be shown that dσ/dΩ|smeared in Equation")
    thisalinea.textcontent.append("(2.16) has no dependence on the azimuthal angle either.")
    thisalinea.textcontent.append("In Equation (2.16), σ represents the angular resolution of the detector. Hence, with")
    thisalinea.textcontent.append("the right value for σ (see Subsection 4.4.3), the smeared diﬀerential cross section")
    thisalinea.textcontent.append("dσ/dΩ|smeared of Equation (2.16) can be directly ﬁtted to the experimental data.")
    thisalinea.textcontent.append("One should keep in mind that this result is evaluated in the centre-of-mass frame,")
    thisalinea.textcontent.append("which means that the experimental data should be transformed to the centre-of-mass")
    thisalinea.textcontent.append("frame before the ﬁt can be performed. The angular resolution of the detector in the")
    thisalinea.textcontent.append("centre-of-mass frame is 1.03 times that same resolution in the LAB-frame.")
    thisalinea.textcontent.append("The results of the DWBA calculation of Section 2.5 are illustrated in Figure 2.5 for")
    thisalinea.textcontent.append("the situation with and without the smearing of Equation (2.16). Figure 2.5 shows")
    thisalinea.textcontent.append("the diﬀerential cross sections for the 116Sn(3He, t)116Sb charge-exchange reaction at")
    thisalinea.textcontent.append("140 MeV/u with E∗ = 0 for the recoil nucleus. Diﬀerential cross sections have been")
    thisalinea.textcontent.append("computed for various transition types and the quantum numbers of these transitions")
    thisalinea.textcontent.append("are shown.")
    thisalinea.textcontent.append("Through this chapter, we have given special emphasis on Gamow-Teller transitions.")
    thisalinea.textcontent.append("However, as indicated in Section 2.3, the normal-modes formalism can be used to")
    thisalinea.textcontent.append("compute the diﬀerential cross section for any transition type. Furthermore, it will")
    thisalinea.textcontent.append("become clear in Chapter 4 that the diﬀerential cross sections of certain other transition")
    thisalinea.textcontent.append("types might also be required to obtain the B(GT ) values. This is the reason that other")
    thisalinea.textcontent.append("transition types are also shown in Figure 2.5.")
    thisalinea.textcontent.append("Figure 2.5: Diﬀerential cross sections near 0◦ for various transition types in the")
    thisalinea.textcontent.append("red lines indicate the result of the DWBA method without any smearing and the blue")
    thisalinea.textcontent.append("lines indicate the result with a smearing of σ = 0.20◦.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "2.7 Extrapolation to q = 0"
    thisalinea.nativeID = 17
    thisalinea.parentID = 10
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 6
    thisalinea.summary = "As mentioned in Section 2.1, the experimental cross sections need to be extrapolated to α = 0 and q = 0. After the smeared result of the DWBA calculation is ﬁtted to the experimental data through an overall normalization parameter (in the centre-of- mass frame), the diﬀerential cross section can be evaluated at α = 0. Let us denote this cross section by dσ/dΩ|ﬁtted(α = 0). Moreover, let us denote the pure DWBA (cid:12) outcome (after the smearing) as dσ (cid:12)smeared (α = 0). As indicated in Section 2.5, both the scattering angle α and the sum of the Q-value "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As mentioned in Section 2.1, the experimental cross sections need to be extrapolated")
    thisalinea.textcontent.append("to α = 0 and q = 0. After the smeared result of the DWBA calculation is ﬁtted to")
    thisalinea.textcontent.append("the experimental data through an overall normalization parameter (in the centre-of-")
    thisalinea.textcontent.append("mass frame), the diﬀerential cross section can be evaluated at α = 0. Let us denote")
    thisalinea.textcontent.append("this cross section by dσ/dΩ|ﬁtted(α = 0). Moreover, let us denote the pure DWBA")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("outcome (after the smearing) as dσ")
    thisalinea.textcontent.append("(cid:12)smeared (α = 0).")
    thisalinea.textcontent.append("As indicated in Section 2.5, both the scattering angle α and the sum of the Q-value")
    thisalinea.textcontent.append("of the ground state and the excitation energy E∗ of the recoil nucleus are needed")
    thisalinea.textcontent.append("as inputs to the DWBA calculation. With this calculation, one could approximate")
    thisalinea.textcontent.append("the (α = 0, q = 0) point by putting α = 0 and E∗ = −Q0, where Q0 denotes the Q-")
    thisalinea.textcontent.append("value of the ground state. Such an approximation is necessary, because a DWBA")
    thisalinea.textcontent.append("calculation with zero linear momentum transfer is not possible. This approximation")
    thisalinea.textcontent.append("technique has been commonly adopted [11, 13, 35]. We will denote the result of this")
    thisalinea.textcontent.append("approximation by dσ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)smeared,q=0 (α = 0).")
    thisalinea.textcontent.append("With these results, the experimental data can be extrapolated to q = 0 by means of")
    thisalinea.textcontent.append("the following relation [11, 35]:")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(α = 0, q = 0) =")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)smeared,q=0 (α = 0)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)smeared (α = 0)")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)ﬁtted")
    thisalinea.textcontent.append("(α = 0). (2.17)")
    thisalinea.textcontent.append("By performing computations for diﬀerent parameters and/or diﬀerent inputs, it was")
    thisalinea.textcontent.append("established that the ratio that the ﬁtted cross section is multiplied with in Equation")
    thisalinea.textcontent.append("(2.17), has an inaccuracy of about 1%. Some typical values for this ratio are listed in")
    thisalinea.textcontent.append("Table 5.5.")
    thisalinea.textcontent.append("Since Equation (2.17) oﬀers us the extrapolation needed in Equation (2.2), the Gamow-")
    thisalinea.textcontent.append("Teller B(GT ) values can now be calculated from the diﬀerential cross sections. For")
    thisalinea.textcontent.append("this, we now need to have experimental diﬀerential cross sections (see Chapters 3 and")
    thisalinea.textcontent.append("4).")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "3 Experimental Methods"
    thisalinea.nativeID = 18
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "As indicated in Section 2.1, the purpose of our experiment is to extract the B(GT )- values of the Gamow-Teller transitions in the 116,122Sn(3He, t)116,122Sb charge-exchange reactions. To induce the charge-exchange reaction, a 3He beam was impinged on a ﬁxed target of the Sn-isotope of interest. The 3He beam was given a dispersive proﬁle (see Section 3.4) and a mean energy of 140 MeV/u. The 116Sn target areal density was 1.87 ± 0.01 mg/cm2 and the 122Sn target areal density was 1.75 ± 0.01 mg/cm2. The isotope enrichment of both targets was above 95% [63]. The charge-exchange reaction produced a "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.1 Overview of the Experiment"
    thisalinea.nativeID = 19
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "As indicated in Section 2.1, the purpose of our experiment is to extract the B(GT )- values of the Gamow-Teller transitions in the 116,122Sn(3He, t)116,122Sb charge-exchange reactions. To induce the charge-exchange reaction, a 3He beam was impinged on a ﬁxed target of the Sn-isotope of interest. The 3He beam was given a dispersive proﬁle (see Section 3.4) and a mean energy of 140 MeV/u. The 116Sn target areal density was 1.87 ± 0.01 mg/cm2 and the 122Sn target areal density was 1.75 ± 0.01 mg/cm2. The isotope enrichment of both targets was above 95% [63]. The charge-exchange reaction produced a "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As indicated in Section 2.1, the purpose of our experiment is to extract the B(GT )-")
    thisalinea.textcontent.append("values of the Gamow-Teller transitions in the 116,122Sn(3He, t)116,122Sb charge-exchange")
    thisalinea.textcontent.append("reactions. To induce the charge-exchange reaction, a 3He beam was impinged on a")
    thisalinea.textcontent.append("ﬁxed target of the Sn-isotope of interest. The 3He beam was given a dispersive proﬁle")
    thisalinea.textcontent.append("(see Section 3.4) and a mean energy of 140 MeV/u. The 116Sn target areal density")
    thisalinea.textcontent.append("was 1.87 ± 0.01 mg/cm2 and the 122Sn target areal density was 1.75 ± 0.01 mg/cm2.")
    thisalinea.textcontent.append("The isotope enrichment of both targets was above 95% [63].")
    thisalinea.textcontent.append("The charge-exchange reaction produced a tritium nucleus as ejectile (triton) and a")
    thisalinea.textcontent.append("recoil Sb-nucleus. The recoil nucleus was not measured. The tritons’ full momentum")
    thisalinea.textcontent.append("vectors were measured by the Grand Raiden Spectrometer [64]. The 3He incident mo-")
    thisalinea.textcontent.append("mentum vector was known. Therefore, the momentum vector of the recoil Sb-nucleus")
    thisalinea.textcontent.append("could be fully reconstructed. This provided us with a full kinematic reconstruction")
    thisalinea.textcontent.append("of the collision.")
    thisalinea.textcontent.append("The excitation-energy spectrum of the recoil nucleus was then obtained from this")
    thisalinea.textcontent.append("kinematic reconstruction. Once the excitation-energy spectrum is known, the diﬀer-")
    thisalinea.textcontent.append("ential cross section versus the scattering angle was extracted for the states in this")
    thisalinea.textcontent.append("spectrum (see Chapter 4). Gamow-Teller transitions were identiﬁed by selecting the")
    thisalinea.textcontent.append("∆L = 0 states. Identiﬁcation of ∆L = 0 alone is enough, since the experiment is a")
    thisalinea.textcontent.append("charge-exchange reaction and, therefore, ∆Tz = −1 is implied for the entire spectrum.")
    thisalinea.textcontent.append("In Chapter 4, it will be explained that for ∆L = 0, all states but one have ∆S = 1 (for")
    thisalinea.textcontent.append("the excitation energies that we could measure). Once a Gamow-Teller transition was")
    thisalinea.textcontent.append("identiﬁed in the excitation-energy spectrum, the B(GT )-value was obtained according")
    thisalinea.textcontent.append("to the procedures of Chapter 2.")
    thisalinea.textcontent.append("In this chapter, the details of the measurement procedure used to obtain the momen-")
    thisalinea.textcontent.append("tum vectors of the tritons with the Grand Raiden Spectrometer will be discussed. In")
    thisalinea.textcontent.append("Section 3.2, the characteristics of the Grand Raiden Spectrometer are discussed and")
    thisalinea.textcontent.append("Section 3.3 will focus on the focal-plane detectors of Grand Raiden. In Section 3.4,")
    thisalinea.textcontent.append("the dispersive beam proﬁle used during the experiment is discussed. Subsequently,")
    thisalinea.textcontent.append("the optical properties of Grand Raiden are discussed in Section 3.5 and the data-")
    thisalinea.textcontent.append("acquisition system is discussed in Section 3.6. Finally, the conversion to a ROOT")
    thisalinea.textcontent.append("data format is discussed in Section 3.7.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.2 The Grand Raiden Spectrometer"
    thisalinea.nativeID = 20
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "A schematic overview of the Grand Raiden Spectrometer [64] at the RCNP facility [65] in Osaka, Japan, is displayed in Figure 3.1. The 3He-beam at an energy of 140 MeV/u, indicated in the ﬁgure by ‘Primary beam’, is produced by the AVF and RING cyclotrons [65, 66] and transported to the Grand Raiden Spectrometer through the high-resolution beam line [67, 68]. This high-resolution beam line (called ‘WS course’) is specially designed to apply the lateral and angular dispersion-matching technique to the primary beam. These techniques are discussed in Section 3.4. A schematic overview of the facility and the beam lines "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("A schematic overview of the Grand Raiden Spectrometer [64] at the RCNP facility")
    thisalinea.textcontent.append("[65] in Osaka, Japan, is displayed in Figure 3.1. The 3He-beam at an energy of")
    thisalinea.textcontent.append("140 MeV/u, indicated in the ﬁgure by ‘Primary beam’, is produced by the AVF and")
    thisalinea.textcontent.append("RING cyclotrons [65, 66] and transported to the Grand Raiden Spectrometer through")
    thisalinea.textcontent.append("the high-resolution beam line [67, 68]. This high-resolution beam line (called ‘WS")
    thisalinea.textcontent.append("course’) is specially designed to apply the lateral and angular dispersion-matching")
    thisalinea.textcontent.append("technique to the primary beam. These techniques are discussed in Section 3.4. A")
    thisalinea.textcontent.append("schematic overview of the facility and the beam lines is shown in Figure 3.2.")
    thisalinea.textcontent.append("The entire Grand Raiden Spectrometer can be rotated around the target to any de-")
    thisalinea.textcontent.append("sired angle between 0◦ and 70◦. Figure 3.1 shows the spectrometer in the 0◦ position.")
    thisalinea.textcontent.append("This position accepts particles with a horizontal scattering angle of 0◦ ± 1.15◦ [64].")
    thisalinea.textcontent.append("In our experiments, the 0◦ and 2.5◦ positions were used. The 2.5◦ position accepts")
    thisalinea.textcontent.append("particles with a horizontal scattering angle of 2.5◦ ± 1.15◦. The accepted vertical")
    thisalinea.textcontent.append("scattering angle is always 0◦ ± 4.0◦ [64]. The total acceptance of the spectrometer")
    thisalinea.textcontent.append("has the shape of an ellipse [64].")
    thisalinea.textcontent.append("The most important parts of the Grand Raiden Spectrometer are the two dipole mag-")
    thisalinea.textcontent.append("nets (see Figure 3.1). These dipole magnets bend tritons with diﬀerent energies over")
    thisalinea.textcontent.append("diﬀerent angles. This phenomenon is known as dispersion. Grand Raiden is designed")
    thisalinea.textcontent.append("to have a large dispersion (D = 15.5 m, [70]) to provide an adequate momentum sep-")
    thisalinea.textcontent.append("aration of the tritons. The momentum-separated tritons are detected at the focal")
    thisalinea.textcontent.append("plane, where their position and angle of incidence are recorded. Due to the momen-")
    thisalinea.textcontent.append("tum separation, this position and angle of incidence can be translated back to the")
    thisalinea.textcontent.append("original momentum of the tritons. The position and angle of incidence are measured")
    thisalinea.textcontent.append("by two wire chambers called MWDC1 and MWDC2 and two scintillators called PS1")
    thisalinea.textcontent.append("and PS2. These detectors are discussed in more detail in the next section.")
    thisalinea.textcontent.append("The Dipole magnet for Spin Rotation (DRS) can serve to identify the polarization")
    thisalinea.textcontent.append("of the tritons [66]. However, since we are not interested in the polarization of the")
    thisalinea.textcontent.append("tritons, an unpolarized beam was used in our experiment and DRS was not used.")
    thisalinea.textcontent.append("The combination of quadrupole magnets in Grand Raiden is used to keep the tritons")
    thisalinea.textcontent.append("focused, so they are directed to the focal plane in the appropriate way. The sextupole")
    thisalinea.textcontent.append("magnet and the multipole magnet are used to correct aberrations. Aberrations are")
    thisalinea.textcontent.append("irregularities in the optics of the spectrometer (the focusing of the tritons) [71]. The")
    thisalinea.textcontent.append("optics of the spectrometer are discussed in more detail in Section 3.5.")
    thisalinea.textcontent.append("The dipole magnets are tuned in such a way that the tritons are deﬂected towards")
    thisalinea.textcontent.append("the focal plane (see Section 3.4). Other light particles, having distinctly diﬀerent")
    thisalinea.textcontent.append("charge-to-mass ratios, are less magnetically rigid than tritons and will, therefore, not")
    thisalinea.textcontent.append("be bent to the focal plane. Heavier particles with the charge-to-mass ratio of tritons")
    thisalinea.textcontent.append("can be produced but with lower energies than the tritons. Therefore, they will not be")
    thisalinea.textcontent.append("bent towards the focal planes either.")
    thisalinea.textcontent.append("Figure 3.1: Overview of the Grand Raiden Spectrometer at 0◦; ﬁgure was adapted")
    thisalinea.textcontent.append("from Ref. [66] according to Ref. [69] and used with permission.")
    thisalinea.textcontent.append("However, two other particles in the spectrometer (besides the tritons) deserve some")
    thisalinea.textcontent.append("attention: 3He2+ and 3He+. 3He2+ is the unreacted beam passing through the target.")
    thisalinea.textcontent.append("When Grand Raiden is in the 0◦ position, both the tritons and the 3He2+ will follow")
    thisalinea.textcontent.append("the same initial trajectory. However, since 3He2+ particles have double the charge of")
    thisalinea.textcontent.append("a triton but about the same mass, their bending in the ﬁrst dipole magnet ensures")
    thisalinea.textcontent.append("that they are easily separated. At the 0◦ position, a Faraday Cup (called D1FC)")
    thisalinea.textcontent.append("inside the ﬁrst dipole magnet was used to stop the 3He2+ ions immediately after this")
    thisalinea.textcontent.append("separation and to collect their charge. However, due to the lateral spread in the beam")
    thisalinea.textcontent.append("proﬁle (see Section 3.4), this charge-collection is not perfect (although the separation")
    thisalinea.textcontent.append("is). During the experiment in Ref. [72], the eﬃciency of this charge-collection was")
    thisalinea.textcontent.append("determined to be about 80%.")
    thisalinea.textcontent.append("When Grand Raiden is in the 2.5◦ position, the tritons and the unreacted 3He2+")
    thisalinea.textcontent.append("follow diﬀerent initial trajectories. Therefore, a Faraday Cup (called Q1FC) behind")
    thisalinea.textcontent.append("Figure 3.2: Overview of the experimental facility at RCNP; ﬁgure used with permis-")
    thisalinea.textcontent.append("sion [66].")
    thisalinea.textcontent.append("the ﬁrst quadrupole magnet was used in this situation to stop the unreacted 3He2+.")
    thisalinea.textcontent.append("Due to the distinct diﬀerence in initial trajectories, the stopping of the Q1FC can be")
    thisalinea.textcontent.append("assumed to be 100%.")
    thisalinea.textcontent.append("The 3He+ ions are particles from the unreacted beam that picked up an electron in")
    thisalinea.textcontent.append("the target. Due to this electron, the mass and charge of 3He+ are virtually identical")
    thisalinea.textcontent.append("to that of a triton. However, since 3He+ did not undergo a nuclear reaction, these")
    thisalinea.textcontent.append("particles all follow the initial trajectory of a triton with a scattering angle of 0◦ (up")
    thisalinea.textcontent.append("to the beam resolution, see Section 3.4). They are, therefore, stopped by the material")
    thisalinea.textcontent.append("of the sextupole magnet when Grand Raiden is in the 2.5◦ position. When Grand")
    thisalinea.textcontent.append("Raiden is in the 0◦ position, the 3He+ can be used to track and tune the beam, since")
    thisalinea.textcontent.append("in our experiment, it was easily identiﬁed in the excitation-energy spectrum by its")
    thisalinea.textcontent.append("abundance (see Chapter 4).")
    thisalinea.textcontent.append("The design parameters of the Grand Raiden Spectrometer are summarized in Table")
    thisalinea.textcontent.append("3.1.")
    thisalinea.textcontent.append("Table 3.1: Design parameters of Grand Raiden; table used with permission [64].")
    thisalinea.textcontent.append("Mean orbit radius 3 m")
    thisalinea.textcontent.append("Total deﬂection angle 162◦")
    thisalinea.textcontent.append("Angular range 0◦ − 90◦")
    thisalinea.textcontent.append("Focal plane length 150 cm")
    thisalinea.textcontent.append("Tilting angle of focal line 45◦")
    thisalinea.textcontent.append("Maximum magnetic ﬁeld strength 18 kG")
    thisalinea.textcontent.append("Maximum particle rigidity 54 kG-m")
    thisalinea.textcontent.append("Vertical magniﬁcation My 5.98")
    thisalinea.textcontent.append("Horizontal magniﬁcation Mx −0.417")
    thisalinea.textcontent.append("Momentum dispersion D 15451 mm")
    thisalinea.textcontent.append("Momentum range 5 %")
    thisalinea.textcontent.append("Momentum resolution p/∆p = 37076")
    thisalinea.textcontent.append("Horizontal angular acceptance ±20 mrad")
    thisalinea.textcontent.append("Vertical angular acceptance ±70 mrad")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.3 Focal-Plane Readout system"
    thisalinea.nativeID = 21
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "The focal-plane readout system consists in our experiment of two parts: the standard focal-plane wire chambers called MWDC1 and MWDC2 (see below) and the two plastic scintillator counters called PS1 and PS2. The purpose of the scintillators PS1 and PS2 is to provide a trigger signal for the MWDCs (see Section 3.6). However, the data obtained by PS1 and PS2 were also stored for further analysis (the main usage of these data is particle Z-identiﬁcation). The scintillators PS1 and PS2 were located downstream of the MWDCs [66, 73, 74]. The two identical Multi-wire Drift Chamber (MWDC) detectors are the most "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The focal-plane readout system consists in our experiment of two parts: the standard")
    thisalinea.textcontent.append("focal-plane wire chambers called MWDC1 and MWDC2 (see below) and the two")
    thisalinea.textcontent.append("plastic scintillator counters called PS1 and PS2. The purpose of the scintillators PS1")
    thisalinea.textcontent.append("and PS2 is to provide a trigger signal for the MWDCs (see Section 3.6). However, the")
    thisalinea.textcontent.append("data obtained by PS1 and PS2 were also stored for further analysis (the main usage")
    thisalinea.textcontent.append("of these data is particle Z-identiﬁcation). The scintillators PS1 and PS2 were located")
    thisalinea.textcontent.append("downstream of the MWDCs [66, 73, 74].")
    thisalinea.textcontent.append("The two identical Multi-wire Drift Chamber (MWDC) detectors are the most impor-")
    thisalinea.textcontent.append("tant part of the detection system for the present experiment. The MWDCs measure")
    thisalinea.textcontent.append("the position of the tritons after they leave the magnetic ﬁeld of the second dipole.")
    thisalinea.textcontent.append("The distance between both MWDCs was 250 mm [73]. A schematic overview of the")
    thisalinea.textcontent.append("two MWDC detectors is given in Figure 3.3. One MWDC detector consists of three")
    thisalinea.textcontent.append("cathode planes with a spacing of 20 mm [74]. The cathode planes have a vertical")
    thisalinea.textcontent.append("orientation and are placed at an angle of 45◦ with respect to the primary beam tra-")
    thisalinea.textcontent.append("jectory. Halfway between the ﬁrst two cathode planes, a plane of vertical wires is")
    thisalinea.textcontent.append("located. This wire plane is called the X-plane. In the X-plane, two potential wires")
    thisalinea.textcontent.append("alternate repeatedly with one sense wire with all distances between the wires being")
    thisalinea.textcontent.append("equal. This pattern was chosen to produce an almost uniform electric ﬁeld.")
    thisalinea.textcontent.append("Halfway between the second and third cathode plane, another plane of wires is located.")
    thisalinea.textcontent.append("This plane is called the U-plane. In the U-plane, the wires form an angle of 48.2◦")
    thisalinea.textcontent.append("with the vertical direction (rotation is in the negative direction with respect to the")
    thisalinea.textcontent.append("beam axis [66]). In this plane, an alternating pattern of one potential wire and one")
    thisalinea.textcontent.append("sense wire is used. The spacing between the sense wires is 6 mm for the X-plane and")
    thisalinea.textcontent.append("4 mm for the U-plane [66, 74].")
    thisalinea.textcontent.append("Figure 3.3: Impression of the layout of a single MWDC detector; ﬁgure is based on")
    thisalinea.textcontent.append("Refs. [66, 74].")
    thisalinea.textcontent.append("The space between the cathode planes is ﬁlled with 70% argon and 30% iso-butane.")
    thisalinea.textcontent.append("A small impurity of iso-propyl alcohol is introduced into the argon before it is mixed")
    thisalinea.textcontent.append("with the iso-butane. The alcohol is mixed at 2 ◦C vapour pressure with the argon")
    thisalinea.textcontent.append("gas [66, 74]. During operation, a potential of −5600 V was applied to the cathode")
    thisalinea.textcontent.append("planes and a potential of −300 V was applied to the potential wires. The sense wires")
    thisalinea.textcontent.append("were kept at ground potential. The potential wires have a diameter of 50 µm and")
    thisalinea.textcontent.append("are made of a gold-plated beryllium-copper alloy. The sense wires have a diameter")
    thisalinea.textcontent.append("of 20 µm and are made of gold-plated tungsten. The cathode planes are made of a")
    thisalinea.textcontent.append("10 µm carbon-aramid ﬁlm. The X-plane consists of a total of 192 sense wires. For")
    thisalinea.textcontent.append("the U-plane, the total number of sense wires is 208 [66, 73].")
    thisalinea.textcontent.append("When a particle passes through the gas in the wire chamber, a cascade of ionizations")
    thisalinea.textcontent.append("is generated. Due to the present electric ﬁelds, the ions produced in the cascade drift")
    thisalinea.textcontent.append("towards the cathode planes while the produced electrons drift towards the sense wires.")
    thisalinea.textcontent.append("When the electrons hit the sense wires, an electron avalanche is formed. Together")
    thisalinea.textcontent.append("with the ions hitting the cathode planes, this is what generates a signal in the sense")
    thisalinea.textcontent.append("wires. This signal is measured in the form of a deviation from the ground potential")
    thisalinea.textcontent.append("in a sense wire. The number of the sense wire where the signal is produced, is stored,")
    thisalinea.textcontent.append("along with the starting time of the signal. This information is digitized to a wire")
    thisalinea.textcontent.append("channel number and a Time-to-Digital Converter (TDC) value by a CAEN V1190A")
    thisalinea.textcontent.append("unit [75]. Pre-ampliﬁcation and Constant Fraction Discrimination (CFD) of the signal")
    thisalinea.textcontent.append("is done by a REPIC RPA-260 unit [76]. Since the drift velocity in the wire chambers is")
    thisalinea.textcontent.append("known, the position where the triton passed the plane of sense wires can be extracted")
    thisalinea.textcontent.append("from the TDC data. With 4 planes of sense wires (2 MWDCs), the full position and")
    thisalinea.textcontent.append("angle of incidence can be reconstructed for the tritons. This procedure is discussed")
    thisalinea.textcontent.append("in Chapter 4 in more detail.")
    thisalinea.textcontent.append("The PS1 (and also PS2) detector is a plastic scintillation counter with a thickness of")
    thisalinea.textcontent.append("10 mm [74]. The active area of the scintillator is 1200 × 120 mm2. It is equipped")
    thisalinea.textcontent.append("with two photomultipliers at the endpoints of type HAMAMATSU-H1161 [74]. The")
    thisalinea.textcontent.append("photomultiplier signals were ﬁrst divided into two signals [73]. One signal was sent")
    thisalinea.textcontent.append("to a CFD. The other signal was digitized by a LeCroy 4300B module [77] to obtain")
    thisalinea.textcontent.append("Amplitude-to-Digital Converted (ADC) data. The ADC data were taken without any")
    thisalinea.textcontent.append("threshold. Instead, the trigger decided when the data would be exported. The CFD")
    thisalinea.textcontent.append("uses a threshold of −50 mV. After the CFD discriminated the ﬁrst signal, it was")
    thisalinea.textcontent.append("again split in two. The ﬁrst split signal was digitized by a LeCroy 4303 module [77]")
    thisalinea.textcontent.append("to obtain TDC data [74] and the second half of this signal was used to generate the")
    thisalinea.textcontent.append("trigger (see Section 3.6) [73, 74]. An aluminum plate with a thickness of 10 mm was")
    thisalinea.textcontent.append("placed between the two scintillators PS1 and PS2. This was done to prevent that the")
    thisalinea.textcontent.append("secondary electrons from one scintillator would ﬁre the other one.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.4 Design of the beam proﬁle"
    thisalinea.nativeID = 22
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "From the AVF and RING cyclotron settings, the primary beam is identiﬁed as 3He2+ and known to have a mean energy of 140 MeV/u. Classically, this primary beam is focused so that it has the smallest possible spatial radius at the target. This is called achromatic focus [70]. However, this type of focus limits the energy resolution of the spectrometer due to the energy spread in the beam. After the beam tuning was done, this energy spread was measured to be about σ = 57 keV. This number was obtained by rotating Grand Raiden to 8◦ to observe elastic scattering "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("From the AVF and RING cyclotron settings, the primary beam is identiﬁed as 3He2+")
    thisalinea.textcontent.append("and known to have a mean energy of 140 MeV/u. Classically, this primary beam is")
    thisalinea.textcontent.append("focused so that it has the smallest possible spatial radius at the target. This is called")
    thisalinea.textcontent.append("achromatic focus [70]. However, this type of focus limits the energy resolution of the")
    thisalinea.textcontent.append("spectrometer due to the energy spread in the beam. After the beam tuning was done,")
    thisalinea.textcontent.append("this energy spread was measured to be about σ = 57 keV. This number was obtained")
    thisalinea.textcontent.append("by rotating Grand Raiden to 8◦ to observe elastic scattering of the 3He-beam. A")
    thisalinea.textcontent.append("The main function of the Grand Raiden Spectrometer is to use the dipole magnets to")
    thisalinea.textcontent.append("bend particles with diﬀerent energies to diﬀerent positions at the focal-plane detector")
    thisalinea.textcontent.append("system. Therefore, Grand Raiden must necessarily have a large dispersion (see Section")
    thisalinea.textcontent.append("3.2 and [64]). However, after the charge-exchange reaction, the energy of the outgoing")
    thisalinea.textcontent.append("tritons has a spread similar to the energy spread in the beam. Due to the large")
    thisalinea.textcontent.append("dispersion of Grand Raiden, this energy spread translates into an uncertainty in the")
    thisalinea.textcontent.append("position measured at the focal-plane detectors. Since this position was used to extract")
    thisalinea.textcontent.append("the triton energy and, from there, the excitation-energy spectrum, the Gamow-Teller")
    thisalinea.textcontent.append("transitions in this spectrum can only be measured with a precision up to the energy")
    thisalinea.textcontent.append("spread in the beam. Hence, under achromatic focus, the energy resolution of our")
    thisalinea.textcontent.append("measurements is limited to the energy spread in the beam.")
    thisalinea.textcontent.append("For this experiment, it was known that the energy resolution of the beam would be")
    thisalinea.textcontent.append("insuﬃcient to allow for an accurate determination of the B(GT ) values of our two")
    thisalinea.textcontent.append("Sn-isotopes [78]. Therefore, dispersion-matching techniques [70] were employed to")
    thisalinea.textcontent.append("improve the resolution of the spectrometer beyond the energy spread of the beam.")
    thisalinea.textcontent.append("The lateral dispersion-matching technique employs monochromatic focus at the target")
    thisalinea.textcontent.append("to improve the energy resolution. Monochromatic focus at the target means that")
    thisalinea.textcontent.append("particles (in our case 3He) with the same energy are focused at the same position at")
    thisalinea.textcontent.append("the target. However, particles with diﬀerent energies are focused at diﬀerent positions.")
    thisalinea.textcontent.append("This position diﬀerence is tuned to counteract exactly the dispersion of Grand Raiden.")
    thisalinea.textcontent.append("Therefore, tritons with the same energy losses in the target but produced by 3He")
    thisalinea.textcontent.append("particles with diﬀerent energies are now focused to the same position at the focal-")
    thisalinea.textcontent.append("plane detectors. Due to the monochromatic focus, this position will no longer possess")
    thisalinea.textcontent.append("an uncertainty from the beam-energy spread. With this uncertainty removed, the")
    thisalinea.textcontent.append("triton energy loss in the target can be measured with a resolution well beyond the")
    thisalinea.textcontent.append("energy spread of the beam. For our experiment, the horizontal size of the beam spot")
    thisalinea.textcontent.append("at the target needed to be about 20 mm to achieve the proper monochromatic focus.")
    thisalinea.textcontent.append("With the lateral dispersion-matching technique, tritons due to excitation of the same")
    thisalinea.textcontent.append("level in the ﬁnal nucleus are bent to exactly the same position at the focal-plane")
    thisalinea.textcontent.append("detectors. However, they will not arrive there with the same angle of incidence.")
    thisalinea.textcontent.append("In the same way that the dispersion of Grand Raiden introduces an uncertainty in")
    thisalinea.textcontent.append("position under achromatic focus, that same dispersion also introduces an uncertainty")
    thisalinea.textcontent.append("in the angle of incidence. After the lateral dispersion-matching technique is applied,")
    thisalinea.textcontent.append("this uncertainty is even greater than under normal achromatic focus [70]. This is")
    thisalinea.textcontent.append("because under lateral dispersion matching, the hit position at the target is no longer")
    thisalinea.textcontent.append("accurately known.")
    thisalinea.textcontent.append("If the angle of incidence on the focal-plane detectors exhibits a large uncertainty, it")
    thisalinea.textcontent.append("is not possible to accurately trace the tritons back through the magnets of Grand")
    thisalinea.textcontent.append("Raiden to the target. Therefore, the scattering angle of the tritons at the target will")
    thisalinea.textcontent.append("also exhibit a large uncertainty.")
    thisalinea.textcontent.append("However, precise knowledge of the scattering angle of the tritons is required to identify")
    thisalinea.textcontent.append("∆L = 0 states (see Chapter 4). As explained in Section 3.1, this is the criterion to")
    thisalinea.textcontent.append("identify Gamow-Teller transitions. Hence, the angle of incidence on the focal plane")
    thisalinea.textcontent.append("must be known accurately. Therefore, the angular dispersion-matching technique was")
    thisalinea.textcontent.append("used in addition to the already discussed lateral dispersion-matching technique.")
    thisalinea.textcontent.append("Under the monochromatic focus from the lateral dispersion-matching technique, par-")
    thisalinea.textcontent.append("ticles with the same energy are focused to the same position on the target, and parti-")
    thisalinea.textcontent.append("cles with diﬀerent energies are focused to diﬀerent positions on the target. However,")
    thisalinea.textcontent.append("all particles still arrive perpendicularly to the target. When the angular dispersion-")
    thisalinea.textcontent.append("matching technique is also used, both the position and the angle of incidence at the")
    thisalinea.textcontent.append("target become energy dependent [70]. The angle of incidence at the target is tuned")
    thisalinea.textcontent.append("exactly to counteract the dispersion of Grand Raiden, causing tritons with the same")
    thisalinea.textcontent.append("energy loss in the target to hit the focal plane under the same angle of incidence. It")
    thisalinea.textcontent.append("must, however, be noted that the dependence of the target angle of incidence on the")
    thisalinea.textcontent.append("particle energy introduces a slight uncertainty in the initial momentum vector of the")
    thisalinea.textcontent.append("4).")
    thisalinea.textcontent.append("Figure 3.4 shows the beam proﬁle under achromatic focus (Figure 3.4a), under only")
    thisalinea.textcontent.append("lateral dispersion matching (Figure 3.4b) and under both lateral and angular disper-")
    thisalinea.textcontent.append("sion matching (Figure 3.4c). Both lateral and angular dispersion matching were used")
    thisalinea.textcontent.append("for our experiment (the situation of Figure 3.4c).")
    thisalinea.textcontent.append("Figure 3.4: Illustration of all three dispersion-matching techniques. Figure is based")
    thisalinea.textcontent.append("on Ref. [70] and used with permission.")
    thisalinea.textcontent.append("It is important to note that for our experiment, the trajectories between the target")
    thisalinea.textcontent.append("and the focal-plane detector in Figure 3.4 belong to 3He+. Since the spectrometer")
    thisalinea.textcontent.append("was tuned to bend tritons towards the focal plane, the 3He2+ from the primary")
    thisalinea.textcontent.append("beam never reaches the focal plane (it is bent too sharply). The 3He+, however,")
    thisalinea.textcontent.append("behaves the same as the unreacted beam, but is bent like the tritons. Therefore, the")
    thisalinea.textcontent.append("dispersion-matching techniques. Since the 3He+ is also easily identiﬁed by its energy")
    thisalinea.textcontent.append("loss in the scintillators, PS1 and PS2, it is a powerful tool to diagnose and tune the")
    thisalinea.textcontent.append("beam.")
    thisalinea.textcontent.append("A simple plot of the horizontal position of the beam spot on the focal-plane detectors")
    thisalinea.textcontent.append("is, however, not enough to realize accurate dispersion matching. When Grand Raiden")
    thisalinea.textcontent.append("is in the 0◦ position, the so-called ‘faint-beam technique’ has to be used to properly")
    thisalinea.textcontent.append("diagnose and tune the beam [70]. The technique is named this way because it requires")
    thisalinea.textcontent.append("the detection of the primary beam by the focal plane detectors. Unless the primary")
    thisalinea.textcontent.append("beam is very weak, it can easily burn the focal-plane detectors. Hence, the name of")
    thisalinea.textcontent.append("the technique. In our experiment, however, the 3He+ peak could be used instead of")
    thisalinea.textcontent.append("the primary beam itself.")
    thisalinea.textcontent.append("The faint-beam technique uses a plot of the phase space of the detected beam (which")
    thisalinea.textcontent.append("is the incident beam detected at 0◦ which goes through the target without any scat-")
    thisalinea.textcontent.append("tering). This situation is illustrated in Figure 3.5. The horizontal position and the")
    thisalinea.textcontent.append("horizontal angle of incidence at the focal plane are plotted against each other (Figure")
    thisalinea.textcontent.append("3.5a). After the over-focus mode of Grand Raiden has been properly realized (see")
    thisalinea.textcontent.append("next section), the plot becomes a very narrow tilted ellipse (Figure 3.5b). When")
    thisalinea.textcontent.append("the narrow ellipse is rotated until its minor axis becomes parallel to the horizontal")
    thisalinea.textcontent.append("position axis, lateral dispersion matching has been fully realized (Figure 3.5c). The")
    thisalinea.textcontent.append("realization of angular dispersion matching can then be accomplished by shortening")
    thisalinea.textcontent.append("the major axis of the ellipse (Figure 3.5d).")
    thisalinea.textcontent.append("Figure 3.5: Illustration of the faint-beam technique; ﬁgure used with permission [70].")
    thisalinea.textcontent.append("When Grand Raiden is not at 0◦ position, more advanced diagnostic tools are required")
    thisalinea.textcontent.append("to realize lateral and angular dispersion matching. The same phase-space plot can")
    thisalinea.textcontent.append("be used as in the faint-beam technique, but this situation requires placing a multi-")
    thisalinea.textcontent.append("slit aperture (sieve slit) between the target and the ﬁrst quadrupole magnet. The")
    thisalinea.textcontent.append("presence of this multi-slit produces a very complicated phase-space plot. However,")
    thisalinea.textcontent.append("if this phase-space plot is interpreted and tuned in the right way, both lateral and")
    thisalinea.textcontent.append("angular dispersion matching can also be realized in this situation. The practical")
    thisalinea.textcontent.append("implementation is far from trivial, since lateral dispersion matching away from the 0◦")
    thisalinea.textcontent.append("position requires that the monochromatic focal points of the beam are placed behind")
    thisalinea.textcontent.append("the target [70].")
    thisalinea.textcontent.append("After both lateral and angular dispersion matching were realized, the measured beam")
    thisalinea.textcontent.append("resolution during the faint-beam technique was about σ = 14 keV, which is indeed")
    thisalinea.textcontent.append("much smaller than the energy spread of the beam (σ = 57 keV). However, besides")
    thisalinea.textcontent.append("this remaining energy resolution of σ = 14 keV, the triton energy resolution of our")
    thisalinea.textcontent.append("experiment also receives a contribution from the energy loss in the target. Since the")
    thisalinea.textcontent.append("charge-exchange reaction can occur anywhere in the target, the Bethe-Bloch energy")
    thisalinea.textcontent.append("loss [79] before and after the reaction is slightly diﬀerent for each particle. This")
    thisalinea.textcontent.append("uncertainty translates into a signiﬁcant contribution to the triton energy resolution.")
    thisalinea.textcontent.append("To reduce this contribution as much as possible, we decided to use thin targets (see")
    thisalinea.textcontent.append("Section 3.1).")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.5 Optical properties of the Spectrometer"
    thisalinea.nativeID = 23
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "As discussed in Section 3.4, accurate knowledge of the triton scattering angle at the target is required to select ∆L = 0 states. This selection, in turn, is necessary to identify the Gamow-Teller states that we are after (see Section 3.1). The purpose of this section is to explain how the triton scattering angle at the target can be obtained from the measured position and angle of incidence at the focal plane. As discussed in Section 3.3, these data are obtained with the MWDCs. To obtain the triton scattering angle from the incident angle and position at the focal plane, "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As discussed in Section 3.4, accurate knowledge of the triton scattering angle at the")
    thisalinea.textcontent.append("target is required to select ∆L = 0 states. This selection, in turn, is necessary to")
    thisalinea.textcontent.append("identify the Gamow-Teller states that we are after (see Section 3.1). The purpose of")
    thisalinea.textcontent.append("this section is to explain how the triton scattering angle at the target can be obtained")
    thisalinea.textcontent.append("from the measured position and angle of incidence at the focal plane. As discussed")
    thisalinea.textcontent.append("in Section 3.3, these data are obtained with the MWDCs.")
    thisalinea.textcontent.append("To obtain the triton scattering angle from the incident angle and position at the focal")
    thisalinea.textcontent.append("plane, one must know exactly how Grand Raiden bends the tritons from the target")
    thisalinea.textcontent.append("to the focal plane. These characteristics are known as the ion-optical properties of")
    thisalinea.textcontent.append("the spectrometer [70, 73, 80]. Knowing these properties, tritons can be traced back")
    thisalinea.textcontent.append("from the focal plane to the target. With this tracing, the triton scattering angle at")
    thisalinea.textcontent.append("the target can be obtained from the incident angle and position at the focal plane.")
    thisalinea.textcontent.append("Calculating the ion-optical properties of Grand Raiden is not trivial, since every")
    thisalinea.textcontent.append("inhomogeneity in the magnetic ﬁelds has to be accounted for. Moreover, both the")
    thisalinea.textcontent.append("dipole ﬁelds and the quadrupole ﬁelds have to be taken into account. Therefore, it")
    thisalinea.textcontent.append("is much more eﬃcient instead to measure the ion-optical properties of Grand Raiden")
    thisalinea.textcontent.append("directly. This was done by a so-called sieve-slit measurement [5, 71, 73].")
    thisalinea.textcontent.append("A sieve slit is a multi-hole aperture that is placed right after the target to cut the")
    thisalinea.textcontent.append("outgoing particles into a series of small pencil beams. These pencil beams are then")
    thisalinea.textcontent.append("detected at the focal plane. From the geometry and position of the sieve slit, the")
    thisalinea.textcontent.append("scattering angle of each pencil beam is known. From the focal-plane detectors, the")
    thisalinea.textcontent.append("position and angle of incidence at the focal plane is known for each pencil beam as")
    thisalinea.textcontent.append("well. Since a sieve slit is typically given a regular structure, the beam spots at the focal")
    thisalinea.textcontent.append("planes are easily matched to the pencil beams coming out of the sieve slit. Hence,")
    thisalinea.textcontent.append("a sieve-slit measurement is an eﬀective way of measuring the relation between the")
    thisalinea.textcontent.append("scattering angle at the target and the focal-plane position and angle of incidence. Of")
    thisalinea.textcontent.append("course, the pencil beams coming out of the sieve slit should cover the full acceptance")
    thisalinea.textcontent.append("of Grand Raiden.")
    thisalinea.textcontent.append("After the sieve-slit measurement is done, a method has to be devised to calculate the")
    thisalinea.textcontent.append("scattering angle at the target from the position and angle of incidence for individual")
    thisalinea.textcontent.append("particles. However, as explained above, the full relation between the scattering angle")
    thisalinea.textcontent.append("at the target and the position and angle of incidence at the focal plane is complicated.")
    thisalinea.textcontent.append("The most common solution to overcome this problem is a Taylor expansion around the")
    thisalinea.textcontent.append("primary-beam trajectory (in our case: 3He+, see Section 3.3). The matrix formalism")
    thisalinea.textcontent.append("of Ref. [81] is extremely helpful in this procedure. The matrix coeﬃcients of this")
    thisalinea.textcontent.append("formalism can be ﬁtted to the sieve-slit data once the beam spots are matched to")
    thisalinea.textcontent.append("the pencil beams. This ﬁtting is known as a sieve-slit analysis and will be discussed")
    thisalinea.textcontent.append("further in Section 4.3.")
    thisalinea.textcontent.append("A schematic picture of the sieve slit used in our experiment is displayed in Figure")
    thisalinea.textcontent.append("3.6. The diameter of each of the small holes was 2 mm. The two larger holes have")
    thisalinea.textcontent.append("diameters of 3 mm and 12 mm. The vertical distance between two succeeding holes")
    thisalinea.textcontent.append("was 5 mm (centre to centre). The horizontal distance between two succeeding holes")
    thisalinea.textcontent.append("was 4 mm (centre to centre). The horizontal direction in Figure 3.6 coincides with")
    thisalinea.textcontent.append("the bending plane of Grand Raiden. The sieve slit was placed 585 mm behind the")
    thisalinea.textcontent.append("target. Magnetic ﬁelds of Grand Raiden are only encountered after the sieve slit.")
    thisalinea.textcontent.append("Figure 3.6: Impression of the sieve slit used in our experiment.")
    thisalinea.textcontent.append("For the sieve-slit measurement, a target of 13CH2 was used. For a sieve-slit measure-")
    thisalinea.textcontent.append("ment, the actual target thickness is not very relevant, since one is not interested in")
    thisalinea.textcontent.append("absolute cross sections. Of course, the target should be thin enough to prevent sub-")
    thisalinea.textcontent.append("stantial Bethe-Bloch energy loss. 13CH2 was chosen as the target, since the energy")
    thisalinea.textcontent.append("spectra of charge-exchange reactions on 13C are well known [82, 83]. The sieve-slit")
    thisalinea.textcontent.append("measurements were only performed at the 0◦ position of Grand Raiden, because it")
    thisalinea.textcontent.append("seemed like a logical assumption that the optical characteristics of Grand Raiden are")
    thisalinea.textcontent.append("not diﬀerent in other positions.")
    thisalinea.textcontent.append("After the sieve-slit measurement was done, the sieve slit was removed from the setup")
    thisalinea.textcontent.append("so data could be taken on the Sn-targets discussed in Section 3.1. The beam proﬁle")
    thisalinea.textcontent.append("discussed in Section 3.4 was also used for the sieve-slit measurements.")
    thisalinea.textcontent.append("With the sieve-slit analysis and a proper energy calibration, one can extract both the")
    thisalinea.textcontent.append("scattering angle and the triton energy at the target. Obtaining the excitation energy")
    thisalinea.textcontent.append("of the recoil nucleus is then a simple matter of kinematics. With the scattering angle")
    thisalinea.textcontent.append("known, states in the excitation-energy spectrum with ∆L = 0 can be selected.")
    thisalinea.textcontent.append("There is, however, one problem with this procedure. Grand Raiden was designed to")
    thisalinea.textcontent.append("focus all particles coming out of the target onto the focal plane. This design allows us")
    thisalinea.textcontent.append("to measure the triton energy (see Section 3.2), but also causes a very small angular")
    thisalinea.textcontent.append("magniﬁcation of 0.17 for the vertical scattering angle at the target [80]. This means")
    thisalinea.textcontent.append("that the measured position and incident angle at the focal plane are very insensitive")
    thisalinea.textcontent.append("to variations in the vertical scattering angle at the target.")
    thisalinea.textcontent.append("This problem does not occur for the horizontal scattering angle due to the large")
    thisalinea.textcontent.append("horizontal angular magniﬁcation of Grand Raiden (see Section 3.4), which results")
    thisalinea.textcontent.append("in an excellent sensitivity to the horizontal scattering angle. By employing angular")
    thisalinea.textcontent.append("dispersion matching of the beam, this sensitivity is also not endangered by the energy")
    thisalinea.textcontent.append("spread of the beam.")
    thisalinea.textcontent.append("In order to increase the sensitivity to variations in the vertical scattering angle, the")
    thisalinea.textcontent.append("over-focus mode of Grand Raiden was used during our experiment [80]. In this")
    thisalinea.textcontent.append("method, the strength of the Q1 quadrupole magnet is increased to focus the par-")
    thisalinea.textcontent.append("ticles on a point prior to the focal-plane detectors (in the vertical direction). In this")
    thisalinea.textcontent.append("way, the vertical position of the particles at the focal plane can be used to measure")
    thisalinea.textcontent.append("the vertical scattering angle of the particles with good sensitivity. An overview of the")
    thisalinea.textcontent.append("over-focus mode is given in Figure 3.7.")
    thisalinea.textcontent.append("From Figure 3.7 it is clear that in the over focus mode, the vertical position provides")
    thisalinea.textcontent.append("good sensitivity to the vertical scattering angle at the target.")
    thisalinea.textcontent.append("Figure 3.7: Impression of the three diﬀerent focal modes of Grand Raiden. Figure is")
    thisalinea.textcontent.append("based on Ref. [80] and used with permission.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.6 Trigger signal and Data-Acquisition System"
    thisalinea.nativeID = 24
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "The trigger signal is actually nothing more than a coincidence signal from the PS1 and PS2 scintillator counters. If all four photomultipliers of these scintillators ﬁre in coincidence (with the time diﬀerences between the photomultipliers at diﬀerent endpoints taken into account), a trigger signal is generated and the outputs from the MWDCs and PS1 and PS2 are saved. A map of the trigger system used in our experiment is shown in Figures 3.8 and 3.9. As discussed in Section 3.3, a signal from a photomultiplier is ﬁrst split in two [73, 74]. ADC data are obtained from the ﬁrst branch "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The trigger signal is actually nothing more than a coincidence signal from the PS1")
    thisalinea.textcontent.append("and PS2 scintillator counters. If all four photomultipliers of these scintillators ﬁre")
    thisalinea.textcontent.append("in coincidence (with the time diﬀerences between the photomultipliers at diﬀerent")
    thisalinea.textcontent.append("endpoints taken into account), a trigger signal is generated and the outputs from")
    thisalinea.textcontent.append("the MWDCs and PS1 and PS2 are saved. A map of the trigger system used in our")
    thisalinea.textcontent.append("experiment is shown in Figures 3.8 and 3.9.")
    thisalinea.textcontent.append("As discussed in Section 3.3, a signal from a photomultiplier is ﬁrst split in two [73, 74].")
    thisalinea.textcontent.append("ADC data are obtained from the ﬁrst branch and the other branch is sent to a CFD")
    thisalinea.textcontent.append("(Constant Fraction Discriminator). After the discrimination is performed, the signal")
    thisalinea.textcontent.append("is again split in two. One branch is used to obtain TDC data and the other branch")
    thisalinea.textcontent.append("is sent to a mean timer. Only one mean timer unit is used per scintillator. This unit")
    thisalinea.textcontent.append("combines the signals of the two photomultipliers within a single scintillator to extract")
    thisalinea.textcontent.append("the time of the hit (this is the mean time of both signals). Then, the signals are fed")
    thisalinea.textcontent.append("into a LeCroy 2366 Universal Logic Module [84] through delay cables (to compensate")
    thisalinea.textcontent.append("for the time-of-ﬂight diﬀerence between the two scintillators). The cable carrying")
    thisalinea.textcontent.append("the PS2 signal introduces a time delay of 1 ns. The cable carrying the PS1 signal")
    thisalinea.textcontent.append("Figure 3.8: Signal-ﬂow scheme of the Grand-Raiden trigger")
    thisalinea.textcontent.append("system. Figure is based on Refs. [66, 73] and used with")
    thisalinea.textcontent.append("permission.")
    thisalinea.textcontent.append("Figure 3.9: Timing")
    thisalinea.textcontent.append("scheme of the Grand-")
    thisalinea.textcontent.append("Raiden trigger sys-")
    thisalinea.textcontent.append("tem. Figure is based")
    thisalinea.textcontent.append("on Refs. [66, 74] and")
    thisalinea.textcontent.append("used with permis-")
    thisalinea.textcontent.append("sion.")
    thisalinea.textcontent.append("introduces a time delay of 16 ns. In this way, a proper coincidence signal between")
    thisalinea.textcontent.append("PS1 and PS2 was generated. This coincidence signal is the trigger signal. The timing")
    thisalinea.textcontent.append("scheme on how the two signals of PS1 and PS2 were combined is displayed in Figure")
    thisalinea.textcontent.append("3.9. The trigger signal provided a common start signal for all data taking.")
    thisalinea.textcontent.append("As discussed in Section 3.3, ADC and TDC data are obtained for the PS1 and PS2")
    thisalinea.textcontent.append("scintillators. After the digitization has been performed by the respective LeCroy")
    thisalinea.textcontent.append("units, data are exported to a high-speed memory module (HSM) through an ECL bus")
    thisalinea.textcontent.append("[73]. The high-speed memory module is part of a VME crate (LeCroy 1191 Dual-Port")
    thisalinea.textcontent.append("Memory [85]). Two memory modules were used in parallel to reduce the dead time")
    thisalinea.textcontent.append("of the system [73]. The data were transported from the VME crate through a gigabit")
    thisalinea.textcontent.append("Ethernet cable to a Fujitsu PRIMERGY CX250S2 computer station [86], where they")
    thisalinea.textcontent.append("were saved on hard-disk memory [73]. See Figure 3.10 for an overview.")
    thisalinea.textcontent.append("For the TDC data of the MWDCs, a slightly diﬀerent procedure is applied. After")
    thisalinea.textcontent.append("the digitization is performed by the REPIC and CAEN units (see Section 3.3), the")
    thisalinea.textcontent.append("data are transported directly to the Fujitsu PRIMERGY CX250S2 computer station")
    thisalinea.textcontent.append("through a gigabit ethernet cable. A CPU located in the CAEN crate itself is used to")
    thisalinea.textcontent.append("manage this data transfer.")
    thisalinea.textcontent.append("No software operations of any kind were performed on the data during this procedure.")
    thisalinea.textcontent.append("The data were just saved as a list of ADC values, TDC values and channel numbers in")
    thisalinea.textcontent.append("a native ﬁle format known as .gr-ﬁles and .gv-ﬁles (a tag was also saved to identify")
    thisalinea.textcontent.append("which trigger signal was used for which data). For each experimental run, one .gr-")
    thisalinea.textcontent.append("ﬁle and one .gv-ﬁle was generated. The ADC and TDC data of the PS1 and PS2")
    thisalinea.textcontent.append("detectors were saved in the .gr-ﬁles and the TDC and channel number data of the")
    thisalinea.textcontent.append("MWDCs were saved in the .gv-ﬁles. In addition, a so-called .blp-ﬁles was also saved")
    thisalinea.textcontent.append("to store the beam parameters. One .blp-ﬁle was generated for each run.")
    thisalinea.textcontent.append("Figure 3.10: Overview of the Grand-Raiden DAQ system. Figure is based on Refs. [73]")
    thisalinea.textcontent.append("and [66] and is used with permission.")
    thisalinea.textcontent.append("These diﬀerent ﬁle formats were used because the diﬀerent detector outputs were dig-")
    thisalinea.textcontent.append("itized by diﬀerent modules, requiring diﬀerent native formats. After the experiment,")
    thisalinea.textcontent.append("the data were transported through the internet to a personal computer. All software")
    thisalinea.textcontent.append("operations on the data were performed after this transportation.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "3.7 Conversion of the data to ROOT"
    thisalinea.nativeID = 25
    thisalinea.parentID = 18
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 6
    thisalinea.summary = "The analysis of the data in Chapter 4 was performed with ROOT [87] version 5.34. Hence, the recorded data had to be converted from its native .gr and .gv formats to a format that can be handled by ROOT. This conversion consists of two steps: the event building and the unpacking. The event building is actually nothing more than merging the content of the .gr-ﬁle, the .gv-ﬁle and the .blp-ﬁle of a single run. As an intermediate step, a .grb-ﬁle is generated. The ﬁnal results are stored in a .bld-ﬁle. This merging is a matter of bookkeeping. All data were "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The analysis of the data in Chapter 4 was performed with ROOT [87] version 5.34.")
    thisalinea.textcontent.append("Hence, the recorded data had to be converted from its native .gr and .gv formats to")
    thisalinea.textcontent.append("a format that can be handled by ROOT. This conversion consists of two steps: the")
    thisalinea.textcontent.append("event building and the unpacking.")
    thisalinea.textcontent.append("The event building is actually nothing more than merging the content of the .gr-ﬁle,")
    thisalinea.textcontent.append("the .gv-ﬁle and the .blp-ﬁle of a single run. As an intermediate step, a .grb-ﬁle")
    thisalinea.textcontent.append("is generated. The ﬁnal results are stored in a .bld-ﬁle. This merging is a matter")
    thisalinea.textcontent.append("of bookkeeping. All data were tagged from the beginning with a reference to their")
    thisalinea.textcontent.append("respective trigger signals. Hence, the event building was simply a matter of matching")
    thisalinea.textcontent.append("the data of the MWDC detectors and the PS detectors to the same trigger signal and")
    thisalinea.textcontent.append("then store it all together in a single native ﬁle (.bld-ﬁle). The idea is that a single")
    thisalinea.textcontent.append("trigger signal corresponds to a single beam particle. Hence, the name event building.")
    thisalinea.textcontent.append("The event building was done using native software of RCNP developed by Atsushi")
    thisalinea.textcontent.append("Tamii, author of Ref. [66].")
    thisalinea.textcontent.append("The unpacking was done with the analyser program. The analyser program was")
    thisalinea.textcontent.append("originally developed in Ref. [66] and later modiﬁed by G. Guillaume [88] to convert")
    thisalinea.textcontent.append("the native .bld-ﬁle into a ROOT data tree. A ROOT data tree is a ﬁle format of the")
    thisalinea.textcontent.append("program ROOT [87, 89] in which large quantities of numbers (like TDC and ADC")
    thisalinea.textcontent.append("data) can be stored on an event-by-event basis. This ROOT data tree was saved to")
    thisalinea.textcontent.append("the computer’s hard disk as a ROOT-ﬁle.")
    thisalinea.textcontent.append("In addition to the conversion of the raw TDC, ADC and channel number data obtained")
    thisalinea.textcontent.append("by the focal-plane detectors, the analyser program also provides a reconstruction of")
    thisalinea.textcontent.append("the triton track through the focal plane detectors. This procedure works slightly")
    thisalinea.textcontent.append("diﬀerently than the one that is described in Chapter 4 (and that was used in this")
    thisalinea.textcontent.append("work), but we will show that the outputs are almost identical.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "4 Data Analysis"
    thisalinea.nativeID = 26
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "In this chapter, the analysis of the raw TDC, ADC and channel-number data obtained according to the procedures of Chapter 3 will be discussed. The ﬁrst step in this anal- ysis is the merging of the diﬀerent experimental runs, which is discussed in Section 4.1. Following that, the triton tracks (modelled as 3D lines) through the focal-plane detec- tion system were reconstructed from the raw TDC, ADC and channel-number data. This procedure is discussed in Section 4.2. Subsequently, these tracks were traced back to the target according to the procedure of Section 3.5. The application of this procedure to the "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this chapter, the analysis of the raw TDC, ADC and channel-number data obtained")
    thisalinea.textcontent.append("according to the procedures of Chapter 3 will be discussed. The ﬁrst step in this anal-")
    thisalinea.textcontent.append("ysis is the merging of the diﬀerent experimental runs, which is discussed in Section 4.1.")
    thisalinea.textcontent.append("Following that, the triton tracks (modelled as 3D lines) through the focal-plane detec-")
    thisalinea.textcontent.append("tion system were reconstructed from the raw TDC, ADC and channel-number data.")
    thisalinea.textcontent.append("This procedure is discussed in Section 4.2. Subsequently, these tracks were traced")
    thisalinea.textcontent.append("back to the target according to the procedure of Section 3.5. The application of this")
    thisalinea.textcontent.append("procedure to the data is discussed in Section 4.3 and follows the procedure discussed")
    thisalinea.textcontent.append("in Ref. [90]. After the tracks were traced back to the target, the excitation-energy")
    thisalinea.textcontent.append("spectrum of the recoil nucleus was reconstructed. The extraction of the diﬀerential")
    thisalinea.textcontent.append("cross sections for various states in this spectrum is discussed in Section 4.4. Finally,")
    thisalinea.textcontent.append("in Section 4.5 is discussed how the procedures of Chapter 2 were applied to extract")
    thisalinea.textcontent.append("B(GT ) for various Gamow-Teller states in the excitation-energy spectrum of the recoil")
    thisalinea.textcontent.append("nucleus. The ﬁnal results are presented in Chapter 5.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "4.1 Merging of the runs"
    thisalinea.nativeID = 27
    thisalinea.parentID = 26
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "For each experimental run, the analyser program (see Section 3.7) produced a separate ROOT-ﬁle. As the ﬁrst step in the data analysis, these ROOT-ﬁles were merged together into one single ROOT-ﬁle per target material. During this merging, each event was labelled with the number of the experimental run in which it was measured. During the merging, several conditions were also imposed on the data. As a ﬁrst condition, it was required that no errors were made during the data taking. If data are saved for one of the MWDC signal wires, both the TDC value and the channel number identifying "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("For each experimental run, the analyser program (see Section 3.7) produced a separate")
    thisalinea.textcontent.append("ROOT-ﬁle. As the ﬁrst step in the data analysis, these ROOT-ﬁles were merged")
    thisalinea.textcontent.append("together into one single ROOT-ﬁle per target material. During this merging, each")
    thisalinea.textcontent.append("event was labelled with the number of the experimental run in which it was measured.")
    thisalinea.textcontent.append("During the merging, several conditions were also imposed on the data. As a ﬁrst")
    thisalinea.textcontent.append("condition, it was required that no errors were made during the data taking. If data")
    thisalinea.textcontent.append("are saved for one of the MWDC signal wires, both the TDC value and the channel")
    thisalinea.textcontent.append("number identifying the speciﬁc wire should have been saved. If data are saved for one")
    thisalinea.textcontent.append("of the photomultipliers, a TDC value, an ADC value and a number identifying the")
    thisalinea.textcontent.append("photomultiplier should have been saved. An error in the data taking was then deﬁned")
    thisalinea.textcontent.append("as that any of these quantities was missing. All events from our analysis passed this")
    thisalinea.textcontent.append("condition. In total, about 47.1 million events were measured with the 116Sn target,")
    thisalinea.textcontent.append("about 94.2 million events were measured with the 122Sn target and about 4.8 million")
    thisalinea.textcontent.append("events were measured with the sieve-slit and the 13CH2 target (see Section 3.5).")
    thisalinea.textcontent.append("As a second condition, it was required that all four photomultipliers of the PS1 and")
    thisalinea.textcontent.append("PS2 scintillators gave exactly one signal per event. This condition was imposed as an")
    thisalinea.textcontent.append("attempt to eliminate background, as tritons are expected to pass this condition. This")
    thisalinea.textcontent.append("condition eliminated less than 0.1% of the events measured.")
    thisalinea.textcontent.append("During the merging of the runs, information obtained with Faraday cups D1FC and")
    thisalinea.textcontent.append("Q1FC (see Section 3.2) and from the experimental log was also added to the ROOT-")
    thisalinea.textcontent.append("ﬁles. As a third condition, it was required that only runs measured with a dispersive")
    thisalinea.textcontent.append("beam proﬁle and measured without the faint beam technique (see Section 3.4) could")
    thisalinea.textcontent.append("be used in the analysis. This condition eliminated no events from the data on Sn-")
    thisalinea.textcontent.append("targets, but eliminated about 9% of the sieve-slit events. Those eliminated events")
    thisalinea.textcontent.append("were measured in achromatic mode.")
    thisalinea.textcontent.append("Finally, a random number from a uniform distribution was added to each of the")
    thisalinea.textcontent.append("recorded TDC and ADC values during the merging. TDC and ADC values have,")
    thisalinea.textcontent.append("by deﬁnition, a discrete nature. By adding a random number from a uniform dis-")
    thisalinea.textcontent.append("tribution, this discrete nature was removed. This facilitated the rest of our analysis")
    thisalinea.textcontent.append("and allowed us to obtain smoother results. By choosing the width of the uniform")
    thisalinea.textcontent.append("distribution exactly equal to the distance between subsequent TDC or ADC values")
    thisalinea.textcontent.append("(the width of a single channel in the digital conversion), the experimental resolution")
    thisalinea.textcontent.append("of the measurements was preserved.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "4.2 Track reconstruction"
    thisalinea.nativeID = 28
    thisalinea.parentID = 26
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "After merging the data of the individual experimental runs, the next step in the analysis is the reconstruction of the triton tracks through the focal plane detector system. This reconstruction utilized the data obtained with the MWDCs and followed the same methodology as used in Ref. [73]. This reconstruction consists of two steps. The ﬁrst step is to obtain the position at which the triton track passed through the wire plane for each of the 4 wire planes (see Section 3.3). The second step is to translate these positions into a description of a 3D line. As explained in Section "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("After merging the data of the individual experimental runs, the next step in the")
    thisalinea.textcontent.append("analysis is the reconstruction of the triton tracks through the focal plane detector")
    thisalinea.textcontent.append("system. This reconstruction utilized the data obtained with the MWDCs and followed")
    thisalinea.textcontent.append("the same methodology as used in Ref. [73]. This reconstruction consists of two steps.")
    thisalinea.textcontent.append("The ﬁrst step is to obtain the position at which the triton track passed through the")
    thisalinea.textcontent.append("wire plane for each of the 4 wire planes (see Section 3.3). The second step is to")
    thisalinea.textcontent.append("translate these positions into a description of a 3D line.")
    thisalinea.textcontent.append("As explained in Section 3.3, a triton passing through the wire chamber produces a")
    thisalinea.textcontent.append("cascade of ionizations in the gas. Subsequently, the produced ions drift towards the")
    thisalinea.textcontent.append("cathode planes and the produced electrons drift towards the sense wires. The TDC")
    thisalinea.textcontent.append("values of the signals recorded by the sense wires represent the drift times of these")
    thisalinea.textcontent.append("electrons. To convert this information into a position coordinate, the TDC values")
    thisalinea.textcontent.append("ﬁrst have to be converted to drift lengths: the distances over which the electrons")
    thisalinea.textcontent.append("drifted from the triton track to the sense wires along the path of the electric ﬁeld.")
    thisalinea.textcontent.append("The drift lengths are illustrated in Figure 4.1.")
    thisalinea.textcontent.append("To map the TDC values of the sense wires onto the drift lengths, a histogram")
    thisalinea.textcontent.append("was created per target material and per MWDC wire plane containing all TDC")
    thisalinea.textcontent.append("values in all of the available events. Then, the cumulative probability distribu-")
    thisalinea.textcontent.append("tion function F was extracted from this histogram. Subsequently, the mapping")
    thisalinea.textcontent.append("L = 10.0 mm · (1 − F (T DC)) was used to transform the uncalibrated TDC values")
    thisalinea.textcontent.append("into drift lengths. The inverse transformation method for generating random num-")
    thisalinea.textcontent.append("bers in statistics prescribes that the obtained values for L indeed have a uniform")
    thisalinea.textcontent.append("distribution. The value of 10 mm comes from the distance between the wires and")
    thisalinea.textcontent.append("the cathode plane in the MWDCs (see Figure 3.3). Using 1 − F (T DC) instead of")
    thisalinea.textcontent.append("F (T DC) itself is necessary, because during the unpacking of the data (see Section")
    thisalinea.textcontent.append("Figure 4.1: Illustration of the drift lengths in a wire plane of the MWDC.")
    thisalinea.textcontent.append("3.7), the TDC values were inverted. For the situation of a common start trigger sys-")
    thisalinea.textcontent.append("tem (see Section 3.6), larger TDC values normally correspond to larger drift lengths.")
    thisalinea.textcontent.append("However, during the unpacking of the data, this relation was artiﬁcially inverted. This")
    thisalinea.textcontent.append("was done in order to maintain compatibility with the previous DAQ system of Grand")
    thisalinea.textcontent.append("Raiden (see Ref. [66] for more details on this older system). Hence, it is obvious that")
    thisalinea.textcontent.append("our mapping to drift lengths has to correct for this inversion. See Ref. [73] for more")
    thisalinea.textcontent.append("details on cancelling this inversion.")
    thisalinea.textcontent.append("The next challenge is to establish whether the obtained drift lengths indeed correspond")
    thisalinea.textcontent.append("to a single triton track. In order to ensure this, several conditions were imposed on")
    thisalinea.textcontent.append("the position reconstruction. The ﬁrst condition is that the number of sense wires")
    thisalinea.textcontent.append("producing a signal within the same wire plane should be between 2 and 7. For a")
    thisalinea.textcontent.append("number smaller than 2, it becomes impossible to extract the position coordinate (see")
    thisalinea.textcontent.append("next paragraph). A number larger than 7 is very unlikely to be produced by a single")
    thisalinea.textcontent.append("triton track. The second condition is that within a single wire plane, the sense wires")
    thisalinea.textcontent.append("producing signals should form a single cluster, since otherwise we would know that")
    thisalinea.textcontent.append("the signals come from more than one track. A single cluster is deﬁned as a group of")
    thisalinea.textcontent.append("direct neighbouring sense wires, which all have produced a signal. The third condition")
    thisalinea.textcontent.append("is that the drift lengths in this cluster should have exactly one local minimum: the")
    thisalinea.textcontent.append("sense wire where the track passed closest to (see Figure 4.1). The situation of having")
    thisalinea.textcontent.append("more than one local minimum within one cluster can only occur if two tracks passed")
    thisalinea.textcontent.append("the wire plane in close proximity.")
    thisalinea.textcontent.append("The position that can be reconstructed with a single wire plane is only a single")
    thisalinea.textcontent.append("coordinate: the location where the triton track passed the wire plane in the direction")
    thisalinea.textcontent.append("perpendicular to the wires. This reconstruction was only done if all of the above")
    thisalinea.textcontent.append("conditions were met. The position coordinate was then reconstructed by ﬁtting a")
    thisalinea.textcontent.append("linear regression line through the drift lengths of Figure 4.1 (see the blue line there).")
    thisalinea.textcontent.append("The drift lengths can be interpreted as y-values and the corresponding x-values were")
    thisalinea.textcontent.append("obtained from the wire channel numbers and the wire spacing (see Section 3.3). The")
    thisalinea.textcontent.append("point where the blue line crosses the x-axis (the wire points in Figure 4.1) is the")
    thisalinea.textcontent.append("position coordinate of interest. In the situation that the same sense wire produced")
    thisalinea.textcontent.append("multiple signals within the same event, only the signal corresponding to the smallest")
    thisalinea.textcontent.append("drift length was used for the linear regression line. This happened in about 16.5% of")
    thisalinea.textcontent.append("the cases and in this situation, the smallest TDC value is the signal from the time of")
    thisalinea.textcontent.append("the current event that we are interested in and the other signals are due to pile-up.")
    thisalinea.textcontent.append("After position coordinates were obtained for all of the four wire planes of the MWDCs,")
    thisalinea.textcontent.append("the triton track could be reconstructed as a 3D line. We chose to describe this 3D")
    thisalinea.textcontent.append("line by the following four parameters, in agreement with the convention of Ref. [73]:")
    thisalinea.textcontent.append("{xfp, yfp, θfp, φfp}. The subscript fp denotes that the parameters characterize a line")
    thisalinea.textcontent.append("through the focal-plane detector system. x and y are the horizontal and vertical")
    thisalinea.textcontent.append("positions at which the track intersects the X-plane of the ﬁrst MWDC, respectively.")
    thisalinea.textcontent.append("θ and φ are the horizontal and vertical angles of incidence at this point of intersection,")
    thisalinea.textcontent.append("respectively. The positive y-direction is deﬁned upwards in the experimental hall. The")
    thisalinea.textcontent.append("positive x-direction is deﬁned in the direction of increasing E∗ of the recoil nucleus,")
    thisalinea.textcontent.append("which means that x decreases if the triton energy increases. The zero-points of all four")
    thisalinea.textcontent.append("parameters are deﬁned by the central orbit of Grand Raiden. However, the precise")
    thisalinea.textcontent.append("values of these zero-points are not important to us, because their contributions will be")
    thisalinea.textcontent.append("cancelled out by the sieve-slit correction described in Section 4.3. The only important")
    thisalinea.textcontent.append("requirement is that the same zero-point trajectory is used for each event. Figure 4.2")
    thisalinea.textcontent.append("presents an example of a trajectory through the MWDCs.")
    thisalinea.textcontent.append("The ﬁtting of the 3D line describing the triton track was done based on the 4 position")
    thisalinea.textcontent.append("coordinates of the 4 wire planes and on the geometry parameters of the MWDCs. The")
    thisalinea.textcontent.append("full line {xfp, yfp, θfp, φfp} could only be reconstructed in the situation where all the")
    thisalinea.textcontent.append("position coordinates of all 4 wire planes were obtained. In the situation that position")
    thisalinea.textcontent.append("coordinates could only be obtained for 3 of the 4 wire planes, the line could only be")
    thisalinea.textcontent.append("reconstructed if φfp was ﬁxed to zero. Fixing φfp to zero is the best choice of the 4")
    thisalinea.textcontent.append("parameters, because due to the over-focus mode of Grand Raiden, φfp is redundant")
    thisalinea.textcontent.append("(see Figure 4.3 and subsequent explanations). If less than 3 position coordinates were")
    thisalinea.textcontent.append("obtained, no line was reconstructed at all. The number of events for which a triton")
    thisalinea.textcontent.append("track could be reconstructed is given in Table 4.1")
    thisalinea.textcontent.append("In Table 4.1, the row marked with ‘4 pos.-co.’ shows the number of events where a")
    thisalinea.textcontent.append("triton track could be reconstructed based on the position coordinates of all 4 wire")
    thisalinea.textcontent.append("chambers. The row marked with ‘3 pos.-co.’ shows the number of events where a")
    thisalinea.textcontent.append("triton track could be reconstructed based on 3 of the 4 position coordinates. The")
    thisalinea.textcontent.append("row marked with ‘No track.’ shows the number of events where no triton track was")
    thisalinea.textcontent.append("reconstructed at all. The row marked with ‘Total’ shows the sum of the previous")
    thisalinea.textcontent.append("rows. These are all the events that passed the conditions from Section 4.1.")
    thisalinea.textcontent.append("From Table 4.1, it is clear that, especially for the Sn-targets, triton tracks could not")
    thisalinea.textcontent.append("be reconstructed for a large number of events. These events are either background")
    thisalinea.textcontent.append("Figure 4.2: Parameterization of the triton tracks through the focal-plane detector")
    thisalinea.textcontent.append("system.")
    thisalinea.textcontent.append("events where a trigger signal was generated by something else than a passing triton, or")
    thisalinea.textcontent.append("are events where the triton track failed to be detected by (some of) the wire planes. In")
    thisalinea.textcontent.append("Subsection 4.4.2, it will be determined that the detection eﬃciency per wire plane for")
    thisalinea.textcontent.append("tritons is about 95% in the 0◦ mode and 89% in the 2.5◦ mode. A correction will be")
    thisalinea.textcontent.append("applied there for these detection eﬃciencies, which will cancel the elimination of the")
    thisalinea.textcontent.append("latter type of events in the determination of the cross section. Since our trigger signal")
    thisalinea.textcontent.append("is a simple coincidence between two scintillators, it is understandable that random")
    thisalinea.textcontent.append("background particles (such as gamma rays) have caused the scintillators to respond")
    thisalinea.textcontent.append("quite often, explaining the large number of background events in Table 4.1. It is")
    thisalinea.textcontent.append("important to realize that no particle identiﬁcation of any kind was done to obtain")
    thisalinea.textcontent.append("Table 4.1. In Section 3.2, it was discussed that other particles than 3He+ and tritons")
    thisalinea.textcontent.append("cannot reach the focal plane detectors by travelling through the dipole magnets of")
    thisalinea.textcontent.append("Grand Raiden. Hence, due to the geometry of the setup, the probability that a")
    thisalinea.textcontent.append("particle other than 3He+ or a triton can produce more than two position coordinates")
    thisalinea.textcontent.append("is extremely small. Therefore, the condition of having 3 or 4 position coordinates")
    thisalinea.textcontent.append("almost acts as a particle identiﬁcation condition. The distinction between 3He+ and")
    thisalinea.textcontent.append("tritons is made on the basis of excitation energy (see Figure 4.4).")
    thisalinea.textcontent.append("Up to this point, our own track reconstruction procedure was discussed (this is also")
    thisalinea.textcontent.append("the procedure that was employed through the rest of this thesis). However, the")
    thisalinea.textcontent.append("Table 4.1: Number of events (in millions) for which a triton track could be recon-")
    thisalinea.textcontent.append("structed. ‘Success type’ refers to the number of successfully obtained position coor-")
    thisalinea.textcontent.append("dinates that were used to reconstruct the track (no particle identiﬁcation of any kind")
    thisalinea.textcontent.append("was applied to obtain these numbers).")
    thisalinea.textcontent.append("Success type 116Sn 122Sn sieve-slit")
    thisalinea.textcontent.append("4 pos.-co. 4.3 8.9 2.8")
    thisalinea.textcontent.append("3 pos.-co. 2.0 4.1 0.67")
    thisalinea.textcontent.append("No track 40.7 81.1 0.89")
    thisalinea.textcontent.append("Total 47.0 94.1 4.4")
    thisalinea.textcontent.append("analyser program introduced in Section 3.7 also provided a track reconstruction using")
    thisalinea.textcontent.append("the same parameters {xfp, yfp, θfp, φfp}. In Figure 4.3, the diﬀerences between these")
    thisalinea.textcontent.append("two procedures are displayed for the events in the sieve-slit data under the condition")
    thisalinea.textcontent.append("that all 4 position coordinates were available.")
    thisalinea.textcontent.append("Figure 4.3: Obtained diﬀerences for the sieve-slit data between the track-")
    thisalinea.textcontent.append("reconstruction method developed for the present data and the track reconstruction")
    thisalinea.textcontent.append("method of the analyser program.")
    thisalinea.textcontent.append("To correctly interpret Figure 4.3, it is important to know that xfp usually takes on")
    thisalinea.textcontent.append("values between ±500.0 mm, that yfp usually takes on values between ±40.0 mm, that")
    thisalinea.textcontent.append("θfp usually takes on values between ±70 mrad and that φfp usually takes on values")
    thisalinea.textcontent.append("between ±20 mrad. Hence, the diﬀerences in xfp are extremely small with respect")
    thisalinea.textcontent.append("to the range of values that xfp can assume. The diﬀerences in yfp and θfp are also")
    thisalinea.textcontent.append("quite small with respect to their range of values, but the diﬀerences in φfp are not so")
    thisalinea.textcontent.append("small with respect to their range. This is to be expected. The triton energy mainly is")
    thisalinea.textcontent.append("measured by the horizontal position xfp and the horizontal scattering angle mainly by")
    thisalinea.textcontent.append("θfp, but the vertical scattering angle cannot be measured accurately by φfp. This is")
    thisalinea.textcontent.append("why our measurements were performed in over-focus mode (see Section 3.5), in which")
    thisalinea.textcontent.append("the vertical scattering angle can also be measured by yfp and the uncertainty in φfp")
    thisalinea.textcontent.append("will not aﬀect the results much.")
    thisalinea.textcontent.append("Similar comparisons between the two track reconstruction methods were also made")
    thisalinea.textcontent.append("for the 116Sn data and for the 122Sn data. The conclusions are similar to the ones")
    thisalinea.textcontent.append("made above for the sieve-slit data.")
    thisalinea.textcontent.append("For certain events, the track reconstruction of the analyser program introduced in")
    thisalinea.textcontent.append("Section 3.7 showed some bugs, and it did not oﬀer track reconstruction in the case")
    thisalinea.textcontent.append("where only 3 position coordinates were available. In Section 4.4, it will be shown that")
    thisalinea.textcontent.append("these events are essential to correct for the detection eﬃciency of the MWDC wire")
    thisalinea.textcontent.append("planes. For these two reasons, we have chosen to use our own procedure for the track")
    thisalinea.textcontent.append("reconstruction instead (described in this section). However, Figure 4.3 shows that")
    thisalinea.textcontent.append("our method gives about the same results as the track reconstruction of the analyser")
    thisalinea.textcontent.append("program introduced in Section 3.7 in the situation where both methods could be")
    thisalinea.textcontent.append("applied. Since both methods were developed independently, this is a good indication")
    thisalinea.textcontent.append("that the track-reconstruction method developed for the present data is reliable.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "4.3 Sieve-slit analysis"
    thisalinea.nativeID = 29
    thisalinea.parentID = 26
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "The next step in our data analysis is to trace the triton tracks {xfp, yfp, θfp, φfp} back to the target. We chose to describe a triton track at the target with the following parameters: {Et, θt, φt}. The subscript t shows that this track is described at the target, immediately after the reaction. Et is the kinetic energy of the triton and θ and φ are the horizontal and vertical scattering angles. In Section 3.5, it was discussed how the relation between triton tracks in the focal plane and triton tracks at the target could be measured. In this "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The next step in our data analysis is to trace the triton tracks {xfp, yfp, θfp, φfp} back")
    thisalinea.textcontent.append("to the target. We chose to describe a triton track at the target with the following")
    thisalinea.textcontent.append("parameters: {Et, θt, φt}. The subscript t shows that this track is described at the")
    thisalinea.textcontent.append("target, immediately after the reaction. Et is the kinetic energy of the triton and θ")
    thisalinea.textcontent.append("and φ are the horizontal and vertical scattering angles.")
    thisalinea.textcontent.append("In Section 3.5, it was discussed how the relation between triton tracks in the focal")
    thisalinea.textcontent.append("plane and triton tracks at the target could be measured. In this section, it will be")
    thisalinea.textcontent.append("described how this measurement (the sieve-slit data) can be used to obtain a 1-to-1")
    thisalinea.textcontent.append("mapping between these two tracks, so that all triton tracks can be individually traced")
    thisalinea.textcontent.append("back to the target. Our method follows the procedures outlined in Refs. [71, 73, 90].")
    thisalinea.textcontent.append("It is assumed that the mapping of the triton track {xfp, yfp, θfp, φfp} to the track")
    thisalinea.textcontent.append("{Et, θt, φt} is described by some unknown function f , which is Taylor-expanded as")
    thisalinea.textcontent.append("follows:")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("Et")
    thisalinea.textcontent.append("θt")
    thisalinea.textcontent.append("φt")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append(" = f")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("xfp")
    thisalinea.textcontent.append("yfp")
    thisalinea.textcontent.append("θfp")
    thisalinea.textcontent.append("φfp")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("=")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("E0 + (E|x) · xfp + (E|y) · yfp + (E|θ) · θfp + (E|φ) · φfp + h.o.t.")
    thisalinea.textcontent.append("θ0 + (θ|x) · xfp + (θ|y) · yfp + (θ|θ) · θfp + (θ|φ) · φfp + h.o.t.")
    thisalinea.textcontent.append("φ0 + (φ|x) · xfp + (φ|y) · yfp + (φ|θ) · θfp + (φ|φ) · φfp + h.o.t.")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("")
    thisalinea.textcontent.append("(4.1)")
    thisalinea.textcontent.append("Here, h.o.t refers to higher-order terms. The coeﬃcients similar to (E|x) in Equation")
    thisalinea.textcontent.append("(4.1) are known as the ion-optical coeﬃcients, or the transfer coeﬃcients [64, 71]. The")
    thisalinea.textcontent.append("problem at hand is to extract these coeﬃcients from the sieve-slit data. As a ﬁrst step")
    thisalinea.textcontent.append("towards solving this problem, the track-reconstruction parameters {xfp, yfp, θfp, φfp}")
    thisalinea.textcontent.append("were plotted against each other in pairs of two. This provided us with 6 diﬀerent plots,")
    thisalinea.textcontent.append("showing the correlations between the track-reconstruction parameters. By changing")
    thisalinea.textcontent.append("the parameters {xfp, yfp, θfp, φfp} manually, the correlations in these histograms were")
    thisalinea.textcontent.append("removed. An example of this procedure is illustrated in Figure 4.4.")
    thisalinea.textcontent.append("Figure 4.4: Parameters of the triton tracks through the focal plane before and after")
    thisalinea.textcontent.append("the manual removal of the correlations between those parameters. The excitation")
    thisalinea.textcontent.append("energies in Figure 4.4d were taken from Ref. [83].")
    thisalinea.textcontent.append("The C++ code used to perform the manual corrections for Figure 4.4 is:")
    thisalinea.textcontent.append("Figure 4.4b can now be compared to Figure 3.6. Since the distance between the target")
    thisalinea.textcontent.append("and the sieve-slit is known (585 mm), θt and φt are known for the events in the sieve-")
    thisalinea.textcontent.append("slit data. Likewise, Figure 4.4d can be compared to the excitation-energy spectra")
    thisalinea.textcontent.append("in Ref. [83] to calibrate the excitation energy. The excitation energies denoted in")
    thisalinea.textcontent.append("magenta in Figure 4.4d show the outcome of this calibration. Relativistic kinematics")
    thisalinea.textcontent.append("then allow us to compute Et.")
    thisalinea.textcontent.append("Knowing both {xfp, yfp, θfp, φfp} and {Et, θt, φt} for a single event in the sieve-slit data")
    thisalinea.textcontent.append("provided us with one Equation (4.1) that is linear in the unknown optical coeﬃcients.")
    thisalinea.textcontent.append("Repeating this procedure for all available events provided us with a linear system of")
    thisalinea.textcontent.append("equations. The optical coeﬃcients were then computed from the least squares solution")
    thisalinea.textcontent.append("of this linear system.")
    thisalinea.textcontent.append("Events that were not in one of the peaks in Figure 4.4d were not used in this procedure,")
    thisalinea.textcontent.append("because for those events, the excitation energy is not well known. For the same reason,")
    thisalinea.textcontent.append("events in the large red blob in the centre of the sieve-slit in Figure 4.4b and events")
    thisalinea.textcontent.append("not in one of the small blobs in that ﬁgure were not used either. Only events where")
    thisalinea.textcontent.append("the triton track could be reconstructed from all 4 position coordinates were used.")
    thisalinea.textcontent.append("This provided us with about 480, 000 equations for the optical coeﬃcients for Et and")
    thisalinea.textcontent.append("the same amounts for the optical coeﬃcients for θt and φt. All coeﬃcients up to the")
    thisalinea.textcontent.append("third order were taken along, in addition to a few higher-order coeﬃcients, which were")
    thisalinea.textcontent.append("known to be important.")
    thisalinea.textcontent.append("The limitation to (about) the third order was chosen carefully. The relation between")
    thisalinea.textcontent.append("the triton tracks in the focal plane and at the target is complicated, due to the use of")
    thisalinea.textcontent.append("diﬀerent focusing magnets (see Section 3.2), so it is important to use as many orders")
    thisalinea.textcontent.append("as possible. However, if all fourth order terms (or more) would be taken along, the")
    thisalinea.textcontent.append("condition number [91] of the linear system (after applying the least-squares method)")
    thisalinea.textcontent.append("would approach the inverse of the machine precision of the ROOT Double-numbers")
    thisalinea.textcontent.append("too closely to allow for an accurate solution. The reason for this is that in the θ-")
    thisalinea.textcontent.append("direction, data were taken through only ﬁve diﬀerent holes of the sieve-slit. It is also")
    thisalinea.textcontent.append("an intuitive conclusion not to use higher orders than third for a sieve-slit of only 5")
    thisalinea.textcontent.append("holes.")
    thisalinea.textcontent.append("The optical coeﬃcients were calculated twice. During the ﬁrst computation, Grand")
    thisalinea.textcontent.append("Raiden was assumed to be in the 0◦ position (as it was during the sieve-slit data")
    thisalinea.textcontent.append("taking), which means that before the linear system is solved, Et is computed from")
    thisalinea.textcontent.append("the excitation energies of Figure 4.4d and a scattering angle of α with α2 = θt")
    thisalinea.textcontent.append("During the second computation, Grand Raiden was assumed to be in the 2.5◦ po-")
    thisalinea.textcontent.append("sition, which means that before the linear system is solved, Et is computed from a")
    thisalinea.textcontent.append("scattering angle of α with α2 = (θt + 2.5◦)2 + φt")
    thisalinea.textcontent.append("optical coeﬃcients for both the 0◦ position and the 2.5◦ position, while the sieve-slit")
    thisalinea.textcontent.append("data were only available for the 0◦ position. During the kinematical computations of")
    thisalinea.textcontent.append("Et, the beam was assumed to hit the target exactly perpendicularly with an energy")
    thisalinea.textcontent.append("of 140 MeV/u.")
    thisalinea.textcontent.append("At this point, we would like to note that if any zero-point trajectory (see Figure")
    thisalinea.textcontent.append("4.2) would be added to the triton tracks {xfp, yfp, θfp, φfp} before the track is traced")
    thisalinea.textcontent.append("back with the optical coeﬃcients, it can be shown from Equation (4.1) that the same")
    thisalinea.textcontent.append("triton tracks {Et, θt, φt} are still obtained if the optical coeﬃcients are transformed")
    thisalinea.textcontent.append("appropriately. Moreover, it is precisely this transformation that is performed, if the")
    thisalinea.textcontent.append("optical coeﬃcients are calculated from the sieve-slit data with the same zero-point")
    thisalinea.textcontent.append("trajectory added. This is the reason why the precise choice of the zero-point trajectory")
    thisalinea.textcontent.append("in Figure 4.2 is not important: the triton tracks {Et, θt, φt} do not depend on it, as")
    thisalinea.textcontent.append("long as the choice for the zero-point trajectory is kept constant.")
    thisalinea.textcontent.append("In practice, the beam did not hit the target exactly perpendicularly. However, the")
    thisalinea.textcontent.append("exact angle at which the beam hit the target is diﬀerent for diﬀerent experimental")
    thisalinea.textcontent.append("runs (diﬀerences are smaller than 0.1◦). However, a precise measurement of this angle")
    thisalinea.textcontent.append("is not possible without knowing the optical coeﬃcients, so we assumed it to be exactly")
    thisalinea.textcontent.append("perpendicular for the kinematical calculations described above. Corrections to this")
    thisalinea.textcontent.append("assumption are applied in the end of this section and in Section 4.4.")
    thisalinea.textcontent.append("The results of applying the calculated optical coeﬃcients to the sieve-slit data are")
    thisalinea.textcontent.append("illustrated in Figure 4.5. The triton tracks {Et, θt, φt} at the target were obtained")
    thisalinea.textcontent.append("from applying the optical coeﬃcients. Subsequently, the excitation-energy spectrum")
    thisalinea.textcontent.append("was reconstructed from these triton tracks through relativistic kinematics (while as-")
    thisalinea.textcontent.append("suming a perpendicular beam). Only triton tracks for which all 4 position coordinates")
    thisalinea.textcontent.append("were obtained are shown in Figure 4.5. It is clear that the excitation-energy spectrum")
    thisalinea.textcontent.append("in Figure 4.5b is identical to the spectrum found in Ref. [83], as it should be. The")
    thisalinea.textcontent.append("diﬀerence between Figure 4.4 and Figure 4.5 is that in Figure 4.4 we removed the")
    thisalinea.textcontent.append("correlations manually and no calibrations were done. On the other hand, Figure 4.5")
    thisalinea.textcontent.append("is the result of applying the ion-optical coeﬃcients and does contain calibrations.")
    thisalinea.textcontent.append("The same optical coeﬃcients were also applied to the triton tracks for which only 3")
    thisalinea.textcontent.append("out of 4 position coordinates could be obtained. Since those triton tracks could be")
    thisalinea.textcontent.append("reconstructed less accurately, manual corrections were necessary after applying the")
    thisalinea.textcontent.append("optical coeﬃcients to ensure that the ﬁnal results matched Figure 4.5 exactly.")
    thisalinea.textcontent.append("The X-plane of the MWDC in the Grand Raiden focal plane has 192 vertical wires")
    thisalinea.textcontent.append("with a spacing of 6 mm between them [66]. Since 1 mm in the focal plane corre-")
    thisalinea.textcontent.append("sponds to about 34 keV in our experiment, this means that, theoretically, excitation")
    thisalinea.textcontent.append("Figure 4.5: Scattering angles of the triton tracks at the target and the excitation-")
    thisalinea.textcontent.append("energy spectrum of the recoil nucleus for the sieve-slit data (with a 13CH2 target).")
    thisalinea.textcontent.append("energies up to about 39 MeV could be measured. However, from Figure 4.5b we see")
    thisalinea.textcontent.append("that excitation energies above 28 MeV cannot be accurately reconstructed with our")
    thisalinea.textcontent.append("optical coeﬃcients. Inspecting individual events shows us that the peak near 30 MeV")
    thisalinea.textcontent.append("in Figure 4.5b is not the result of excitation of a level in the spectrum, but an exper-")
    thisalinea.textcontent.append("imental artefact. This is understandable, since any Taylor expansion will eventually")
    thisalinea.textcontent.append("break down somewhere and our inspection of the artefact shows that this happens")
    thisalinea.textcontent.append("above 28 MeV. Hence, excitation energies above 28 MeV cannot be reliably measured")
    thisalinea.textcontent.append("using our procedure. However, events corresponding to an excitation energy above")
    thisalinea.textcontent.append("15 MeV might already be less reliable, because the highest excitation-energy peak in")
    thisalinea.textcontent.append("the spectrum that we could match to a known state in the literature is at 15.06 MeV")
    thisalinea.textcontent.append("(see Figure 4.4d). These boundaries are the reason why we felt comfortable to trun-")
    thisalinea.textcontent.append("cate our shell model calculation in Section 2.2 after the ﬁrst 25 energy levels (which")
    thisalinea.textcontent.append("corresponds to a truncation above an excitation energy of 34 MeV).")
    thisalinea.textcontent.append("The results for applying the optical coeﬃcients to the data taken with the 116Sn and")
    thisalinea.textcontent.append("only applying the optical coeﬃcients to the data obtained with the 116Sn and 122Sn")
    thisalinea.textcontent.append("targets, respectively. The horizontal scattering angle in these ﬁgures is equal to θt for")
    thisalinea.textcontent.append("data obtained with Grand Raiden in the 0◦ mode and it is equal to θt + 2.5◦ for data")
    thisalinea.textcontent.append("obtained with Grand Raiden in the 2.5◦ mode. This is reﬂected by the two horizontal")
    thisalinea.textcontent.append("band structures in these ﬁgures.")
    thisalinea.textcontent.append("It is clear from Figures 4.6a and 4.6b that the positions of the various states in the")
    thisalinea.textcontent.append("excitation-energy spectrum still show some dependence on the scattering angle. This")
    thisalinea.textcontent.append("dependence has a number of diﬀerent reasons. The ﬁrst reason is that it was assumed")
    thisalinea.textcontent.append("that the beam hit the target perpendicularly, while Figures 4.6a and 4.6b show that")
    thisalinea.textcontent.append("this is not the case. As indicated in Section 3.4, the 3He+ beam spot is easily identiﬁed")
    thisalinea.textcontent.append("Figure 4.6: Results of applying our optical coeﬃcients to the data on the")
    thisalinea.textcontent.append("by its abundance. It is the large beam spot at negative excitation energies. From")
    thisalinea.textcontent.append("Figures 4.6a and 4.6b, it is clear that this spot is not exactly at zero degrees. The")
    thisalinea.textcontent.append("second reason is that the optical coeﬃcients for the 2.5◦ mode were obtained through")
    thisalinea.textcontent.append("data that were taken in the 0◦ mode, since sieve-slit data in the 2.5◦ mode were not")
    thisalinea.textcontent.append("available. The third reason is that the dispersive mode gives rise to uncertainties in")
    thisalinea.textcontent.append("the momentum vector of the beam (see Section 3.4). The fourth reason is that the")
    thisalinea.textcontent.append("Taylor expansion of Equation (4.1) was limited to third order (apart from a few well")
    thisalinea.textcontent.append("chosen higher-order terms). Finally, the ﬁfth reason is that the position xfp at the")
    thisalinea.textcontent.append("focal plane is proportional to the triton momentum, while we calibrated xfp against")
    thisalinea.textcontent.append("excitation energy. This introduces non-linearity in the calibration, which could only")
    thisalinea.textcontent.append("be modeled up to third order.")
    thisalinea.textcontent.append("Because of the reasons presented above, manual corrections were introduced in the")
    thisalinea.textcontent.append("obtained excitation energies for the data obtained with the 116Sn and 122Sn targets af-")
    thisalinea.textcontent.append("ter the optical coeﬃcients were applied. The purpose of these corrections is to remove")
    thisalinea.textcontent.append("the dependence on the horizontal and vertical scattering angles of the various states")
    thisalinea.textcontent.append("in the excitation-energy spectrum. The results of these corrections are illustrated in")
    thisalinea.textcontent.append("Figures 4.6c and 4.6d. Figures 4.6e and 4.6f are horizontal projections of Figures 4.6c")
    thisalinea.textcontent.append("and 4.6d and they show the excitation-energy spectrum of the recoil nucleus after")
    thisalinea.textcontent.append("these corrections.")
    thisalinea.textcontent.append("It is evident that both Figures 4.6e and 4.6f show two very large peaks. The largest one")
    thisalinea.textcontent.append("at negative excitation energies is due to 3He+ particles, as indicated above. Since this")
    thisalinea.textcontent.append("peak represents the unreacted beam, the distance between this peak and the next one")
    thisalinea.textcontent.append("(the ground state), should reﬂect the Q-value of the ground state. Ref. [21] calculates")
    thisalinea.textcontent.append("a Q-value of 4.722 MeV for the 116Sn(3He, t)116Sb charge-exchange reaction, while")
    thisalinea.textcontent.append("Figure 4.6e provides us with 4.647 MeV. The diﬀerence of 75 keV between these")
    thisalinea.textcontent.append("numbers is quite large. However, the calculation from Ref. [21] did not include the")
    thisalinea.textcontent.append("eﬀects of energy loss in the target (which was about 6 keV for tritons and about")
    thisalinea.textcontent.append("24 keV for 3He). Moreover, the calibration of the excitation energy (see Figures 4.4d")
    thisalinea.textcontent.append("and 4.5b) was found to have a systematic uncertainty of about 40 keV FWHM. This")
    thisalinea.textcontent.append("number was obtained by comparing the positions of the two states near 6.36 MeV")
    thisalinea.textcontent.append("and 6.89 MeV in the excitation-energy spectrum of 13C (3He, t) 13N in Figure 4.5b to")
    thisalinea.textcontent.append("the positions of those same states as reported in Ref. [83]. Therefore, the diﬀerence")
    thisalinea.textcontent.append("of 75 keV can be reasonably explained by the systematic uncertainty of the energy")
    thisalinea.textcontent.append("calibration and the eﬀects of energy losses in the target. For the 122Sn(3He, t)122Sb")
    thisalinea.textcontent.append("charge-exchange reaction, Ref. [21] presented a ground-state Q-value of 1.624 MeV")
    thisalinea.textcontent.append("while Figure 4.6f provided us with 1.581 MeV.")
    thisalinea.textcontent.append("The other large peak is the so-called Isobaric Analogue State (IAS). The IAS is a")
    thisalinea.textcontent.append("narrow Fermi transition occurring for any (p, n)-type charge-exchange reaction (like")
    thisalinea.textcontent.append("the (3He, t) reaction) [13]. What makes the IAS so special is that it carries (almost)")
    thisalinea.textcontent.append("the full strength of the Fermi sum-rule (see Equation (2.8)). This has two important")
    thisalinea.textcontent.append("consequences. The ﬁrst one is that any ∆L = 0 transition in the excitation-energy")
    thisalinea.textcontent.append("spectrum other than the IAS must be a Gamow-Teller transition (it could also be a")
    thisalinea.textcontent.append("contribution from Giant Monopole Resonances, but those contributions only come in")
    thisalinea.textcontent.append("at high excitation energies and are expected to be small [5], see Section 5.3). Hence,")
    thisalinea.textcontent.append("one can easily distinguish between Fermi and Gamow-Teller transitions. The second")
    thisalinea.textcontent.append("consequence is that B(F ) = |N − Z| is known beforehand for the IAS. Therefore, a")
    thisalinea.textcontent.append("peak is available to us, which has a very large number of counts, a known B(F ) value")
    thisalinea.textcontent.append("and a reaction mechanism similar to Gamow-Teller transitions. Hence, the IAS can")
    thisalinea.textcontent.append("be used to test and verify our analysis procedures. This is the reason why Fermi")
    thisalinea.textcontent.append("transitions also had to be considered in Section 2.1 and why the IAS was selected in")
    thisalinea.textcontent.append("Tables 4.2 and 4.3 to test the dependence on the parameters in the theoretical model.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "4.4 Computation of the diﬀerential cross sections"
    thisalinea.nativeID = 30
    thisalinea.parentID = 26
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "In this section, we discuss how the diﬀerential cross section as a function of the scattering angle α was extracted for various states (peaks) in the excitation-energy spectrum (Figures 4.6e and 4.6f). As a ﬁrst step, we will derive a formula to compute this diﬀerential cross section in Subsection 4.4.1. Subsequently, it will be discussed in Subsection 4.4.2 how the various quantities in this formula can be extracted from the data. The actual computation of the cross section is then treated in Subsection 4.4.3. The procedure that we followed is derived from the deﬁnition of the diﬀerential cross section [44]: "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this section, we discuss how the diﬀerential cross section as a function of the")
    thisalinea.textcontent.append("scattering angle α was extracted for various states (peaks) in the excitation-energy")
    thisalinea.textcontent.append("spectrum (Figures 4.6e and 4.6f). As a ﬁrst step, we will derive a formula to compute")
    thisalinea.textcontent.append("this diﬀerential cross section in Subsection 4.4.1. Subsequently, it will be discussed")
    thisalinea.textcontent.append("in Subsection 4.4.2 how the various quantities in this formula can be extracted from")
    thisalinea.textcontent.append("the data. The actual computation of the cross section is then treated in Subsection")
    thisalinea.textcontent.append("4.4.3.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "4.4.1 Relevant formulas for the extraction of the cross sections"
    thisalinea.nativeID = 31
    thisalinea.parentID = 30
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "The procedure that we followed is derived from the deﬁnition of the diﬀerential cross section [44]: dR dΩ = dσ dΩ · t · I, (4.2) where dR/dΩ is the rate at which a certain reaction occurs in number of particles per time and per solid angle, t is the areal density of the target in number of particles per area, I is the beam intensity in number of particles per time and dσ/dΩ is the diﬀerential cross section in area per solid angle. However, if a reaction rate were measured over an inﬁnitesimal time interval dτ and/or an inﬁnitesimal "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The procedure that we followed is derived from the deﬁnition of the diﬀerential cross")
    thisalinea.textcontent.append("section [44]:")
    thisalinea.textcontent.append("dR")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("=")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("· t · I,")
    thisalinea.textcontent.append("(4.2)")
    thisalinea.textcontent.append("where dR/dΩ is the rate at which a certain reaction occurs in number of particles per")
    thisalinea.textcontent.append("time and per solid angle, t is the areal density of the target in number of particles")
    thisalinea.textcontent.append("per area, I is the beam intensity in number of particles per time and dσ/dΩ is the")
    thisalinea.textcontent.append("diﬀerential cross section in area per solid angle. However, if a reaction rate were")
    thisalinea.textcontent.append("measured over an inﬁnitesimal time interval dτ and/or an inﬁnitesimal solid angle")
    thisalinea.textcontent.append("dΩ, it would be impossible to accumulate any statistics for the measurement. There-")
    thisalinea.textcontent.append("fore, the best that one can do is to perform a measurement over a small ﬁnite solid")
    thisalinea.textcontent.append("angle A and approximate dR/dΩ by R/A where R is the reaction rate in number of")
    thisalinea.textcontent.append("particles per unit of time measured over solid angle A. Since the solid angle A of the")
    thisalinea.textcontent.append("measurement has to be covered by the detector, A has to include the eﬀects of the")
    thisalinea.textcontent.append("detector acceptance (which is why we denote it by A).")
    thisalinea.textcontent.append("The problem with the inﬁnitesimal time interval dτ can be solved more elegantly, since")
    thisalinea.textcontent.append("the diﬀerential cross section is time independent. To solve this problem, Equation")
    thisalinea.textcontent.append("(4.2) can be integrated over time. As long as the integration is limited over a single")
    thisalinea.textcontent.append("experimental run, t and A are independent of time and the integration is straightfor-")
    thisalinea.textcontent.append("ward. t and A are time-independent within a single run under the assumption that")
    thisalinea.textcontent.append("the target is uniform and the beam is not moving on the target during the run. The")
    thisalinea.textcontent.append("time integration and the approximation of dR/dΩ by R/A are illustrated by:")
    thisalinea.textcontent.append("Pprod")
    thisalinea.textcontent.append("A")
    thisalinea.textcontent.append("=")
    thisalinea.textcontent.append("(cid:90)")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("A")
    thisalinea.textcontent.append("R dτ =")
    thisalinea.textcontent.append("(cid:90) R")
    thisalinea.textcontent.append("A")
    thisalinea.textcontent.append("dτ ≈")
    thisalinea.textcontent.append("(cid:90) dR")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("dτ =")
    thisalinea.textcontent.append("(cid:90) dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("·t·I dτ =")
    thisalinea.textcontent.append("(cid:90)")
    thisalinea.textcontent.append("·t·")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("I dτ =")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("·t·Q")
    thisalinea.textcontent.append("(4.3)")
    thisalinea.textcontent.append("Here, Pprod is the time integral of R over the experimental run. This means that")
    thisalinea.textcontent.append("Pprod is the total number of particles produced (and not yet detected) by the reaction")
    thisalinea.textcontent.append("in the solid angle A during the run. Q is the time integral of I, which means that")
    thisalinea.textcontent.append("it is the total number of beam particles impinged on the target during the run. As")
    thisalinea.textcontent.append("indicated, A is the solid angle over which the measurement was taken.")
    thisalinea.textcontent.append("However, Pprod is the number of particles produced, not the number of particles")
    thisalinea.textcontent.append("detected. Fortunately, Pprod can be translated to a number of detected particles P")
    thisalinea.textcontent.append("by the overall detection eﬃciency (cid:15): Pprod = P/(cid:15). Hence, for a single experimental")
    thisalinea.textcontent.append("run, the diﬀerential cross section can be obtained by the following relation:")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("=")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("tQ")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("P")
    thisalinea.textcontent.append("(cid:15)A")
    thisalinea.textcontent.append("(4.4)")
    thisalinea.textcontent.append("A close inspection of Equation (4.4) reveals that all quantities except the diﬀerential")
    thisalinea.textcontent.append("cross section must depend on the speciﬁc experimental run (say, the n-th run). This")
    thisalinea.textcontent.append("dependence will be denoted by a subscript n from now on. The assumption that the")
    thisalinea.textcontent.append("diﬀerential cross section must be run-independent follows from the scientiﬁc premise")
    thisalinea.textcontent.append("that each measurement must be reproducible (it will also be veriﬁed experimentally in")
    thisalinea.textcontent.append("Figure 4.10). As for the other quantities: the target could be changed between runs.")
    thisalinea.textcontent.append("Hence t is run-dependent. A run can be long or short, hence Q, the total number")
    thisalinea.textcontent.append("of beam particles in the run, is diﬀerent for each experimental run. As a result, P ,")
    thisalinea.textcontent.append("the number of detected particles produced by the reaction, is run-dependent. The")
    thisalinea.textcontent.append("detector settings and position (0◦ mode and 2.5◦ mode) can be changed between runs,")
    thisalinea.textcontent.append("hence (cid:15) and A are also, in principle, run-dependent.")
    thisalinea.textcontent.append("Equation (4.4) also reveals that all quantities, except t and Q, depend on the scattering")
    thisalinea.textcontent.append("angle α. P depends on α because the diﬀerential cross section does. A has to depend")
    thisalinea.textcontent.append("on α, since we measure the dependence of the diﬀerential cross section on α by")
    thisalinea.textcontent.append("performing measurements for diﬀerent solid angles A. Moreover, there is no a priori")
    thisalinea.textcontent.append("reason to assume that the detection eﬃciency would not depend on the solid angle")
    thisalinea.textcontent.append("(and, hence, on α). To denote the dependence on the run number n and the scattering")
    thisalinea.textcontent.append("angle α explicitly, Equation (4.4) can be rewritten as:")
    thisalinea.textcontent.append("Pn(α) =")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(α) · (cid:15)n(α) · An(α) · tn · Qn (4.5)")
    thisalinea.textcontent.append("Measurements from diﬀerent experimental runs can now be combined by summing")
    thisalinea.textcontent.append("Equation (4.5) over n. Since the diﬀerential cross section is run-independent, Equation")
    thisalinea.textcontent.append("(4.5) can be rewritten as:")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(α) =")
    thisalinea.textcontent.append("(cid:80)")
    thisalinea.textcontent.append("(cid:80)")
    thisalinea.textcontent.append("(4.6)")
    thisalinea.textcontent.append("Equation (4.6) is the formula that was used in our work to compute the diﬀerential")
    thisalinea.textcontent.append("cross section for various states in the excitation-energy spectra. Hence, the next task")
    thisalinea.textcontent.append("is to discuss how the various quantities in Equation (4.6) can be extracted from our")
    thisalinea.textcontent.append("data.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "4.4.2 Extraction of peaks, acceptance and eﬃciency"
    thisalinea.nativeID = 32
    thisalinea.parentID = 30
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "For our measurements, tn was extracted by carefully weighting the targets after preparation and by measuring their dimensions. Only one 116Sn target was used for all experimental runs measuring 116Sn(3He, t)116Sb. Likewise, only one 122Sn tar- get was used for all experimental runs measuring 122Sn(3He, t)122Sb and only one target areal density was 1.87 ± 0.01 mg/cm2 and the 122Sn target areal density was 1.75 ± 0.01 mg/cm2. Extracting tn is then simply a matter of dividing the areal density by the atomic mass. Qn was extracted from the measurements of the Faraday Cups D1FC and Q1FC (see Section 3.2). "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("For our measurements, tn was extracted by carefully weighting the targets after")
    thisalinea.textcontent.append("preparation and by measuring their dimensions. Only one 116Sn target was used")
    thisalinea.textcontent.append("for all experimental runs measuring 116Sn(3He, t)116Sb. Likewise, only one 122Sn tar-")
    thisalinea.textcontent.append("get was used for all experimental runs measuring 122Sn(3He, t)122Sb and only one")
    thisalinea.textcontent.append("target areal density was 1.87 ± 0.01 mg/cm2 and the 122Sn target areal density was")
    thisalinea.textcontent.append("1.75 ± 0.01 mg/cm2. Extracting tn is then simply a matter of dividing the areal")
    thisalinea.textcontent.append("density by the atomic mass.")
    thisalinea.textcontent.append("Qn was extracted from the measurements of the Faraday Cups D1FC and Q1FC (see")
    thisalinea.textcontent.append("Section 3.2). These Faraday cups stopped the unreacted beam and measured the")
    thisalinea.textcontent.append("total amount of charge accumulated during a single experimental run. In Section 3.2,")
    thisalinea.textcontent.append("it was stated that Faraday Cup Q1FC (used in the 2.5◦ mode) had an eﬃciency of")
    thisalinea.textcontent.append("100%, while Faraday Cup D1FC had a lower eﬃciency for which a correction had to")
    thisalinea.textcontent.append("be applied. The imperfect eﬃciency is a result of the lateral beam spread due to the")
    thisalinea.textcontent.append("dispersive mode, which means that the precise eﬃciency of this Faraday cup depends")
    thisalinea.textcontent.append("on the individual beam tuning for each experiment. Hence, the number of 80% from")
    thisalinea.textcontent.append("Ref. [72] does not necessarily have to be correct for our situation. Therefore, we")
    thisalinea.textcontent.append("determined the eﬃciency of this Faraday cup from the requirement that B(F ) from")
    thisalinea.textcontent.append("the IAS has to match the theoretical result from the Fermi sum rule. The resulting")
    thisalinea.textcontent.append("eﬃciency is 84%. In Section 4.5, it will be discussed why the obtained number of 84%")
    thisalinea.textcontent.append("is reliable.")
    thisalinea.textcontent.append("The extraction of An(α) from the data was more tricky, because the eﬀects of the")
    thisalinea.textcontent.append("detector acceptance had to be modelled. In Section 3.2, it was explained that the")
    thisalinea.textcontent.append("aperture of Grand Raiden was elliptical. However, the true acceptance of Grand")
    thisalinea.textcontent.append("Raiden is more complicated than a simple ellipse due to the over-focus mode (see")
    thisalinea.textcontent.append("Section 3.4). The over-focus mode causes the acceptance to gain a momentum depen-")
    thisalinea.textcontent.append("dence, hence a dependence on the scattering angle. Therefore, the acceptance had to")
    thisalinea.textcontent.append("be extracted directly from the data. In order to do this, all events of all runs were")
    thisalinea.textcontent.append("accumulated into a single histogram per target material and per Grand Raiden mode")
    thisalinea.textcontent.append("(0◦ or 2.5◦), plotting θt versus φt for the triton tracks at the target. Subsequently,")
    thisalinea.textcontent.append("a boundary was put on this histogram to determine the edges of the Grand Raiden")
    thisalinea.textcontent.append("acceptance. The boundary was carefully tuned to obtain a suitable model for the")
    thisalinea.textcontent.append("acceptance. This acceptance model is illustrated for the 116Sn target in Figure 4.7a")
    thisalinea.textcontent.append("for the 0◦ mode of Grand Raiden and in Figure 4.7b for the 2.5◦ mode.")
    thisalinea.textcontent.append("The red peak at large θt in Figure 4.7b is an experimental artefact. At large excitation")
    thisalinea.textcontent.append("energies (above 20 MeV), the tritons in this region of θt come very close to the edges")
    thisalinea.textcontent.append("of the dipole magnetic ﬁelds of Grand Raiden. As a result, their ﬂight paths are")
    thisalinea.textcontent.append("diﬀerent, which is what produces the peak. For this reason, we have ignored the data")
    thisalinea.textcontent.append("for the 116Sn target in the region E∗ > 20 MeV and θt > 0.6◦. For the 122Sn target,")
    thisalinea.textcontent.append("this phenomenon occurred only at excitation energies higher than 28 MeV, which is")
    thisalinea.textcontent.append("outside the range of our Taylor expansion. Therefore, no such conditions needed to")
    thisalinea.textcontent.append("be imposed on the data of the 122Sn target.")
    thisalinea.textcontent.append("To investigate the dependence of the diﬀerential cross section on the scattering angle")
    thisalinea.textcontent.append("α, the scattering angle α was divided into bins of 0.3◦. This bin size was chosen as")
    thisalinea.textcontent.append("a trade-oﬀ between the requirement to keep suﬃcient statistics in each bin and the")
    thisalinea.textcontent.append("desire of having the bins as small as possible to learn as much about the relation")
    thisalinea.textcontent.append("between the diﬀerential cross section and α as possible. Since the diﬀerential cross")
    thisalinea.textcontent.append("section was assumed to have no dependence on the azimuthal angle (see Section 2.5),")
    thisalinea.textcontent.append("no binning was done here to achieve maximum statistics. Applying the acceptance")
    thisalinea.textcontent.append("models of Figures 4.7a and 4.7b to this binning then provided us with a proper model")
    thisalinea.textcontent.append("for An(α). This model is illustrated for the 116Sn target in Figure 4.7c.")
    thisalinea.textcontent.append("In Figure 4.7c, the red ring illustrates An(α) for a certain bin in α and for all 0◦ runs")
    thisalinea.textcontent.append("for the 116Sn target. Likewise, the blue ring illustrates An(α) for that same bin and")
    thisalinea.textcontent.append("for all 2.5◦ runs. The measurement error in An(α) was modelled as 0.02◦ times the")
    thisalinea.textcontent.append("length of the boundary between the red (blue) ring and the white background. This")
    thisalinea.textcontent.append("boundary was determined as previously described above. Therefore, this is the only")
    thisalinea.textcontent.append("source of inaccuracy. The boundary between the red (blue) ring and the green surface")
    thisalinea.textcontent.append("comes purely from the binning in α and is, therefore, known precisely. The error of")
    thisalinea.textcontent.append("0.02◦ was chosen to model the uncertainty of the choice of the boundary as well as")
    thisalinea.textcontent.append("possible. The centre of the An(α)-bins like Figure 4.7c was chosen to coincide with")
    thisalinea.textcontent.append("the position of the 3He+-peak.")
    thisalinea.textcontent.append("Figure 4.7: Extraction of An(α) from the data taken with the 116Sn target.")
    thisalinea.textcontent.append("The detection eﬃciency per MWDC wire plane was modelled as N4/(N3 + N4), where")
    thisalinea.textcontent.append("N4 is the number of events where a triton track could be reconstructed based on all")
    thisalinea.textcontent.append("4 position coordinates and N3 is the number of events where a triton track could be")
    thisalinea.textcontent.append("reconstructed based only on the 3 position coordinates from the 3 wire planes other")
    thisalinea.textcontent.append("than the one under study [73]. The total detection eﬃciency was then deﬁned as the")
    thisalinea.textcontent.append("product of the detection eﬃciencies of all 4 wire planes multiplied with 1 − τ , where τ")
    thisalinea.textcontent.append("is the total dead time of the DAQ system in the measurement run divided by the total")
    thisalinea.textcontent.append("duration of that run (τ is about 2%). Since the detection eﬃciency of each wire plane")
    thisalinea.textcontent.append("is completely independent of the other 3 wire planes, this product indeed deﬁnes the")
    thisalinea.textcontent.append("overall probability of a triton track being detected in all 4 wire planes. Therefore, if")
    thisalinea.textcontent.append("the only events used for Pn(α) were the triton tracks, which could be reconstructed")
    thisalinea.textcontent.append("from all 4 position coordinates, this product can model the detection eﬃciency (cid:15)n(α).")
    thisalinea.textcontent.append("Events were labelled per individual experimental run and per bin in the scattering")
    thisalinea.textcontent.append("angle α (see Figure 4.7c) before the detection eﬃciency was computed, so that the")
    thisalinea.textcontent.append("dependence on run number and scattering angle could be taken into account. Only")
    thisalinea.textcontent.append("events ending up inside one of the acceptance cuts of Figures 4.7a and 4.7b were")
    thisalinea.textcontent.append("taken along in the computation of the detection eﬃciency to eliminate background")
    thisalinea.textcontent.append("contributions. Since the detection eﬃciency of tritons and 3He+ particles is obviously")
    thisalinea.textcontent.append("diﬀerent, the events located in the 3He+-peaks of Figures 4.6e and 4.6f were not")
    thisalinea.textcontent.append("included in the computation of the detection eﬃciency. The overall detection eﬃciency")
    thisalinea.textcontent.append("in the 0◦ mode was about 81% for both Sn-targets, but varied slightly (at the level")
    thisalinea.textcontent.append("of < 2%) with run number and α-bin. The overall detection eﬃciency in the 2.5◦")
    thisalinea.textcontent.append("mode was about 63% with ﬂuctuations < 2% with respect to run number and α-bin")
    thisalinea.textcontent.append("for the 116Sn target. However, for the 122Sn target in the 2.5◦ mode, the eﬃciency")
    thisalinea.textcontent.append("varied between 58% and 65%. These variations were mainly with respect to run")
    thisalinea.textcontent.append("number. Since (cid:15)n(α) was calculated for every run and for diﬀerent bins in α, all these")
    thisalinea.textcontent.append("ﬂuctuations were properly taken into account.")
    thisalinea.textcontent.append("This leaves us with the extraction of Pn(α) from the data. Pn(α) were not extracted")
    thisalinea.textcontent.append("for individual runs, but only P (α) = (cid:80)")
    thisalinea.textcontent.append("it is clear that P (α) is all that one really needs to extract the diﬀerential cross section.")
    thisalinea.textcontent.append("To extract P (α), the data were accumulated in separate histograms for each bin in")
    thisalinea.textcontent.append("α. For each bin, the excitation energy vs. counts was plotted with a ﬁne binning.")
    thisalinea.textcontent.append("Data of diﬀerent runs were added together in the same histogram. Subsequently, a")
    thisalinea.textcontent.append("function was ﬁtted to each histogram. For most states in the excitation-energy spec-")
    thisalinea.textcontent.append("trum, this function was a pure Gaussian plus a positive piecewise linear background.")
    thisalinea.textcontent.append("However, for the IAS, the Gaussian was given thicker tails (described in Equation")
    thisalinea.textcontent.append("(4.7)). Subsequently, P (α) was computed as the integral of the Gaussian part of the")
    thisalinea.textcontent.append("ﬁt, in absolute number of counts. The computation of P (α) is illustrated for various")
    thisalinea.textcontent.append("bins in α for the 122Sn(3He, t)122Sb data in Figure 4.8 for the ground state and ﬁrst")
    thisalinea.textcontent.append("few excited states and in Figure 4.9 for the IAS.")
    thisalinea.textcontent.append("The sieve-slit correction contained some errors that manually had to be corrected")
    thisalinea.textcontent.append("for (this was illustrated in Figure 4.6). This is the reason why the Gaussian ﬁts")
    thisalinea.textcontent.append("sometimes need to have thicker tails. Since most states do not have extremely high")
    thisalinea.textcontent.append("Figure 4.8: Computation of P (α) (coloured areas) for various bins of α, for the")
    thisalinea.textcontent.append("are shown.")
    thisalinea.textcontent.append("Figure 4.9: Computation of P (α) (coloured areas) for various bins of α, for the IAS")
    thisalinea.textcontent.append("in the reaction 122Sn(3He, t)122Sb.")
    thisalinea.textcontent.append("statistics, the tails are not so desperately needed, but for the IAS this is diﬀerent.")
    thisalinea.textcontent.append("Hence, tails were included for the IAS. The same errors in the sieve-slit correction are")
    thisalinea.textcontent.append("also responsible for the ground states in Figures 4.6e and 4.6f being not precisely at")
    thisalinea.textcontent.append("zero energy. To correct for this, the excitation energies in the ﬁnal result were shifted")
    thisalinea.textcontent.append("over this diﬀerence. The Gaussian shape with tails used to ﬁt both IAS is given by:")
    thisalinea.textcontent.append("y(x) = p0e−z(cid:48)2/2 z(cid:48) = z if − p3 ≤ z ≤ p4 z =")
    thisalinea.textcontent.append("x − p1")
    thisalinea.textcontent.append("p2")
    thisalinea.textcontent.append("(4.7)")
    thisalinea.textcontent.append("z(cid:48) = p4 +")
    thisalinea.textcontent.append("z − p4")
    thisalinea.textcontent.append("√")
    thisalinea.textcontent.append("1 + p6")
    thisalinea.textcontent.append("z − p4")
    thisalinea.textcontent.append("if z ≥ p4 z(cid:48) = −p3 +")
    thisalinea.textcontent.append("z + p3")
    thisalinea.textcontent.append("√")
    thisalinea.textcontent.append("1 + p5")
    thisalinea.textcontent.append("z + p3")
    thisalinea.textcontent.append("if z ≤ −p3")
    thisalinea.textcontent.append("This function is described by 7 parameters {p0, ..., p6}. The ﬁrst three are the height,")
    thisalinea.textcontent.append("position and width of the pure Gaussian. Parameter p4 determines how much to the")
    thisalinea.textcontent.append("right from the mean the Gaussian shape makes a smooth transition to exponential")
    thisalinea.textcontent.append("decay. Parameter p6 determines the lifetime of this decay. The parameters p3 and p5")
    thisalinea.textcontent.append("have a similar role at the left of the Gaussian. The shape of the function presented")
    thisalinea.textcontent.append("in Equation (4.7) is illustrated in Figure 4.9.")
    thisalinea.textcontent.append("The quantity P (α) was computed as the analytic integral of Equation (4.7) (or of a")
    thisalinea.textcontent.append("pure Gaussian, in case no tails were used) after the peak was ﬁtted. The contribu-")
    thisalinea.textcontent.append("tion from the linear background was subtracted from the evaluation of the integral.")
    thisalinea.textcontent.append("Subsequently, the dimension of the evaluated integral was transformed to absolute")
    thisalinea.textcontent.append("number of counts. In order to ensure that the evaluated integral indeed represents")
    thisalinea.textcontent.append("the correct number of counts, each ﬁtted peak in each bin of α for each analyzed state")
    thisalinea.textcontent.append("was visually inspected and subjected to a χ2 test. Based on these tests, we conclude")
    thisalinea.textcontent.append("that P (α) indeed contains the right number of physical counts in the peak.")
    thisalinea.textcontent.append("As indicated in Section 4.3, the beam did not hit the target perpendicularly and")
    thisalinea.textcontent.append("the angle and position at which the beam hit the target were run-dependent. To")
    thisalinea.textcontent.append("correct for this dependence, a 3D Gaussian was ﬁtted through the 3He+ peak for")
    thisalinea.textcontent.append("each run separately. The 3D Gaussian is a product of a Gaussian in the excitation")
    thisalinea.textcontent.append("energy direction, a Gaussian in the θt direction and a Gaussian in the φt direction (see")
    thisalinea.textcontent.append("Figure 4.6). Through this ﬁt, E∗, θt and φt of the beam were determined for each run.")
    thisalinea.textcontent.append("Subsequently, each event was individually shifted by these quantities before adding")
    thisalinea.textcontent.append("them up in the histograms used to determine P (α). For runs taken in the 2.5◦ mode,")
    thisalinea.textcontent.append("the shift of the previous 0◦ mode run was used, since no 3He+ peak was available for")
    thisalinea.textcontent.append("these runs. To correct for possible errors in this procedure, events were also shifted")
    thisalinea.textcontent.append("over the mean E∗ of the IAS (computed from the ﬁts that led to Figure 4.10).")
    thisalinea.textcontent.append("For the 122Sn(3He, t)122Sb reaction, the 3He+ peak was approximately located at")
    thisalinea.textcontent.append("E∗ ≈ −1.57 MeV, θ ≈ −0.05◦ and φ ≈ 0.7◦. Variations in these numbers per run")
    thisalinea.textcontent.append("(which were corrected for by the shifts discussed above) were of the order of ∆E∗ ≈")
    thisalinea.textcontent.append("25 keV, ∆θ ≈ 0.02◦ and ∆φ ≈ 0.05◦. The IAS was located at about ∆E∗ ≈ 11.24 MeV")
    thisalinea.textcontent.append("and variations were of the order of ∆E∗ ≈ 10 keV. For the 116Sn(3He, t)116Sb reac-")
    thisalinea.textcontent.append("tion, the 3He+ peak was approximately located at E∗ ≈ −4.65 MeV, θ ≈ −0.03◦ and")
    thisalinea.textcontent.append("φ ≈ 0.61◦. Variations in these numbers per run (which were corrected for by the shifts")
    thisalinea.textcontent.append("discussed above) were of the order of ∆E∗ ≈ 2 keV, ∆θ ≈ 0.005◦ and ∆φ ≈ 0.002◦.")
    thisalinea.textcontent.append("The IAS was located at about ∆E∗ ≈ 8.37 MeV and variations were of the order of")
    thisalinea.textcontent.append("∆E∗ ≈ 1 keV.")
    thisalinea.textcontent.append("Since the IAS is always a very narrow state [13], this peak was used to determine the")
    thisalinea.textcontent.append("energy resolution of our measurements. This resolution is given by the width of the")
    thisalinea.textcontent.append("Gaussian ﬁt (parameter p2 in Equation (4.7)). After the resolution was determined")
    thisalinea.textcontent.append("from the ﬁt for each bin in α, those resolutions were plotted against α and interpolated")
    thisalinea.textcontent.append("by a quadratic function around α = 0 to obtain a smooth variation of the energy")
    thisalinea.textcontent.append("resolution with α. Subsequently, this quadratic function was used to ﬁx the width of")
    thisalinea.textcontent.append("all other Gaussian ﬁts for all other states in the spectrum. For the 116Sn target, an")
    thisalinea.textcontent.append("energy resolution of σ = (30.4 + 1.10α2) keV was obtained (α is in degrees). For the")
    thisalinea.textcontent.append("These energy resolutions are quite a bit larger than the σ = 14 keV that was obtained")
    thisalinea.textcontent.append("with the faint beam technique (see Section 3.4). One of the reasons for this diﬀerence")
    thisalinea.textcontent.append("is the diﬀerence in energy loss in the target depending on where the charge-exchange")
    thisalinea.textcontent.append("reaction occurred (see Section 3.4). With the Bethe-Bloch formula [79], this diﬀerence")
    thisalinea.textcontent.append("in energy loss was calculated to be 17.1 keV for the 122Sn target and 19.3 keV for the")
    thisalinea.textcontent.append("in the magnetic ﬁelds of Grand Raiden, variations in beam tuning between the dif-")
    thisalinea.textcontent.append("ferent experimental runs, and, possibly, a coupling from the IAS to Giant Monopole")
    thisalinea.textcontent.append("Resonances (see Ref. [5]) for more details).")
    thisalinea.textcontent.append("To avoid the coupling from the IAS to Giant Monopole Resonances, one could, in")
    thisalinea.textcontent.append("theory, also have chosen a well-known low-lying state to determine the energy reso-")
    thisalinea.textcontent.append("lution. This was attempted in our data analysis and failed. There are two reasons")
    thisalinea.textcontent.append("for this. The ﬁrst one is that the IAS has much more statistics than these low-lying")
    thisalinea.textcontent.append("states (at least several factors). The second reason is, that the suitable well-known")
    thisalinea.textcontent.append("low-lying states lie very close together for both of our targets (see Figure 4.8 for an")
    thisalinea.textcontent.append("illustration). For this reason, ﬁtting these states to Gaussians without prior knowl-")
    thisalinea.textcontent.append("edge on the widths of these (overlapping) Gaussians will introduce large systematic")
    thisalinea.textcontent.append("errors. Hence, the low-lying states could not be used to accurately determine the")
    thisalinea.textcontent.append("energy resolution and we chose to use the IAS instead.")
    thisalinea.textcontent.append("The reason for choosing to describe the energy resolution with a quadratic depen-")
    thisalinea.textcontent.append("dence on α (in the present range of α) was purely phenomenological. The plot with")
    thisalinea.textcontent.append("obtained resolutions from the IAS against scattering angle contains large ﬂuctuations")
    thisalinea.textcontent.append("(for both targets). The cause of these ﬂuctuations is the use of Equation (4.7). This")
    thisalinea.textcontent.append("equation contains quite a lot of parameters that have to be ﬁtted to one single peak.")
    thisalinea.textcontent.append("Hence, it can sometimes be diﬃcult to disentangle all of these parameters, causing")
    thisalinea.textcontent.append("parameter p2, the Gaussian width, to ﬂuctuate. As a result, these ﬂuctuations need")
    thisalinea.textcontent.append("to be smoothened out to prevent ﬂuctuations in the cross sections of other states. A")
    thisalinea.textcontent.append("quadratic function turned out to a good choice, while simultaneously providing good")
    thisalinea.textcontent.append("ﬁts for the other states in the spectrum. Nevertheless, the quadratic dependence")
    thisalinea.textcontent.append("might seem odd, as a simple geometrical argument would suggest that the contri-")
    thisalinea.textcontent.append("bution from energy loss in the target to the resolution should depend linearly on α.")
    thisalinea.textcontent.append("Given the large ﬂuctuations in the resolution versus scattering angle, a linear func-")
    thisalinea.textcontent.append("tion could also have been used to smoothen the ﬂuctuations. However, the quadratic")
    thisalinea.textcontent.append("function turned out to give better results for ﬁtting the states in the excitation-energy")
    thisalinea.textcontent.append("spectrum. The fact that a (weak) quadratic function performs well for this task might")
    thisalinea.textcontent.append("suggest that other contributions (discussed above) to the resolution than the energy")
    thisalinea.textcontent.append("loss in the target may be signiﬁcant. The fact that the beam resolution of 14 keV")
    thisalinea.textcontent.append("and the computed diﬀerence in energy loss added in quadrature, is signiﬁcantly less")
    thisalinea.textcontent.append("than the energy resolutions at α = 0 provides further evidence for this.")
    thisalinea.textcontent.append("A close inspection of the region between the 3He+ peak and the ground state in")
    thisalinea.textcontent.append("Figures 4.6e and 4.6f reveals that the spectra have an almost negligible instrumental")
    thisalinea.textcontent.append("background. The reason for this is that this background was already eliminated by")
    thisalinea.textcontent.append("the conditions imposed in Sections 4.1 and 4.2. However, the recoil nucleus 116Sb")
    thisalinea.textcontent.append("has a proton separation energy of Sp = 4.077 MeV and a neutron separation energy")
    thisalinea.textcontent.append("of Sn = 7.890 MeV [21]. Therefore, above an excitation energy of 4.077 MeV, the")
    thisalinea.textcontent.append("spectrum will develop a physical background due to proton emission. Moreover, the")
    thisalinea.textcontent.append("excitation-energy spectrum of 116Sb is rich and complex [21], meaning that also below")
    thisalinea.textcontent.append("4.077 MeV a large number of closely-packed states are present. Most of these states")
    thisalinea.textcontent.append("have quite high angular momentum. Hence, close to α = 0 the contributions from")
    thisalinea.textcontent.append("these states will be small. Nevertheless, the sum of these contributions can provide")
    thisalinea.textcontent.append("a non-zero background for the Gamow-Teller states even below 4.077 MeV. Another")
    thisalinea.textcontent.append("background source comes from the fact that the isotope enrichment of the target is")
    thisalinea.textcontent.append("not exactly 100% (see Section 3.1). For all these reasons, a background has to be")
    thisalinea.textcontent.append("added to our ﬁts. The same arguments also apply to the 122Sb nucleus, except that")
    thisalinea.textcontent.append("here, Sp = 6.425 MeV and Sn = 6.806 MeV [21].")
    thisalinea.textcontent.append("The rich and complex excitation-energy spectra of the recoil nuclei were also the")
    thisalinea.textcontent.append("reason why the beam was given a dispersive beam proﬁle (see Section 3.4). Without")
    thisalinea.textcontent.append("it, it would not have been possible to resolve the individual Gamow-Teller states in")
    thisalinea.textcontent.append("the excitation-energy spectra [21, 63].")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "4.4.3 Cross-section results"
    thisalinea.nativeID = 33
    thisalinea.parentID = 30
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "Now that all individual components in Equation (4.6) have been discussed and ob- tained for each run, the diﬀerential cross section for each individual peak in the excitation-energy spectra in Figures 4.6e and 4.6f can be obtained. The results are illustrated for the IAS of both nuclei in Figure 4.10. In these ﬁgures, the black curves show the outcome of Equation (4.6). The other curves show the diﬀerential cross sec- tions when Equation (4.6) is limited to individual experimental runs (meaning that there is no summing over individual runs). The coloured numbers are the numbers used to label these individual "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Now that all individual components in Equation (4.6) have been discussed and ob-")
    thisalinea.textcontent.append("tained for each run, the diﬀerential cross section for each individual peak in the")
    thisalinea.textcontent.append("excitation-energy spectra in Figures 4.6e and 4.6f can be obtained. The results are")
    thisalinea.textcontent.append("illustrated for the IAS of both nuclei in Figure 4.10. In these ﬁgures, the black curves")
    thisalinea.textcontent.append("show the outcome of Equation (4.6). The other curves show the diﬀerential cross sec-")
    thisalinea.textcontent.append("tions when Equation (4.6) is limited to individual experimental runs (meaning that")
    thisalinea.textcontent.append("there is no summing over individual runs). The coloured numbers are the numbers")
    thisalinea.textcontent.append("used to label these individual runs during the experiment. The horizontal error bars")
    thisalinea.textcontent.append("have a length of σ = 0.3◦/2")
    thisalinea.textcontent.append("3 is used to approximate")
    thisalinea.textcontent.append("the rectangular bin width by a Gaussian standard deviation.")
    thisalinea.textcontent.append("3 = 0.087◦. The factor 1/2")
    thisalinea.textcontent.append("√")
    thisalinea.textcontent.append("√")
    thisalinea.textcontent.append("Figure 4.10: Experimentally-determined cross sections for the IAS. The black curve")
    thisalinea.textcontent.append("shows the result for using all data after summing over all experimental runs according")
    thisalinea.textcontent.append("to Equation (4.6). The other curves show the results for individual runs.")
    thisalinea.textcontent.append("The advantage of combining the data of diﬀerent experimental runs through Equation")
    thisalinea.textcontent.append("(4.6) is that the Gaussian ﬁt can be made after the runs are added. For most states")
    thisalinea.textcontent.append("in the excitation-energy spectra, the statistics were too low even to attempt Gaussian")
    thisalinea.textcontent.append("ﬁts for individual runs. However, for both IAS, this could be done. In order to make")
    thisalinea.textcontent.append("the most accurate ﬁts in the situation where only few counts (from a single run)")
    thisalinea.textcontent.append("were available, all parameters, except p0, were ﬁxed prior to the ﬁtting (see Equation")
    thisalinea.textcontent.append("(4.7)). The values for ﬁxing the parameters were determined from the black curves")
    thisalinea.textcontent.append("(where all the runs were used in the ﬁt).")
    thisalinea.textcontent.append("From Figure 4.10, it is clear that the results for individual runs match the black")
    thisalinea.textcontent.append("curve (the combinations of the runs) approximately up to the measurement errors.")
    thisalinea.textcontent.append("Hence, there is no signiﬁcant diﬀerence between the cross sections determined from")
    thisalinea.textcontent.append("the various runs. Therefore, Figure 4.10 provides experimental veriﬁcation of the")
    thisalinea.textcontent.append("claim in Subsection 4.4.1 that the cross section has no dependence on n, which was")
    thisalinea.textcontent.append("used to derive Equation (4.6).")
    thisalinea.textcontent.append("Once the cross section for a speciﬁc state is extracted from the data according to")
    thisalinea.textcontent.append("Equation (4.6), two ﬁnal steps need to be taken before this cross section can be ﬁtted")
    thisalinea.textcontent.append("to the results of Section 2.6. The ﬁrst step is to transform the data from the lab-")
    thisalinea.textcontent.append("frame to the centre-of-mass frame. Since the sieve-slit and the target were at rest")
    thisalinea.textcontent.append("in the lab-frame and the triton tracks were traced back to the target based on these")
    thisalinea.textcontent.append("sieve-slit data (see Section 4.3), Et, θt, φt, and α are all deﬁned in the lab-frame. The")
    thisalinea.textcontent.append("transformation was done point-by-point. The results in Figure 4.10 are still in the")
    thisalinea.textcontent.append("lab-frame.")
    thisalinea.textcontent.append("The second step is to determine the smearing resolution that has to be used in the")
    thisalinea.textcontent.append("procedures of Section 2.6. This resolution is a convolution of the angular resolution in")
    thisalinea.textcontent.append("θt, the angular resolution in φt, and the bin width in α. The angular resolutions for")
    thisalinea.textcontent.append("θt and φt were determined from the sieve-slit data by ﬁtting Gaussians through the")
    thisalinea.textcontent.append("small blobs of the data displayed in Figure 4.5a. The resolution in θt was determined")
    thisalinea.textcontent.append("to be 0.09◦ and the resolution in φt was determined to be 0.15◦. As stated before, the")
    thisalinea.textcontent.append("standard deviation of a bin in α is 0.09◦. The quadratic addition of these numbers")
    thisalinea.textcontent.append("provides us with a smearing resolution of σ ≈ 0.2◦.")
    thisalinea.textcontent.append("However, the 3He+ peak of the data obtained with the 122Sn target showed a con-")
    thisalinea.textcontent.append("siderable spread in both θt and φt. This spread indicated that the beam itself also")
    thisalinea.textcontent.append("carried an angular resolution that had to be taken along in the smearing. Therefore,")
    thisalinea.textcontent.append("the resulting smearing resolution for the 122Sn target became σ = 0.3◦. For the 116Sn")
    thisalinea.textcontent.append("target, the 3He+ peak was very narrow in the direction of both θt and φt and σ = 0.2◦")
    thisalinea.textcontent.append("still remains the ﬁnal resolution to be used in the analysis.")
    thisalinea.textcontent.append("The ﬁtting of the outcomes from Section 2.6 to the measured cross section (computed")
    thisalinea.textcontent.append("with Equation (4.6)) and the extraction of B(GT ) or B(F ) is discussed in the next")
    thisalinea.textcontent.append("section.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "4.5 Multipole decomposition analysis"
    thisalinea.nativeID = 34
    thisalinea.parentID = 26
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "To determine the quantum numbers ∆L, ∆S and ∆J of a speciﬁc transition, the diﬀerential cross section of that speciﬁc state in the excitation-energy spectrum can be ﬁtted by DWBA calculations assuming a theoretical model (see Figure 2.5 for an illustration). In the present case, these quantum numbers were determined by comparing the experimental data to DWBA calculations displayed in Figure 2.5 and to the known excited states listed in Ref. [21]. For the IAS, the comparison is straightforward, since it is a Fermi transition with ∆L = ∆S = ∆J = 0. Hence, only one option in Figure 2.5 "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("To determine the quantum numbers ∆L, ∆S and ∆J of a speciﬁc transition, the")
    thisalinea.textcontent.append("diﬀerential cross section of that speciﬁc state in the excitation-energy spectrum can")
    thisalinea.textcontent.append("be ﬁtted by DWBA calculations assuming a theoretical model (see Figure 2.5 for")
    thisalinea.textcontent.append("an illustration). In the present case, these quantum numbers were determined by")
    thisalinea.textcontent.append("comparing the experimental data to DWBA calculations displayed in Figure 2.5 and")
    thisalinea.textcontent.append("to the known excited states listed in Ref. [21].")
    thisalinea.textcontent.append("For the IAS, the comparison is straightforward, since it is a Fermi transition with")
    thisalinea.textcontent.append("∆L = ∆S = ∆J = 0. Hence, only one option in Figure 2.5 remains (a separate version")
    thisalinea.textcontent.append("of Figure 2.5 was computed for the 122Sn target). This model was ﬁtted to the")
    thisalinea.textcontent.append("experimental data and the overall normalization was the only ﬁtting parameter, as")
    thisalinea.textcontent.append("indicated in Chapter 2 and in agreement with Refs. [11] and [35]. Subsequently, the")
    thisalinea.textcontent.append("B(F ) values were computed with the extrapolation method of Section 2.7. The results")
    thisalinea.textcontent.append("are shown in Figure 4.11. The ﬁt probability shown in the ﬁgure is the probability")
    thisalinea.textcontent.append("to obtain the corresponding reduced χ2-value, or any larger value. The E∗ shown in")
    thisalinea.textcontent.append("the ﬁgure is the measured excitation energy of the transition.")
    thisalinea.textcontent.append("Figure 4.11: Fitting of the theoretical model from Chapter 2 to the measured data")
    thisalinea.textcontent.append("for the diﬀerential cross section of the IAS in the centre-of-mass frame.")
    thisalinea.textcontent.append("In order to explore to what extent the obtained B(F ) values depend on the model")
    thisalinea.textcontent.append("used to ﬁt the data, several parameters of the model were varied. Subsequently, the")
    thisalinea.textcontent.append("B(F ) values were also extracted for these varied parameters and compared to the")
    thisalinea.textcontent.append("outcome of the sum rule. The speciﬁc parameter variations and the results for those")
    thisalinea.textcontent.append("variations are displayed in Tables 4.2 and 4.3. In these tables, the numbers presented")
    thisalinea.textcontent.append("in bold correspond to the theoretical model as discussed in Chapter 2 without any")
    thisalinea.textcontent.append("modiﬁcations. This situation is the one that applies to Figure 4.11 and this is also the")
    thisalinea.textcontent.append("situation that we will continue to use in the remainder of this thesis, unless otherwise")
    thisalinea.textcontent.append("indicated. It is clear from Tables 4.2 and 4.3 that all parameter variations investigated")
    thisalinea.textcontent.append("result in a diﬀerence smaller than 1σ (1σ being the measurement error in B(F ), which")
    thisalinea.textcontent.append("is shown in the ‘Err’-column) between the measured B(F ) value and the B(F ) value")
    thisalinea.textcontent.append("Table 4.2: Eﬀects on the ﬁnal B(F ) values and on the ﬁt quality for certain parameter")
    thisalinea.textcontent.append("changes in the theoretical model for the diﬀerential cross section of the IAS of the")
    thisalinea.textcontent.append("ﬁts in this table. The sum rule (2.8) prescribes that B(F ) = 16. ‘Opt. Pot.’ refers")
    thisalinea.textcontent.append("to changes in the optical-potential parameters.")
    thisalinea.textcontent.append("Parameter changes B(F ) Err. red. χ2 Fit prob.")
    thisalinea.textcontent.append("Model parameters from Chapter 2 16.0 0.88 1.103 35.0%")
    thisalinea.textcontent.append("WSAW: lower Ebind by 2 MeV 16.0 0.88 1.308 19.9%")
    thisalinea.textcontent.append("Set VSO = 0 in WSAW 16.0 0.88 1.104 34.9%")
    thisalinea.textcontent.append("Set a = 1.0 fm in WSAW 15.9 0.88 0.868 58.7%")
    thisalinea.textcontent.append("Set R = 1.0A1/3 fm in WSAW 16.2 0.89 9.482 4.54 · 10−20")
    thisalinea.textcontent.append("Set all OBTDs to 1 in FOLD 15.9 0.88 0.985 46.3%")
    thisalinea.textcontent.append("Opt. Pot: set Ws = 0 15.8 0.87 8.627 7.04 · 10−18")
    thisalinea.textcontent.append("Opt. Pot: set Ws = 15 MeV 16.0 0.88 0.936 51.4%")
    thisalinea.textcontent.append("Opt. Pot: reduce VR by 5 MeV 16.2 0.89 3.700 6.29 · 10−6")
    thisalinea.textcontent.append("Opt. Pot: reduce rR by 0.3 fm 16.0 0.88 4.826 1.69 · 10−8")
    thisalinea.textcontent.append("Opt. Pot: reduce aR by 0.3 fm 15.6 0.86 0.214 99.9%")
    thisalinea.textcontent.append("Opt. Pot: reduce VI by 5 MeV 15.9 0.88 1.519 10.2%")
    thisalinea.textcontent.append("Opt. Pot: reduce rI by 0.3 fm 15.6 0.86 13.24 6.72 · 10−30")
    thisalinea.textcontent.append("Opt. Pot: reduce aI by 0.3 fm 15.8 0.87 1.511 10.4%")
    thisalinea.textcontent.append("Opt. Pot: set outgoing depths 16.6 0.92 4.678 3.76 · 10−8")
    thisalinea.textcontent.append("to 70% of incoming depths")
    thisalinea.textcontent.append("Table 4.3: Same as Table 4.2, but now for the 122Sn(3He, t)122Sb reaction. The sum")
    thisalinea.textcontent.append("rule (2.8) now prescribes that B(F ) = 22.")
    thisalinea.textcontent.append("Parameter changes B(F ) Err. red. χ2 Fit prob.")
    thisalinea.textcontent.append("Model parameters from Chapter 2 22.5 1.21 1.017 43.1%")
    thisalinea.textcontent.append("WSAW: lower Ebind by 2 MeV 22.6 1.21 1.043 40.5%")
    thisalinea.textcontent.append("Set VSO = 0 in WSAW 22.5 1.22 1.016 43.2%")
    thisalinea.textcontent.append("Set a = 1.0 fm in WSAW 22.4 1.21 1.010 43.8%")
    thisalinea.textcontent.append("Set R = 1.0A1/3 fm in WSAW 23.2 1.25 8.072 1.82 · 10−16")
    thisalinea.textcontent.append("Set all OBTDs to 1 in FOLD 22.5 1.21 0.941 50.8%")
    thisalinea.textcontent.append("Opt. Pot: set Ws = 0 22.7 1.22 6.890 1.68 · 10−13")
    thisalinea.textcontent.append("Opt. Pot: set Ws = 15 MeV 22.5 1.21 0.984 32.3%")
    thisalinea.textcontent.append("Opt. Pot: reduce VR by 5 MeV 23.0 1.24 3.304 4.57 · 10−5")
    thisalinea.textcontent.append("Opt. Pot: reduce rR by 0.3 fm 22.8 1.23 4.499 9.80 · 10−8")
    thisalinea.textcontent.append("Opt. Pot: reduce aR by 0.3 fm 21.9 1.18 0.755 70.9%")
    thisalinea.textcontent.append("Opt. Pot: reduce VI by 5 MeV 22.5 1.21 0.964 48.4%")
    thisalinea.textcontent.append("Opt. Pot: reduce rI by 0.3 fm 22.6 1.21 11.35 6.58 · 10−25")
    thisalinea.textcontent.append("Opt. Pot: reduce aI by 0.3 fm 22.3 1.20 1.343 17.9%")
    thisalinea.textcontent.append("Opt. Pot: set outgoing depths 23.7 1.27 3.854 2.87 · 10−6")
    thisalinea.textcontent.append("to 70% of incoming depths")
    thisalinea.textcontent.append("according to the sum rule (except for the ‘70% of incoming depths’-case for the 122Sn")
    thisalinea.textcontent.append("target, which is still below 2σ). Moreover, a close inspection of Chapter 2 reveals that")
    thisalinea.textcontent.append("all input parameters of the FOLD program that could not be precisely obtained from")
    thisalinea.textcontent.append("our measured data, were investigated in Tables 4.2 and 4.3. Therefore, we conclude")
    thisalinea.textcontent.append("that Tables 4.2 and 4.3 are a very strong indication that the B(F ) values do not")
    thisalinea.textcontent.append("strongly depend on the theoretical model used to ﬁt the data. Since the underlying")
    thisalinea.textcontent.append("physics of the IAS and of the Gamow-Teller states are very similar (see Section 2.1),")
    thisalinea.textcontent.append("we will assume that this conclusion is transferable to the Gamow-Teller states. Hence,")
    thisalinea.textcontent.append("we conclude that our procedure to extract B(F ) and B(GT ) values depends only on")
    thisalinea.textcontent.append("the measured data and is rather model independent.")
    thisalinea.textcontent.append("It is actually preferable to do a study like Tables 4.2 and 4.3 on the IAS and not")
    thisalinea.textcontent.append("directly on a Gamow-Teller transition. There are three reasons for this. The ﬁrst")
    thisalinea.textcontent.append("reason is that the number of measured events is much larger for the IAS than for any")
    thisalinea.textcontent.append("of the Gamow-Teller transitions (see Figures 4.6e and 4.6f). Hence, the measurement")
    thisalinea.textcontent.append("errors for the B(GT ) values would be relatively larger than for the B(F ) values")
    thisalinea.textcontent.append("of the IAS, meaning that diﬀerences due to parameter values are less likely to be")
    thisalinea.textcontent.append("signiﬁcant for B(GT ) values. The second reason is that B(GT ) values contain a")
    thisalinea.textcontent.append("certain systematic error, which is not present in B(F ) values. The origin of this")
    thisalinea.textcontent.append("systematic error will be discussed at the end of this section (see Equation (4.10)). At")
    thisalinea.textcontent.append("this point, it is suﬃcient to know that a systematic error in B(GT ) will also make")
    thisalinea.textcontent.append("changes in the B(GT ) value due to parameter modiﬁcations less signiﬁcant. The")
    thisalinea.textcontent.append("third reason is that for the IAS the value of B(F ) is known from the sum rule. Hence,")
    thisalinea.textcontent.append("our measurements for diﬀerent parameters can be compared to a known value, while")
    thisalinea.textcontent.append("measurements for B(GT ) values with diﬀerent parameters can only be compared")
    thisalinea.textcontent.append("among each other. Equation (2.9) describes a sum rule for Gamow-Teller states,")
    thisalinea.textcontent.append("but this sum is typically distributed over many diﬀerent states in the excitation-")
    thisalinea.textcontent.append("energy spectrum. Therefore, this rule cannot be used as a veriﬁcation tool like for")
    thisalinea.textcontent.append("the IAS. Hence, the study of changes in B(F ) values (for the IAS) due to parameter")
    thisalinea.textcontent.append("modiﬁcations is more reliable.")
    thisalinea.textcontent.append("In Tables 4.2 and 4.3, it is also clear that the reduced χ2 values (and the resulting ﬁt")
    thisalinea.textcontent.append("probability) sometimes become much worse due to modiﬁcations in the parameters")
    thisalinea.textcontent.append("of the theoretical model. It is understandable that the shape of the theoretically-")
    thisalinea.textcontent.append("computed diﬀerential cross section may be quite diﬀerent for diﬀerent input param-")
    thisalinea.textcontent.append("eters, and this diﬀerent shape may result in a bad ﬁt to the experimental data.")
    thisalinea.textcontent.append("However, since our main interest is in the B(F ) and B(GT ) values, the important")
    thisalinea.textcontent.append("conclusion from Tables 4.2 and 4.3 is that these B(F ) values do not change signiﬁ-")
    thisalinea.textcontent.append("cantly under parameter modiﬁcations, even in the case of a bad ﬁt.")
    thisalinea.textcontent.append("It should also be noted that for certain parameter variations, the reduced χ2-value")
    thisalinea.textcontent.append("becomes lower than 1. Normally, this would mean that the data are not statistically")
    thisalinea.textcontent.append("scattered, which is typically an indication an of overestimation of the error bars.")
    thisalinea.textcontent.append("However, in the case of Tables 4.2 and 4.3, the situation is diﬀerent. Since the purpose")
    thisalinea.textcontent.append("of these tables is just to investigate the sensitivity of B(F ) to parameter variations,")
    thisalinea.textcontent.append("there are no arguments to why those variations should correspond to any physical")
    thisalinea.textcontent.append("situation (of course, the bold lines do correspond to physical parameter choices).")
    thisalinea.textcontent.append("Since any set of data-points could be ﬁtted to an unphysical model with χ2 = 0, the")
    thisalinea.textcontent.append("low χ2 values in Tables 4.2 and 4.3 do not necessarily indicate an overestimation of")
    thisalinea.textcontent.append("the error bars.")
    thisalinea.textcontent.append("Figure 4.11 also provides us with some important conclusions regarding the eﬃciency")
    thisalinea.textcontent.append("of the 0◦ Faraday cup. As explained earlier, this eﬃciency was determined from the")
    thisalinea.textcontent.append("requirement that the B(F ) values of the IAS have to be equal to |N − Z|, the Fermi")
    thisalinea.textcontent.append("sum rule. However, the Faraday cup eﬃciency was assumed to be the same for both")
    thisalinea.textcontent.append("Figure 4.11a and Figure 4.11b. Moreover, ﬁtting this eﬃciency only aﬀects the data")
    thisalinea.textcontent.append("obtained in the 0◦ mode (the data-points in the region α < 3◦) and not the other")
    thisalinea.textcontent.append("data-points. Since the computation of the blue curves in Figure 4.11 is independent")
    thisalinea.textcontent.append("of the Faraday cup eﬃciency, this means that the data-points outside the α < 3◦ can")
    thisalinea.textcontent.append("be used as a veriﬁcation to whether the right Faraday cup eﬃciency was obtained.")
    thisalinea.textcontent.append("Given the high ﬁt probabilities in Figure 4.11, we may conclude that we obtained the")
    thisalinea.textcontent.append("correct Faraday cup eﬃciency of 84% at 0◦ (the 2.5◦ eﬃciency was assumed to be")
    thisalinea.textcontent.append("100%).")
    thisalinea.textcontent.append("From Figure 4.11 and Tables 4.2 and 4.3, we conclude that our procedure to extract")
    thisalinea.textcontent.append("B(F ) from the data indeed provides the right answer and that this answer is model-")
    thisalinea.textcontent.append("independent. This should not come as a big surprise, since the same experimental")
    thisalinea.textcontent.append("data were used in all situations of Tables 4.2 and 4.3 (only the theoretical model")
    thisalinea.textcontent.append("parameters were varied). Nevertheless, this conclusion now allows us to use the same")
    thisalinea.textcontent.append("procedure to extract B(GT ) values for Gamow-Teller states in the excitation-energy")
    thisalinea.textcontent.append("spectrum. However, in the case of B(GT ) values, there are a few additional challenges")
    thisalinea.textcontent.append("which have to be dealt with.")
    thisalinea.textcontent.append("The ﬁrst challenge is the inﬂuence of the spin-orbit coupling in the nuclear many-")
    thisalinea.textcontent.append("body problem. Due to this coupling, excited states cannot be labeled by their orbital")
    thisalinea.textcontent.append("quantum number L or their spin quantum number S, but only by their total angular")
    thisalinea.textcontent.append("momentum quantum number J and their parity P = (−1)L. This labeling is tradi-")
    thisalinea.textcontent.append("tionally denoted as J P . Therefore, it is sometimes possible to reach the same state")
    thisalinea.textcontent.append("J P in the excitation-energy spectrum of the recoil nucleus through diﬀerent transi-")
    thisalinea.textcontent.append("tion types (with diﬀerent quantum numbers). This is also the case for Gamow-Teller")
    thisalinea.textcontent.append("transitions. A Gamow-Teller transition has ∆L = 0 and ∆S = 1. This means that")
    thisalinea.textcontent.append("the only possibility is that ∆J = 1. Since both 116Sn and 122Sn have a 0+ ground")
    thisalinea.textcontent.append("state [21], the state where the recoil nucleus has to end up in after a Gamow-Teller")
    thisalinea.textcontent.append("transition is always a 1+ state. However, the same 1+ state can also be reached by")
    thisalinea.textcontent.append("a ∆L = 2, ∆S = 1, ∆J = 1 quadrupole transition. This means that if we select a")
    thisalinea.textcontent.append("peak in the excitation-energy spectrum that corresponds to a 1+ state (established")
    thisalinea.textcontent.append("by comparison with Ref. [21]), this peak will be a combination of a Gamow-Teller")
    thisalinea.textcontent.append("transition and a quadrupole transition. Hence, our challenge is to disentangle these")
    thisalinea.textcontent.append("contributions.")
    thisalinea.textcontent.append("To disentangle the Gamow-Teller and quadrupole contributions, the Multipole De-")
    thisalinea.textcontent.append("composition Analysis (MDA) technique was used [6, 92]. The MDA implies that we")
    thisalinea.textcontent.append("do not ﬁt one partial-wave amplitude (which corresponds to one theoretical curve")
    thisalinea.textcontent.append("from Figure 2.5), but several, and each amplitude is given its own normalization pa-")
    thisalinea.textcontent.append("rameter. The mathematical description for the function used to ﬁt the data is given")
    thisalinea.textcontent.append("by:")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(α) =")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("cL ·")
    thisalinea.textcontent.append("dσ")
    thisalinea.textcontent.append("dΩ")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)smeared")
    thisalinea.textcontent.append("(α, L), (4.8)")
    thisalinea.textcontent.append("where the coeﬃcients cL are real positive numbers. They are the only ﬁtting param-")
    thisalinea.textcontent.append("eters used. The sum runs over values of L: the change in orbital angular momentum")
    thisalinea.textcontent.append("number of the transition. The subscript ‘smeared’ denotes that this is one of the")
    thisalinea.textcontent.append("smeared curves of Figure 2.5. It is important to know that no more than one contri-")
    thisalinea.textcontent.append("bution with a speciﬁc L (or actually ∆L) should be taken along in Equation (4.8).")
    thisalinea.textcontent.append("This can be a limitation, since diﬀerent ∆S and/or ∆J may result in diﬀerent transi-")
    thisalinea.textcontent.append("tion types, even when their ∆L are equal. This is illustrated in Figures 2.5c and 2.5d.")
    thisalinea.textcontent.append("Both of these transitions have ∆L = 2, while the diﬀerential cross sections are not")
    thisalinea.textcontent.append("the same. This means that any minimization algorithm that would try to disentangle")
    thisalinea.textcontent.append("such contributions by ﬁtting Equation (4.8) to the data will end up in a very shallow")
    thisalinea.textcontent.append("and ill-deﬁned minimum.")
    thisalinea.textcontent.append("Fortunately, if it is already known that the state in the excitation-energy spectrum is")
    thisalinea.textcontent.append("a 1+ state, we know that this state can only be reached by a Gamow-Teller transition,")
    thisalinea.textcontent.append("or by a ∆L = 2, ∆S = 1, ∆J = 1 quadrupole transition. Hence, we do not encounter")
    thisalinea.textcontent.append("more contributions with the same ∆L and Equation (4.8) will simply have two terms.")
    thisalinea.textcontent.append("If this equation is then ﬁtted to the data, B(GT ) can be extracted with Equation")
    thisalinea.textcontent.append("(2.17) from the ∆L = 0 contribution. This procedure has been applied successfully")
    thisalinea.textcontent.append("in Ref. [59].")
    thisalinea.textcontent.append("For Gamow-Teller transitions at low excitation energy, the MDA technique described")
    thisalinea.textcontent.append("above can be used eﬀectively to obtain B(GT ) values. However, from Ref. [28] and")
    thisalinea.textcontent.append("[32] (these papers deal with Sn(3He, t)Sb reactions), it is known that at higher exci-")
    thisalinea.textcontent.append("tation energies, Gamow-Teller states lie close to each other as broad resonances that")
    thisalinea.textcontent.append("have an intrinsic width, which increases with the excitation energy. This behaviour")
    thisalinea.textcontent.append("is caused by the coupling of the Gamow-Teller transition to many-particle many-hole")
    thisalinea.textcontent.append("conﬁgurations [32] and it can easily become several MeV wide even when the exci-")
    thisalinea.textcontent.append("tation energy is below that of the IAS. When Gamow-Teller states have such wide")
    thisalinea.textcontent.append("structures, individual states can no longer be identiﬁed in the spectrum. This can")
    thisalinea.textcontent.append("be seen in Figures 4.6e and 4.6f. One can clearly see distinct individual peaks in")
    thisalinea.textcontent.append("the region of the ﬁrst few MeV of excitation energy. However, at higher excitation")
    thisalinea.textcontent.append("energies, the spectra become a continuum of overlapping states and only the IAS can")
    thisalinea.textcontent.append("be identiﬁed easily. Hence, the second challenge is how we can obtain B(GT ) values")
    thisalinea.textcontent.append("in the region of higher excitation energy.")
    thisalinea.textcontent.append("This challenge can also be overcome by the MDA technique. For this procedure,")
    thisalinea.textcontent.append("the excitation-energy spectrum was split in small bins of 200 keV. For each bin, the")
    thisalinea.textcontent.append("experimental cross section was computed according to Equation (4.6) as discussed in")
    thisalinea.textcontent.append("Section 4.4. However, now the entire content of the bin was taken as P (α). No Gaus-")
    thisalinea.textcontent.append("sians were ﬁtted (because no peaks could be identiﬁed). Furthermore, the background")
    thisalinea.textcontent.append("for quasi-free scattering was subtracted (the precise procedure is described below).")
    thisalinea.textcontent.append("Then, the resulting cross section was ﬁtted to Equation (4.8). Since no distinct peaks")
    thisalinea.textcontent.append("were identiﬁed and no quantum numbers were established, all possible contributions")
    thisalinea.textcontent.append("have to be taken along in Equation (4.8). Due to the choice of only measuring in")
    thisalinea.textcontent.append("0◦ mode and 2.5◦ mode and due to the acceptance of Grand Raiden, no data were")
    thisalinea.textcontent.append("available above α = 4.2◦. Hence, we could aﬀord to truncate the sum at L = 0, ..., 4")
    thisalinea.textcontent.append("in Equation (4.8).")
    thisalinea.textcontent.append("As indicated earlier, only one type of transition per ∆L can be taken along in Equa-")
    thisalinea.textcontent.append("tion (4.8). We chose the Gamow-Teller transition as the ∆L = 0 contribution, the")
    thisalinea.textcontent.append("spin-dipole transition as the ∆L = 1 contribution and the ∆S = 1, ∆J = ∆L as the")
    thisalinea.textcontent.append("∆L ≥ 2 contributions. The reason for selecting the Gamow-Teller contribution is")
    thisalinea.textcontent.append("that we have assumed (based on Ref. [13]) that all ∆L = 0 contributions are Gamow-")
    thisalinea.textcontent.append("Teller, except in the case of the IAS (see Section 4.3). For the other contributions, we")
    thisalinea.textcontent.append("simply selected the most dominant one (determined by calculations using the FOLD")
    thisalinea.textcontent.append("program). After the ﬁtting, B(GT ) was extracted from the ∆L = 0 contribution of")
    thisalinea.textcontent.append("Equation (4.8), just as described earlier. By this method, which we shall denote from")
    thisalinea.textcontent.append("now on as ‘full MDA’, a spectrum of B(GT ) values per bin of 200 keV excitation")
    thisalinea.textcontent.append("energy was obtained. With this spectrum, one can still see how much Gamow-Teller")
    thisalinea.textcontent.append("strength is located at which position of the excitation-energy spectrum, even though")
    thisalinea.textcontent.append("no individual peaks could be identiﬁed.")
    thisalinea.textcontent.append("A theoretical model was used to compute and subtract the background for quasi-free")
    thisalinea.textcontent.append("charge exchange. This model is described by Equation (4.9) [28].")
    thisalinea.textcontent.append("d2σ")
    thisalinea.textcontent.append("dΩdE∗ (E∗, α) = N0 ·")
    thisalinea.textcontent.append("1 − e(Et−E0)/T")
    thisalinea.textcontent.append("1 + ((Et − EQF )/W )2 (4.9)")
    thisalinea.textcontent.append("The parameters T and W were ﬁxed to the values of Ref. [28]: T = 100 MeV and")
    thisalinea.textcontent.append("W = 22 MeV. Et is the triton energy, which depends on the excitation energy E∗ and")
    thisalinea.textcontent.append("on the scattering angle α through relativistic kinematics (the α-dependence is known")
    thisalinea.textcontent.append("from the data to be very weak near 0◦). E0 is described by E0 = Et(E∗ = 0) − Sp")
    thisalinea.textcontent.append("where Sp is the proton-separation energy of the recoil nucleus. N0 was determined")
    thisalinea.textcontent.append("by ﬁtting equation (4.9) to the data according to the procedure outlined in Ref. [28].")
    thisalinea.textcontent.append("This means that N0 is determined from the assumption that at an excitation energy of")
    thisalinea.textcontent.append("28 MeV, the quasi-free charge-exchange background contributes 100% to the measures")
    thisalinea.textcontent.append("diﬀerential cross section d2σ/dΩdE∗. The shape of the background described by")
    thisalinea.textcontent.append("Equation (4.9) did not appear to be very sensitive to the precise value of EQF . It is,")
    thisalinea.textcontent.append("therefore, possible to determine it from a data ﬁt (which is what we did), but also to")
    thisalinea.textcontent.append("simply use the initialization value of Ref. [28], namely EQF = 180 MeV.")
    thisalinea.textcontent.append("By integrating Equation (4.9) over the respective bin of the ‘full MDA’, one can")
    thisalinea.textcontent.append("determine for each data-point, dσ/dΩ versus α, how much background has to be")
    thisalinea.textcontent.append("subtracted. To be able to compare our results to the outcomes of other experiments,")
    thisalinea.textcontent.append("we computed the spectrum of B(GT ) values twice: once without subtracting the")
    thisalinea.textcontent.append("quasi-free charge-exchange background and once after subtracting it.")
    thisalinea.textcontent.append("To summarize, absolute B(GT ) values were obtained for low-lying Gamow-Teller")
    thisalinea.textcontent.append("states (where the single peaks could be resolved) and B(GT ) values per bin of 200 keV")
    thisalinea.textcontent.append("were obtained for the higher excitation energies. However, the third and ﬁnal challenge")
    thisalinea.textcontent.append("for extracting B(GT ) values is their systematic error. As explained earlier, 1+ states")
    thisalinea.textcontent.append("have a Gamow-Teller contribution and a quadrupole contribution. Unfortunately, the")
    thisalinea.textcontent.append("tensor-τ component of the nucleon-nucleon interaction causes interference between")
    thisalinea.textcontent.append("these two contributions [36]. This interference results in a systematic error on each")
    thisalinea.textcontent.append("B(GT ) value that cannot be reduced or overcome by increasing our statistics or")
    thisalinea.textcontent.append("measurement resolutions. Hence, the only thing we can do is to estimate these errors")
    thisalinea.textcontent.append("and take them along in our ﬁnal result. The estimation of the systematic error is")
    thisalinea.textcontent.append("given by [36, 37]:")
    thisalinea.textcontent.append("∆B(GT )systematic")
    thisalinea.textcontent.append("B(GT )")
    thisalinea.textcontent.append("= 0.03 − 0.035 · ln(B(GT )). (4.10)")
    thisalinea.textcontent.append("As a consequence of the systematic error estimated by Equation (4.10), B(GT ) values")
    thisalinea.textcontent.append("always have a limit to the accuracy with which they can be measured (for (3He, t)")
    thisalinea.textcontent.append("reactions). However, since the relative error in the value of B(GT ) depends only loga-")
    thisalinea.textcontent.append("rithmitically on the value itself, the systematic uncertainties will, generally, be small.")
    thisalinea.textcontent.append("For instance, a B(GT ) value of 0.14 will have a systematic uncertainty (according")
    thisalinea.textcontent.append("to Equation (4.10)) below 10%. The uncertainty does not go above 15% as long as")
    thisalinea.textcontent.append("B(GT ) is above 0.033 and it drops below 5% for B(GT ) values above 0.57.")
    thisalinea.textcontent.append("Now that all procedures to extract the B(GT ) values have been discussed and have")
    thisalinea.textcontent.append("been tested on the IAS, we can move on to presenting the ﬁnal results and discussing")
    thisalinea.textcontent.append("them. This will be done in Chapter 5.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "5 Results and Discussion"
    thisalinea.nativeID = 35
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 6
    thisalinea.summary = "As indicated in Section 4.5, B(GT ) values were computed for individual states in the lower region of the excitation-energy spectrum, while the ‘full MDA’-technique was employed to analyze the region of higher energies. To eﬃciently present the computed B(GT ) values for these individual states, we will ﬁrst display the excitation-energy spectra again for labeling purposes. For the 116Sn(3He, t)116Sb reaction, this labeling is given in Figures 5.1a and 5.1c. The labeling of the states in the spectrum of the 122Sn(3He, t)122Sb reaction is shown in Figures 5.1b and 5.1d. We would like to emphasize that, contrary to Figures "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "5.1 Results"
    thisalinea.nativeID = 36
    thisalinea.parentID = 35
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "As indicated in Section 4.5, B(GT ) values were computed for individual states in the lower region of the excitation-energy spectrum, while the ‘full MDA’-technique was employed to analyze the region of higher energies. To eﬃciently present the computed B(GT ) values for these individual states, we will ﬁrst display the excitation-energy spectra again for labeling purposes. For the 116Sn(3He, t)116Sb reaction, this labeling is given in Figures 5.1a and 5.1c. The labeling of the states in the spectrum of the 122Sn(3He, t)122Sb reaction is shown in Figures 5.1b and 5.1d. We would like to emphasize that, contrary to Figures "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As indicated in Section 4.5, B(GT ) values were computed for individual states in the")
    thisalinea.textcontent.append("lower region of the excitation-energy spectrum, while the ‘full MDA’-technique was")
    thisalinea.textcontent.append("employed to analyze the region of higher energies. To eﬃciently present the computed")
    thisalinea.textcontent.append("B(GT ) values for these individual states, we will ﬁrst display the excitation-energy")
    thisalinea.textcontent.append("spectra again for labeling purposes. For the 116Sn(3He, t)116Sb reaction, this labeling")
    thisalinea.textcontent.append("is given in Figures 5.1a and 5.1c. The labeling of the states in the spectrum of")
    thisalinea.textcontent.append("the 122Sn(3He, t)122Sb reaction is shown in Figures 5.1b and 5.1d. We would like to")
    thisalinea.textcontent.append("emphasize that, contrary to Figures 4.6e and 4.6f, all corrections to the data discussed")
    thisalinea.textcontent.append("in Section 4.4 were applied to the results presented in Figures 5.1a - 5.1d.")
    thisalinea.textcontent.append("The B(GT ) values of the 116Sn(3He, t)116Sb reaction corresponding to states labeled")
    thisalinea.textcontent.append("in Figures 5.1c are presented in Table 5.1. The ﬁrst column shows the label of the")
    thisalinea.textcontent.append("state from Figure 5.1c. States that do not contain Gamow-Teller contributions were")
    thisalinea.textcontent.append("not shown in the table. The second column (labeled ‘Meas. E∗’) shows the excitation")
    thisalinea.textcontent.append("energy of the state as determined from our data. The column labeled ‘Lit. E∗’ shows")
    thisalinea.textcontent.append("the excitation energy of the state according to Ref. [21]. For the lower states, ﬁnding")
    thisalinea.textcontent.append("the proper correspondence between Ref. [21] and our data was possible. However, as")
    thisalinea.textcontent.append("the excitation energy E∗ goes up, so does the density of the levels. Hence, at higher")
    thisalinea.textcontent.append("E∗ it becomes increasingly diﬃcult to match our measured states to those in Ref. [21].")
    thisalinea.textcontent.append("Hence, there will ultimately be a point at which the resolution of our measurements")
    thisalinea.textcontent.append("and/or the lack of quantum numbers in Ref. [21] makes it impossible to obtain a")
    thisalinea.textcontent.append("proper correspondence. This is why the column ‘Lit. E∗’ is only partially ﬁlled.")
    thisalinea.textcontent.append("The states that have the ‘Lit. E∗’-column ﬁlled, are all conﬁrmed to be 0+ → 1+")
    thisalinea.textcontent.append("transitions (except for the IAS, which is a 0+ → 0+ transition). For the states in")
    thisalinea.textcontent.append("the table that do not have the ‘Lit. E∗’-column ﬁlled, our data suggest that they")
    thisalinea.textcontent.append("are Gamow-Teller states and, therefore, 0+ → 1+ transitions, but we do not have a")
    thisalinea.textcontent.append("conﬁrmation of that in the literature.")
    thisalinea.textcontent.append("The columns ‘red. χ2’, ‘NDF’ and ‘Fit prob.’ show the properties of the MDA ﬁt")
    thisalinea.textcontent.append("that was used to extract B(GT ) from the data. The resulting B(GT ) values are")
    thisalinea.textcontent.append("displayed in the ﬁnal column marked ‘B value’. The reason that the Number-of-")
    thisalinea.textcontent.append("Degrees of Freedom (NDF) is diﬀerent for each state, is that sometimes the statistics")
    thisalinea.textcontent.append("was not enough to obtain data-points at larger scattering angles. The systematic")
    thisalinea.textcontent.append("error in the last column comes from Equation (4.10). The measurement error (meas)")
    thisalinea.textcontent.append("in the last column contains a contribution from the ﬁt inaccuracy, a 5% contribution")
    thisalinea.textcontent.append("from the uncertainty in the unit cross section (see Section 2.1) and a 1% contribution")
    thisalinea.textcontent.append("from inaccuracies in the extrapolation to q = 0 (see Section 2.7), which are added in")
    thisalinea.textcontent.append("quadrature.")
    thisalinea.textcontent.append("Figure 5.1: Excitation-energy spectra of the 116Sn(3He, t)116Sb and 122Sn(3He, t)122Sb")
    thisalinea.textcontent.append("charge-exchange reactions, integrated over the scattering angle α between 0◦ and")
    thisalinea.textcontent.append("4.5◦. The corrections from Subsection 4.4.2 were applied. Peaks in the region of low")
    thisalinea.textcontent.append("excitation energy are assigned labels with the numbered red arrows.")
    thisalinea.textcontent.append("The MDA ﬁts used to extract B(GT ) from the data are shown in Figure 5.2 for the")
    thisalinea.textcontent.append("ﬁrst 4 Gamow-Teller states of the 116Sn(3He, t)116Sb reaction. The other states in")
    thisalinea.textcontent.append("Table 5.1 have similar plots. Similar to Table 5.1 and Figure 5.2, Table 5.2 and Figure")
    thisalinea.textcontent.append("5.3 show the results for the Gamow-Teller states at lower excitation energy for the")
    thisalinea.textcontent.append("It should be noted that some states in Tables 5.1 and 5.2 have a rather low Fit")
    thisalinea.textcontent.append("probability (below 5%). As can be seen in Figure 5.1, these states have relatively")
    thisalinea.textcontent.append("small peaks which are also close to other peaks. It is, therefore, diﬃcult to accurately")
    thisalinea.textcontent.append("determine the areas of these peaks from Gaussian ﬁts. These diﬃculties cause the")
    thisalinea.textcontent.append("data-points to contain more scattering than what one would normally expect from a")
    thisalinea.textcontent.append("Table 5.1: Analysis results of the low-lying Gamow-Teller states in the excitation-")
    thisalinea.textcontent.append("energy spectrum of the 116Sn(3He, t)116Sb charge-exchange reaction. The ﬁrst column")
    thisalinea.textcontent.append("shows the labeling of the states according to Figure 5.1c. States that do not contain")
    thisalinea.textcontent.append("Gamow-Teller contributions were left out from the table. The second column shows")
    thisalinea.textcontent.append("the excitation energy of the state as determined from our data. The third column")
    thisalinea.textcontent.append("shows the excitation energy of the state according to Ref. [21]. The energy marked")
    thisalinea.textcontent.append("with a ∗ was calculated from Ref. [13]. The fourth, ﬁfth and sixth columns show the")
    thisalinea.textcontent.append("properties of the MDA ﬁt. The last column shows the corresponding B(GT ) value")
    thisalinea.textcontent.append("(B(F ) for the IAS).")
    thisalinea.textcontent.append("Table 5.2: Same as Table 5.1, but now for the 122Sn(3He, t)122Sb charge-exchange")
    thisalinea.textcontent.append("reaction. See Figure 5.1d for the labeling of the states.")
    thisalinea.textcontent.append("Figure 5.2: Illustration of the extraction of B(GT ) from an MDA ﬁt for the ﬁrst few")
    thisalinea.textcontent.append("states of Table 5.1 (which deals with the reaction 116Sn(3He, t)116Sb).")
    thisalinea.textcontent.append("purely statistical basis. A good example of this phenomenon is state No. 4 in Table")
    thisalinea.textcontent.append("5.1. The angular distribution of this state is plotted in Figure 5.2. However, from")
    thisalinea.textcontent.append("Tables 4.2 and 4.3 we know that B(GT ) (or B(F )) is rather insensitive to a low ﬁt")
    thisalinea.textcontent.append("probability. The reason for this is that B(GT ) (and also B(F )) is determined mostly")
    thisalinea.textcontent.append("by the data-points near α = 0 and not so much by the other data-points. Therefore,")
    thisalinea.textcontent.append("we know that in this situation, a low ﬁt probability cannot be easily translated into")
    thisalinea.textcontent.append("a systematic contribution of the B(GT ) error and we have chosen not to do so. It")
    thisalinea.textcontent.append("should also be noted that a ﬁt with a low probability may be the result of the peak")
    thisalinea.textcontent.append("being a doublet that cannot be resolved with our energy resolution.")
    thisalinea.textcontent.append("As explained in the beginning of this section and in Section 4.5, absolute dimensionless")
    thisalinea.textcontent.append("B(GT ) values could only be obtained for the Gamow-Teller states at lower excitation")
    thisalinea.textcontent.append("energy. Therefore, the data at higher excitation energies were analyzed with the ‘full")
    thisalinea.textcontent.append("MDA’ technique introduced in Section 4.5 to obtain a spectrum of B(GT ) values for")
    thisalinea.textcontent.append("each of the charge-exchange reactions that were studied in this work. The systematic")
    thisalinea.textcontent.append("error contribution of the ‘full MDA’ technique was estimated by temporarily remov-")
    thisalinea.textcontent.append("ing the ∆L = 4 contribution [93]. The results are displayed in Figure 5.4 and the")
    thisalinea.textcontent.append("systematic error contributions from the ‘full MDA’ technique are shown separately.")
    thisalinea.textcontent.append("The systematic contribution from the tensor interference (see Equation (4.10)) is not")
    thisalinea.textcontent.append("included in the ﬁgure. This equation only applies to dimensionless B(GT ) values,")
    thisalinea.textcontent.append("Figure 5.3: Same as Figure 5.2, but now for Table 5.2 and for the reaction")
    thisalinea.textcontent.append("while the values in Figure 5.4 have a unit of MeV−1 due to the nature of the ‘full")
    thisalinea.textcontent.append("MDA technique’ (it is a consequence of binning the excitation-energy spectrum).")
    thisalinea.textcontent.append("Hence, the contribution from the tensor interference cannot be easily estimated for")
    thisalinea.textcontent.append("the distributions in Figure 5.4. However, when the spectrum is divided in Gamow-")
    thisalinea.textcontent.append("Teller resonances (see Figure 5.7), one can apply Equation (4.10) to the B(GT ) values")
    thisalinea.textcontent.append("of these resonances and one ﬁnds that the tensor interference is a few percent at most.")
    thisalinea.textcontent.append("Both the situation where the quasi-free charge-exchange background of Equation (4.9)")
    thisalinea.textcontent.append("was subtracted and the situation where it was not subtracted are shown in Figure")
    thisalinea.textcontent.append("5.4. Both situations are considered for being able to compare our results to other")
    thisalinea.textcontent.append("experiments, which is what we will do in the following sections. Based on these")
    thisalinea.textcontent.append("comparisons, we will determine which of these two situations is the ‘correct one’.")
    thisalinea.textcontent.append("The darker areas in the spectra of Figure 5.4 are the regions where the IAS is located.")
    thisalinea.textcontent.append("However, as explained in Section 4.5, the MDA method cannot distinguish Fermi and")
    thisalinea.textcontent.append("Gamow-Teller contributions, since they both have the same ∆L. This is the reason")
    thisalinea.textcontent.append("why a large spike is located in this region: it is the sum of B(GT ) and B(F ) · ˆσGT /ˆσF ,")
    thisalinea.textcontent.append("and not purely B(GT ). However, B(F ) is known from the Fermi sum rule and one")
    thisalinea.textcontent.append("might try to subtract the contribution for B(F ) from the spectrum. Unfortunately,")
    thisalinea.textcontent.append("this would be possible only if the entire contribution from the IAS is located within")
    thisalinea.textcontent.append("a single bin of the spectrum. Otherwise, one would never know which contribution")
    thisalinea.textcontent.append("Figure 5.4: Spectra of B(GT ) values as computed with the ‘full MDA’ technique.")
    thisalinea.textcontent.append("The cyan histogram represents the situation where the quasi-free charge-exchange")
    thisalinea.textcontent.append("background is subtracted and the yellow histogram represents the situation where it")
    thisalinea.textcontent.append("is not subtracted. The small black vertical bars on top of the histograms represent")
    thisalinea.textcontent.append("the measurement errors (meas) analogue to Tables 5.1 and 5.2. The systematic errors")
    thisalinea.textcontent.append("from Equation (4.10) are not shown in the ﬁgure. The systematic errors from the ‘full")
    thisalinea.textcontent.append("MDA’ analysis technique are shown as a grey band. The bin width is 200 keV. The")
    thisalinea.textcontent.append("darker-shaded bins are the regions where the computation from the B(GT ) values is")
    thisalinea.textcontent.append("inaccurate due to a contribution from the IAS.")
    thisalinea.textcontent.append("of B(F ) would belong to which bin. From Figure 5.4 one can see that the IAS is")
    thisalinea.textcontent.append("distributed over more than one bin (this is a result of our choice to use a uniform")
    thisalinea.textcontent.append("binning). Therefore, subtracting the contribution of B(F ) would be an inaccurate")
    thisalinea.textcontent.append("procedure and is, therefore, not performed. We also would like to note that for the")
    thisalinea.textcontent.append("E∗ > 20 MeV and θt > 0.6◦. Therefore, these 116Sn data were ignored in the analysis")
    thisalinea.textcontent.append("that led to Figure 5.4a (see Figure 4.7b for more details on this artefact).")
    thisalinea.textcontent.append("We like to illustrate the computation of the B(GT ) spectrum by showing the ‘full")
    thisalinea.textcontent.append("MDA’ technique for the two bins marked with red arrows in Figure 5.4. These plots")
    thisalinea.textcontent.append("are shown in Figure 5.5 (for the situation where the quasi-free charge-exchange back-")
    thisalinea.textcontent.append("ground not is subtracted). Other regions would yield the same quality of ﬁts showing")
    thisalinea.textcontent.append("the quality of the full MDA analysis and the reliability of the ﬁts.")
    thisalinea.textcontent.append("The diﬀerent multipolarity contributions to the total diﬀerential cross section are")
    thisalinea.textcontent.append("shown in Figure 5.6 for scattering angles α = 0◦ and α = 1.5◦. Multipolarities up to")
    thisalinea.textcontent.append("∆L = 4 were considered in this analysis. These two scattering angles were chosen,")
    thisalinea.textcontent.append("because they yield maximum contributions of the ∆L = 0 and ∆L = 1 multipolarities,")
    thisalinea.textcontent.append("respectively.")
    thisalinea.textcontent.append("Figure 5.5: Illustration of the ‘full MDA’ technique for the marked bins of Figure 5.4.")
    thisalinea.textcontent.append("Figure 5.6: Illustration of the diﬀerent multipolarity contributions in the ‘full MDA’")
    thisalinea.textcontent.append("technique to the total diﬀerential cross section. Results are shown for the yellow")
    thisalinea.textcontent.append("situation where the quasi-free charge-exchange background is not subtracted.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "5.2 Comparison to previous results"
    thisalinea.nativeID = 37
    thisalinea.parentID = 35
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "In this section, we will compare our results to the results of Ref. [28], which contains a detailed study of the Gamow-Teller cross sections of multiple Sn-isotopes. Since Ref. [28] only contains measured cross sections, several steps have to be taken before the data of Ref. [28] can be compared to our extracted B(GT ) values. As a ﬁrst step, the measured cross sections in Ref. [28] have to be extrapolated to α = 0 and q = 0. This will be discussed in Subsection 5.2.1. As a second step, the Gamow-Teller unit cross sections at 67 MeV/u have to "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this section, we will compare our results to the results of Ref. [28], which contains")
    thisalinea.textcontent.append("a detailed study of the Gamow-Teller cross sections of multiple Sn-isotopes. Since")
    thisalinea.textcontent.append("Ref. [28] only contains measured cross sections, several steps have to be taken before")
    thisalinea.textcontent.append("the data of Ref. [28] can be compared to our extracted B(GT ) values. As a ﬁrst")
    thisalinea.textcontent.append("step, the measured cross sections in Ref. [28] have to be extrapolated to α = 0 and")
    thisalinea.textcontent.append("q = 0. This will be discussed in Subsection 5.2.1. As a second step, the Gamow-Teller")
    thisalinea.textcontent.append("unit cross sections at 67 MeV/u have to be determined (remember Equation (2.2)).")
    thisalinea.textcontent.append("This will be discussed in Subsection 5.2.2. Once this is done, B(GT ) values can be")
    thisalinea.textcontent.append("extracted from the data published in Ref. [28]. These B(GT ) values can then be")
    thisalinea.textcontent.append("compared to our own obtained B(GT ) values (see previous section). This will be")
    thisalinea.textcontent.append("done in Subsection 5.2.3.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "5.2.1 Extrapolation to α = 0 and q = 0"
    thisalinea.nativeID = 38
    thisalinea.parentID = 37
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "To extract the Gamow-Teller cross sections, the Gamow-Teller states in the excitation- energy spectrum were subdivided in ﬁve broad resonances in Ref. [28]. To determine the cross sections of these resonances, the excitation-energy spectrum was ﬁtted to a sum of Gaussians. This ﬁtting procedure is illustrated in Figure 5.7. Five Gaussians were used to ﬁt the Gamow-Teller resonances, a sixth was added to ﬁt the IAS and a seventh was added to ﬁt the broad dipole resonance [28], which is due to the excita- tion of the IsoVector Giant Dipole Resonance (IVGDR) and the IsoVector Spin Giant Dipole Resonance (IVSGDR) "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("To extract the Gamow-Teller cross sections, the Gamow-Teller states in the excitation-")
    thisalinea.textcontent.append("energy spectrum were subdivided in ﬁve broad resonances in Ref. [28]. To determine")
    thisalinea.textcontent.append("the cross sections of these resonances, the excitation-energy spectrum was ﬁtted to a")
    thisalinea.textcontent.append("sum of Gaussians. This ﬁtting procedure is illustrated in Figure 5.7. Five Gaussians")
    thisalinea.textcontent.append("were used to ﬁt the Gamow-Teller resonances, a sixth was added to ﬁt the IAS and a")
    thisalinea.textcontent.append("seventh was added to ﬁt the broad dipole resonance [28], which is due to the excita-")
    thisalinea.textcontent.append("tion of the IsoVector Giant Dipole Resonance (IVGDR) and the IsoVector Spin Giant")
    thisalinea.textcontent.append("Dipole Resonance (IVSGDR) [92, 94]. GT1 is also known as the Gamow-Teller Reso-")
    thisalinea.textcontent.append("nance (GTR) and the smaller resonances GT2-GT5 are known as pygmy resonances")
    thisalinea.textcontent.append("[28]. The quasi-free charge-exchange background description of Equation (4.9) was")
    thisalinea.textcontent.append("also added to the ﬁtting procedure. For the ﬁtting, the excitation-energy spectrum")
    thisalinea.textcontent.append("was given a binning of 120 keV per channel and was analyzed up to 28 MeV.")
    thisalinea.textcontent.append("We would like to emphasize that, since the quasi-free charge-exchange background of")
    thisalinea.textcontent.append("Equation (4.9) is included in the ﬁtting procedure used in Ref. [28], we must compare")
    thisalinea.textcontent.append("the results from Ref. [28] to the cyan histograms in Figure 5.4.")
    thisalinea.textcontent.append("Before we can extrapolate the cross section published in Ref. [28], it is necessary to")
    thisalinea.textcontent.append("review some aspects of the ﬁtting procedure illustrated in Figure 5.7. In Ref. [28],")
    thisalinea.textcontent.append("this ﬁtting procedure is applied to two excitation-energy spectra. One spectrum is")
    thisalinea.textcontent.append("subjected to the condition −0.3◦ ≤ α ≤ 1.3◦ and the second one to the condition")
    thisalinea.textcontent.append("1.3◦ ≤ α ≤ 2.9◦. Technically, these conditions were imposed on θt in Ref. [28], but as")
    thisalinea.textcontent.append("the spectrometer used only has a vertical acceptance of approximately |φt| ≤ 0.5◦, θt")
    thisalinea.textcontent.append("and α were quite similar in Ref. [28]. On the other hand, our spectrometer has an")
    thisalinea.textcontent.append("acceptance of approximately |φt| ≤ 3◦ (see Figure 4.7). Hence, if we want to duplicate")
    thisalinea.textcontent.append("the results of Ref. [28], we have to consider the full scattering angle α. The spectrum")
    thisalinea.textcontent.append("subjected to −0.3◦ ≤ α ≤ 1.3◦ shall be denoted as the α ≈ 0◦ spectrum from now on.")
    thisalinea.textcontent.append("The 1.3◦ ≤ α ≤ 2.9◦ spectrum shall be denoted as the α ≈ 2◦ spectrum.")
    thisalinea.textcontent.append("Figure 5.7: Illustration of the ﬁtting procedure used in Ref. [28], applied to our own")
    thisalinea.textcontent.append("The diﬀerential cross sections of the Gamow-Teller resonances illustrated in Figure")
    thisalinea.textcontent.append("5.7 were extracted from the areas of the Gaussians ﬁtted to the α ≈ 0◦ spectrum.")
    thisalinea.textcontent.append("The outcomes are tabulated in Ref. [28]. We would like to emphasize that these")
    thisalinea.textcontent.append("cross sections were not extrapolated to α = 0 and not to q = 0. This information")
    thisalinea.textcontent.append("was obtained from Refs. [28, 32]. Diﬀerential cross sections were also extracted from")
    thisalinea.textcontent.append("the areas of Gaussians ﬁtted to the α ≈ 2 spectrum. These cross sections were not")
    thisalinea.textcontent.append("tabulated in Ref. [28], but were used to conﬁrm the ∆L = 0 character of the Gamow-")
    thisalinea.textcontent.append("Teller resonances GT1-GT5.")
    thisalinea.textcontent.append("The approximation of the α = 0 diﬀerential cross sections by the Gaussian areas of")
    thisalinea.textcontent.append("the α ≈ 0◦ spectrum always provides an underestimate (for ∆L = 0 cross sections).")
    thisalinea.textcontent.append("The reason for this is that the large angular bin −0.3◦ ≤ α ≤ 1.3◦ introduces substan-")
    thisalinea.textcontent.append("tial smearing in the angular distributions of the diﬀerential cross sections (see Section")
    thisalinea.textcontent.append("2.6). By smearing the theoretical distributions of the diﬀerential cross sections com-")
    thisalinea.textcontent.append("puted with the FOLD-program, these eﬀects can be studied. For this smearing, the")
    thisalinea.textcontent.append("Gaussian distribution in Equation (2.16) should be replaced with a rectangular one")
    thisalinea.textcontent.append("in α(cid:48) = (cid:112)x(cid:48)2 + y(cid:48)2 with appropriate boundaries. The outcome of this smearing is")
    thisalinea.textcontent.append("illustrated in Figure 5.8 for both the α ≈ 0◦ spectrum and the α ≈ 2◦ spectrum. The")
    thisalinea.textcontent.append("precise percentages to which the α = 0 diﬀerential cross sections are underestimated")
    thisalinea.textcontent.append("by the α ≈ 0◦ cross sections (obtained from the Gaussian areas) are listed in Table")
    thisalinea.textcontent.append("5.3.")
    thisalinea.textcontent.append("In Chapter 2, it has been explained how the theoretical distributions of the diﬀerential")
    thisalinea.textcontent.append("cross sections at 140 MeV/u were computed. With those distributions, the results of")
    thisalinea.textcontent.append("Table 5.3 at 140 MeV/u were computed. The 67 MeV/u results were obtained anal-")
    thisalinea.textcontent.append("ogously, but a diﬀerent optical potential had to be used. The optical potential from")
    thisalinea.textcontent.append("Ref. [46] was chosen for both the entrance and the exit channels, since this potential")
    thisalinea.textcontent.append("is obtained from ﬁtting elastic scattering data in the range 10 MeV/u − 73 MeV/u.")
    thisalinea.textcontent.append("Figure 5.8: Theoretical distributions of the IAS (left) and Gamow-Teller (right) dif-")
    thisalinea.textcontent.append("ferential cross sections for 116Sn(3He, t)116Sb at 140 MeV/u. The smearing eﬀects are")
    thisalinea.textcontent.append("illustrated as well.")
    thisalinea.textcontent.append("Table 5.3: The percentage of the α = 0 cross sections of the IAS and GTR that")
    thisalinea.textcontent.append("remains after taking the smearing eﬀects of the α ≈ 0◦ excitation-energy spectrum")
    thisalinea.textcontent.append("into account; see text for details.")
    thisalinea.textcontent.append("Target 140 MeV/u IAS 140 MeV/u GTR 67 MeV/u IAS 67 MeV/u GTR")
    thisalinea.textcontent.append("The formula for this optical potential is the same as Equation (2.15), but the param-")
    thisalinea.textcontent.append("eters are diﬀerent. The optical potential parameters, as obtained from Ref. [46], are")
    thisalinea.textcontent.append("listed in Table 5.4.")
    thisalinea.textcontent.append("Table 5.4: 3He and triton optical potential parameters at 67 MeV/u. The 3He optical")
    thisalinea.textcontent.append("potentials are for the Sn nuclei and the triton ones are for the Sb nuclei. rC = 1.25 fm.")
    thisalinea.textcontent.append("Nucleus VR[MeV] rR[fm] aR[fm] VI [MeV] rI [fm] aI [fm] Ws[MeV]")
    thisalinea.textcontent.append("Table 5.3 describes how the diﬀerential cross sections tabulated in Ref. [28] (The")
    thisalinea.textcontent.append("α ≈ 0◦ cross sections) can be extrapolated to α = 0: the tabulated cross sections in")
    thisalinea.textcontent.append("Ref. [28] should be divided by the appropriate percentage from table 5.3. In order")
    thisalinea.textcontent.append("to extract B(GT ) values that can be compared to our results of Section 5.1, the")
    thisalinea.textcontent.append("diﬀerential cross sections should then also be extrapolated to q = 0. With the FOLD-")
    thisalinea.textcontent.append("program and the optical potentials of Tables 5.4 and 2.2, the extrapolation ratios of")
    thisalinea.textcontent.append("Equation (2.17) can be computed. They are listed in Table 5.5 for the states shown")
    thisalinea.textcontent.append("in Figure 5.7.")
    thisalinea.textcontent.append("Target 140 MeV/u 116Sn 140 MeV/u 122Sn 67 MeV/u 116Sn 67 MeV/u 122Sn")
    thisalinea.textcontent.append("Table 5.5: FOLD-computed extrapolation ratios to q = 0.")
    thisalinea.textcontent.append("IAS 0.99")
    thisalinea.textcontent.append("GT1 1.02")
    thisalinea.textcontent.append("GT2 0.95")
    thisalinea.textcontent.append("GT3 0.94")
    thisalinea.textcontent.append("GT4 0.94")
    thisalinea.textcontent.append("GT5 0.94")
    thisalinea.textcontent.append("0.99")
    thisalinea.textcontent.append("1.01")
    thisalinea.textcontent.append("0.94")
    thisalinea.textcontent.append("0.94")
    thisalinea.textcontent.append("0.96")
    thisalinea.textcontent.append("0.97")
    thisalinea.textcontent.append("1.01")
    thisalinea.textcontent.append("1.07")
    thisalinea.textcontent.append("0.92")
    thisalinea.textcontent.append("0.89")
    thisalinea.textcontent.append("0.89")
    thisalinea.textcontent.append("0.89")
    thisalinea.textcontent.append("0.97")
    thisalinea.textcontent.append("1.04")
    thisalinea.textcontent.append("0.90")
    thisalinea.textcontent.append("0.89")
    thisalinea.textcontent.append("0.91")
    thisalinea.textcontent.append("0.94")
    thisalinea.textcontent.append("Hence, as an overall summary of our discussion, we state that a cross section published")
    thisalinea.textcontent.append("in Ref. [28] should be divided by a percentage in Table 5.3 and multiplied by a factor")
    thisalinea.textcontent.append("from Table 5.5 to obtain the cross section at α = 0 and q = 0. This is shown for the")
    thisalinea.textcontent.append("results of Ref. [28] in Table 5.6.")
    thisalinea.textcontent.append("Table 5.6: Positions (E∗), widths (Γ, FWHM) and cross sections (dσ/dΩ) for the")
    thisalinea.textcontent.append("Gamow-Teller resonances illustrated in Figure 5.7. These results have been obtained")
    thisalinea.textcontent.append("with permission from Ref. [28] (which has a beam energy of 67 MeV/u). The third")
    thisalinea.textcontent.append("column contains the cross sections as they were obtained from Ref. [28]. The fourth")
    thisalinea.textcontent.append("column contains the cross sections extrapolated to q = 0 and α = 0. All cross sections")
    thisalinea.textcontent.append("are in mb/sr.")
    thisalinea.textcontent.append("IAS 8.36 ± 0.03 −− 6.0 ± 0.4 7.78 ± 0.52")
    thisalinea.textcontent.append("GT1 10.04 ± 0.25 5.5 ± 0.3 16.8 ± 2.0 24.03 ± 2.86")
    thisalinea.textcontent.append("GT2 5.04 ± 0.25 2.5 ± 0.3 6.2 ± 0.7 7.59 ± 0.86")
    thisalinea.textcontent.append("GT3 3.18 ± 0.20 0.8 ± 0.3 2.1 ± 0.3 2.51 ± 0.36")
    thisalinea.textcontent.append("GT4 1.84 ± 0.20 1.1 ± 0.3 2.5 ± 0.3 2.97 ± 0.36")
    thisalinea.textcontent.append("GT5 0.74 ± 0.20 0.5 ± 0.3 0.7 ± 0.1 0.83 ± 0.12")
    thisalinea.textcontent.append("Σ(GT) −− −− 28.3 ± 2.2 37.93 ± 3.03")
    thisalinea.textcontent.append("IAS 11.24 ± 0.03 −− 8.1 ± 0.5 10.10 ± 0.62")
    thisalinea.textcontent.append("GT1 12.25 ± 0.25 5.6 ± 0.3 21.9 ± 2.6 30.67 ± 3.64")
    thisalinea.textcontent.append("GT2 6.65 ± 0.25 3.7 ± 0.3 9.2 ± 1.1 11.12 ± 1.33")
    thisalinea.textcontent.append("GT3 3.37 ± 0.20 3.1 ± 0.3 6.3 ± 0.8 7.57 ± 0.96")
    thisalinea.textcontent.append("GT4 1.45 ± 0.20 0.7 ± 0.3 1.2 ± 0.1 1.47 ± 0.12")
    thisalinea.textcontent.append("GT5 −− −− −− −−")
    thisalinea.textcontent.append("Σ(GT) −− −− 38.6 ± 2.9 50.83 ± 4.00")
    thisalinea.textcontent.append("To make the comparison in Subsection 5.2.3 as genuine as possible, we have also ana-")
    thisalinea.textcontent.append("lyzed our data by applying the ﬁtting procedure of Figure 5.7 to an α ≈ 0◦ spectrum")
    thisalinea.textcontent.append("of our own data. Subsequently, we have divided the obtained Gaussian areas through")
    thisalinea.textcontent.append("their respective denominators of Equation (4.6) to obtain the α ≈ 0◦ diﬀerential cross")
    thisalinea.textcontent.append("sections. For the ﬁtting procedures, we limited the mean and width of each Gaus-")
    thisalinea.textcontent.append("sian to the values of Ref. [28] up to the measurement errors reported there. For the")
    thisalinea.textcontent.append("IVSGDR, we limited the mean and width to the values of Ref. [28] up to 1 keV, as it")
    thisalinea.textcontent.append("was otherwise impossible for the ﬁtting algorithm to disentangle the IVSGDR from")
    thisalinea.textcontent.append("the quasi-free charge-exchange background. The results of analyzing our data by this")
    thisalinea.textcontent.append("ﬁtting procedure are shown in Table 5.7.")
    thisalinea.textcontent.append("Table 5.7: Same as Table 5.6, but now for the data measured in this work at")
    thisalinea.textcontent.append("140 MeV/u.")
    thisalinea.textcontent.append("IAS 8.349 ± 0.001 0.087 ± 0.003 5.83 ± 0.08 8.38 ± 0.12")
    thisalinea.textcontent.append("GT1 10.290 ± 0.250 5.411 ± 0.031 41.05 ± 0.40 68.06 ± 0.66")
    thisalinea.textcontent.append("GT2 5.046 ± 0.010 2.2 ± 0.3 10.96 ± 1.50 16.98 ± 2.32")
    thisalinea.textcontent.append("GT3 3.158 ± 0.010 0.845 ± 0.026 2.21 ± 0.07 3.39 ± 0.11")
    thisalinea.textcontent.append("GT4 1.861 ± 0.014 1.4 ± 0.3 3.83 ± 0.82 5.86 ± 1.26")
    thisalinea.textcontent.append("GT5 0.658 ± 0.006 0.4 ± 0.3 0.66 ± 0.49 1.01 ± 0.75")
    thisalinea.textcontent.append("Σ(GT) −− −− 58.71 ± 1.82 95.30 ± 2.83")
    thisalinea.textcontent.append("IAS 11.251 ± 0.001 0.094 ± 0.003 8.67 ± 0.09 12.62 ± 0.13")
    thisalinea.textcontent.append("GT1 12.461 ± 0.010 5.779 ± 0.031 66.07 ± 0.66 110.37 ± 1.10")
    thisalinea.textcontent.append("GT2 6.625 ± 0.013 3.4 ± 0.3 16.94 ± 1.51 26.48 ± 2.36")
    thisalinea.textcontent.append("GT3 3.170 ± 0.200 3.4 ± 0.3 9.09 ± 0.81 14.19 ± 1.26")
    thisalinea.textcontent.append("GT4 1.524 ± 0.012 0.667 ± 0.026 0.54 ± 0.03 0.81 ± 0.05")
    thisalinea.textcontent.append("GT5 0.0 ± 0.001 0.106 ± 0.001 0.84 ± 0.02 1.35 ± 0.03")
    thisalinea.textcontent.append("Σ(GT) −− −− 93.48 ± 1.84 153.20 ± 2.90")
    thisalinea.textcontent.append("When comparing Tables 5.6 and 5.7, it becomes apparent that the mean and width of")
    thisalinea.textcontent.append("the Gaussians all agree within their respective measurement errors. However, as the")
    thisalinea.textcontent.append("data were taken at diﬀerent beam energies, the cross sections cannot be compared.")
    thisalinea.textcontent.append("They will ﬁrst have to be converted into B(GT )-values (or B(F ) for the IAS). This")
    thisalinea.textcontent.append("was not done in Ref. [28], so we will do this ourselves. This means that we will")
    thisalinea.textcontent.append("have to come up with reasonable estimates of the Gamow-Teller unit cross sections")
    thisalinea.textcontent.append("at 67 MeV/u. This is the topic of the next subsection.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "5.2.2 Determination of the Gamow-Teller unit cross sections"
    thisalinea.nativeID = 39
    thisalinea.parentID = 37
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "As discussed in Section 2.1, the only way to determine a Gamow-Teller unit cross section without resorting to possibly inaccurate nuclear structure models, is to extract it from the lifetime of the recoil nucleus. However, this can only be done if the ground state of the recoil nucleus can undergo Gamow-Teller decay. Hence, our strategy for obtaining the Gamow-Teller unit cross sections for 116Sn and 122Sn at 67 MeV/u will be to ﬁrst determine the unit cross sections for the isotopes of Sn that do have a recoil nucleus with a ground state that can undergo Gamow-Teller decay and then "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As discussed in Section 2.1, the only way to determine a Gamow-Teller unit cross")
    thisalinea.textcontent.append("section without resorting to possibly inaccurate nuclear structure models, is to extract")
    thisalinea.textcontent.append("it from the lifetime of the recoil nucleus. However, this can only be done if the ground")
    thisalinea.textcontent.append("state of the recoil nucleus can undergo Gamow-Teller decay. Hence, our strategy for")
    thisalinea.textcontent.append("obtaining the Gamow-Teller unit cross sections for 116Sn and 122Sn at 67 MeV/u will")
    thisalinea.textcontent.append("be to ﬁrst determine the unit cross sections for the isotopes of Sn that do have a")
    thisalinea.textcontent.append("recoil nucleus with a ground state that can undergo Gamow-Teller decay and then to")
    thisalinea.textcontent.append("extrapolate those results to 116Sn and 122Sn.")
    thisalinea.textcontent.append("Among the data in Ref. [28], there are two Sn-isotopes that fulﬁll the condition of")
    thisalinea.textcontent.append("having a recoil nucleus with a ground state that can undergo Gamow-Teller decay:")
    thisalinea.textcontent.append("were reported in Ref. [35]: B(GT ) = 0.344 for 118Sn and B(GT ) = 0.345 for 120Sn.")
    thisalinea.textcontent.append("In Ref. [28], the diﬀerential cross sections of these ground states were extracted from")
    thisalinea.textcontent.append("the α ≈ 0◦ spectrum and were reported to be 0.843 mb/sr for 118Sn and 0.979 mb/sr")
    thisalinea.textcontent.append("for 120Sn at 67 MeV/u.")
    thisalinea.textcontent.append("Hence, for the nuclei 118Sn and 120Sn, the Gamow-Teller unit cross sections could be")
    thisalinea.textcontent.append("determined. However, Equation (2.2) cannot be immediately applied to the numbers")
    thisalinea.textcontent.append("given above, as the cross sections in Ref. [28] are not extrapolated to α = 0 and q = 0")
    thisalinea.textcontent.append("and they may also contain ∆L (cid:54)= 0 multipolarity contributions. The extrapolation")
    thisalinea.textcontent.append("could be performed in a similar way as was done in Subsection 5.2.1, but the mul-")
    thisalinea.textcontent.append("tipolarity contributions form a bigger challenge. The reason for this is that in its")
    thisalinea.textcontent.append("tables, Ref. [28] only reports cross sections determined from the α ≈ 0◦ spectrum.")
    thisalinea.textcontent.append("For this reason, we have chosen to also perform a data analysis like in Ref. [28] on")
    thisalinea.textcontent.append("our own data as well (see table 5.7), so a fair comparison can still be made (see next")
    thisalinea.textcontent.append("subsection).")
    thisalinea.textcontent.append("Fortunately, there exists a work-around for 118Sn. For this isotope, Ref. [28] contains")
    thisalinea.textcontent.append("a ﬁgure showing the ground state for both the α ≈ 0◦ spectrum and for the α ≈ 2◦")
    thisalinea.textcontent.append("spectrum. This is shown in Figure 5.9.")
    thisalinea.textcontent.append("From Ref. [28], it is known that both spectra in Figure 5.9 were collected from the")
    thisalinea.textcontent.append("same experimental run and that the relevant solid angles are about equal. This")
    thisalinea.textcontent.append("means that the proportionality factor (the denominator in Equation (4.6)) between")
    thisalinea.textcontent.append("the number of counts and the cross section is the same for the α ≈ 0◦ and α ≈ 2◦")
    thisalinea.textcontent.append("spectrum. Knowing this, a Multipole Decomposition Analysis can be performed on")
    thisalinea.textcontent.append("the number of counts (as read from the ﬁgure) of the ground-state peak in Figure 5.4.")
    thisalinea.textcontent.append("The result can then be scaled to the reported number of 0.843 mb/sr.")
    thisalinea.textcontent.append("Using the FOLD-program and the procedures of Section 2.5, both the smeared and")
    thisalinea.textcontent.append("unsmeared multipolarity distributions were computed for 118Sn at 67 MeV/u (see")
    thisalinea.textcontent.append("Table 5.4 for the optical potentials used). Since only two data-points are available")
    thisalinea.textcontent.append("in Figure 5.9, the Multipole Decomposition Analysis can include at most two an-")
    thisalinea.textcontent.append("gular distributions. Obviously, one of them has to be a ∆L = 0, ∆S = 1, ∆J = 1")
    thisalinea.textcontent.append("Gamow-Teller distribution. For the other one, we chose a ∆L = 2, ∆S = 1, ∆J = 1")
    thisalinea.textcontent.append("quadrupole contribution. Since it is known from Ref. [21] that the 118Sb ground state")
    thisalinea.textcontent.append("is a 1+ state and the 118Sn ground state is a 0+ state, any other contribution to this")
    thisalinea.textcontent.append("transition than the two being considered is negligible. This is the same assumption")
    thisalinea.textcontent.append("as what was used for the low-lying Gamow-Teller states in Tables 5.1 and 5.2.")
    thisalinea.textcontent.append("The two-point Multipole Decomposition Analysis is illustrated in Figure 5.10. From")
    thisalinea.textcontent.append("the two condition that the α ≈ 0◦ smeared values have to add up to 236 counts and")
    thisalinea.textcontent.append("that the α ≈ 2◦ smeared values have to add up to 70 counts, the coeﬃcients of how")
    thisalinea.textcontent.append("the two multipolarity distributions in Figure 5.10 should add up can be determined.")
    thisalinea.textcontent.append("Let us denote the Gamow-Teller coeﬃcient as γ (in FOLD output units, γ = 0.80)")
    thisalinea.textcontent.append("and the quadrupole coeﬃcient as β (in FOLD output units, β = 1.64). With these")
    thisalinea.textcontent.append("Figure 5.9: Excitation-energy spectra for α ≈ 0◦ and α ≈ 2◦, as measured in Ref. [28];")
    thisalinea.textcontent.append("ﬁgure used with permission.")
    thisalinea.textcontent.append("coeﬃcients, one can determine that the α ≈ 0◦ cross section of 0.843 mb/sr contains")
    thisalinea.textcontent.append("a Gamow-Teller contribution, which is about 87%. Hence, the Gamow-Teller cross")
    thisalinea.textcontent.append("section at α ≈ 0◦ is 0.735 mb/sr. Extrapolating this number to α = 0 and q = 0")
    thisalinea.textcontent.append("analogously to Subsection 5.2.1 gives a cross section of 0.892 mb/sr. Dividing this")
    thisalinea.textcontent.append("number through a B(GT ) value of 0.344, results then in a Gamow-Teller unit cross")
    thisalinea.textcontent.append("section of 2.59 mb/sr for 118Sn at 67 MeV/u.")
    thisalinea.textcontent.append("Next, we face the challenge of extrapolating this number to the isotopes 116Sn and")
    thisalinea.textcontent.append("ground state [21], so we must rely on such an extrapolation. For this extrapolation,")
    thisalinea.textcontent.append("we will compute unit cross sections according to the procedures outlined in Ref. [11]:")
    thisalinea.textcontent.append("ˆσGT = K · ND(GT ) · |Vστ |2 ˆσF = K · ND(F ) · |Vτ |2,")
    thisalinea.textcontent.append("(5.1)")
    thisalinea.textcontent.append("K =")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("π2(cid:126)4c4 ·")
    thisalinea.textcontent.append("p0")
    thisalinea.textcontent.append("p0")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("p0")
    thisalinea.textcontent.append("p0")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("||(cid:126)peject||")
    thisalinea.textcontent.append("||(cid:126)pbeam||")
    thisalinea.textcontent.append(",")
    thisalinea.textcontent.append("ND(GT ) =")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("ND(F ) =")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append("(cid:12)")
    thisalinea.textcontent.append(",")
    thisalinea.textcontent.append("where K is a kinematic factor, ND is the distortion factor, and Vτ and Vστ are the")
    thisalinea.textcontent.append("volume integrals of the central τ - and στ -components of the eﬀective nucleon-nucleon")
    thisalinea.textcontent.append("interaction [11, 13]. This type of computation was already introduced in Section")
    thisalinea.textcontent.append("2.1, but due to arguments presented in Ref. [35], we did not need to actually use it.")
    thisalinea.textcontent.append("However, we do need it now for the extrapolation to the isotopes 116Sn and 122Sn, so")
    thisalinea.textcontent.append("we do treat this type of computation in more detail now. In the computation of K, a")
    thisalinea.textcontent.append("p0 factor refers to the total energy component of the 4-momentum of the particle and")
    thisalinea.textcontent.append("||(cid:126)p|| refers to the total 3-momentum of the particle. Hence, the computation of K is a")
    thisalinea.textcontent.append("simple matter of kinematics. The distortion factors ND are ratios between the DWBA")
    thisalinea.textcontent.append("and PWBA (see Section 2.5) computed cross sections at zero momentum transfer and")
    thisalinea.textcontent.append("at zero scattering angle. ND may be computed with the FOLD-program according to")
    thisalinea.textcontent.append("the procedures outlined in Section 2.5. As the third piece of information, we obtained")
    thisalinea.textcontent.append("the volume integrals from Ref. [95]: |Vστ | = 168 MeV · fm3 and |Vτ | = 149 MeV · fm3")
    thisalinea.textcontent.append("at 67 MeV/u.")
    thisalinea.textcontent.append("Figure 5.10: Illustration of the two-point Multipole Decomposition Analysis done for")
    thisalinea.textcontent.append("the 118Sb ground state at 67 MeV/u using the data from Ref. [28].")
    thisalinea.textcontent.append("For 118Sn, we computed K = 5.64 · 10−4 fm−4MeV−2 (this would be K = 6.45 · 10−4")
    thisalinea.textcontent.append("fm−4MeV−2 at 140 MeV/u). With FOLD, we computed ND(GT ) = 4.24 · 10−3, re-")
    thisalinea.textcontent.append("sulting in a Gamow-Teller unit cross section of 0.678 mb/sr. This number is quite")
    thisalinea.textcontent.append("diﬀerent than what we derived from the measured cross section of the recoil nucleus")
    thisalinea.textcontent.append("and the lifetime of that nucleus (2.59 mb/sr). However, it was brieﬂy discussed in")
    thisalinea.textcontent.append("Section 2.1 that a computation of a unit cross section through Equation (5.1) may")
    thisalinea.textcontent.append("have large uncertainties. According to Ref. [13], ND may have uncertainties as large")
    thisalinea.textcontent.append("as 20%. However, in Ref. [13] the inﬂuence of surface optical potentials on this un-")
    thisalinea.textcontent.append("certainty was not considered. Surface potentials may make the uncertainty on ND (a")
    thisalinea.textcontent.append("lot) larger. Moreover, there is also a substantial uncertainty about the precise values")
    thisalinea.textcontent.append("of the volume integral (Compare Refs. [96] and [95], for example). Therefore, it is not")
    thisalinea.textcontent.append("so surprising that the computed unit cross section through equation (5.1) are oﬀ by")
    thisalinea.textcontent.append("about a factor 3.")
    thisalinea.textcontent.append("However, it is possible to use equation (5.1) to extrapolate the Gamow-Teller unit")
    thisalinea.textcontent.append("cross section of 118Sn to the other isotopes. For 118Sn, we obtained 0.678 mb/sr.")
    thisalinea.textcontent.append("With exactly the same inputs, we obtained 0.660 mb/sr for 116Sn and 0.627 mb/sr for")
    thisalinea.textcontent.append("does give us some conﬁdence that the Gamow-Teller unit cross sections of these three")
    thisalinea.textcontent.append("Sn-isotopes are not that far apart. Hence, we will use the calculated results to rescale")
    thisalinea.textcontent.append("the Gamow-Teller unit cross section of 118Sn, so that we can obtain the correct unit")
    thisalinea.textcontent.append("cross sections for the other isotopes. We obtained for 67 MeV/u:")
    thisalinea.textcontent.append("ˆσGT (116Sn) = 2.53 mb/sr , ˆσF (116Sn) = 0.49 mb/sr,")
    thisalinea.textcontent.append("ˆσGT (122Sn) = 2.40 mb/sr , ˆσF (122Sn) = 0.46 mb/sr.")
    thisalinea.textcontent.append("(5.2)")
    thisalinea.textcontent.append("We have also given the Fermi cross sections in Equation (5.2) for the sake of comple-")
    thisalinea.textcontent.append("tion. These numbers were simply obtained from Ref. [28] by assuming B(F ) = |N − Z|")
    thisalinea.textcontent.append("for the IAS. For the sake of comparison, we shall also give the Fermi and Gamow-")
    thisalinea.textcontent.append("Teller unit cross sections at 140 MeV/u from Ref. [35], which we have used through")
    thisalinea.textcontent.append("this thesis:")
    thisalinea.textcontent.append("ˆσGT (116Sn) = 4.96 mb/sr , ˆσF (116Sn) = 0.47 mb/sr,")
    thisalinea.textcontent.append("ˆσGT (122Sn) = 4.80 mb/sr , ˆσF (122Sn) = 0.44 mb/sr.")
    thisalinea.textcontent.append("(5.3)")
    thisalinea.textcontent.append("From Ref. [35], it is known that the unit cross sections in Equation (5.3) have a")
    thisalinea.textcontent.append("relative uncertainty of 5%. From Ref. [93], it is known that the measured Gamow-")
    thisalinea.textcontent.append("Teller unit cross section of 118Sn at 67 MeV/u carries an experimental uncertainty of")
    thisalinea.textcontent.append("15%. This uncertainty contains a contribution from the uncertainty in the B(GT )-")
    thisalinea.textcontent.append("value of the ground state, a 10% uncertainty in the measured cross sections [32] and")
    thisalinea.textcontent.append("a systematic uncertainty from the crude MDA that we have used to estimate the")
    thisalinea.textcontent.append("quadrupole contribution. When the Gamow-Teller unit cross section at 67 MeV/u")
    thisalinea.textcontent.append("is extrapolated to the isotopes 116Sn and 122Sn, even more uncertainty is added.")
    thisalinea.textcontent.append("Therefore, we shall assume an uncertainty of 20% for the Gamow-Teller unit cross")
    thisalinea.textcontent.append("sections in equation (5.2). The Fermi unit cross sections at 67 MeV/u can be assumed")
    thisalinea.textcontent.append("to have an uncertainty of only 10%, as they were determined from the measured IAS")
    thisalinea.textcontent.append("in Ref. [28]. Hence, they only carry statistical uncertainty from the IAS measurement")
    thisalinea.textcontent.append("and a small systematic uncertainty from the extrapolation to α = 0 and q = 0.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "5.2.3 Comparison to Ref. [28]"
    thisalinea.nativeID = 40
    thisalinea.parentID = 37
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "With Equations (5.2) and (5.3), the B(GT )-values corresponding to Tables 5.6 and 5.7 can be computed (by applying Equation (2.2)). The results are displayed in Tables 5.8 and 5.9 for the 116Sn and 122Sn targets, respectively. Table 5.8: B(F ) and B(GT ) values for 116Sn(3He, t)116Sb obtained through various methods. The ﬁrst column shows the state labels as in Figure 5.7. The second column shows the B values obtained from Table 5.6 (at a beam energy of 67 MeV/u). The third column shows the B values from Table 5.7 (at a beam energy of 140 MeV/u). The fourth "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("With Equations (5.2) and (5.3), the B(GT )-values corresponding to Tables 5.6 and")
    thisalinea.textcontent.append("5.7 can be computed (by applying Equation (2.2)). The results are displayed in Tables")
    thisalinea.textcontent.append("5.8 and 5.9 for the 116Sn and 122Sn targets, respectively.")
    thisalinea.textcontent.append("Table 5.8: B(F ) and B(GT ) values for 116Sn(3He, t)116Sb obtained through various")
    thisalinea.textcontent.append("methods. The ﬁrst column shows the state labels as in Figure 5.7. The second column")
    thisalinea.textcontent.append("shows the B values obtained from Table 5.6 (at a beam energy of 67 MeV/u). The")
    thisalinea.textcontent.append("third column shows the B values from Table 5.7 (at a beam energy of 140 MeV/u).")
    thisalinea.textcontent.append("The fourth column shows B values obtained from an MDA with Gaussians (at a")
    thisalinea.textcontent.append("beam energy 140 MeV/u). The last column shows B values as obtained from the")
    thisalinea.textcontent.append("cyan spectra of Figure 5.4 (at a beam energy of 140 MeV/u). See text for details.")
    thisalinea.textcontent.append("State Ref. [28] α ≈ 0◦ MDA with Gaussians B(GT ) spectrum")
    thisalinea.textcontent.append("IAS 16 17.9 ± 0.9 16.3 ± 0.9")
    thisalinea.textcontent.append("16.0 ± 0.88")
    thisalinea.textcontent.append("GT1 9.5 ± 2.2 13.7 ± 0.7 10.6 ± 0.6")
    thisalinea.textcontent.append("9.82 ± 0.51")
    thisalinea.textcontent.append("2.39 ± 0.14")
    thisalinea.textcontent.append("GT2 3.0 ± 0.7 3.4 ± 0.5 2.2 ± 0.2")
    thisalinea.textcontent.append("GT3 1.0 ± 0.3 0.7 ± 0.1 0.32 ± 0.02 0.10 ± 0.04")
    thisalinea.textcontent.append("GT4 1.2 ± 0.3 1.2 ± 0.3 0.62 ± 0.04 0.83 ± 0.09")
    thisalinea.textcontent.append("0.50 ± 0.20")
    thisalinea.textcontent.append("GT5 0.3 ± 0.1 0.2 ± 0.2")
    thisalinea.textcontent.append("Σ(B(GT )) 15.0 ± 3.3 19.2 ± 1.1 13.8 ± 1.1 13.81 ± 0.79")
    thisalinea.textcontent.append("0 ± 0")
    thisalinea.textcontent.append("Table 5.9: Same as Table 5.8, but now for 122Sn(3He, t)122Sb.")
    thisalinea.textcontent.append("State Ref. [28] α ≈ 0◦ MDA with Gaussians B(GT ) spectrum")
    thisalinea.textcontent.append("IAS 22 28.6 ± 1.5 25.7 ± 1.4")
    thisalinea.textcontent.append("22.5 ± 1.21")
    thisalinea.textcontent.append("GT1 12.8 ± 3.0 23.0 ± 1.2 14.7 ± 0.8 17.06 ± 0.87")
    thisalinea.textcontent.append("GT2 4.6 ± 1.1 5.5 ± 0.6 2.8 ± 0.2")
    thisalinea.textcontent.append("3.14 ± 0.19")
    thisalinea.textcontent.append("GT3 3.2 ± 0.8 3.0 ± 0.3 0.96 ± 0.07 1.00 ± 0.16")
    thisalinea.textcontent.append("0.04 ± 0.03")
    thisalinea.textcontent.append("GT4 0.6 ± 0.2 0.2 ± 0.1")
    thisalinea.textcontent.append("0.5 ± 0.7")
    thisalinea.textcontent.append("GT5 −− 0.3 ± 0.1")
    thisalinea.textcontent.append("0 ± 0")
    thisalinea.textcontent.append("0 ± 0")
    thisalinea.textcontent.append("Σ(B(GT )) 21.2 ± 4.6 31.9 ± 1.7 18.5 ± 1.4 23.18 ± 1.31")
    thisalinea.textcontent.append("In order to arrive at the numbers presented in the last two columns of Tables 5.8 and")
    thisalinea.textcontent.append("5.9, the following two procedures were used: the ‘MDA with Gaussians’ method and")
    thisalinea.textcontent.append("the ‘B(GT )-spectrum’ method. With the ‘MDA with Gaussians’ method, Gaussians")
    thisalinea.textcontent.append("were ﬁtted to the excitation-energy spectra after all the corrections from Section 4.4")
    thisalinea.textcontent.append("were applied and after the spectra were divided in bins of 0.3◦ for the scattering angle")
    thisalinea.textcontent.append("α. Subsequently, the Gaussians were ﬁtted according to Figure 5.7 and cross sections")
    thisalinea.textcontent.append("were extracted from their areas according to the procedures discussed in Section")
    thisalinea.textcontent.append("4.4. Finally, an MDA as illustrated in Figure 5.5 was done to obtain the B(GT )")
    thisalinea.textcontent.append("values. This means that, eﬀectively, the only diﬀerence between the ‘α ≈ 0◦’ column")
    thisalinea.textcontent.append("and the ‘MDA with Gaussians’ column is whether or not the higher multipolarity")
    thisalinea.textcontent.append("contributions are subtracted. Both columns have used the same excitation-energy")
    thisalinea.textcontent.append("spectra (our data) and have used the same ﬁtting procedure illustrated in Figure 5.7.")
    thisalinea.textcontent.append("The ‘B(GT )-spectrum’ method works the other way around: the MDA is done before")
    thisalinea.textcontent.append("the Gaussians in Figure 5.7 are ﬁtted. With this method, Gaussians according to")
    thisalinea.textcontent.append("Figure 5.7 were ﬁtted to the cyan histograms of Figure 5.4 and the B(GT ) values in")
    thisalinea.textcontent.append("the tables were obtained from their areas. The cyan histograms of Figure 5.4 were")
    thisalinea.textcontent.append("obtained with the ‘full MDA’ technique described in Section 4.5.")
    thisalinea.textcontent.append("Since the Gaussians from Figure 5.7 have widths of sometimes several MeVs, the")
    thisalinea.textcontent.append("‘MDA with Gaussians’ procedure is not expected to be very accurate, as the theoret-")
    thisalinea.textcontent.append("ical calculation of each multipole contribution depends on the excitation energy (see")
    thisalinea.textcontent.append("Section 2.5). Moreover, it has been explained in Subsection 4.4.2 that pure Gaus-")
    thisalinea.textcontent.append("sians do not always suﬃce for ﬁtting peaks in our data. However, the purpose of this")
    thisalinea.textcontent.append("method is not to do very accurate analysis (as is the ‘B(GT )-spectrum’ column), but")
    thisalinea.textcontent.append("to qualitatively determine how the ‘α ≈ 0◦’ column changes when the higher multi-")
    thisalinea.textcontent.append("polarity contributions are subtracted. For this purpose, the accuracy of the method")
    thisalinea.textcontent.append("is suﬃcient. In this situation, one might wonder why the error bars in the ‘MDA with")
    thisalinea.textcontent.append("Gaussians’ column are of the same order as those in the ‘B(GT )-spectrum’ column.")
    thisalinea.textcontent.append("The reason for this is, that the error bars in the ‘MDA with Gaussians’ column do not")
    thisalinea.textcontent.append("include the systematic contributions from the inaccurate ﬁttings of the pure Gaus-")
    thisalinea.textcontent.append("sians and from the excitation-energy dependence in the multipole calculation. These")
    thisalinea.textcontent.append("contributions are very hard to accurately estimate, and since the ‘B(GT )-spectrum’")
    thisalinea.textcontent.append("column results are also available, such estimations would also have limited use.")
    thisalinea.textcontent.append("The B(F ) values of the IAS in the ‘B(GT )-spectrum’ column were taken from Tables")
    thisalinea.textcontent.append("5.1 and 5.2, as those values were obtained from accurate ﬁttings of the whole peak (see")
    thisalinea.textcontent.append("Subsection 4.4.3 and Figure 4.11). The Σ(B(GT )) values in these columns were not")
    thisalinea.textcontent.append("obtained from summation of the 5 GT states (as is the case for the other columns),")
    thisalinea.textcontent.append("but from integrating the cyan B(GT ) spectra of Figure 5.4 up to 28 MeV (which")
    thisalinea.textcontent.append("should provide about the same answer, since the contributions above GT1 are small).")
    thisalinea.textcontent.append("The value of 28 MeV was chosen because above that excitation energy, our Sieve-")
    thisalinea.textcontent.append("Slit analysis is no longer reliable (see Section 4.3). Finally, the B(F )-values in the")
    thisalinea.textcontent.append("‘Ref. [28]’ column were simply put equal to |N − Z|.")
    thisalinea.textcontent.append("From Tables 5.8 and 5.9, it is clear that good agreement could be obtained between")
    thisalinea.textcontent.append("the ‘α ≈ 0◦’ column and the ‘Ref. [28]’ column. There is a discrepancy between the")
    thisalinea.textcontent.append("values of GT1 (and, as a result, there is also a discrepancy in the sum), but the B(GT )")
    thisalinea.textcontent.append("values of GT2-GT5 all agree up to their respective measurement errors. A possible")
    thisalinea.textcontent.append("reason for the discrepancy in GT1 could be the systematic uncertainty in the ﬁtting")
    thisalinea.textcontent.append("procedure illustrated in Figure 5.7. This procedure only ﬁts a sum of Gaussians to")
    thisalinea.textcontent.append("the data. Hence, in the situation that the excitation-energy spectrum is relatively")
    thisalinea.textcontent.append("ﬂat, it may be hard to disentangle the individual Gaussians. From Figure 5.1, it")
    thisalinea.textcontent.append("can be seen that the 122Sn spectrum is ﬂatter than the 116Sn spectrum. Since the")
    thisalinea.textcontent.append("discrepancy of GT1 is also larger for 122Sn than for 116Sn, this could be an indication")
    thisalinea.textcontent.append("that the systematic uncertainty in the ﬁtting procedure is indeed responsible for the")
    thisalinea.textcontent.append("discrepancy of GT1. Moreover, the ﬁgures in Ref. [28] suggest that the left ﬂank of")
    thisalinea.textcontent.append("the GT1 Gaussian could easily have been a bit larger, while our own ﬁtting plots")
    thisalinea.textcontent.append("suggest that this ﬂank could have been a bit smaller. This is also an indication that")
    thisalinea.textcontent.append("the systematic uncertainty in the ﬁtting procedure is responsible.")
    thisalinea.textcontent.append("The diﬀerences between the ‘α ≈ 0◦’ column and the ‘MDA with Gaussians’ column")
    thisalinea.textcontent.append("in Tables 5.8 and 5.9 are easily understood, as we have already explained that the")
    thisalinea.textcontent.append("only diﬀerence between these columns is the subtraction of the higher multipolarity")
    thisalinea.textcontent.append("contributions. Hence, it is only natural to expect that all the B(GT ) values drop.")
    thisalinea.textcontent.append("As explained, the α ≈ 0◦ cross sections (both from our own data and from Ref. [28])")
    thisalinea.textcontent.append("are directly obtained from ﬁtting Gaussians to the α ≈ 0◦ excitation-energy spectrum")
    thisalinea.textcontent.append("(see Figure 5.7) [28, 32]. It was simply assumed that these cross sections were Gamow-")
    thisalinea.textcontent.append("Teller, so that B(GT ) values could be computed, and that our data could be compared")
    thisalinea.textcontent.append("to Ref. [28]. Therefore, we must conclude that the ﬁrst two columns in Tables 5.8")
    thisalinea.textcontent.append("and 5.9 are overestimates of the actual cross sections.")
    thisalinea.textcontent.append("Eﬀectively, the diﬀerence between the ‘MDA with Gaussians’ column and the ‘B(GT )-")
    thisalinea.textcontent.append("spectrum’ column is the accuracy of the analysis. It was already discussed above")
    thisalinea.textcontent.append("that the ‘MDA with Gaussians’ method suﬀers from two types of inaccuracies: 1)")
    thisalinea.textcontent.append("ﬁtting the states with pure Gaussians and 2) performing MDA on these states (of")
    thisalinea.textcontent.append("several MeV wide) without correcting for the excitation-energy dependence of the")
    thisalinea.textcontent.append("multipolarity contributions. Since the ‘B(GT )-spectrum’ method uses a relatively")
    thisalinea.textcontent.append("ﬁne binning of 200 keV in the excitation-energy spectrum and performs an MDA")
    thisalinea.textcontent.append("before the Gaussians of Figure 5.7 are ﬁtted, this method does not suﬀer from these")
    thisalinea.textcontent.append("inaccuracies. Hence, one expects that the ‘MDA with Gaussians’ column and the")
    thisalinea.textcontent.append("‘B(GT )-spectrum’ column agree with each other, but that the ‘B(GT )-spectrum’")
    thisalinea.textcontent.append("column are more accurate. This agreement is also found in Tables 5.8 and 5.9. There")
    thisalinea.textcontent.append("are a few relatively small discrepancies (like the IAS of 122Sn), but they can be")
    thisalinea.textcontent.append("explained by the systematic uncertainties of the ‘MDA with Gaussians’ method (which")
    thisalinea.textcontent.append("was not included in the tables).")
    thisalinea.textcontent.append("Hence, we can conclude from Tables 5.8 and 5.9 that, when the same analysis proce-")
    thisalinea.textcontent.append("dure was followed, our results agree with those published in Ref. [28], except for the")
    thisalinea.textcontent.append("GT1-peak of 122Sn. For that peak, the discrepancy was attributed to systematic un-")
    thisalinea.textcontent.append("certainties. However, this procedure gives an overestimate of the cross sections, since")
    thisalinea.textcontent.append("nothing was done to subtract the higher multipolarity contributions. When these")
    thisalinea.textcontent.append("contributions are subtracted, the results match our cyan B(GT ) spectra of Figure")
    thisalinea.textcontent.append("5.4, since the analysis procedure of Ref. [28] includes the subtraction of the quasi-free")
    thisalinea.textcontent.append("charge-exchange background.")
    thisalinea.textcontent.append("In Ref. [28], the individual states in the region of low excitation energy (below 4 MeV)")
    thisalinea.textcontent.append("were also studied. These results can be compared to Tables 5.1 and 5.2. This compar-")
    thisalinea.textcontent.append("ison is shown in Tables 5.10 and 5.11. Since the cross sections were obtained from the")
    thisalinea.textcontent.append("α ≈ 0◦ spectrum, they may contain ∆L (cid:54)= 0 contributions as well as a Gamow-Teller")
    thisalinea.textcontent.append("contribution. Ref. [28] does not contain suﬃcient information for 116Sn and 122Sn to")
    thisalinea.textcontent.append("eliminate these contributions, so we shall assume that the Gamow-Teller contribu-")
    thisalinea.textcontent.append("tion is 87% (like we determined for the ground state of 118Sn). With this number, it")
    thisalinea.textcontent.append("becomes possible to extrapolate the Gamow-Teller contribution to q = 0 and α = 0")
    thisalinea.textcontent.append("so that B(GT ) values can be obtained. Based on Ref. [32], we shall assume a 10%")
    thisalinea.textcontent.append("statistical uncertainty for these cross sections.")
    thisalinea.textcontent.append("Table 5.10: Comparison for the individual states in the region of low excitation energy")
    thisalinea.textcontent.append("for 116Sn(3He, t)116Sb between our data and those of Refs. [21, 28]. Our data were")
    thisalinea.textcontent.append("taken from Table 5.1. All energies are in keV. All cross sections are in mb/sr. The")
    thisalinea.textcontent.append("labeling of the states was taken from Figure 5.1.")
    thisalinea.textcontent.append("State E∗ [21] E∗ [28] E∗ (this work) dσ/dΩ(α ≈ 0◦) [28] dσ/dΩ(GT, α, q = 0)")
    thisalinea.textcontent.append("1 93.99 100 91 0.951 0.992")
    thisalinea.textcontent.append("4 731.72 760 718 −− −−")
    thisalinea.textcontent.append("6 917.82 930 895 −− −−")
    thisalinea.textcontent.append("8 1158.42 1160 1144 −− −−")
    thisalinea.textcontent.append("9 1385.82 1370 1336 −− −−")
    thisalinea.textcontent.append("10 −− −− 1538 −− −−")
    thisalinea.textcontent.append("11 −− 1680 1613 −− −−")
    thisalinea.textcontent.append("13 −− 1830 1842 −− −−")
    thisalinea.textcontent.append("14 −− 1980 1958 −− −−")
    thisalinea.textcontent.append("15 −− −− 2220 −− −−")
    thisalinea.textcontent.append("16 −− 2280 2291 0.614 0.634")
    thisalinea.textcontent.append("−− −− 2520 −− −− −−")
    thisalinea.textcontent.append("17 −− 2780 2753 −− −−")
    thisalinea.textcontent.append("18 −− 3080 3069 −− −−")
    thisalinea.textcontent.append("19 −− 3350 3315 0.666 0.691")
    thisalinea.textcontent.append("−− −− 4520 −− −− −−")
    thisalinea.textcontent.append("−− −− 4770 −− −− −−")
    thisalinea.textcontent.append("−− −− 5010 −− −− −−")
    thisalinea.textcontent.append("−− −− 5260 −− −− −−")
    thisalinea.textcontent.append("−− −− 5770 −− −− −−")
    thisalinea.textcontent.append("The systematic uncertainty of the energy calibration was estimated at 40 keV FWHM")
    thisalinea.textcontent.append("(see Section 4.3). From this estimate, we conclude that the energies of the individual")
    thisalinea.textcontent.append("states in Tables 5.10 and 5.11 agree within the uncertainty of the calibration.")
    thisalinea.textcontent.append("For a few of these states, Ref. [28] also provided cross sections (see tables). For the ﬁrst")
    thisalinea.textcontent.append("Gamow-Teller states, we obtain from these cross sections that B(GT ) = 0.39 ± 0.09")
    thisalinea.textcontent.append("for 116Sn at 67 MeV/u and B(GT ) = 0.33 ± 0.07 for 122Sn at 67 MeV/u. These")
    thisalinea.textcontent.append("values are higher than the ones reported in Tables 5.1 and 5.2. However, given the")
    thisalinea.textcontent.append("relatively large uncertainty of the numbers at 67 MeV/u, the discrepancies are not")
    thisalinea.textcontent.append("that signiﬁcant. The discrepancy may be explained by the assumption that the cross")
    thisalinea.textcontent.append("sections in Tables 5.10 and 5.11 all have an 87% Gamow-Teller contribution. We have")
    thisalinea.textcontent.append("estimated this number from a Figure in Ref. [28] for the ground state of the recoil")
    thisalinea.textcontent.append("nucleus of 118Sn at 67 MeV/u. However, there is no a priori reason to assume that")
    thisalinea.textcontent.append("the same number also holds for the lowest Gamow-Teller states of 116Sn and 122Sn.")
    thisalinea.textcontent.append("However, this number could very well be lower. If this number would have been 70%,")
    thisalinea.textcontent.append("there would not have been any discrepancy. Hence, we conclude that, although the")
    thisalinea.textcontent.append("B(GT ) values of the ﬁrst states in Tables 5.10 and 5.11 are higher than those in")
    thisalinea.textcontent.append("Table 5.11: Same as Table 5.10, but now for 122Sn(3He, t)122Sb.")
    thisalinea.textcontent.append("State E∗ [21] E∗ [28] E∗ (this work) dσ/dΩ(α ≈ 0◦) [28] dσ/dΩ(GT, α, q = 0)")
    thisalinea.textcontent.append("1 121.50 70 119 0.704 0.782")
    thisalinea.textcontent.append("4 620 630 668 −− −−")
    thisalinea.textcontent.append("8 −− 1350 1358 1.059 1.142")
    thisalinea.textcontent.append("9 −− −− 1681 −− −−")
    thisalinea.textcontent.append("10 −− 1780 1782 0.482 0.516")
    thisalinea.textcontent.append("12 −− 2050 2019 −− −−")
    thisalinea.textcontent.append("13 −− −− 2156 −− −−")
    thisalinea.textcontent.append("14 −− −− 2307 −− −−")
    thisalinea.textcontent.append("15 −− 2500 2493 −− −−")
    thisalinea.textcontent.append("16 −− −− 2597 −− −−")
    thisalinea.textcontent.append("17 −− 2840 2842 −− −−")
    thisalinea.textcontent.append("18 −− 3190 3164 −− −−")
    thisalinea.textcontent.append("−− −− 3510 −− −− −−")
    thisalinea.textcontent.append("−− −− 4000 −− −− −−")
    thisalinea.textcontent.append("−− −− 4420 −− −− −−")
    thisalinea.textcontent.append("Tables 5.1 and 5.2, no deﬁnitive conclusions about agreement can be made due to the")
    thisalinea.textcontent.append("uncertainty in the relative multipolarity contributions.")
    thisalinea.textcontent.append("For the other states in Tables 5.10 and 5.11 where cross sections are available, the")
    thisalinea.textcontent.append("corresponding B(GT ) values are much higher than what we have obtained in Tables")
    thisalinea.textcontent.append("5.1 and 5.2. A possible explanation for this diﬀerence could be our assumption of")
    thisalinea.textcontent.append("a linear phenomenological background in the ﬁttings of the states listed in Tables")
    thisalinea.textcontent.append("5.1 and 5.2 (see Subsection 4.4.2 for further details). However, no phenomenological")
    thisalinea.textcontent.append("background is discussed in Ref. [28]. Hence, it is plausible to assume that no such")
    thisalinea.textcontent.append("background was used in the analysis procedures of Ref. [28] either. The fact that the")
    thisalinea.textcontent.append("diﬀerences are much smaller for ﬁrst Gamow-Teller states of 116Sn and 122Sn supports")
    thisalinea.textcontent.append("this claim, because our phenomenological background was found to be zero for those")
    thisalinea.textcontent.append("states, but non-zero for the other states. Therefore, we conclude that due to the")
    thisalinea.textcontent.append("diﬀerence in phenomenological background, the B(GT ) values of the states labeled")
    thisalinea.textcontent.append("higher than 1 cannot be compared.")
    thisalinea.textcontent.append("Hence, for the individual states in Tables 5.10 and 5.11, we conclude that the positions")
    thisalinea.textcontent.append("of Ref. [28] match our positions, but that the cross sections could not be compared")
    thisalinea.textcontent.append("due to a diﬀerence in the phenomenological background. For the ﬁrst Gamow-Teller")
    thisalinea.textcontent.append("states, this diﬀerence was absent, but the uncertainty in the diﬀerent multipolarity")
    thisalinea.textcontent.append("contributions at 67 MeV/u also made it impossible to make a good comparison there.")
    thisalinea.textcontent.append("For the Gamow-Teller resonances our conclusion is that we were able to make a")
    thisalinea.textcontent.append("comparison and to obtain agreement when the same analysis procedure was followed")
    thisalinea.textcontent.append("as in Ref. [28]. This procedure subtracts the quasi-free charge-exchange background,")
    thisalinea.textcontent.append("but does not subtract the higher multipolarity contributions.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "5.3 Comparison to the Gamow-Teller sum rule"
    thisalinea.nativeID = 41
    thisalinea.parentID = 35
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "The total Gamow-Teller strength, listed in the Σ(B(GT )) column in Tables 5.8 and 5.9, can be compared to the Gamow-Teller sum rule (see Equation 2.9), also known as the Ikeda sum rule [92]: (cid:88) BE∗ (GT, n → p) − (cid:88) BE∗ (GT, p → n) = 3|N − Z| (5.4) In the (3He, t) charge-exchange reaction, the p → n contribution in medium-heavy and heavy nuclei is relatively small due to Pauli-blocking [94]. With the program NORMOD (see Section 2.3), it was determined that the total absolute B(GT ) strength associated with p → n transitions is about "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The total Gamow-Teller strength, listed in the Σ(B(GT )) column in Tables 5.8 and")
    thisalinea.textcontent.append("5.9, can be compared to the Gamow-Teller sum rule (see Equation 2.9), also known")
    thisalinea.textcontent.append("as the Ikeda sum rule [92]:")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("BE∗ (GT, n → p) −")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("BE∗ (GT, p → n) = 3|N − Z| (5.4)")
    thisalinea.textcontent.append("In the (3He, t) charge-exchange reaction, the p → n contribution in medium-heavy")
    thisalinea.textcontent.append("and heavy nuclei is relatively small due to Pauli-blocking [94]. With the program")
    thisalinea.textcontent.append("NORMOD (see Section 2.3), it was determined that the total absolute B(GT ) strength")
    thisalinea.textcontent.append("associated with p → n transitions is about 2.2 for the 116Sn target and about 3.5")
    thisalinea.textcontent.append("for the 122Sn target. Since this p → n contribution is relatively small compared to")
    thisalinea.textcontent.append("3|N − Z|, it is common [28, 92, 94] to compare the total measured Gamow-Teller")
    thisalinea.textcontent.append("strength, Σ(B(GT )), in (p, n)-type reactions to 3|N − Z|, although it would be more")
    thisalinea.textcontent.append("exact to compare it to 3|N − Z| + (cid:80)")
    thisalinea.textcontent.append("the common practice and compare to 3|N − Z|.")
    thisalinea.textcontent.append("As discussed in Section 5.2, the ‘B(GT )-spectrum’ method of Tables 5.8 and 5.9")
    thisalinea.textcontent.append("provides the most accurate results. This is because those Σ(B(GT )) were obtained")
    thisalinea.textcontent.append("from the histogram integrals of Figure 5.4, which is a procedure that does not re-")
    thisalinea.textcontent.append("quire inaccurate Gaussian ﬁttings (and where the higher multipolarity contribu-")
    thisalinea.textcontent.append("tions are subtracted). The integrals of the cyan histograms up to 28 MeV are")
    thisalinea.textcontent.append("Σ(B(GT )) = 13.81 ± 0.79 for the 116Sn target and Σ(B(GT )) = 23.18 ± 1.31 for the")
    thisalinea.textcontent.append("target and 35 ± 2% for the 122Sn target. Hence, only a small fraction of the Gamow-")
    thisalinea.textcontent.append("Teller sum rule was found below an excitation energy of 28 MeV. It is well known")
    thisalinea.textcontent.append("that for N > Z nuclei, only about 50% − 60% of the total Gamow-Teller strength")
    thisalinea.textcontent.append("of the Ikeda sum rule can be found near or below the Gamow-Teller resonance (the")
    thisalinea.textcontent.append("GT1-state in Figure 5.7) [5, 94, 97, 98]. This phenomenon is known as quenching")
    thisalinea.textcontent.append("of the Gamow-Teller strength. The missing Gamow-Teller strength is to a large ex-")
    thisalinea.textcontent.append("tent moved to higher excitation energies due to coupling to 2p-2h conﬁgurations, as")
    thisalinea.textcontent.append("has been observed in the (p, n) reaction on 90Zr [99]. This leaves little strength to")
    thisalinea.textcontent.append("be moved to very high excitation energies due to coupling to the ∆ resonance [99].")
    thisalinea.textcontent.append("However, these excitation-energies are far outside of the detector acceptance in our")
    thisalinea.textcontent.append("experiment (see Section 4.3).")
    thisalinea.textcontent.append("Although quenching is a known phenomenon, the 50% − 60% prescribed by the lit-")
    thisalinea.textcontent.append("erature is still a lot more than the 29 ± 2% and 35 ± 2% that were measured. On")
    thisalinea.textcontent.append("the other hand, our data do agree with previously measured results when the same")
    thisalinea.textcontent.append("analysis procedure is applied (see Section 5.2), which is a clear indication that the")
    thisalinea.textcontent.append("low percentage of Gamow-Teller strength that we found is not a consequence of some")
    thisalinea.textcontent.append("experimental artefact. To resolve this issue, we also compared our results to the re-")
    thisalinea.textcontent.append("sults of Ref. [92]. In this paper, the Gamow-Teller B(GT ) spectrum is extracted for")
    thisalinea.textcontent.append("the Grand Raiden spectrometer at RCNP and were also analyzed by the ‘full MDA’")
    thisalinea.textcontent.append("technique described in Section 4.5. This provided a spectrum of B(GT ) values much")
    thisalinea.textcontent.append("like Figure 5.4. However, in Ref. [92] the quasi-free charge-exchange background (see")
    thisalinea.textcontent.append("Equation 4.9) was not subtracted. This means that we should compare the yellow")
    thisalinea.textcontent.append("spectra of Figure 5.4 to the results presented in Ref. [92]. The integrals of these B(GT )")
    thisalinea.textcontent.append("spectra are plotted in Figure 5.11 as a function of the excitation energy where the")
    thisalinea.textcontent.append("integral is truncated. For the sake of completeness, the situation where the quasi-free")
    thisalinea.textcontent.append("charge-exchange background is subtracted, is shown in Figure 5.12.")
    thisalinea.textcontent.append("Figure 5.11: Full integral of the B(GT ) spectra as a function of the excitation energy")
    thisalinea.textcontent.append("where the integral was truncated. The data on 150Nd(3He, t)150Pm were obtained")
    thisalinea.textcontent.append("from Ref. [92]. The other data were obtained from the yellow spectra of Figure 5.4.")
    thisalinea.textcontent.append("From Figure 5.11, it becomes clear that at lower excitation energies, the diﬀerences")
    thisalinea.textcontent.append("are signiﬁcant, but at higher excitation energies, the error bands start to overlap")
    thisalinea.textcontent.append("(although for 116Sn, the overlap can only be realized by including the systematic")
    thisalinea.textcontent.append("errors from the MDA). At the limit of the excitation energy that we could measure")
    thisalinea.textcontent.append("(28 MeV), a fraction of 38 ± 2% of the Ikeda sum rule was found for the 116Sn target, a")
    thisalinea.textcontent.append("fraction of 48 ± 3% was found for the 122Sn target and a fraction of 52 ± 5% was found")
    thisalinea.textcontent.append("for the 150Nd target. When the systematic errors from the MDA are included, these")
    thisalinea.textcontent.append("results become 38 ± 7% for the 116Sn target and 48 ± 6% for the 122Sn target. The")
    thisalinea.textcontent.append("systematic contribution from the MDA was already included in the 52 ± 5% found")
    thisalinea.textcontent.append("for the 150Nd target [92]. The discrepancies at lower excitation-energies in Figure")
    thisalinea.textcontent.append("Figure 5.12: Same as Figure 5.11, but now for the situation where the quasi-free")
    thisalinea.textcontent.append("charge-exchange background is subtracted (the cyan spectra of Figure 5.4).")
    thisalinea.textcontent.append("5.11 are a direct consequence of the diﬀerence in the position of the Gamow-Teller")
    thisalinea.textcontent.append("resonance (GT1 in Figure 5.7) for diﬀerent isotopes [94].")
    thisalinea.textcontent.append("We conclude, therefore, that the 122Sn results and the 150Nd results are in agreement")
    thisalinea.textcontent.append("with the expected quenching of the Gamow-Teller strength and are in agreement")
    thisalinea.textcontent.append("with each other. However, the 116Sn results are signiﬁcantly lower. Given the rel-")
    thisalinea.textcontent.append("atively large systematic errors of the ‘full MDA’ technique, the diﬀerence between")
    thisalinea.textcontent.append("the 38 ± 7% for the 116Sn target and the 50% − 60% expected quenching is not even")
    thisalinea.textcontent.append("that large (the 7% is only a single standard deviation), but is too large to simply")
    thisalinea.textcontent.append("attribute to inaccuracies of the procedure. The facts that we were able to reproduce")
    thisalinea.textcontent.append("B(F ) = |N − Z| and that we were able to obtain reasonably good agreements to the")
    thisalinea.textcontent.append("results of Ref. [28] (when we followed their analysis procedure) provide strong hints")
    thisalinea.textcontent.append("for this. We will further discuss the low percentage of 38 ± 7% in Section 5.5, as we")
    thisalinea.textcontent.append("need the comparison to theory from that section for this.")
    thisalinea.textcontent.append("From the above discussion, we can conclude that without subtracting the quasi-free")
    thisalinea.textcontent.append("charge-exchange background, our results for the 122Sn target are in reasonable agree-")
    thisalinea.textcontent.append("ment with the expected quenching of the Gamow-Teller strength of 50% − 60% and")
    thisalinea.textcontent.append("with Ref. [92] (where no quasi-free charge-exchange background was subtracted ei-")
    thisalinea.textcontent.append("ther). For the 116Sn, the percentage is somewhat lower, but the diﬀerence is not")
    thisalinea.textcontent.append("that large. We can also conclude that when the subtraction of the quasi-free charge-")
    thisalinea.textcontent.append("exchange background is included, we ﬁnd signiﬁcantly less Gamow-Teller strength")
    thisalinea.textcontent.append("than the expected quenching of 50% − 60% for both of our isotopes (see Figure 5.12).")
    thisalinea.textcontent.append("The explanation for ﬁnding signiﬁcantly less Gamow-Teller strength than found in")
    thisalinea.textcontent.append("the literature (50% − 60% of the Ikeda sum rule) when the quasi-free charge-exchange")
    thisalinea.textcontent.append("background is subtracted, can be found in Figure 5.7 and Equation (4.9). By choosing")
    thisalinea.textcontent.append("Equation (4.9) to describe the quasi-free charge-exchange background, our analysis")
    thisalinea.textcontent.append("procedure is no longer model independent, meaning that the obtained B(GT ) spectra")
    thisalinea.textcontent.append("will not be model independent either [93]. Moreover, Equation (4.9) contains two")
    thisalinea.textcontent.append("parameters that must be ﬁtted to the data: EQF and the overall-normalization pa-")
    thisalinea.textcontent.append("rameter, N0. From the magenta line in Figure 5.7, it is clear that we have chosen N0")
    thisalinea.textcontent.append("in such a way that at 28 MeV, the quasi-free charge-exchange background exhausts")
    thisalinea.textcontent.append("100% of the measured total cross section. This normalization is approximately in")
    thisalinea.textcontent.append("agreement with Ref. [28].")
    thisalinea.textcontent.append("However, this normalization procedure is incorrect because the region around 28 MeV")
    thisalinea.textcontent.append("also contains tails from the IVSGMR and IVGMR [5, 93], which have been ignored")
    thisalinea.textcontent.append("in our analysis. The IVGMR is a giant resonance with the following properties:")
    thisalinea.textcontent.append("∆L = 0, ∆T = 1 and ∆S = 0. These quantum numbers are the same as those of")
    thisalinea.textcontent.append("the IAS, but the diﬀerence with the IAS is that the IVGMR involves a change of")
    thisalinea.textcontent.append("∆n = 1 in the principal quantum number of the shell model (see Figure 2.1) while")
    thisalinea.textcontent.append("the IAS has ∆n = 0 [5]. A similar comparison applies to Gamow-Teller transitions")
    thisalinea.textcontent.append("and to the IVSGMR. It should be noted that the IVGMR strength is not part of")
    thisalinea.textcontent.append("the Fermi sum rule, but has a sum rule of its own (because its transition operator")
    thisalinea.textcontent.append("is diﬀerent). Likewise, the IVSGMR has a sum rule of its own and is not part of")
    thisalinea.textcontent.append("the Ikeda sum rule [5, 94]. However, some models that are used to explain the")
    thisalinea.textcontent.append("quenching phenomenon of the Gamow-Teller strength claim that the missing part of")
    thisalinea.textcontent.append("this strength is located in the same region as that of the IVSGMR and/or the IVGMR")
    thisalinea.textcontent.append("(see Ref. [5] and references therein). This means that the region around 28 MeV may")
    thisalinea.textcontent.append("carry ∆L = 0 contributions from Gamow-Teller transitions, from the IVSGMR and")
    thisalinea.textcontent.append("from the IVGMR. As it is impossible to disentangle these contributions with an MDA")
    thisalinea.textcontent.append("(see Section 4.5), the only way to include all of the Gamow-Teller strength in this")
    thisalinea.textcontent.append("region in our analysis is to do an MDA on all of the data in this region. Hence, a")
    thisalinea.textcontent.append("normalization of the quasi-free charge-exchange background that ends up subtracting")
    thisalinea.textcontent.append("100% of the data at 28 MeV must be an overestimation of the background subtraction.")
    thisalinea.textcontent.append("Due to the poor systematic knowledge on the quasi-free charge-exchange background,")
    thisalinea.textcontent.append("it is impossible to determine the correct normalization of Equation (4.9) that keeps")
    thisalinea.textcontent.append("all contributions from the IVGMR, the IVSGMR and the Gamow-Teller strength")
    thisalinea.textcontent.append("intact [5]. There basically exist only two techniques to distinguish the quasi-free")
    thisalinea.textcontent.append("charge-exchange background from the other contributions. The ﬁrst one is to select")
    thisalinea.textcontent.append("a charge-exchange reaction where this background is known to be small (which is not")
    thisalinea.textcontent.append("the case for (3He, t)). The second technique is to try to suppress this background")
    thisalinea.textcontent.append("experimentally (as was done, for example, in Ref. [5]). Since our data is limited to")
    thisalinea.textcontent.append("α < 4.4◦ and no further measurements were done on the recoil nucleus, we did not")
    thisalinea.textcontent.append("have suitable tools to suppress the quasi-free charge-exchange background experi-")
    thisalinea.textcontent.append("mentally. Hence, the only way to preserve any Gamow-Teller strength near 28 MeV")
    thisalinea.textcontent.append("is to omit the subtraction of the quasi-free charge-exchange background completely.")
    thisalinea.textcontent.append("This conclusion is in agreement with the procedures and considerations followed in")
    thisalinea.textcontent.append("Ref. [92], as conﬁrmed by Ref. [93]. Hence, we conclude that it is better to take this")
    thisalinea.textcontent.append("region of excitation energy as part of the data for the MDA and not as background.")
    thisalinea.textcontent.append("The result would be the yellow spectra in Figure 5.4. The analysis with the back-")
    thisalinea.textcontent.append("ground subtraction (cyan spectra) should then only be used for the sake of comparing")
    thisalinea.textcontent.append("our results with those of Ref. [28].")
    thisalinea.textcontent.append("To summarize, we conclude that the quasi-free charge-exchange background should")
    thisalinea.textcontent.append("not be subtracted, because it is not possible to determine the correct normalization")
    thisalinea.textcontent.append("parameter that keeps the contributions from the IVGMR, the IVSGMR, and the")
    thisalinea.textcontent.append("shifted Gamow-Teller strength intact. We also conclude that our results for the 122Sn")
    thisalinea.textcontent.append("target are in agreement with Ref. [92] and with the expected quenching of the Gamow-")
    thisalinea.textcontent.append("Teller strength, but that our results for the 116Sn target are somewhat lower. When")
    thisalinea.textcontent.append("the same data is analyzed according to the procedure of Ref. [28] (which subtracts the")
    thisalinea.textcontent.append("quasi-free background, but not the higher multipolarity contributions), our results are")
    thisalinea.textcontent.append("in agreement with the ones published there.")
    thisalinea.textcontent.append("This leaves one ﬁnal issue to be discussed. Ref. [28] claims to have found that the")
    thisalinea.textcontent.append("Gamow-Teller Resonance alone (GT1 in Figure 5.7) has a B(GT ) value of 65 ± 3%")
    thisalinea.textcontent.append("of the Ikeda sum rule. However, according to Tables 5.8 and 5.9, the sum of all ﬁve")
    thisalinea.textcontent.append("Gamow-Teller resonances (GT1-GT5), as measured by Ref. [28], only carries about")
    thisalinea.textcontent.append("32% of the Ikeda sum rule (for the 116Sn and 122Sn targets). Moreover, we have")
    thisalinea.textcontent.append("even claimed this number to be an overestimate, because it still includes the higher")
    thisalinea.textcontent.append("multipolarity contributions. Hence, there is a clear discrepancy, which has to be")
    thisalinea.textcontent.append("explained.")
    thisalinea.textcontent.append("The large sum rule fraction of 65 ± 3% in Ref. [28] was computed using the following")
    thisalinea.textcontent.append("equation [28, 94, 100, 101]:")
    thisalinea.textcontent.append("B(GT ) =")
    thisalinea.textcontent.append("σGT")
    thisalinea.textcontent.append("σIAS")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("kIAS")
    thisalinea.textcontent.append("kGT")
    thisalinea.textcontent.append("·")
    thisalinea.textcontent.append("|N − Z|")
    thisalinea.textcontent.append("D")
    thisalinea.textcontent.append(", D =")
    thisalinea.textcontent.append("ND(GT ) · |Vστ |2")
    thisalinea.textcontent.append("ND(IAS) · |Vτ |2 =")
    thisalinea.textcontent.append("ˆσGT")
    thisalinea.textcontent.append("ˆσF")
    thisalinea.textcontent.append(", (5.5)")
    thisalinea.textcontent.append("where kGT")
    thisalinea.textcontent.append("after a Gamow-Teller (Fermi) transition [100]. The ratio of these wave numbers is")
    thisalinea.textcontent.append("close to unity [100]. σGT (σIAS) is the measured cross section of the Gamow-Teller")
    thisalinea.textcontent.append("(IAS) transition. The |N − Z| comes from the Fermi sum rule and D is computed")
    thisalinea.textcontent.append("with the distortion factors and volume integrals that we already have seen in Equation")
    thisalinea.textcontent.append("(5.1). The advantage of Equation (5.5) is that the reduction in the measured cross")
    thisalinea.textcontent.append("sections due to the smearing (see Table 5.3 and Figure 5.8) is canceled out. The")
    thisalinea.textcontent.append("losses are nearly equal for Fermi and Gamow-Teller transitions, so the ratio of the")
    thisalinea.textcontent.append("cross sections is largely unaﬀected.")
    thisalinea.textcontent.append("From the results shown in Equation (5.2), we compute D = 5.20 for 116Sn and D = 5.23")
    thisalinea.textcontent.append("for 122Sn at 67 MeV. Similarly, Equation (5.3) can be used to derive that D = 10.62")
    thisalinea.textcontent.append("for 116Sn and D = 10.86 for 122Sn at 140 MeV. With these values for D, Equation")
    thisalinea.textcontent.append("(5.5) can reasonably reproduce our results in the ﬁrst two columns of Tables 5.8 and")
    thisalinea.textcontent.append("5.9. However, the authors from Ref. [28] used D = (E/E0)2 from Ref. [101] with")
    thisalinea.textcontent.append("E0 = 55.0 ± 0.4 MeV and E the beam energy per nucleon. At 67 MeV/u, this gives")
    thisalinea.textcontent.append("D = 1.48, resulting in much higher B(GT ) values. However, it is not correct to use")
    thisalinea.textcontent.append("D = (E/E0)2 for the data measured in Ref. [28], because those data were obtained by")
    thisalinea.textcontent.append("a (3He, t) reaction, while D = (E/E0)2 only applies to (p, n) reactions [101]. Hence,")
    thisalinea.textcontent.append("the statement in Ref. [28] that the Gamow-Teller Resonances carries 65 ± 3% of the")
    thisalinea.textcontent.append("Ikeda sum rule is not correct. It should have been about 15%, which is in more or")
    thisalinea.textcontent.append("less in agreement with the GT1 results in the ﬁrst column of Tables 5.8 and 5.9. The")
    thisalinea.textcontent.append("small diﬀerence is explained by the eﬀects of extrapolating to q = 0 and α = 0, which")
    thisalinea.textcontent.append("are neglected in Equation (5.5).")
    thisalinea.textcontent.append("As a ﬁnal remark, we would like to note that D = 5.2 at 67 MeV/u implies that")
    thisalinea.textcontent.append("ND(GT )/ND(F ) = 4.1. When this ratio is calculated with the FOLD-program ac-")
    thisalinea.textcontent.append("cording to the procedures of Section 2.5, one obtains ND(GT )/ND(F ) = 3.6 for")
    thisalinea.textcontent.append("ND(GT )/ND(F ) = 4.1 up to the 22% error margin for values of D (see next section).")
    thisalinea.textcontent.append("Hence, although the values for ND(GT )/ND(F ) may appear to be quite larger than")
    thisalinea.textcontent.append("unity, there is an agreement between theory (FOLD-program) and experiment (de-")
    thisalinea.textcontent.append("duced unit cross sections). Moreover, these values also provide agreement between")
    thisalinea.textcontent.append("our data and the data of Ref. [28] (see previous section), so we conclude that these")
    thisalinea.textcontent.append("values are reliable.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "5.4 Error analysis"
    thisalinea.nativeID = 42
    thisalinea.parentID = 35
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "In this section, we would like to give a short overview of all the possible sources of uncertainty that can arise when diﬀerential cross sections are translated into B(GT ) values. These sources of uncertainty are: The uncertainty from source 1) was removed from our own data by using the ‘full MDA’ technique. Figure 5.6 illustrates the removal of the higher multipolarity con- tributions and from Figure 5.11, we know that this technique introduced a systematic error of about 6% of the Ikeda sum rule for 116Sn and 5% for 122Sn. However, since Ref. [28] does not contain suﬃcient information "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this section, we would like to give a short overview of all the possible sources of")
    thisalinea.textcontent.append("uncertainty that can arise when diﬀerential cross sections are translated into B(GT )")
    thisalinea.textcontent.append("values. These sources of uncertainty are:")
    thisalinea.textcontent.append("The uncertainty from source 1) was removed from our own data by using the ‘full")
    thisalinea.textcontent.append("MDA’ technique. Figure 5.6 illustrates the removal of the higher multipolarity con-")
    thisalinea.textcontent.append("tributions and from Figure 5.11, we know that this technique introduced a systematic")
    thisalinea.textcontent.append("error of about 6% of the Ikeda sum rule for 116Sn and 5% for 122Sn. However, since")
    thisalinea.textcontent.append("Ref. [28] does not contain suﬃcient information to perform an MDA on GT1-GT5")
    thisalinea.textcontent.append("for the isotopes of interest, the higher multipolarity contributions could not be sub-")
    thisalinea.textcontent.append("tracted from the data in Ref. [28]. The column labeled ‘α ≈ 0◦’ in Tables 5.8 and")
    thisalinea.textcontent.append("5.9 was speciﬁcally made from the excitation-energy spectra which included all the")
    thisalinea.textcontent.append("multipolarities. This allowed us to make a fair comparison between our data and the")
    thisalinea.textcontent.append("data of Ref. [28]. By comparing the numbers in the ‘α ≈ 0◦’ column with those in")
    thisalinea.textcontent.append("the ‘B(GT ) spectrum’ column, the eﬀects of including the higher multipolarity con-")
    thisalinea.textcontent.append("tributions can be estimated for our own data. It is better to use the numbers in the")
    thisalinea.textcontent.append("‘B(GT ) spectrum’ column for this rather than those in the ‘MDA with Gaussians’")
    thisalinea.textcontent.append("column, since the latter suﬀers from some systematic uncertainties (see Section 5.2).")
    thisalinea.textcontent.append("This comparison shows that the inclusion of the higher multipolarity contributions")
    thisalinea.textcontent.append("results in an overestimation of the B(GT ) values by about 30%.")
    thisalinea.textcontent.append("The eﬀects of source 2), the extrapolation to q = 0 fm−1 and α = 0◦, were listed in")
    thisalinea.textcontent.append("Tables 5.3 and 5.5. Hence, we conclude that the extrapolation to α = 0 increases the")
    thisalinea.textcontent.append("B(GT ) values by about 25% and the extrapolation to q = 0 reduces them by about")
    thisalinea.textcontent.append("12%. Hence, the net eﬀect of source 2) is estimated as an increase of 13 ± 1.1% for")
    thisalinea.textcontent.append("the data in Ref. [28]. For our own data, this is 34 ± 1.1%. As can be seen from Tables")
    thisalinea.textcontent.append("5.6 and 5.7, we have corrected the data for these eﬀects (the ‘full MDA’ technique also")
    thisalinea.textcontent.append("corrects for these eﬀects, see Section 4.5). The number of 1.1% was obtained from")
    thisalinea.textcontent.append("adding in quadrature the propagated uncertainties in the optical potential parameters")
    thisalinea.textcontent.append("(see Ref. [46] for details) to the systematic contribution of 1% reported in section 2.7.")
    thisalinea.textcontent.append("Source 3), the subtraction of the quasi-free charge-exchange background, has a large")
    thisalinea.textcontent.append("eﬀect: it reduces the Gamow-Teller strength in the region near 28 MeV excitation")
    thisalinea.textcontent.append("energy and should, therefore, not be done. However, the quasi-free charge-exchange")
    thisalinea.textcontent.append("background was subtracted in Ref. [28], which reduced the Gamow-Teller Resonance")
    thisalinea.textcontent.append("(GT1) by about 23%. This number is obtained by ﬁtting Gaussians like Figure 5.7 to")
    thisalinea.textcontent.append("the cyan and yellow spectra of Figure 5.4 and comparing their areas. Since it was not")
    thisalinea.textcontent.append("possible to add the quasi-free charge-exchange background to the results published in")
    thisalinea.textcontent.append("Ref. [28], we have chosen to also subtract it from our data to make a fair comparison")
    thisalinea.textcontent.append("(see Section 5.2). This subtraction results in an underestimate of the Gamow-Teller")
    thisalinea.textcontent.append("strength of at most 23% when one considers the cyan and yellow spectra in Figure")
    thisalinea.textcontent.append("5.4.")
    thisalinea.textcontent.append("We discussed in Section 5.3 that the percentage of how much Gamow-Teller strength of")
    thisalinea.textcontent.append("the Ikeda sum rule is found in GT1 should be 15% instead of 65%. This is because for")
    thisalinea.textcontent.append("Equation (5.5), we computed D = 5.20 for 116Sn and D = 5.23 for 122Sn at 67 MeV,")
    thisalinea.textcontent.append("while Ref. [28] used D = 1.48. Our values for D were obtained by dividing the Gamow-")
    thisalinea.textcontent.append("Teller unit cross section with an uncertainty of 20% by the Fermi unit cross section")
    thisalinea.textcontent.append("with an uncertainty of 10% (see Equation (5.2)). By adding the uncertainties in")
    thisalinea.textcontent.append("quadrature, we conclude that our computed values for D have an uncertainty of")
    thisalinea.textcontent.append("22%. To verify this claim, we have also computed the values of D from Equation")
    thisalinea.textcontent.append("(5.1). This resulted in D = 4.58 for 116Sn and D = 4.86 for 122Sn. These results are")
    thisalinea.textcontent.append("within our uncertainty of 22%, conﬁrming that 22% is a reasonable estimate of error")
    thisalinea.textcontent.append("in the determination of D. If this error of 22% is propagated to the determination of")
    thisalinea.textcontent.append("(B(GT ), the value will be 15 ± 4% of the Ikeda sum rule for GT1.")
    thisalinea.textcontent.append("Equation 5.5 was not used to obtain absolute B(GT ) values presented in Tables 5.3")
    thisalinea.textcontent.append("and 5.7. Instead, we chose to use the unit cross sections of Equations (5.2) and")
    thisalinea.textcontent.append("(5.3). The reason for this choice is that the measurement errors in the IAS can be")
    thisalinea.textcontent.append("circumvented for the computation of the B(GT ) values. The unit cross sections at")
    thisalinea.textcontent.append("140 MeV/u have an uncertainty of 5% and those at 67 MeV/u have an uncertainty")
    thisalinea.textcontent.append("of 20% (10% for the Fermi unit cross sections). These uncertainties have been incor-")
    thisalinea.textcontent.append("porated in the errors of Tables 5.8 and 5.9 for both the data from Ref. [28] and for")
    thisalinea.textcontent.append("our own data. Hence, the numbers of 5% (140 MeV/u) and 20% (67 MeV/u) are")
    thisalinea.textcontent.append("the uncertainties of source 4).")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "1. Higher multipolarity contributions; "
    thisalinea.nativeID = 43
    thisalinea.parentID = 42
    thisalinea.alineatype = texttype.ENUMERATION
    thisalinea.enumtype = enum_type.DIGIT
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "1. Higher multipolarity contributions; "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("1. Higher multipolarity contributions;")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "2. Extrapolation to q = 0 ..."
    thisalinea.nativeID = 44
    thisalinea.parentID = 42
    thisalinea.alineatype = texttype.ENUMERATION
    thisalinea.enumtype = enum_type.DIGIT
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "2. Extrapolation to q = 0 fm−1 and α = 0◦; "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("2. Extrapolation to q = 0 fm−1 and α = 0◦;")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "3. The quasi-free charge-exchange background; "
    thisalinea.nativeID = 45
    thisalinea.parentID = 42
    thisalinea.alineatype = texttype.ENUMERATION
    thisalinea.enumtype = enum_type.DIGIT
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "3. The quasi-free charge-exchange background; "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("3. The quasi-free charge-exchange background;")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "4. The overall normalization. "
    thisalinea.nativeID = 46
    thisalinea.parentID = 42
    thisalinea.alineatype = texttype.ENUMERATION
    thisalinea.enumtype = enum_type.DIGIT
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "4. The overall normalization. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("4. The overall normalization.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "5.5 Comparison to QRPA+QPVC calculations"
    thisalinea.nativeID = 47
    thisalinea.parentID = 35
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "The yellow B(GT ) spectra of Figure 5.4 could also be compared to theoretical calcu- lations using the Quasi-particle Random-Phase Approximation (QRPA) plus Quasi- Particle Vibration Coupling (QPVC). These calculations were done according to the procedure outlined in Ref. [102] and were done using the QRPA+QPVC formalism with the Skyrme interaction SkM∗ [103]. Before discussing this comparison, let us ﬁrst give a brief overview of how the QRPA+QPVC method can be used to compute B(GT ) values. We shall limit ourselves to a brief outline of this method and refer to Refs. [94, 102] for further details. In the Random-Phase "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The yellow B(GT ) spectra of Figure 5.4 could also be compared to theoretical calcu-")
    thisalinea.textcontent.append("lations using the Quasi-particle Random-Phase Approximation (QRPA) plus Quasi-")
    thisalinea.textcontent.append("Particle Vibration Coupling (QPVC). These calculations were done according to the")
    thisalinea.textcontent.append("procedure outlined in Ref. [102] and were done using the QRPA+QPVC formalism")
    thisalinea.textcontent.append("with the Skyrme interaction SkM∗ [103]. Before discussing this comparison, let us")
    thisalinea.textcontent.append("ﬁrst give a brief overview of how the QRPA+QPVC method can be used to compute")
    thisalinea.textcontent.append("B(GT ) values. We shall limit ourselves to a brief outline of this method and refer to")
    thisalinea.textcontent.append("Refs. [94, 102] for further details.")
    thisalinea.textcontent.append("In the Random-Phase Approximation (RPA), the ground state of the nucleus is de-")
    thisalinea.textcontent.append("noted as |0(cid:105). In Section 2.3, |0(cid:105) was introduced through Slater-determinants, as the")
    thisalinea.textcontent.append("antisymmetrized direct product of single-particle wave functions, obtained from the")
    thisalinea.textcontent.append("nuclear shell model ﬁlled from the bottom (see Section 2.2). However, in the RPA,")
    thisalinea.textcontent.append("ground-state correlations are taken along in the description of |0(cid:105) (by a more advanced")
    thisalinea.textcontent.append("method than the occupation numbers from Table 2.1). When the mean ﬁeld of the")
    thisalinea.textcontent.append("used shell model is obtained from some phenomenological description, one refers to")
    thisalinea.textcontent.append("the method as ‘shell model RPA’. However, when the mean ﬁeld is obtained from a")
    thisalinea.textcontent.append("variational calculation of the nuclear many-body problem (this method is known as")
    thisalinea.textcontent.append("the Hartree-Fock method), one refers to the method as ’self-consistent RPA’ [94].")
    thisalinea.textcontent.append("Subsequently, nuclear excitations are modeled as phonons (vibrational modes) propa-")
    thisalinea.textcontent.append("gating through the nucleus [94]. These phonons are then described as superpositions")
    thisalinea.textcontent.append("of 1p1h excitations (see Section 2.3). Under this assumption, the operator that excites")
    thisalinea.textcontent.append("the nucleus from its ground state to an excitation energy E can be described as [94]:")
    thisalinea.textcontent.append("Γ†")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("(cid:16)")
    thisalinea.textcontent.append("X ν")
    thisalinea.textcontent.append("(cid:17)")
    thisalinea.textcontent.append(", (5.6)")
    thisalinea.textcontent.append("where ν is a discrete index labeling a phonon having energy E, and m and i denote")
    thisalinea.textcontent.append("sets of 4 quantum numbers (n, l, m, j) specifying speciﬁc single-particle states in the")
    thisalinea.textcontent.append("nuclear shell model (see Section 2.2). Note that for deformed nuclei, m and i denote")
    thisalinea.textcontent.append("diﬀerent sets of quantum numbers. The operator a (a†) is the 1-particle annihilation")
    thisalinea.textcontent.append("(creation) operator corresponding to such a single-particle state and X and Y are")
    thisalinea.textcontent.append("complex coeﬃcients. The sum runs over all 1p1h excitations that result in a total")
    thisalinea.textcontent.append("excitation energy of E. Since the coeﬃcients X and Y of the superpositions are the")
    thisalinea.textcontent.append("amplitudes that determine the probability with which that speciﬁc 1p1h excitation")
    thisalinea.textcontent.append("contributes to the total nuclear excitation, the coeﬃcients X and Y are limited by")
    thisalinea.textcontent.append("the normalization condition:")
    thisalinea.textcontent.append("(|X ν")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("(5.7)")
    thisalinea.textcontent.append("Equations (5.6) and (5.7) are not suﬃcient to uniquely determine the coeﬃcients")
    thisalinea.textcontent.append("X and Y . However, the RPA model assumes that the nuclear excitations behave")
    thisalinea.textcontent.append("like phonons, which are boson particles. Hence, one imposes the Bose commutation")
    thisalinea.textcontent.append("relation on the operator (5.6): [Γν, Γ†")
    thisalinea.textcontent.append("coeﬃcients X and Y can be obtained for all energies and single-particle states by")
    thisalinea.textcontent.append("solving a set of coupled linear equations [94]. Subsequently, the transition matrix")
    thisalinea.textcontent.append("element for any transition operator ˆO can then be computed as [94]:")
    thisalinea.textcontent.append("(cid:104)E| ˆO|0(cid:105) =")
    thisalinea.textcontent.append("X ν")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("where the coeﬃcients Fm,i are the expansion coeﬃcients when ˆO is expanded as 1p1h")
    thisalinea.textcontent.append("transitions:")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("ˆO =")
    thisalinea.textcontent.append("Fk,la†")
    thisalinea.textcontent.append("(5.9)")
    thisalinea.textcontent.append("The coeﬃcients Fm,i can be obtained by taking anti-commutators and using the")
    thisalinea.textcontent.append("relation {ax, a†")
    thisalinea.textcontent.append("For Gamow-Teller transitions, ˆO is known from Equation (2.6). Hence the B(GT )")
    thisalinea.textcontent.append("value of a state having excitation energy E can be computed as [94]:")
    thisalinea.textcontent.append("B(GT )E =")
    thisalinea.textcontent.append("1")
    thisalinea.textcontent.append("2J + 1")
    thisalinea.textcontent.append("· | (cid:104)E| ˆO|0(cid:105) |2 (5.10)")
    thisalinea.textcontent.append("A common problem with RPA calculations is that in the ground state |0(cid:105), each single-")
    thisalinea.textcontent.append("particle state of the nuclear shell model is assumed to be either fully occupied, or")
    thisalinea.textcontent.append("completely empty. Hence, RPA calculations can only be used for closed-shell nuclei")
    thisalinea.textcontent.append("[94]. To circumvent this problem, the RPA formalism, which is deﬁned in terms of")
    thisalinea.textcontent.append("particle creation and annihilation operators, is reformulated in terms of quasi-particle")
    thisalinea.textcontent.append("annihilation and creation operators. This is done by means of a linear transformation:")
    thisalinea.textcontent.append("αµ = uµa†")
    thisalinea.textcontent.append("where µ denotes again a set of 4 quantum numbers (n, l, m, j) in the nuclear shell")
    thisalinea.textcontent.append("model (or another more appropriate set of quantum numbers for deformed nuclei).")
    thisalinea.textcontent.append("States labeled with −µ refer to the time-reversed state of the state labeled with µ.")
    thisalinea.textcontent.append("vµ is the fullness of the state labeled by µ (see Table 2.1) and uµ is the associated")
    thisalinea.textcontent.append("emptiness, which is given by uµ")
    thisalinea.textcontent.append("is inverted and ﬁlled into all particle annihilation and creation operators in equations")
    thisalinea.textcontent.append("(5.6) - (5.9), one obtains the basic formalism of the Quasi-particle Random-Phase")
    thisalinea.textcontent.append("Approximation (QRPA).")
    thisalinea.textcontent.append("With the Quasi-particle Vibration-Coupling (QPVC) method, a QRPA calculation as")
    thisalinea.textcontent.append("outlined above is done ﬁrst, and then the obtained strength (Equation (5.10)) is shifted")
    thisalinea.textcontent.append("and redistributed through couplings to doorway states [102]. These doorway states")
    thisalinea.textcontent.append("are assumed to be all the two-quasiparticle excitations that couple to the relevant")
    thisalinea.textcontent.append("phonon (which is the phonon created by Equation (5.6) with the excitation energy of")
    thisalinea.textcontent.append("interest). With this method, the width of excitations such as giant resonances can be")
    thisalinea.textcontent.append("predicted more realistically than with a pure QRPA calculation. Finally, SkM∗ is the")
    thisalinea.textcontent.append("Skyrme interaction [103] used in the Hartree-Fock method to obtain the mean-ﬁeld")
    thisalinea.textcontent.append("for the self-consistent (Q)RPA. Note, however, that a pure Hartee-Fock method does")
    thisalinea.textcontent.append("not consider ground-state correlations, while those correlations were taken along in")
    thisalinea.textcontent.append("obtaining the mean-ﬁeld of the self-consistent QRPA+QPVC method of Ref. [102].")
    thisalinea.textcontent.append("The results of the QRPA+QPVC calculations with Skyrme SkM∗ interaction were")
    thisalinea.textcontent.append("obtained from Ref. [104]. The comparison to our results is shown in Figure 5.13.")
    thisalinea.textcontent.append("The systematic errors of the ‘full MDA’ technique are, again, shown as a separate")
    thisalinea.textcontent.append("band (and are not included in the error bars of the data-points). We have normalized")
    thisalinea.textcontent.append("the results of the QRPA+QPVC calculation to (0.75)2 times the Ikeda sum rule, in")
    thisalinea.textcontent.append("agreement with Ref. [92].")
    thisalinea.textcontent.append("Figure 5.13: Comparison between our measured B(GT ) spectra and the")
    thisalinea.textcontent.append("QRPA+QPVC calculations from Ref. [104].")
    thisalinea.textcontent.append("From Figure 5.13, it is clear that in the region around and above the IAS, the")
    thisalinea.textcontent.append("QRPA+QPVC result and the measured result agree reasonably well. Except for")
    thisalinea.textcontent.append("the small peak near 13.5 MeV for 116Sn and the small drop near 13 MeV for 122Sn,")
    thisalinea.textcontent.append("the QRPA+QPVC result is within the total error band of the measured results. This")
    thisalinea.textcontent.append("total error band is deﬁned as the systematic contribution from the ‘full MDA’ tech-")
    thisalinea.textcontent.append("nique and the measurement errors (see Section 5.1), added in quadrature. However,")
    thisalinea.textcontent.append("problems arise at lower excitation energies, where the QRPA+QPVC result predicts")
    thisalinea.textcontent.append("a large, broad peak that is not found in our measured results. For 116Sn, this large,")
    thisalinea.textcontent.append("broad low-energy peak is located near 3 MeV and for 122Sn, it is located near 5.5 MeV.")
    thisalinea.textcontent.append("The large, broad low-energy peak calculated by the QRPA+QPVC model of Ref. [102]")
    thisalinea.textcontent.append("has a discrepancy with experimental data of (3He, t) from Ref. [28] (when the correct")
    thisalinea.textcontent.append("normalization and extrapolation to α = 0 and q = 0 is applied, see Sections 5.2 and")
    thisalinea.textcontent.append("5.3), (p, n) data [105] and our data (see Figure 5.13). This discrepancy also shows up in")
    thisalinea.textcontent.append("very recent and yet unpublished data on 132Sn(p, n)132Sb [106]. Possible reﬁnements")
    thisalinea.textcontent.append("of the model are currently under investigation [104].")
    thisalinea.textcontent.append("We also would like to note that no QRPA+QPVC result was computed for the region")
    thisalinea.textcontent.append("above 22 MeV, because not much Gamow-Teller strength was expected in that region")
    thisalinea.textcontent.append("[104]. Hence, we assumed a B(GT ) of zero in that region (for the QRPA+QPVC")
    thisalinea.textcontent.append("result). However, from Figure 5.13 it is clear that B(GT ) is signiﬁcantly larger than")
    thisalinea.textcontent.append("zero in that region. Therefore, we conclude that the QRPA+QPVC result had to be")
    thisalinea.textcontent.append("extended to 28 MeV and contributions from the IVSGMR and/or the IVGMR would")
    thisalinea.textcontent.append("have to be included (this is possible within the QRPA+QPVC model [104]).")
    thisalinea.textcontent.append("Hence, we conclude that the QRPA+QPVC result and the measured result agree")
    thisalinea.textcontent.append("reasonably well near the IAS and Gamow-Teller resonance, but that the strength")
    thisalinea.textcontent.append("of the large, broad low-energy peak is overestimated by the QRPA+QPVC result.")
    thisalinea.textcontent.append("A further test of the QRPA+QPVC model of Ref. [102] would be to extend the")
    thisalinea.textcontent.append("calculation beyond 22 MeV, which requires one to incorporate contributions from the")
    thisalinea.textcontent.append("IVGMR and IVSGMR for a fair comparison.")
    thisalinea.textcontent.append("Finally, let us go back to the issue of ﬁnding only 38 ± 7% of the Ikeda sum rule")
    thisalinea.textcontent.append("below 28 MeV for the 116Sn target. As explained above, the same normalization of the")
    thisalinea.textcontent.append("theoretical QRPA+QPVC result, (0.75)2 · 3|N − Z|, provided a reasonable agreement")
    thisalinea.textcontent.append("for both the data on the 116Sn target and for the data on the 122Sn target in the region")
    thisalinea.textcontent.append("around the IAS and the Gamow-Teller resonance (GT1 in Figure 5.7). Moreover, the")
    thisalinea.textcontent.append("diﬀerence between the large, broad low-energy peak of the QRPA+QPVC result and")
    thisalinea.textcontent.append("the experimental result is about the same for both targets, relative to the Ikeda sum")
    thisalinea.textcontent.append("rule. For the 116Sn target, this diﬀerence is about 1.6 MeV−1 and for the 122Sn,")
    thisalinea.textcontent.append("this is about 1.9 MeV−1. When these numbers are divided by 3|N − Z|, one obtains")
    thisalinea.textcontent.append("roughly the same number of 0.032 MeV−1. Therefore, we conclude that the diﬀerence")
    thisalinea.textcontent.append("in Gamow-Teller strength found between the 116Sn target and the 122Sn target comes")
    thisalinea.textcontent.append("from the region above the Gamow-Teller resonance: above 19 MeV. This claim is")
    thisalinea.textcontent.append("further supported by the overlapping error bands in Figure 5.11 near 19 MeV.")
    thisalinea.textcontent.append("It has already been discussed extensively that the region between 19 MeV and 28 MeV")
    thisalinea.textcontent.append("may contain Gamow-Teller strength, tails from the IVGMR and/or IVSGMR and a")
    thisalinea.textcontent.append("contribution from the quasi-free charge-exchange background, which cannot be sep-")
    thisalinea.textcontent.append("arated by our experimental and analysis techniques. As a result, we had to include")
    thisalinea.textcontent.append("all of these contributions in our MDA. Therefore, we conclude that the diﬀerence of")
    thisalinea.textcontent.append("ﬁnding 48 ± 6% of the Ikeda sum rule for the 122Sn target and 52 ± 5% for the 150Nd")
    thisalinea.textcontent.append("target [92] on one hand, and 38 ± 7% for the 116Sn target on the other hand, might")
    thisalinea.textcontent.append("just be the result of a diﬀerence in the quasi-free change-exchange background.")
    thisalinea.textcontent.append("A diﬀerence in contributions from the IVGMR and/or IVSGMR might also be the")
    thisalinea.textcontent.append("case, but this is less likely, as those reaction mechanisms are closely related to the")
    thisalinea.textcontent.append("IAS and to the Gamow-Teller resonance (except for their ∆n) [5], for which we found")
    thisalinea.textcontent.append("good agreements between the 116Sn and 122Sn targets and to B(F ) = |N − Z|. Given")
    thisalinea.textcontent.append("the general shape of the quasi-free change-exchange background in Figure 5.7, the")
    thisalinea.textcontent.append("results presented in Figure 5.13a suggest that this background contribution is very")
    thisalinea.textcontent.append("small for the 116Sn target. After all, the experimental data become nearly zero near")
    thisalinea.textcontent.append("20 MeV. As this does not happen in Figure 5.13b, the contribution to the percentage")
    thisalinea.textcontent.append("of 48 ± 6 for the 122Sn target of the quasi-free charge-exchange background may not")
    thisalinea.textcontent.append("be so small. Likewise, the spectrum of B(GT ) values in Ref. [92] also does not show")
    thisalinea.textcontent.append("such a zero-point, so the contribution of the quasi-free charge-exchange background")
    thisalinea.textcontent.append("to the 52 ± 5% for the 150Nd target may also be signiﬁcant.")
    thisalinea.textcontent.append("In order to resolve this issue, an interesting follow-up experiment would be to repeat")
    thisalinea.textcontent.append("the 140 MeV/u 116,122Sn(3He, t)116,122Sb charge-exchange reactions while also mea-")
    thisalinea.textcontent.append("suring the decay protons of the recoil nucleus. Such an experiment has been done")
    thisalinea.textcontent.append("in Ref. [5] for natPb(3He, t)Bi at 59 MeV/u. In this thesis, it was shown that by")
    thisalinea.textcontent.append("requiring a coincidence between emitted tritons and protons and by limiting the data")
    thisalinea.textcontent.append("to large backward proton angles, the quasi-free charge-exchange background could be")
    thisalinea.textcontent.append("eﬃciently reduced. As a follow-up experiment, we propose to repeat this technique")
    thisalinea.textcontent.append("for the isotopes and beam energy used in this work. This would allow us to suppress")
    thisalinea.textcontent.append("the contribution from the quasi-free charge-exchange background, which might allow")
    thisalinea.textcontent.append("us to resolve the diﬀerence between 38 ± 7% for the 116Sn target and 48 ± 6% for")
    thisalinea.textcontent.append("the 122Sn target. However, it is important to note that not all of the Gamow-Teller")
    thisalinea.textcontent.append("strength comes from states in the recoil nucleus that can decay by proton emission.")
    thisalinea.textcontent.append("Hence, this technique will also suppress a part of the Gamow-Teller strength (the")
    thisalinea.textcontent.append("part that belongs to states that cannot decay by proton emission). As a result, this")
    thisalinea.textcontent.append("technique will not be able to reproduce the 50% − 60% quenching of the Gamow-")
    thisalinea.textcontent.append("Teller strength. But it can be used to see if the diﬀerence in percentage between the")
    thisalinea.textcontent.append("to determine whether the diﬀerence in percentages comes from the quasi-free charge-")
    thisalinea.textcontent.append("exchange background. Note that this also means that a proper comparison between")
    thisalinea.textcontent.append("the experimental data and the result of the QRPA+QPVC calculation at higher ex-")
    thisalinea.textcontent.append("citation energies would either require the inclusion of the quasi-free charge-exchange")
    thisalinea.textcontent.append("background in the calculation, or to limit the calculation to Gamow-Teller strength")
    thisalinea.textcontent.append("that comes from states that can decay by proton emission.")
    thisalinea.textcontent.append("Another reason for the small diﬀerence between the 38 ± 7% for the 116Sn target and")
    thisalinea.textcontent.append("the 48 ± 6% for the 116Sn target might be uncertainties in the Gamow-Teller unit cross")
    thisalinea.textcontent.append("section. In our analysis, we have assumed that Equation (2.2) is valid for the entire")
    thisalinea.textcontent.append("excitation-energy spectrum and that the unit cross sections of Equation (5.3) (which")
    thisalinea.textcontent.append("come from Ref. [35]) are valid for the entire spectrum as well. However, from Refs. [11,")
    thisalinea.textcontent.append("101], it is known that Equation (2.2) is derived in the limit of vanishing momentum")
    thisalinea.textcontent.append("transfer, and that corrections would have to be included when the energy loss in the")
    thisalinea.textcontent.append("reaction becomes larger. This is precisely the region of large excitation energy, and")
    thisalinea.textcontent.append("we have already established that this region is responsible for the diﬀerence between")
    thisalinea.textcontent.append("the percentages. Hence, the diﬀerence between the percentages may also be a result")
    thisalinea.textcontent.append("of neglecting the corrections for larger energy loss. These corrections would have to")
    thisalinea.textcontent.append("be modeled as an excitation-energy dependence of the unit cross section.")
    thisalinea.textcontent.append("Unfortunately, our experimental data does not contain suﬃcient information to ex-")
    thisalinea.textcontent.append("tract the excitation-energy dependence of the unit cross section. Since we have only")
    thisalinea.textcontent.append("measured the trajectory of the beam and the triton, all we could measure was the")
    thisalinea.textcontent.append("diﬀerential cross section of the reaction. Using the FOLD-program, this diﬀerential")
    thisalinea.textcontent.append("cross section could be subjected to a Multipole Decomposition Analysis, which could")
    thisalinea.textcontent.append("be translated to B(GT ) values only by applying the unit cross sections of Ref. [35].")
    thisalinea.textcontent.append("The use of Ref. [35] could be omitted in follow-up experiments by performing mea-")
    thisalinea.textcontent.append("surements on 118Sn or 120Sn instead, because there, the Gamow-Teller unit cross")
    thisalinea.textcontent.append("section can be reliably extracted from the cross section of the ground state of the")
    thisalinea.textcontent.append("recoil nucleus. This would mean that no interpolation of the Gamow-Teller unit cross")
    thisalinea.textcontent.append("section is necessary (which is what was done in Ref. [35]). However, this procedure")
    thisalinea.textcontent.append("would still only allow us to determine ˆσGT near E∗ = 0, and would, therefore, not be")
    thisalinea.textcontent.append("a solution to the question of how to model the E∗ dependence of ˆσGT .")
    thisalinea.textcontent.append("A possible solution to this issue would be to use accurate theoretical calculations of")
    thisalinea.textcontent.append("the Gamow-Teller strength distribution. If such a model provides good agreement")
    thisalinea.textcontent.append("to the experimental data in the region of low excitation energy (say, below and near")
    thisalinea.textcontent.append("the Gamow-teller resonance), discrepancies at higher excitation energies could be")
    thisalinea.textcontent.append("attributed to an excitation-energy dependence of the unit cross section. This indicates")
    thisalinea.textcontent.append("the need to further improve the QRPA+QPVC calculation discussed in this section in")
    thisalinea.textcontent.append("the region of low excitation energy and to extend the calculation to higher excitation")
    thisalinea.textcontent.append("energies. This would also require one to either include the quasi-free charge-exchange")
    thisalinea.textcontent.append("background in the calculation, or limit it to Gamow-Teller states that can decay by")
    thisalinea.textcontent.append("proton emission.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "6 Passive Cooling Veriﬁcation for the X-slit system"
    thisalinea.nativeID = 48
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 7
    thisalinea.summary = "The Facility for Antiproton and Ion Research (FAIR) will be one of the largest and most complex accelerator facilities in the world [29, 107]. FAIR is, at this moment, under construction. The civil construction of the buildings started in the summer of 2017. It is expected to ﬁnish in 2022. The full opening of the facility is planned for 2025 [107]. FAIR is designed as a major upgrade of the present nuclear accelerator facility GSI (Helmholtzzentrum f¨ur SchwerIonenforschung) located near Darmstadt in Germany. The center of the FAIR facility will be a synchrotron accelerator with a circumference of 1100 m "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.1 The Super Fragment Separator"
    thisalinea.nativeID = 49
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "The Facility for Antiproton and Ion Research (FAIR) will be one of the largest and most complex accelerator facilities in the world [29, 107]. FAIR is, at this moment, under construction. The civil construction of the buildings started in the summer of 2017. It is expected to ﬁnish in 2022. The full opening of the facility is planned for 2025 [107]. FAIR is designed as a major upgrade of the present nuclear accelerator facility GSI (Helmholtzzentrum f¨ur SchwerIonenforschung) located near Darmstadt in Germany. The center of the FAIR facility will be a synchrotron accelerator with a circumference of 1100 m "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The Facility for Antiproton and Ion Research (FAIR) will be one of the largest and")
    thisalinea.textcontent.append("most complex accelerator facilities in the world [29, 107]. FAIR is, at this moment,")
    thisalinea.textcontent.append("under construction. The civil construction of the buildings started in the summer of")
    thisalinea.textcontent.append("2017. It is expected to ﬁnish in 2022. The full opening of the facility is planned for")
    thisalinea.textcontent.append("2025 [107].")
    thisalinea.textcontent.append("FAIR is designed as a major upgrade of the present nuclear accelerator facility GSI")
    thisalinea.textcontent.append("(Helmholtzzentrum f¨ur SchwerIonenforschung) located near Darmstadt in Germany.")
    thisalinea.textcontent.append("The center of the FAIR facility will be a synchrotron accelerator with a circumference")
    thisalinea.textcontent.append("of 1100 m [107]. It will consist of two accelerator rings called SIS-100 and SIS-300")
    thisalinea.textcontent.append("[29]. In the SIS-100/300, all stable isotopes up to uranium can be accelerated up to")
    thisalinea.textcontent.append("energies of several GeV per nucleon [29]. The present SIS-18 of the GSI facility will")
    thisalinea.textcontent.append("serve as an injector to the SIS-100/300 rings. Figure 6.1 shows an overview of the")
    thisalinea.textcontent.append("entire FAIR facility.")
    thisalinea.textcontent.append("Experiments with stable beams only comprise a small fraction of the full nuclear")
    thisalinea.textcontent.append("physics spectrum. This has already become evident from the discussion on nucle-")
    thisalinea.textcontent.append("osynthesis in Section 1.5. Therefore, FAIR is also designed to produce high-quality")
    thisalinea.textcontent.append("beams of exotic nuclei (nuclei close to the driplines). These exotic nuclei are pro-")
    thisalinea.textcontent.append("duced at the Rare Isotope Production Target (see Figure 6.1) through ﬁssion and")
    thisalinea.textcontent.append("fragmentation reactions. After production, the exotic nuclei are separated in-ﬂight")
    thisalinea.textcontent.append("by the Super FRagment Separator (Super-FRS) [29, 30] to produce high-quality ex-")
    thisalinea.textcontent.append("otic beams (see Figure 6.1). When the separation process is complete, the nuclei")
    thisalinea.textcontent.append("of interest can be transported through 3 diﬀerent branches to the experimental ar-")
    thisalinea.textcontent.append("eas [30]. At the low-energy branch, the ions can be slowed down for high-precision")
    thisalinea.textcontent.append("measurements [30]. The ring-branch can transport the ions to the CR and RESR")
    thisalinea.textcontent.append("storage rings for storage-ring measurements [29, 30]. Finally, the high-energy branch")
    thisalinea.textcontent.append("can transport the nuclei of interest to the R3B experiment, where these nuclei can be")
    thisalinea.textcontent.append("studied through high-energy collisions. For a more detailed explanation of the R3B")
    thisalinea.textcontent.append("experiment, we refer to Chapter 7.")
    thisalinea.textcontent.append("The separation principle of the Super-FRS is based on the use of beam collimators")
    thisalinea.textcontent.append("to stop the unwanted nuclei [109]. After exiting the Rare Isotope Production Target")
    thisalinea.textcontent.append("due to their forward momentum, the nuclei are guided through a series of dipole and")
    thisalinea.textcontent.append("Figure 6.1: Overview of the new FAIR facility; ﬁgure used with permission [108].")
    thisalinea.textcontent.append("quadrupole magnets. The beam collimators are located at the diﬀerent focal planes of")
    thisalinea.textcontent.append("this magnet system [110]. The magnets are tuned in such a way that only the nuclei")
    thisalinea.textcontent.append("of interest can pass through all collimators.")
    thisalinea.textcontent.append("The Super-FRS is divided into 3 diﬀerent regions: The pre-separator, the main sepa-")
    thisalinea.textcontent.append("rator and the end branches [30]. The end branches were discussed above. They serve")
    thisalinea.textcontent.append("mainly to transport the nuclei of interest to the relevant experimental areas after the")
    thisalinea.textcontent.append("separation is complete. The pre-separator is the ﬁrst region after the Rare Isotope")
    thisalinea.textcontent.append("production Target and performs the ﬁrst step in the separation process. Further sep-")
    thisalinea.textcontent.append("aration of the nuclei is performed in the main-separator. The pre-separator contains")
    thisalinea.textcontent.append("two collimators moving in the horizontal direction (called X-slits) and two collimators")
    thisalinea.textcontent.append("moving in the vertical direction (called Y-slits). The main separator contains three")
    thisalinea.textcontent.append("X-slits and one Y-slit in the center and four more X-slits and three more Y-slits at")
    thisalinea.textcontent.append("the interfaces to the end branches [110]. An overview of the Super-FRS infrastructure")
    thisalinea.textcontent.append("is displayed in Figure 6.2.")
    thisalinea.textcontent.append("The Rare Isotope production Target is designed to handle primary beam energies up")
    thisalinea.textcontent.append("to 1.5 GeV/u [29]. Secondary beams of exotic nuclei can be produced at this target")
    thisalinea.textcontent.append("with energies up to 1.3 GeV/u and with a power of up to 500 W [30]. These energies")
    thisalinea.textcontent.append("are achieved in one of the most common situations where a 1.5 GeV/u 238U92+ beam")
    thisalinea.textcontent.append("bombards a rotating carbon target wheel of 2.5 mg/cm2 [30]. In such a situation,")
    thisalinea.textcontent.append("Figure 6.2: Overview of the Super-FRS infrastructure; ﬁgure based on [30] and [110].")
    thisalinea.textcontent.append("the collimators that absorb the unwanted nuclei are activated up to a level that is")
    thisalinea.textcontent.append("dangerous for humans, even after the beam is switched oﬀ. After more and more")
    thisalinea.textcontent.append("of the unwanted ions are stopped in subsequent collimators, the activation becomes")
    thisalinea.textcontent.append("less severe. It is, therefore, only dangerous for humans to be around the collimators")
    thisalinea.textcontent.append("located inside the pre-separator [111]. Hence, every action inside the pre-separator")
    thisalinea.textcontent.append("hall is controlled by robots [30].")
    thisalinea.textcontent.append("The problem with this system is that the ﬁrst X-slit in the pre-separator has to")
    thisalinea.textcontent.append("absorb a very large fraction of the unwanted ions. Hence, this X-slit system should")
    thisalinea.textcontent.append("be capable of absorbing a power of up to 500 W. Therefore, this ﬁrst X-slit system")
    thisalinea.textcontent.append("should be suﬃciently cooled to handle the thermal stress caused by absorption of")
    thisalinea.textcontent.append("this high power. Moreover, the cooling system should be suitable for handling with")
    thisalinea.textcontent.append("robots. In this chapter, we will discuss the possibilities for such a cooling system and")
    thisalinea.textcontent.append("their eﬀectiveness.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.2 The X- and Y-slit systems"
    thisalinea.nativeID = 50
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "The X- and Y-slit systems are designed and produced by KVI-CART, University of Groningen, Netherlands, as part of a contract with GSI, Darmstadt, Germany. The computer drawings of the X- and Y-slits are displayed in Figures 6.3 and 6.4. Figure 6.3: Computer drawing of the X-slit sys- tem designed at KVI-CART; ﬁgure used with permission [111]. Figure 6.4: Computer drawing of the Y-slit system designed at KVI- CART [112]. The X- and Y-slit systems use two solid Densimet blocks to stop the unwanted nuclei. Densimet is a metal alloy containing 97% Tungsten, 2% Nickel and 1% Iron [111]. The dimensions "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The X- and Y-slit systems are designed and produced by KVI-CART, University of")
    thisalinea.textcontent.append("Groningen, Netherlands, as part of a contract with GSI, Darmstadt, Germany. The")
    thisalinea.textcontent.append("computer drawings of the X- and Y-slits are displayed in Figures 6.3 and 6.4.")
    thisalinea.textcontent.append("Figure 6.3: Computer drawing of the X-slit sys-")
    thisalinea.textcontent.append("tem designed at KVI-CART; ﬁgure used with")
    thisalinea.textcontent.append("permission [111].")
    thisalinea.textcontent.append("Figure 6.4: Computer drawing of")
    thisalinea.textcontent.append("the Y-slit system designed at KVI-")
    thisalinea.textcontent.append("CART [112].")
    thisalinea.textcontent.append("The X- and Y-slit systems use two solid Densimet blocks to stop the unwanted nuclei.")
    thisalinea.textcontent.append("Densimet is a metal alloy containing 97% Tungsten, 2% Nickel and 1% Iron [111]. The")
    thisalinea.textcontent.append("dimensions of a single pre-separator X-slit Densimet block are 200 × 180 × 250 mm3.")
    thisalinea.textcontent.append("The dimensions of a single pre-separator Y-slit Densimet block are 392 × 90 × 250 mm3")
    thisalinea.textcontent.append("[110]. The Densimet blocks used by the X- and Y-slits in the main separator are a")
    thisalinea.textcontent.append("little thinner, since they do not have to absorb as many nuclei as the ones in the")
    thisalinea.textcontent.append("pre-separator.")
    thisalinea.textcontent.append("The top ﬂange of the vacuum chamber is part of the X- and Y-slit systems (brown")
    thisalinea.textcontent.append("in Figures 6.3 and 6.4). The movement of the Densimet blocks is controlled by two")
    thisalinea.textcontent.append("stepping motors [111], read out by linear potentiometers and secured by end switches,")
    thisalinea.textcontent.append("springs and other safety systems. These motors and electronics are located inside the")
    thisalinea.textcontent.append("Perspex box, shown in grey. On top of the entire system, a robot mount is located.")
    thisalinea.textcontent.append("With this robot mount, a KUKA-robot [30] can lift an entire X-slit system (or Y-")
    thisalinea.textcontent.append("slit system) out of the Super-FRS infrastructure and replace it with a new one [30,")
    thisalinea.textcontent.append("109]. This is a prerequisite for the X- and Y-slit systems located inside the pre-")
    thisalinea.textcontent.append("separator. Humans cannot enter the pre-separator hall due to the high activation")
    thisalinea.textcontent.append("of the collimators. Therefore, if an X-slit or a Y-slit experiences a malfunction, no")
    thisalinea.textcontent.append("repairs are possible. Hence, in this situation, replacement is the only option left.")
    thisalinea.textcontent.append("During the replacement procedure, the Densimet blocks can be disconnected from the")
    thisalinea.textcontent.append("rest of the system [110]. Then, the rest of the system can be replaced and the old")
    thisalinea.textcontent.append("Densimet blocks can be reconnected to it. This construction is done to preserve the")
    thisalinea.textcontent.append("original Densimet blocks in case of a malfunction. The Densimet blocks are the most")
    thisalinea.textcontent.append("expensive parts of the X- and Y-slit systems and no malfunction is possible there as")
    thisalinea.textcontent.append("these components are made of solid metal blocks.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.3 Cooling options"
    thisalinea.nativeID = 51
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "Three diﬀerent possibilities exist to handle the thermal stress on the ﬁrst X-slit system: No cooling, active cooling and passive cooling [111]. No cooling means that we verify that the X-slit system can handle the thermal stress without any additional cooling. Active cooling means that cooling water (or a diﬀerent ﬂuid) is used to reduce the temperature suﬃciently. Passive cooling means that the design of the X-slit system is changed to maximize the infrared emission. With the increased infrared emission, the X-slit system should then be able to handle the thermal stress without active cooling. To explore the three diﬀerent "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Three diﬀerent possibilities exist to handle the thermal stress on the ﬁrst X-slit system:")
    thisalinea.textcontent.append("No cooling, active cooling and passive cooling [111]. No cooling means that we verify")
    thisalinea.textcontent.append("that the X-slit system can handle the thermal stress without any additional cooling.")
    thisalinea.textcontent.append("Active cooling means that cooling water (or a diﬀerent ﬂuid) is used to reduce the")
    thisalinea.textcontent.append("temperature suﬃciently. Passive cooling means that the design of the X-slit system is")
    thisalinea.textcontent.append("changed to maximize the infrared emission. With the increased infrared emission, the")
    thisalinea.textcontent.append("X-slit system should then be able to handle the thermal stress without active cooling.")
    thisalinea.textcontent.append("To explore the three diﬀerent cooling options, thermal simulations were performed")
    thisalinea.textcontent.append("for the worst-case scenario. As discussed in Section 6.1, the secondary beam can have")
    thisalinea.textcontent.append("a power of up to 500 W. Hence, the largest thermal stress is experienced by the")
    thisalinea.textcontent.append("ﬁrst X-slit system when this slit has to absorb the full 500 W with one of the two")
    thisalinea.textcontent.append("Densimet blocks (see Figure 6.3). The ions in the secondary beam can have an energy")
    thisalinea.textcontent.append("of up to 1.3 GeV/u and all ions up to uranium can be present. Hence, the worst-case")
    thisalinea.textcontent.append("scenario is that the full secondary beam consists of 238U92+ ions, all with an energy")
    thisalinea.textcontent.append("of 1.3 GeV/u. This worst-case scenario was discussed and explored in Ref. [111]. In")
    thisalinea.textcontent.append("this situation, the beam was assumed to have a Gaussian proﬁle with σ = 5 mm in")
    thisalinea.textcontent.append("all transverse directions.")
    thisalinea.textcontent.append("Initial thermal simulations (performed with Siemens NX 9.0 [113]) show that the")
    thisalinea.textcontent.append("maximum steady-state temperature of the Densimet block absorbing the secondary")
    thisalinea.textcontent.append("beam can get up to about 700 ◦C [111]. According to the production company Plansee")
    thisalinea.textcontent.append("[114], Densimet (type 185) can safely be used up to 1000 ◦C. Hence, even in the worst-")
    thisalinea.textcontent.append("case scenario, the thermal stress poses no problem for the Densimet blocks themselves.")
    thisalinea.textcontent.append("However, the Densimet blocks are connected through Stainless Steel rods to the step-")
    thisalinea.textcontent.append("ping motors and readout electronics on the outside of the vacuum chamber (see Figure")
    thisalinea.textcontent.append("6.3). According to our NX simulations, thermal conduction through the rods and in-")
    thisalinea.textcontent.append("frared emission of the Densimet blocks cause the top ﬂange of the vacuum chamber")
    thisalinea.textcontent.append("to heat up to about 100 ◦C [111]. At such temperatures, the stepping motors and/or")
    thisalinea.textcontent.append("electronics can be damaged [115]. Therefore, we conclude that the ﬁrst X-slit system")
    thisalinea.textcontent.append("in the Super-FRS does need additional cooling.")
    thisalinea.textcontent.append("By simulating a simple water cooling system on the Densimet blocks in NX, it is")
    thisalinea.textcontent.append("shown that the maximum steady-state temperature of the Densimet blocks can easily")
    thisalinea.textcontent.append("be reduced to 200 ◦C [111]. However, such an active cooling system adds a lot of")
    thisalinea.textcontent.append("complexity to the design of the X-slit system. The most important reason for this is")
    thisalinea.textcontent.append("that the Densimet blocks should be disconnectable from the rest of the X-slit system")
    thisalinea.textcontent.append("(see Section 6.2). Moreover, the cooling system should also be able to operate in a")
    thisalinea.textcontent.append("high vacuum of 10−7 mbar [109, 110]. Such a complex cooling system signiﬁcantly")
    thisalinea.textcontent.append("increases the probability of malfunctions. Since this X-slit system is located inside")
    thisalinea.textcontent.append("the pre-separator area, malfunctions cannot be repaired by humans and repairs by")
    thisalinea.textcontent.append("robots are always much more diﬃcult and costly.")
    thisalinea.textcontent.append("Secondly, malfunctions of the X-slit system could involve leakages in the cooling")
    thisalinea.textcontent.append("system. Since the Super-FRS has no robots or equipment to clean the beamlines")
    thisalinea.textcontent.append("of cooling ﬂuid [30], such leakages are very problematic.")
    thisalinea.textcontent.append("A third argument against the use of an active cooling system is that the cooling ﬂuid")
    thisalinea.textcontent.append("might become radioactive. This means that all cooling ﬂuid has to be treated as")
    thisalinea.textcontent.append("radioactive waste, which is troublesome and expensive.")
    thisalinea.textcontent.append("Since the ﬁrst X-slit system does need additional cooling and an active cooling system")
    thisalinea.textcontent.append("is undesirable, the X-slit system has to be passively cooled. Because the Densimet")
    thisalinea.textcontent.append("blocks absorb the unwanted ions, a passive cooling system means that one artiﬁcially")
    thisalinea.textcontent.append("increases the infrared emissivity of the Densimet blocks. Since Densimet is expected")
    thisalinea.textcontent.append("to have an emissivity of about (cid:15) ≈ 0.07 [111], passive cooling is expected to reduce")
    thisalinea.textcontent.append("the Densimet temperature signiﬁcantly.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.4 Passive cooling by stainless steel ribs"
    thisalinea.nativeID = 52
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "For the present design, it is proposed to mount small ribs of stainless steel on the top and bottom plates of the Densimet blocks (see Figure 6.5) to increase the infrared emission [111]. A thermal simulation performed with NX shows that the stainless steel ribs reduce the maximum temperature of the Densimet blocks from 700 ◦C to 550 ◦C and that the temperature of the top ﬂange of the vacuum chamber is reduced from 100 ◦C to 35 ◦C. The steady-state result of this simulation is shown in Figure 6.6. For the convection of the air on the outside of "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("For the present design, it is proposed to mount small ribs of stainless steel on the top")
    thisalinea.textcontent.append("and bottom plates of the Densimet blocks (see Figure 6.5) to increase the infrared")
    thisalinea.textcontent.append("emission [111]. A thermal simulation performed with NX shows that the stainless")
    thisalinea.textcontent.append("steel ribs reduce the maximum temperature of the Densimet blocks from 700 ◦C to")
    thisalinea.textcontent.append("550 ◦C and that the temperature of the top ﬂange of the vacuum chamber is reduced")
    thisalinea.textcontent.append("from 100 ◦C to 35 ◦C. The steady-state result of this simulation is shown in Figure")
    thisalinea.textcontent.append("6.6. For the convection of the air on the outside of the vacuum chamber, an eﬃciency")
    thisalinea.textcontent.append("of 100% was assumed.")
    thisalinea.textcontent.append("A vacuum chamber wall of 35 ◦C poses no threat for stepping motors and electronics")
    thisalinea.textcontent.append("[115]. Moreover, one must not forget that there is still some material between the")
    thisalinea.textcontent.append("vacuum chamber wall and the motors and electronics (see Figure 6.3). Therefore, the")
    thisalinea.textcontent.append("temperature experienced by the motors and electronics will probably be even lower")
    thisalinea.textcontent.append("than this 35 ◦C. Hence, according to the simulation of Figure 6.6, the stainless steel")
    thisalinea.textcontent.append("ribs provide suﬃcient cooling for the X-slit system.")
    thisalinea.textcontent.append("Finally, we would also like to emphasize the fact that a (passive) cooling system is")
    thisalinea.textcontent.append("only needed for the ﬁrst X-slit system in the Super-FRS (see Figure 6.2). As discussed")
    thisalinea.textcontent.append("in Section 6.1, the ﬁrst collimator (X-slit) should absorb a signiﬁcant fraction of the")
    thisalinea.textcontent.append("unwanted nuclei. Hence, the power of the secondary beam will be several factors lower")
    thisalinea.textcontent.append("than 500 W when it reaches the next collimator. Based on our simulations discussed")
    thisalinea.textcontent.append("Figure 6.5: Stainless steel")
    thisalinea.textcontent.append("ribs on the Densimet")
    thisalinea.textcontent.append("blocks of the ﬁrst X-slit")
    thisalinea.textcontent.append("system; ﬁgure used with")
    thisalinea.textcontent.append("Permission [111].")
    thisalinea.textcontent.append("Figure 6.6: Siemens NX thermal simula-")
    thisalinea.textcontent.append("tion results with the Stainless steel ribs;")
    thisalinea.textcontent.append("ﬁgure used with permission [111].")
    thisalinea.textcontent.append("so far, we therefore conclude that no additional cooling is needed for the second")
    thisalinea.textcontent.append("collimator. For subsequent collimators, the thermal stress will obviously be even less.")
    thisalinea.textcontent.append("Hence, for all subsequent collimators no additional cooling system is required.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.5 Simulation veriﬁcation"
    thisalinea.nativeID = 53
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "In order to test the NX simulation procedure of Section 6.4, this procedure was com- pared to COMSOL [116] and Matlab [117] simulations. All three computer programs were given the same test case: a single Densimet block (with the dimensions of the X-slit system blocks) hanging in vacuum. A 500 W 238U92+ beam with a transverse Gaussian proﬁle (σ = 5 mm) and an energy of 1.5 GeV/u was used to bombard this block at a distance of 60 mm from the slit-side. This scenario was explored in [111]. Note that this beam energy is a little diﬀerent from the "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In order to test the NX simulation procedure of Section 6.4, this procedure was com-")
    thisalinea.textcontent.append("pared to COMSOL [116] and Matlab [117] simulations. All three computer programs")
    thisalinea.textcontent.append("were given the same test case: a single Densimet block (with the dimensions of the")
    thisalinea.textcontent.append("X-slit system blocks) hanging in vacuum. A 500 W 238U92+ beam with a transverse")
    thisalinea.textcontent.append("Gaussian proﬁle (σ = 5 mm) and an energy of 1.5 GeV/u was used to bombard this")
    thisalinea.textcontent.append("block at a distance of 60 mm from the slit-side. This scenario was explored in [111].")
    thisalinea.textcontent.append("Note that this beam energy is a little diﬀerent from the beam energy in the worst-case")
    thisalinea.textcontent.append("scenario discussed in Section 6.3.")
    thisalinea.textcontent.append("The computer simulations were set up completely independently. For NX, the exact")
    thisalinea.textcontent.append("same settings of Section 6.4 were used. For COMSOL, the native heat simulation")
    thisalinea.textcontent.append("package of the COMSOL core was used. For the Matlab simulation, we developed")
    thisalinea.textcontent.append("our own code. This was done to obtain good understanding of the physics and mathe-")
    thisalinea.textcontent.append("matics in the thermal simulations. Our Matlab code includes thermal radiation on the")
    thisalinea.textcontent.append("surface and heat diﬀusion modeled by a second order discretization based on Taylor")
    thisalinea.textcontent.append("expansions. To convert heat diﬀusion into temperature, a Debije model was used to")
    thisalinea.textcontent.append("model the speciﬁc heat. The Debije temperature of the model was TD = 450.21 K.")
    thisalinea.textcontent.append("This number was obtained from averaging the density, molar mass, longitudinal and")
    thisalinea.textcontent.append("transversal speeds of sound of tungsten (97%), nickel (2%) and iron (1%). After this")
    thisalinea.textcontent.append("averaging was done, the Debije temperature was computed. To obtain the diﬀusion")
    thisalinea.textcontent.append("coeﬃcient, a thermal conductivity of K = 103 W/(K · m) was used as a crude es-")
    thisalinea.textcontent.append("timate. For the thermal radiation, an emissivity of (cid:15) = 0.07 [111] was used. Time")
    thisalinea.textcontent.append("integration in the model was done by the Backward Euler method to provide absolute")
    thisalinea.textcontent.append("stability. A multidimensional version of the Newton-Rapson method was used to solve")
    thisalinea.textcontent.append("the Backward Euler equations (Linear systems were solved by Gaussian elimination).")
    thisalinea.textcontent.append("We refer the interested reader to Ref. [91] for more details on these methods.")
    thisalinea.textcontent.append("The Debije model provided a speciﬁc heat of CV = 136.5 J/(K · kg) in the temperature")
    thisalinea.textcontent.append("range of interest. Hence, it is clear that the values for speciﬁc heat and thermal")
    thisalinea.textcontent.append("conductivity do not match the numbers of Ref. [118]. The reason for this is that")
    thisalinea.textcontent.append("in our Matlab model we assumed for simplicity that Densimet is a perfect alloy of")
    thisalinea.textcontent.append("tungsten (97%), nickel (2%) and iron (1%). According to [118], this is not the case.")
    thisalinea.textcontent.append("The tungsten, nickel and iron are mixed in powder form and then compressed under")
    thisalinea.textcontent.append("heavy pressure and heat. This causes the material properties to be diﬀerent from")
    thisalinea.textcontent.append("an ideal average. In our Matlab model, we did not want to include such special")
    thisalinea.textcontent.append("material properties for the sake of simplicity. We wanted our Matlab model to be as")
    thisalinea.textcontent.append("simple and clear as possible so that the outcomes of the model are well understood.")
    thisalinea.textcontent.append("A consequence of this choice is that NX and COMSOL should calculate the test case")
    thisalinea.textcontent.append("with the same physical parameters as the Matlab model. Otherwise, a comparison")
    thisalinea.textcontent.append("cannot be made between the simulation procedures. Of course, the true properties of")
    thisalinea.textcontent.append("Densimet according to Ref. [118] were used in our simulations discussed in Sections")
    thisalinea.textcontent.append("6.3 and 6.4.")
    thisalinea.textcontent.append("If one wishes to put the full heat load of the beam on the surface of a single mesh")
    thisalinea.textcontent.append("in the simulation, a signiﬁcant restriction should be imposed on the mesh size. This")
    thisalinea.textcontent.append("is because the power density experienced by the heat-loaded mesh should equal the")
    thisalinea.textcontent.append("power density of the beam. The power density experienced by the heat-loaded mesh")
    thisalinea.textcontent.append("can be calculated by dividing the 500 W beam power by the volume of that single")
    thisalinea.textcontent.append("mesh. Given that the penetration depth of the 1.5 GeV/u 238U92+ beam is about")
    thisalinea.textcontent.append("16 mm in Densimet (calculated from Bethe-Bloch energy-loss formula) and the trans-")
    thisalinea.textcontent.append("verse beam proﬁle is Gaussian with σ = 5 mm, the power density of the beam can")
    thisalinea.textcontent.append("be calculated. The required number of mesh points to meet the requirement just")
    thisalinea.textcontent.append("discussed is 16 in the x, y and z direction (uniformly distributed). The Simulation")
    thisalinea.textcontent.append("results for NX, COMSOL and Matlab with these parameters are displayed in Figure")
    thisalinea.textcontent.append("6.7.")
    thisalinea.textcontent.append("From Figure 6.7, it is obtained that the minimum temperature on the block is")
    thisalinea.textcontent.append("Tmin = 556 ◦C and the maximum temperature is Tmax = 671 ◦C for the NX simula-")
    thisalinea.textcontent.append("Figure 6.7: Simulation results for the comparison of NX (left picture), Matlab (center")
    thisalinea.textcontent.append("picture) and Comsol (right picture) procedures in the test case. The NX and Matlab")
    thisalinea.textcontent.append("results are in degrees Celsius. The Comsol results are in Kelvin.")
    thisalinea.textcontent.append("tion. In the Matlab simulation, these temperatures are observed to be Tmin = 542 ◦C")
    thisalinea.textcontent.append("and Tmax = 658 ◦C. Comsol provided us with Tmin = 556 ◦C and Tmax = 653 ◦C.")
    thisalinea.textcontent.append("This gives an overall diﬀerence between the three simulations of less than 19 ◦C. For")
    thisalinea.textcontent.append("simulations on such a coarse mesh this is an excellent result, suggesting that our NX")
    thisalinea.textcontent.append("procedure of Section 6.4 is trustworthy.")
    thisalinea.textcontent.append("However, as good as this result may be for a coarse mesh simulation, a diﬀerence of")
    thisalinea.textcontent.append("19 ◦C between simulations alone is simply too much to allow any deﬁnite statements")
    thisalinea.textcontent.append("about the trustworthiness of the simulations in Section 6.4. Therefore, the mesh was")
    thisalinea.textcontent.append("changed to a non-uniform grid of 0.3 mm in the Bragg-peak region [111]. As discussed")
    thisalinea.textcontent.append("above, this mesh size prevents us from putting a simple 500 W heat load on a single")
    thisalinea.textcontent.append("mesh. Instead, the power of the beam had to be carefully divided over the diﬀerent")
    thisalinea.textcontent.append("meshes in and around the Bragg peak region. The mesh size of 0.3 mm was chosen")
    thisalinea.textcontent.append("so that the sharp Bragg peak itself could still be accurately represented on the mesh.")
    thisalinea.textcontent.append("For this ﬁne mesh, results could be obtained with Comsol and NX for the test case.")
    thisalinea.textcontent.append("However, our Matlab model was not capable to provide results for this ﬁne mesh")
    thisalinea.textcontent.append("within acceptable CPU time. This is not very surprising, since the Matlab code")
    thisalinea.textcontent.append("was written with the goal to be simple and understandable and not to give a fast")
    thisalinea.textcontent.append("performance. The NX and Comsol results for the ﬁne mesh simulation are displayed")
    thisalinea.textcontent.append("in Figure 6.8 [111].")
    thisalinea.textcontent.append("From Figure 6.8, we obtain that Tmin = 555 ◦C and Tmax = 639 ◦C for the NX sim-")
    thisalinea.textcontent.append("ulation and we obtain Tmin = 556 ◦C and Tmax = 639 ◦C for the Comsol simulation")
    thisalinea.textcontent.append("[111]. This is a diﬀerence of less than a degree. Such a small diﬀerence is a strong")
    thisalinea.textcontent.append("indication that our results from Section 6.4 are trustworthy. However, since the same")
    thisalinea.textcontent.append("simulations on a coarser mesh gave a diﬀerence of 19 ◦C, the results of Section 6.4")
    thisalinea.textcontent.append("can only be trusted up to the computational error of the mesh size. Since roughly")
    thisalinea.textcontent.append("the same mesh was used on the Densimet block in Section 6.4 as in Figure 6.7, this")
    thisalinea.textcontent.append("error is estimated to be 19 ◦C.")
    thisalinea.textcontent.append("Strictly speaking, this means that the vacuum wall temperature could become 35 ◦C")
    thisalinea.textcontent.append("+ 19 ◦C = 54 ◦C in reality. This is worse for the electronics and stepping motors")
    thisalinea.textcontent.append("Figure 6.8: Simulation results for the comparison of NX (left picture) and Comsol")
    thisalinea.textcontent.append("(right picture) in the test case with a 0.3 mm non-uniform mesh. The camera view in")
    thisalinea.textcontent.append("the left picture is upside-down. The NX results are in degrees Celsius and the Comsol")
    thisalinea.textcontent.append("results are in Kelvin; ﬁgure used with permission [111].")
    thisalinea.textcontent.append("than the predicted 35 ◦C. However, according to Ref. [115], this temperature still")
    thisalinea.textcontent.append("poses no problem for the electronics and the stepping motors (the maximum they can")
    thisalinea.textcontent.append("take is 80 ◦C).")
    thisalinea.textcontent.append("This is a strong indication that the ﬁrst X-slit system can be safely used inside the")
    thisalinea.textcontent.append("pre-separator. However, no simulation matches reality exactly. Therefore, it was")
    thisalinea.textcontent.append("decided also to verify the temperatures of the X-slit system experimentally. This is")
    thisalinea.textcontent.append("discussed in the next sections.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.6 Experimental veriﬁcation with AGOR"
    thisalinea.nativeID = 54
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "Since FAIR is still under construction (see Section 6.1), a 500 W 238U92+ beam of 1.3 GeV/u is not yet available to us to directly verify our predictions in Section 6.4. Therefore, two alternatives are available for experimental veriﬁcation. The ﬁrst option is to impinge a beam with lower power on a smaller test-version of the X-slit system and use our simulation procedure of Section 6.4 to reproduce the measurements. The second option is to apply the thermal load of 500 W to the X-slit system by a diﬀerent mean than an ion beam. Both of these options will tell "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Since FAIR is still under construction (see Section 6.1), a 500 W 238U92+ beam of")
    thisalinea.textcontent.append("1.3 GeV/u is not yet available to us to directly verify our predictions in Section 6.4.")
    thisalinea.textcontent.append("Therefore, two alternatives are available for experimental veriﬁcation. The ﬁrst option")
    thisalinea.textcontent.append("is to impinge a beam with lower power on a smaller test-version of the X-slit system")
    thisalinea.textcontent.append("and use our simulation procedure of Section 6.4 to reproduce the measurements.")
    thisalinea.textcontent.append("The second option is to apply the thermal load of 500 W to the X-slit system by a")
    thisalinea.textcontent.append("diﬀerent mean than an ion beam. Both of these options will tell us something about")
    thisalinea.textcontent.append("the trustworthiness of the simulations in Section 6.4.")
    thisalinea.textcontent.append("We chose to explore both options. The ﬁrst option (a smaller test-version of the X-slit")
    thisalinea.textcontent.append("system) was explored in Ref. [111] and is discussed in this section. The beam used")
    thisalinea.textcontent.append("in the experimental veriﬁcation of the second option was produced by the AGOR cy-")
    thisalinea.textcontent.append("clotron [119]. The second option (a diﬀerent thermal load than a beam) was explored")
    thisalinea.textcontent.append("in Ref. [115] and is discussed in Section 6.7.")
    thisalinea.textcontent.append("To build a small test setup for the X-slit system, three small tungsten alloy blocks")
    thisalinea.textcontent.append("were connected to a 4 mm stainless steel spindle and secured with stainless steel nuts.")
    thisalinea.textcontent.append("Between each two blocks, two thin aluminum plates were connected to the spindle to")
    thisalinea.textcontent.append("shield the other blocks from infrared emissions. The spindle was vertically mounted")
    thisalinea.textcontent.append("inside a stainless steel vacuum chamber in such a way that it could be moved up and")
    thisalinea.textcontent.append("down during the experiment. In this way, the blocks could be irradiated one-by-one.")
    thisalinea.textcontent.append("The bottom block was manufactured by Plansee [114], was of type Densimet D185")
    thisalinea.textcontent.append("[118] and had dimensions of 30 × 30 × 50 mm3. It was equipped with small stainless")
    thisalinea.textcontent.append("steel ribs to mimic the eﬀect of the passive cooling discussed in Section 6.4. The middle")
    thisalinea.textcontent.append("block was identical to the bottom block, but was not equipped with stainless steel")
    thisalinea.textcontent.append("ribs. The upper block was manufactured by A.L.M.T. Corp, a Japanese company,")
    thisalinea.textcontent.append("and had dimensions of 25 × 25 × 50 mm3. This block had a similar composition as")
    thisalinea.textcontent.append("the two other Densimet blocks. The 4 big sides of this block were covered with a")
    thisalinea.textcontent.append("CerablackTM coating with an emissivity larger than 0.9. Each block was oriented in")
    thisalinea.textcontent.append("such a way that the beam bombarded one of the small faces. The upper block was")
    thisalinea.textcontent.append("placed in the experiment to investigate whether a high-emissivity coating could be an")
    thisalinea.textcontent.append("option for the passive cooling.")
    thisalinea.textcontent.append("Each Densimet block was equipped with two K-type thermocouples to measure the")
    thisalinea.textcontent.append("temperature directly. Each of the thermocouple junctions was embedded in a stainless")
    thisalinea.textcontent.append("steel plate of 1 cm × 1 cm × 1 mm. This stainless steel plate was welded to one of")
    thisalinea.textcontent.append("the corners of the Densimet block for optimal thermal conduction. The wires of the")
    thisalinea.textcontent.append("thermocouples were made of nickel alloys and wrapped in Teﬂon ﬁbers to provide")
    thisalinea.textcontent.append("good thermal and electrical insulation. Each wire was ﬁrst individually wrapped in")
    thisalinea.textcontent.append("Teﬂon ﬁbers and then the two wires of one thermocouple were wrapped together in")
    thisalinea.textcontent.append("Teﬂon ﬁbers once more. One thermocouple was placed on a corner close to the beam")
    thisalinea.textcontent.append("and the other one was placed on a corner far from the beam. This setup has been")
    thisalinea.textcontent.append("brieﬂy discussed in Ref. [111].")
    thisalinea.textcontent.append("In order to compare the outcome with our simulation procedure, an NX computer")
    thisalinea.textcontent.append("model of this setup was also constructed. Both the NX model and the real setup are")
    thisalinea.textcontent.append("displayed in Figure 6.9.")
    thisalinea.textcontent.append("The beam used to heat the three small blocks was a 20Ne5+ beam of 30 MeV/u with")
    thisalinea.textcontent.append("a power of 21.6 W produced by the AGOR cyclotron [119] at KVI-CART in the")
    thisalinea.textcontent.append("Netherlands [111]. Each block was irradiated with the beam for roughly 4 hours. The")
    thisalinea.textcontent.append("bottom block with the stainless steel ribs (see Figure 6.9b) was irradiated ﬁrst. Then,")
    thisalinea.textcontent.append("the beam was switched oﬀ so that the experimentalists could enter the room and move")
    thisalinea.textcontent.append("the second block into the beam. Then, the second and third block were irradiated in")
    thisalinea.textcontent.append("a similar way. During the ﬁrst hour of the irradiation of the block with the stainless")
    thisalinea.textcontent.append("steel ribs, the beam power was linearly increased from 0 to 21.6 W. During the rest")
    thisalinea.textcontent.append("of the experiment, the beam power was kept constant. After the irradiation of the")
    thisalinea.textcontent.append("second block, the beam power was temporarily increased to 30 W for a period of")
    thisalinea.textcontent.append("roughly one hour. After the irradiation of the third block (with the coating) was")
    thisalinea.textcontent.append("done, the setup was rotated to put the beam on one of the coated faces of the third")
    thisalinea.textcontent.append("block for a period of roughly one hour. The ﬁrst irradiation of the third block was on")
    thisalinea.textcontent.append("a side that was not covered with the Cerablack coating.")
    thisalinea.textcontent.append("Figure 6.9: Small test setup for the X-slit system to verify the NX simulation proce-")
    thisalinea.textcontent.append("dure experimentally. Figure (a) shows the vacuum chamber of the setup and Figure")
    thisalinea.textcontent.append("(b) shows the content of that chamber. Figures (c) and (d) show the NX computer")
    thisalinea.textcontent.append("model of the test setup. Figures (c) and (d) were produced by M. F. Lindemulder")
    thisalinea.textcontent.append("and are used with permission.")
    thisalinea.textcontent.append("The X- and Y-slit systems (see Section 6.2) have to run reliably inside the pre-")
    thisalinea.textcontent.append("separator area for many years [111]. To mimic the radiation eﬀects of the activa-")
    thisalinea.textcontent.append("tion inside this area over such a long time, the coating on the third block had to be")
    thisalinea.textcontent.append("irradiated directly by the beam. After this test, the coating on the block was inves-")
    thisalinea.textcontent.append("tigated. It turned out that the coating was signiﬁcantly damaged by the irradiation")
    thisalinea.textcontent.append("of the AGOR beam (see Figure 6.10 for an illustration). Therefore, this coating was")
    thisalinea.textcontent.append("rejected as a passive cooling option. The temperatures measured by the thermocou-")
    thisalinea.textcontent.append("ples are displayed in Figure 6.11. The K-type thermocouples were linearly calibrated")
    thisalinea.textcontent.append("using the melting point and evaporation point of water.")
    thisalinea.textcontent.append("To reproduce the experimental data of Figure 6.11, most material properties of Den-")
    thisalinea.textcontent.append("simet were obtained from Ref. [118]. In addition, 100% convection was assumed")
    thisalinea.textcontent.append("in the air outside the vacuum chamber. The speciﬁc Densimet alloy used for the")
    thisalinea.textcontent.append("X- and Y-slits is D185 with a density of 18.5 g/cm3 and a thermal conductivity of")
    thisalinea.textcontent.append("85 W/(m · K). However, the emissivity and speciﬁc heat of Densimet D185 are not")
    thisalinea.textcontent.append("reported in Ref. [118].")
    thisalinea.textcontent.append("Densimet is not an ideal alloy [118]. The components are not mixed in their liquid")
    thisalinea.textcontent.append("state, but in powder form. Then, they are compressed under high heat. Due to")
    thisalinea.textcontent.append("this production process, it is diﬃcult to argue that material properties of Densimet")
    thisalinea.textcontent.append("like emissivity and speciﬁc heat should be close to a weighted average of the material")
    thisalinea.textcontent.append("properties of the components. Therefore, it was decided to obtain the speciﬁc heat and")
    thisalinea.textcontent.append("emissivity from matching the simulation to the experimental data. For this matching")
    thisalinea.textcontent.append("Figure 6.10: Coated")
    thisalinea.textcontent.append("Densimet block af-")
    thisalinea.textcontent.append("ter irradiation of the")
    thisalinea.textcontent.append("coating.")
    thisalinea.textcontent.append("Figure 6.11: Temperature results on the small test setup for")
    thisalinea.textcontent.append("the X-slit system [120].")
    thisalinea.textcontent.append("procedure, only the experimental data on the clean Densimet block was used. By")
    thisalinea.textcontent.append("repeating the simulation for the other two Densimet blocks with the same material")
    thisalinea.textcontent.append("properties, the simulation procedure of Section 6.4 can then be veriﬁed.")
    thisalinea.textcontent.append("To match the speciﬁc heat and emissivity to the data, the knowledge was used that")
    thisalinea.textcontent.append("only the emissivity controls the steady-state temperature and that only the speciﬁc")
    thisalinea.textcontent.append("heat controls the slope of the graph during the heating [115]. This is easy to un-")
    thisalinea.textcontent.append("derstand, since the Densimet block heats up only by the beam and cools down by")
    thisalinea.textcontent.append("conduction and infrared emission. Therefore, the steady-state temperature is simply")
    thisalinea.textcontent.append("the temperature of the block at which these processes balance each other. Conduc-")
    thisalinea.textcontent.append("tion is controlled by the thermal conductivity of the items connected to the Densimet")
    thisalinea.textcontent.append("block (the spindle and the thermocouple wires). Infrared emission is controlled by")
    thisalinea.textcontent.append("the Densimet emissivity and the beam is controlled by us. Since the material com-")
    thisalinea.textcontent.append("position of the thermocouple wires and the spindle are known, the emissivity is the")
    thisalinea.textcontent.append("only unknown parameter left in the steady-state temperature. Since speciﬁc heat is")
    thisalinea.textcontent.append("deﬁned as the change in energy due to a change in temperature, this is exactly what")
    thisalinea.textcontent.append("determines the increase in temperature of the Densimet block under an external heat")
    thisalinea.textcontent.append("load. Hence, the slope of the graph is controlled (mostly) by the speciﬁc heat.")
    thisalinea.textcontent.append("The matching procedure provided us with a speciﬁc heat of CV = 215 J/(kg · K) and")
    thisalinea.textcontent.append("an emissivity of (cid:15) = 0.25. As one can see from Figure 6.11, this gives an agreement of")
    thisalinea.textcontent.append("better than 10 ◦C for the clean Densimet block. At the steady state, this is an error")
    thisalinea.textcontent.append("of less than 3%, suggesting that the matching procedure was done accurately. The")
    thisalinea.textcontent.append("same set of parameters could reproduce the data of the Densimet block with stainless")
    thisalinea.textcontent.append("steel ribs up to a diﬀerence of roughly 20 ◦C. Due to the lower temperatures, one")
    thisalinea.textcontent.append("can therefore state that the error between experiment and simulation remains below")
    thisalinea.textcontent.append("20 ◦C. The small kinks in the steady-state experimental data for the block with")
    thisalinea.textcontent.append("stainless steel ribs were due to short beam failures and were not modeled in our")
    thisalinea.textcontent.append("simulation.")
    thisalinea.textcontent.append("We would like to emphasize that the Densimet emissivity of (cid:15) = 0.25 obtained from")
    thisalinea.textcontent.append("this matching procedure is much higher than the (cid:15) = 0.07 emissivity, which we ob-")
    thisalinea.textcontent.append("tained for Densimet from Ref. [111] and used in Section 6.4. This is because our")
    thisalinea.textcontent.append("estimate of (cid:15) = 0.07 was based on the assumption that Densimet is a perfect alloy")
    thisalinea.textcontent.append("and that the blocks were polished. However, since Densimet is not a perfect alloy")
    thisalinea.textcontent.append("and since the blocks might have been somewhat corroded before the experiment, it")
    thisalinea.textcontent.append("should come as no surprise that the actual obtained emissivity of (cid:15) = 0.25 is much")
    thisalinea.textcontent.append("diﬀerent from what we previously accepted. Since the obtained value of the Densimet")
    thisalinea.textcontent.append("emissivity is higher, this is actually very good news, as this provides the X- and Y-slit")
    thisalinea.textcontent.append("system with more passive cooling.")
    thisalinea.textcontent.append("For this set of parameters, there is a considerable discrepancy between simulation and")
    thisalinea.textcontent.append("experiment for the coated block (see Figure 6.11). This discrepancy is not understood.")
    thisalinea.textcontent.append("However, since the coating was already ruled out as a passive cooling option for other")
    thisalinea.textcontent.append("reasons, and since no more time was available for this project, we decided not to")
    thisalinea.textcontent.append("pursue further understanding of the discrepancy.")
    thisalinea.textcontent.append("Other parameters for the simulation were obtained from the NX [113] material database.")
    thisalinea.textcontent.append("In particular, a stainless steel emissivity of (cid:15) = 0.65 was used [111]. An emissivity of")
    thisalinea.textcontent.append("(cid:15) = 0.3 was used for the aluminum radiation shields. The reason for this is that the")
    thisalinea.textcontent.append("setup has been stored in air for several days before the experiment. Therefore, it is")
    thisalinea.textcontent.append("reasonable to assume that the aluminum oxidized on the surface. Even a thin layer")
    thisalinea.textcontent.append("of oxidized aluminum on the surface radically changes the emissivity of aluminum")
    thisalinea.textcontent.append("to (cid:15) = 0.3 [121]. Commercial non-oxidized aluminum typically has an emissivity of")
    thisalinea.textcontent.append("(cid:15) = 0.09 [122].")
    thisalinea.textcontent.append("Special attention should be paid to the thermocouple wires. The wires have a diam-")
    thisalinea.textcontent.append("eter of 3 mm. Inside, two metal wires of 0.8 mm diameter are located. One of these")
    thisalinea.textcontent.append("wires has a composition of 0.5% silicon, 0.4% iron, 10% chromium and 89.1% Nickel.")
    thisalinea.textcontent.append("The other wire has a composition of 95% Nickel, 1.7% manganese, 1.7% silicon and")
    thisalinea.textcontent.append("1.7% aluminum. The two thin wires in Figure 6.9d have a diameter of 2.1 mm and")
    thisalinea.textcontent.append("each carry one of these metal wires inside. The metal wires are wrapped with Teﬂon.")
    thisalinea.textcontent.append("To model the interior of these wires, the thermal conductivity for the metal wires")
    thisalinea.textcontent.append("was computed as a weighted average from Ref. [122]. Then, it was averaged with the")
    thisalinea.textcontent.append("thermal conductivity of Teﬂon according to the cross sections of such wires. The emis-")
    thisalinea.textcontent.append("sivity of the wires is the Teﬂon emissivity of (cid:15) = 0.92 [122]. The thermal conductivity")
    thisalinea.textcontent.append("was computed to be K = 13.53 W/(m · K). The speciﬁc heat of the thermocouple")
    thisalinea.textcontent.append("wires was obtained through a similar calculation and estimated to be 500 J/(kg · K).")
    thisalinea.textcontent.append("With these numbers, the wires could be simulated as solids without internal structure.")
    thisalinea.textcontent.append("The stainless steel spindle was simulated as a solid rod without any structure on")
    thisalinea.textcontent.append("the surface. To include the eﬀects of the screw thread, the emissivity was increased")
    thisalinea.textcontent.append("to (cid:15) = 0.82. This number was obtained by assuming a stainless steel emission of")
    thisalinea.textcontent.append("(cid:15) = 0.65 and by modeling the screw thread like a saw-tooth function of 45◦ with a")
    thisalinea.textcontent.append("depth of 1 mm and performing an analytic calculation of all possible re-absorptions")
    thisalinea.textcontent.append("and re-emissions between the teeth of the saw-tooth.")
    thisalinea.textcontent.append("The fact that there are two diﬀerent experimental temperature results for the clean")
    thisalinea.textcontent.append("block and the coated block in Figure 6.11 is that each Densimet block was equipped")
    thisalinea.textcontent.append("with two thermocouples. It was conﬁrmed by a separate COMSOL [116] simulation")
    thisalinea.textcontent.append("that the temperature gradient between these two thermocouples is expected to be")
    thisalinea.textcontent.append("very small. Hence, only a single thermocouple was read out in the NX simulation.")
    thisalinea.textcontent.append("The block with the stainless steel ribs was also given two thermocouples, but one")
    thisalinea.textcontent.append("of them (the one far from the beam spot) broke down during the assembling of the")
    thisalinea.textcontent.append("setup. It remained in the setup, but it could no longer provide valid data.")
    thisalinea.textcontent.append("Based on this experimental veriﬁcation, it is therefore reasonable to assume that")
    thisalinea.textcontent.append("the diﬀerence between the NX simulations and reality is smaller than 20 ◦C for a")
    thisalinea.textcontent.append("Densimet block with stainless steel ribs. Therefore, the real temperatures of the X-")
    thisalinea.textcontent.append("slit system itself should not deviate more than 20 ◦C from our simulations of Section")
    thisalinea.textcontent.append("6.4. From the same simulations, a wall temperature of 35 ◦C was obtained. Hence,")
    thisalinea.textcontent.append("the temperature of this wall is expected not to exceed 55 ◦C in reality. Since the")
    thisalinea.textcontent.append("electronics can stand temperatures up to 80◦C [115], this experimental veriﬁcation")
    thisalinea.textcontent.append("conﬁrms that the X-slit system can run inside the pre-separator without problems.")
    thisalinea.textcontent.append("The fact that the Densimet emissivity was measured to be diﬀerent from what was")
    thisalinea.textcontent.append("used in Section 6.4 does not endanger our claim of 55 ◦C, since a higher Densimet")
    thisalinea.textcontent.append("emissivity would only improve the passive cooling of the blocks and of the top plate")
    thisalinea.textcontent.append("of the vacuum chamber wall.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.7 Experimental veriﬁcation with heating elements"
    thisalinea.nativeID = 55
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 6
    thisalinea.summary = "As a second experimental veriﬁcation, a thermal load with suﬃcient power was applied to the prototype of the ﬁrst X-slit system itself. This procedure is discussed in detail in Ref. [115], so we shall only brieﬂy summarize the results here. For this procedure, a 12 mm copper plate was put between the Densimet blocks of the X-slit system (see Figure 6.3). The copper plate was equipped with small heating elements. Together, these heating elements could generate a power of up to 1300 W. The entire X-slit system was equipped with 14 K-type thermocouples for accurate temperature measurements on diﬀerent places. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As a second experimental veriﬁcation, a thermal load with suﬃcient power was applied")
    thisalinea.textcontent.append("to the prototype of the ﬁrst X-slit system itself. This procedure is discussed in detail")
    thisalinea.textcontent.append("in Ref. [115], so we shall only brieﬂy summarize the results here.")
    thisalinea.textcontent.append("For this procedure, a 12 mm copper plate was put between the Densimet blocks")
    thisalinea.textcontent.append("of the X-slit system (see Figure 6.3). The copper plate was equipped with small")
    thisalinea.textcontent.append("heating elements. Together, these heating elements could generate a power of up to")
    thisalinea.textcontent.append("1300 W. The entire X-slit system was equipped with 14 K-type thermocouples for")
    thisalinea.textcontent.append("accurate temperature measurements on diﬀerent places. These thermocouples are")
    thisalinea.textcontent.append("of the same type as the ones used in Section 6.6, with one small exception. These")
    thisalinea.textcontent.append("thermocouples were equipped with a polished stainless steel coating around the Teﬂon")
    thisalinea.textcontent.append("ﬁbers. According to the company that produced these thermocouples, this stainless")
    thisalinea.textcontent.append("steel coating reduces the emissivity of the thermocouple wires to (cid:15) < 0.04. Therefore,")
    thisalinea.textcontent.append("it is no longer necessary to include the thermocouple wires in the simulations. Hence,")
    thisalinea.textcontent.append("the simulations in Ref. [115] were done without these wires.")
    thisalinea.textcontent.append("The X-slit system with the heaters and the thermocouples was placed in a vac-")
    thisalinea.textcontent.append("uum chamber. During the experiment, the pressure in the chamber was kept be-")
    thisalinea.textcontent.append("low 10−3 mbar [115]. All thermocouples were read out and the power dissipated by")
    thisalinea.textcontent.append("the heaters was measured from their electrical power consumption. Heater powers")
    thisalinea.textcontent.append("of 132 W, 515 W, 1026 W and 1300 W were used. After an increase in power, data")
    thisalinea.textcontent.append("were taken for suﬃcient time to reach the steady temperature. After the experiment")
    thisalinea.textcontent.append("was done, our NX simulation procedure was used (the same as in Section 6.4 and")
    thisalinea.textcontent.append("Section 6.6) to mimic the experimental data. A speciﬁc heat of CV = 215 J/(kg · K)")
    thisalinea.textcontent.append("and an emissivity of (cid:15) = 0.25 were used for the Densimet blocks, since those values")
    thisalinea.textcontent.append("were obtained from the matching procedure in Section 6.6.")
    thisalinea.textcontent.append("During the experiment, the stainless steel ribs were removed from the Densimet blocks.")
    thisalinea.textcontent.append("However, 4 stainless steel clamps were put on the Densimet blocks instead. These")
    thisalinea.textcontent.append("clamps were used to press the Densimet blocks ﬁrmly against the copper plate with")
    thisalinea.textcontent.append("the heaters ensuring good thermal conduction between the plate and the Densimet")
    thisalinea.textcontent.append("blocks. A special heat-conducting paste was put between the Densimet blocks and")
    thisalinea.textcontent.append("the copper plate for the same purpose. The absence of the stainless steel ribs and")
    thisalinea.textcontent.append("the presence of the clamps cause less passive cooling of the X-slit system during the")
    thisalinea.textcontent.append("experiment than one would expect from the simulations of Section 6.4. However,")
    thisalinea.textcontent.append("since in Section 6.4, a Densimet emissivity of (cid:15) = 0.07 was assumed while the actual")
    thisalinea.textcontent.append("emissivity of Densimet was measured to be (cid:15) = 0.25, this reduction of passive cooling")
    thisalinea.textcontent.append("during the experiment posed no risk for damaging the electronics or the stepping")
    thisalinea.textcontent.append("motors of the X-slit system.")
    thisalinea.textcontent.append("The results of this experimental veriﬁcation are displayed in Figures 6.12 and 6.13.")
    thisalinea.textcontent.append("When these ﬁgures are compared with Figure 6.11, one important conclusion can")
    thisalinea.textcontent.append("be drawn immediately: The diﬀerence between simulation and experiment is always")
    thisalinea.textcontent.append("below 20 ◦C for the measured speciﬁc heat of CV = 215 J/(kg · K) and the measured")
    thisalinea.textcontent.append("emissivity of (cid:15) = 0.25. This is not true for the applied power of 1300 W near the")
    thisalinea.textcontent.append("Densimet block, but there are two reasons why this poses no problem.")
    thisalinea.textcontent.append("The ﬁrst reason is that the temperature near the Densimet blocks is not what poses")
    thisalinea.textcontent.append("a threat to the X-slit system. It is the temperature at the top ﬂange of the vacuum")
    thisalinea.textcontent.append("chamber, since this is where the precious electronics and stepping motors are located")
    thisalinea.textcontent.append("(see Section 6.3). At this location, the diﬀerence is below 20 ◦C.")
    thisalinea.textcontent.append("The second reason is that during operation, the X-slit system will never receive a heat")
    thisalinea.textcontent.append("load of 1300 W. It will at most receive 500 W, although this power can be deposited")
    thisalinea.textcontent.append("nearly completely in one of the blocks. That is why a total power dissipation of at")
    thisalinea.textcontent.append("least 1000 W had to be tested in this experiment (this experiment could only divide")
    thisalinea.textcontent.append("the power symmetrically over the two Densimet blocks). For 1026 W, the diﬀerence")
    thisalinea.textcontent.append("is below 20 ◦C.")
    thisalinea.textcontent.append("Figure 6.12: NX simulated and experi-")
    thisalinea.textcontent.append("mental temperatures on the top face of")
    thisalinea.textcontent.append("one of the Densimet blocks during the ap-")
    thisalinea.textcontent.append("plication of a thermal load to the X-slit")
    thisalinea.textcontent.append("system prototype; ﬁgure used with per-")
    thisalinea.textcontent.append("mission [115].")
    thisalinea.textcontent.append("Figure 6.13: NX simulated and experi-")
    thisalinea.textcontent.append("mental temperatures on the top ﬂange")
    thisalinea.textcontent.append("(in air) of the vacuum chamber during")
    thisalinea.textcontent.append("the application of a thermal load to the")
    thisalinea.textcontent.append("X-slit system prototype. 100% convec-")
    thisalinea.textcontent.append("tion was assumed on the air-side of the")
    thisalinea.textcontent.append("plate; ﬁgure used with permission [115].")
    thisalinea.textcontent.append("From this comparison, it can be concluded that the error margin of our NX simulation")
    thisalinea.textcontent.append("procedure is below 20 ◦C. Therefore, the claim made at the end of Section 6.6 remains")
    thisalinea.textcontent.append("valid: during operation the real temperature of the vacuum chamber wall should")
    thisalinea.textcontent.append("not exceed 35 ◦C + 20 ◦C = 55 ◦C (based on Section 6.4). This, however, raises the")
    thisalinea.textcontent.append("question why the measured temperature of the vacuum chamber wall in Figure 6.13")
    thisalinea.textcontent.append("can become as high as 70 ◦C.")
    thisalinea.textcontent.append("There are two reasons for this. The ﬁrst reason is that in order to exceed 55 ◦C (see")
    thisalinea.textcontent.append("Figure 6.13), the total heat deposited in the system has to be above the 500 W that")
    thisalinea.textcontent.append("the X-slit system has to endure during operation. The 55 ◦C is based on a simulation")
    thisalinea.textcontent.append("with a 500 W heat load only (see Section 6.4). The second reason is that during")
    thisalinea.textcontent.append("the experiment of Figure 6.13, only a few stainless steel clamps were present on the")
    thisalinea.textcontent.append("Densimet blocks, while the result in which the temperature of 55 ◦C was calculated, is")
    thisalinea.textcontent.append("based on a simulation with all stainless steel ribs present. Hence, the passive cooling")
    thisalinea.textcontent.append("by stainless steel in Figure 6.13 is much worse than the one in Section 6.4.")
    thisalinea.textcontent.append("Nevertheless, the top plate of the vacuum chamber wall stays below 80 ◦C during all")
    thisalinea.textcontent.append("simulations and experimental veriﬁcations, which is the upper limit for the stepping")
    thisalinea.textcontent.append("motors and electronics to operate without malfunctions [115]. Therefore, we con-")
    thisalinea.textcontent.append("clude that the X-slit system can safely take the maximum heat load of 500 W it can")
    thisalinea.textcontent.append("experience from the beam load inside the Super-FRS.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "6.8 Conclusion"
    thisalinea.nativeID = 56
    thisalinea.parentID = 48
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 7
    thisalinea.summary = "When operating the slit systems with the Super-FRS beams, the main problem to deal with is that the electronics and stepping motors of the ﬁrst X-slit system inside the pre-separator might not be able to handle the thermal stress caused by the secondary beam. To solve this problem, the Densimet blocks of the ﬁrst X-slit system in the pre-separator were equipped with small stainless steel ribs to provide passive cooling. Two experiments (Sections 6.6 and 6.7) conﬁrm that due to this passive cooling the temperature of the top ﬂange of the vacuum chamber will stay below 55 ◦C during operation. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("When operating the slit systems with the Super-FRS beams, the main problem to deal")
    thisalinea.textcontent.append("with is that the electronics and stepping motors of the ﬁrst X-slit system inside the")
    thisalinea.textcontent.append("pre-separator might not be able to handle the thermal stress caused by the secondary")
    thisalinea.textcontent.append("beam. To solve this problem, the Densimet blocks of the ﬁrst X-slit system in the")
    thisalinea.textcontent.append("pre-separator were equipped with small stainless steel ribs to provide passive cooling.")
    thisalinea.textcontent.append("Two experiments (Sections 6.6 and 6.7) conﬁrm that due to this passive cooling the")
    thisalinea.textcontent.append("temperature of the top ﬂange of the vacuum chamber will stay below 55 ◦C during")
    thisalinea.textcontent.append("operation. Since the electronics and stepping motors can operate safely up to a")
    thisalinea.textcontent.append("temperature of 80 ◦C, we conclude that with the passive cooling by stainless steel")
    thisalinea.textcontent.append("ribs, the X-slit system can safely be used inside the pre-separator.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "7 Design of the VETO detector for NeuLAND"
    thisalinea.nativeID = 57
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 8
    thisalinea.summary = "The R3B experiment is a versatile experimental setup for nuclear physics research. The goal of this experiment is to obtain kinematically complete reconstructions of nuclear Reactions with Relativistic Radioactive Beams (R3B [10]. These reactions are an important tool to explore nuclear structure properties far from the valley of stability. The R3B setup will be located at the high-energy branch of the Super-FRS at the FAIR-facility (see Chapter 6, Figure 6.2). Therefore, the setup has access to high quality (in terms of intensity and purity) secondary beams of all (rare) isotopes up to Uranium [30]. In particular, secondary beams of very "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.1 Overview of the R3B experiment"
    thisalinea.nativeID = 58
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "The R3B experiment is a versatile experimental setup for nuclear physics research. The goal of this experiment is to obtain kinematically complete reconstructions of nuclear Reactions with Relativistic Radioactive Beams (R3B [10]. These reactions are an important tool to explore nuclear structure properties far from the valley of stability. The R3B setup will be located at the high-energy branch of the Super-FRS at the FAIR-facility (see Chapter 6, Figure 6.2). Therefore, the setup has access to high quality (in terms of intensity and purity) secondary beams of all (rare) isotopes up to Uranium [30]. In particular, secondary beams of very "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The R3B experiment is a versatile experimental setup for nuclear physics research.")
    thisalinea.textcontent.append("The goal of this experiment is to obtain kinematically complete reconstructions of")
    thisalinea.textcontent.append("nuclear Reactions with Relativistic Radioactive Beams (R3B [10]. These reactions")
    thisalinea.textcontent.append("are an important tool to explore nuclear structure properties far from the valley of")
    thisalinea.textcontent.append("stability.")
    thisalinea.textcontent.append("The R3B setup will be located at the high-energy branch of the Super-FRS at the")
    thisalinea.textcontent.append("FAIR-facility (see Chapter 6, Figure 6.2). Therefore, the setup has access to high")
    thisalinea.textcontent.append("quality (in terms of intensity and purity) secondary beams of all (rare) isotopes up to")
    thisalinea.textcontent.append("Uranium [30]. In particular, secondary beams of very neutron-rich nuclei of medium")
    thisalinea.textcontent.append("mass can be eﬃciently produced [10, 30].")
    thisalinea.textcontent.append("In the R3B experiment itself, the ions from such a secondary beam are impinged")
    thisalinea.textcontent.append("on a ﬁxed target to study various types of nuclear reactions. The products of such")
    thisalinea.textcontent.append("reactions are then bent by a large acceptance superconducting dipole magnet (the")
    thisalinea.textcontent.append("GLAD-magnet) for spectrometric analysis [123]. Diﬀerent detector systems are lo-")
    thisalinea.textcontent.append("cated around the target and the dipole magnet to provide a kinematically-complete")
    thisalinea.textcontent.append("reconstruction of the reaction. Due to the forward boost of the reaction products, the")
    thisalinea.textcontent.append("R3B setup can provide a almost full solid angle acceptance for these products [10].")
    thisalinea.textcontent.append("Multiple types of nuclear reactions can be studied, including knockout reactions,")
    thisalinea.textcontent.append("quasi-free scattering, elastic proton scattering, charge-exchange reactions, ﬁssion and")
    thisalinea.textcontent.append("spallation reactions and fragmentations. These reactions can help us understand")
    thisalinea.textcontent.append("various aspects of nuclear structure, such as the nuclear shell structure, nuclear mass")
    thisalinea.textcontent.append("and charge densities, correlations and cluster structures. In particular, Gamow-Teller")
    thisalinea.textcontent.append("transitions can be eﬃciently studied through charge-exchange reactions, which is the")
    thisalinea.textcontent.append("reason that the development of this setup is part of this work. For a more detailed")
    thisalinea.textcontent.append("overview of the nuclear reactions that can be studied at the R3B experiment, the")
    thisalinea.textcontent.append("reader is referred to Ref. [10].")
    thisalinea.textcontent.append("The R3B setup has worldwide unique facilities. At present, there are 3 diﬀerent in-")
    thisalinea.textcontent.append("stitutes in the world that possess a modern in-ﬂight ion separator (some are under")
    thisalinea.textcontent.append("construction) [124]. These institutes are: GSI (which will become FAIR in the near")
    thisalinea.textcontent.append("future, see Chapter 6), NSCL/MSU in the United States and RIBF in Japan. Having")
    thisalinea.textcontent.append("such an in-ﬂight separator in the institute is a prerequisite for an R3B-like experi-")
    thisalinea.textcontent.append("mental setup, because without it, short-lived nuclei far from the region of stability")
    thisalinea.textcontent.append("cannot be studied.")
    thisalinea.textcontent.append("From these institutes, FAIR is the only one where the in-ﬂight ion separator (Super-")
    thisalinea.textcontent.append("FRS) can provide both a very high beam energy and a high beam intensity [124].")
    thisalinea.textcontent.append("Under certain conditions, both the BigRIPS separator at RIBF and the ARIS sepa-")
    thisalinea.textcontent.append("rator at NSCL/MSU can provide an even higher beam intensity than the Super-FRS.")
    thisalinea.textcontent.append("However, neither of them can provide secondary beams above 350 MeV/u, while the")
    thisalinea.textcontent.append("Super-FRS can go up to 1.5 GeV/u [124]. The older FRS at GSI (which the Super-")
    thisalinea.textcontent.append("FRS will succeed) can also provide these higher beam energies already, but only at")
    thisalinea.textcontent.append("a much lower intensity [30]. Hence, the R3B setup is the only experimental setup in")
    thisalinea.textcontent.append("the world that can eﬃciently study nuclei far from stability at higher energies.")
    thisalinea.textcontent.append("In addition to access to the Super-FRS beams, the detector systems of the R3B setup")
    thisalinea.textcontent.append("have high granularities and precise time resolutions [125–128] making it possible to")
    thisalinea.textcontent.append("perform a precise kinematic reconstruction of the reaction. The granularity and the")
    thisalinea.textcontent.append("time resolution of the R3B setup surpass those of the present SAMURAI setup at")
    thisalinea.textcontent.append("RIBF [129]. For example, the R3B neutron detector consist of 5 cm thick scintillators")
    thisalinea.textcontent.append("[126], while the SAMURAI neutron detector consist of 12 cm thick scintillators [130,")
    thisalinea.textcontent.append("131]. The HRS spectrometer for the ARIS separator is still in its design phase [132].")
    thisalinea.textcontent.append("Nevertheless, invariant-mass spectroscopy with neutrons has also been done for many")
    thisalinea.textcontent.append("years with the MoNA-LISA setup using the Sweeper magnet at NSCL/MSU.")
    thisalinea.textcontent.append("However, it should be noted that higher granularities and better time resolutions")
    thisalinea.textcontent.append("are required when the beam energy goes up, because this means that the reaction")
    thisalinea.textcontent.append("products will have a larger boost in the forward direction.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.2 The R3B setup and the role of the VETO de- tector"
    thisalinea.nativeID = 59
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "An overview of the full R3B setup is presented in Figure 7.1. This conﬁguration will be used during the ﬁrst R3B experiments at phase-0 of FAIR [133, 134]. Both before and immediately after the target, the beam encounters double-sided mi- crostrip silicon detectors and position sensitive silicon strip detectors [125]. The pur- pose of these detectors is to measure the starting time and position for Time-of-Flight measurements of the other R3B detectors and to perform the charge identiﬁcation of the incoming beam. The target is surrounded by a proton silicon tracking system [127] and a gamma spectrometer called CALIFA [128]. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("An overview of the full R3B setup is presented in Figure 7.1. This conﬁguration will")
    thisalinea.textcontent.append("be used during the ﬁrst R3B experiments at phase-0 of FAIR [133, 134].")
    thisalinea.textcontent.append("Both before and immediately after the target, the beam encounters double-sided mi-")
    thisalinea.textcontent.append("crostrip silicon detectors and position sensitive silicon strip detectors [125]. The pur-")
    thisalinea.textcontent.append("pose of these detectors is to measure the starting time and position for Time-of-Flight")
    thisalinea.textcontent.append("measurements of the other R3B detectors and to perform the charge identiﬁcation of")
    thisalinea.textcontent.append("the incoming beam. The target is surrounded by a proton silicon tracking system")
    thisalinea.textcontent.append("[127] and a gamma spectrometer called CALIFA [128]. Together, these systems can")
    thisalinea.textcontent.append("detect and identify all high energy photons and light charged-particles emitted from")
    thisalinea.textcontent.append("the target.")
    thisalinea.textcontent.append("After the target region, the beam and reaction products enter the superconducting")
    thisalinea.textcontent.append("dipole magnet GLAD [123]. This magnet serves to separate protons, ions and neutrons")
    thisalinea.textcontent.append("into three distinct particle streams. The rest of the setup is, therefore, divided into")
    thisalinea.textcontent.append("three diﬀerent spectrometer arms as well.")
    thisalinea.textcontent.append("Figure 7.1: Overview of the new R3B experimental setup [135]. Figure was based on")
    thisalinea.textcontent.append("the technical drawings of D. Koerper (email: D.Koerper@gsi.de) and was used with")
    thisalinea.textcontent.append("permission.")
    thisalinea.textcontent.append("A large scattering chamber, located directly behind the GLAD magnet, contains")
    thisalinea.textcontent.append("several tracking detectors [125]. Most of these detectors are part of the proton arm")
    thisalinea.textcontent.append("and serve to reconstruct the momenta of the protons. The proton arm does not extend")
    thisalinea.textcontent.append("beyond the scattering chamber. The ion spectrometer arm contains a 200 µm thick")
    thisalinea.textcontent.append("ﬁber detector inside the scattering chamber to detect the exact ﬂight paths of the ions")
    thisalinea.textcontent.append("(for particle identiﬁcation based on the GLAD bending angle). After passing through")
    thisalinea.textcontent.append("this detector, the ions leave the scattering chamber through a pipe and arrive at a")
    thisalinea.textcontent.append("Time-of-Flight wall several meters away [125]. The interior of the GLAD magnet and")
    thisalinea.textcontent.append("the scattering chamber (with the pipe) can (and, most of the time, will) be evacuated")
    thisalinea.textcontent.append("to a vacuum of about 10−5 mbar [136].")
    thisalinea.textcontent.append("The neutrons are not bent by the GLAD magnet and leave the scattering chamber")
    thisalinea.textcontent.append("through a 4 mm thick stainless steel window. Several meters further, the neutrons")
    thisalinea.textcontent.append("are detected by NeuLAND (Neu Large Area Neutron Detector) [126]. NeuLAND")
    thisalinea.textcontent.append("is designed to reconstruct the position and time of the ﬁrst interaction between the")
    thisalinea.textcontent.append("neutron and the NeuLAND material.")
    thisalinea.textcontent.append("In this Chapter, we will focus our attention on the NeuLAND detector of the R3B")
    thisalinea.textcontent.append("setup. Upon completion, NeuLAND’s active material volume will be composed of")
    thisalinea.textcontent.append("3000 plastic scintillator bars, each with dimensions of 5 cm × 5 cm × 270 cm. The")
    thisalinea.textcontent.append("scintillation plastic (organic plastic BC408) is wrapped with a reﬂective aluminum")
    thisalinea.textcontent.append("foil (0.2 mm thick) and with tape (0.5 mm thick) to guide the light to both ends")
    thisalinea.textcontent.append("of the bar. Each bar is connected to conical-shaped light guide at both ends of")
    thisalinea.textcontent.append("10 cm long to guide the light towards the photomultipliers. The scintillators are")
    thisalinea.textcontent.append("arranged in planes of 50 bars each, creating a 2.5 m × 2.5 m plane (excluding the")
    thisalinea.textcontent.append("light guides). The entire detector is composed of 60 such planes, which are stacked")
    thisalinea.textcontent.append("behind each other with alternating perpendicular orientations. The ﬁrst plane has a")
    thisalinea.textcontent.append("horizontal orientation. Neutrons from the reaction at the target are impinged almost")
    thisalinea.textcontent.append("perpendicularly to the ﬁrst plane.")
    thisalinea.textcontent.append("When a neutron enters NeuLAND’s active volume (2.5 m × 2.5 m × 3 m), it can un-")
    thisalinea.textcontent.append("dergo hadronic interactions with the detector material. Such hadronic interactions")
    thisalinea.textcontent.append("can knock out protons (or other charged particles), which in turn generate scintilla-")
    thisalinea.textcontent.append("tion light when they travel through NeuLAND’s active material. This scintillation")
    thisalinea.textcontent.append("light is detected by the photomultipliers. The PMT signals are recorded by Time-")
    thisalinea.textcontent.append("to-Digital Converter (TDC) and Charge-to-Digital Converter (QDC) electronics (see")
    thisalinea.textcontent.append("[126] for a more detailed description) and then further processed during oﬄine anal-")
    thisalinea.textcontent.append("ysis. This oﬄine analysis procedure is described in more detail in Section 7.3. After")
    thisalinea.textcontent.append("the NeuLAND analysis is complete, the data will yield a (t, (cid:126)x) pair for each neu-")
    thisalinea.textcontent.append("tron (called a reconstructed ﬁrst hit). From this time and position, the neutron’s")
    thisalinea.textcontent.append("energy and momentum can be reconstructed, providing the necessary information for")
    thisalinea.textcontent.append("a kinematically-complete reconstruction of the reaction at the target.")
    thisalinea.textcontent.append("The problem addressed in this Chapter is that charged particles may also enter Neu-")
    thisalinea.textcontent.append("LAND’s volume. These background charged particles mainly come from secondary")
    thisalinea.textcontent.append("scatterings in detector material behind the GLAD ﬁeld and will also generate scintil-")
    thisalinea.textcontent.append("lation light in NeuLAND. PMT signals from this light may spoil the reconstruction of")
    thisalinea.textcontent.append("the neutron momenta. Therefore, one may require an active shield for the NeuLAND")
    thisalinea.textcontent.append("detector against such charged particles. Such an active shield is called a VETO de-")
    thisalinea.textcontent.append("tector, because every signal detected by the shield can be given a negative trigger")
    thisalinea.textcontent.append("(VETO trigger) to prevent it from contributing to the neutron signals.")
    thisalinea.textcontent.append("In this Chapter the detailed design (based on Monte Carlo simulations) of this VETO")
    thisalinea.textcontent.append("detector is discussed. The simulation procedure is explained in Section 7.3 and bench-")
    thisalinea.textcontent.append("marked against experimental data in Section 7.4. The detector design itself is then")
    thisalinea.textcontent.append("discussed in Section 7.5. The overall eﬃciency of the designed VETO detector is")
    thisalinea.textcontent.append("explored in Section 7.6 for various reactions.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.3 Simulation procedure"
    thisalinea.nativeID = 60
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "This Chapter contains two sets of simulations: simulations used to design the VETO (discussed in Section 7.5) and simulations used to evaluate the performance of the VETO (discussed in Section 7.6). Both simulation procedures are mostly identical, but there are some important diﬀerences in geometry and physics list, which will be explained in detail. Both sets of simulations were performed with R3BRoot [137, 138]. R3BRoot is an integrated simulation framework that uses the Geant4 [139] simulation toolkit to Figure 7.2: Overview of the NeuLAND simulation/analysis procedure in R3BRoot [137, 138]. perform the Monte Carlo simulations. The previous version of Geant4, "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("This Chapter contains two sets of simulations: simulations used to design the VETO")
    thisalinea.textcontent.append("(discussed in Section 7.5) and simulations used to evaluate the performance of the")
    thisalinea.textcontent.append("VETO (discussed in Section 7.6). Both simulation procedures are mostly identical,")
    thisalinea.textcontent.append("but there are some important diﬀerences in geometry and physics list, which will be")
    thisalinea.textcontent.append("explained in detail.")
    thisalinea.textcontent.append("Both sets of simulations were performed with R3BRoot [137, 138]. R3BRoot is an")
    thisalinea.textcontent.append("integrated simulation framework that uses the Geant4 [139] simulation toolkit to")
    thisalinea.textcontent.append("Figure 7.2: Overview of the NeuLAND simulation/analysis procedure in R3BRoot")
    thisalinea.textcontent.append("[137, 138].")
    thisalinea.textcontent.append("perform the Monte Carlo simulations. The previous version of Geant4, Geant3, can")
    thisalinea.textcontent.append("also be used as an alternative. In addition, R3BRoot is equipped with a ROOT [87]")
    thisalinea.textcontent.append("(version 5) user interface and with detailed geometry ﬁles for all detector systems in")
    thisalinea.textcontent.append("the R3B setup (see Section 7.2). All active detector components are also marked as")
    thisalinea.textcontent.append("active areas in Geant3 and in geant4 so that all particle interactions inside these areas")
    thisalinea.textcontent.append("are saved for further analysis.")
    thisalinea.textcontent.append("R3BRoot is equipped with dedicated software for each detector system to mimic")
    thisalinea.textcontent.append("detector responses, to unpack experimental data and to further analyze those data.")
    thisalinea.textcontent.append("This has the advantage that exactly the same software can be used to analyze all data")
    thisalinea.textcontent.append("regardless of whether these data were simulated or measured. Detector responses such")
    thisalinea.textcontent.append("as photomultiplier signals are calculated by so-called digitizers, which reconstruct the")
    thisalinea.textcontent.append("signal from the result of the Geant4 (or Geant3) simulation. An overview of the full")
    thisalinea.textcontent.append("software package available in R3BRoot for the NeuLAND detector is presented in")
    thisalinea.textcontent.append("Figure 7.2.")
    thisalinea.textcontent.append("Before any simulation as presented in Figure 7.2 can be performed, the NeuLAND")
    thisalinea.textcontent.append("detector geometry has to be deﬁned. In both sets of simulations, the NeuLAND")
    thisalinea.textcontent.append("scintillator bars were modeled as 4.8 cm × 4.8 cm × 250.0 cm square active volumes")
    thisalinea.textcontent.append("made of BC408 plastic scintillator material [126]. The bars were wrapped with 0.2 mm")
    thisalinea.textcontent.append("thick aluminum to model the light reﬂection foil and with 0.5 mm thick tape. The")
    thisalinea.textcontent.append("tape material was modeled by a CH2-polymer. Around the tape, a 0.3 mm air region")
    thisalinea.textcontent.append("is modeled to account for the fact that one will never be able to mechanically mount")
    thisalinea.textcontent.append("the bars in a perfect position. This conﬁguration causes that the total dimension of")
    thisalinea.textcontent.append("each bar equals 5.0 cm × 5.0 cm × 250.0 cm. To model NeuLAND’s geometry, 3000")
    thisalinea.textcontent.append("bars were stacked in the same orientation as discussed in Section 7.2. We would like")
    thisalinea.textcontent.append("to emphasize that only the BC408 volumes are modeled as active detector volumes. It")
    thisalinea.textcontent.append("is also important to note that the conical light guides and photomultipliers at the end")
    thisalinea.textcontent.append("of all scintillator bars are not included in our geometry. The eﬀects of the light guides")
    thisalinea.textcontent.append("and photomultipliers were simulated by the digitizer instead, which is discussed later")
    thisalinea.textcontent.append("in this section.")
    thisalinea.textcontent.append("For the simulations used to design the VETO, the experimental cave of Figure 7.1 was")
    thisalinea.textcontent.append("modeled as a huge box ﬁlled with air. The z-axis was chosen along the incoming beam.")
    thisalinea.textcontent.append("The y-axis pointed upward (in the experimental cave) and the x-axis was deﬁned in")
    thisalinea.textcontent.append("such a way that a right-handed coordinate system was obtained. NeuLAND was")
    thisalinea.textcontent.append("positioned in the cave in such a way that its front active area was centered around")
    thisalinea.textcontent.append("and perpendicular to the z-axis and located at a distance of 14.0 m from the target")
    thisalinea.textcontent.append("at the origin. As discussed in Section 7.2, the ﬁrst layer of 50 bars of NeuLAND have")
    thisalinea.textcontent.append("a horizontal orientation, which means that those bars were parallel to the x-axis.")
    thisalinea.textcontent.append("The Monte Carlo simulations used to design the VETO were performed by ﬁring par-")
    thisalinea.textcontent.append("ticles with a particle gun from the origin onto NeuLAND, in a conic proﬁle around")
    thisalinea.textcontent.append("the z-axis with a uniform distribution over the full range of the azimuthal angle φ")
    thisalinea.textcontent.append("and a uniform distribution in the polar angle θ between 0 and 80 mrad to mimic the")
    thisalinea.textcontent.append("scattered reaction products (no target was present in these simulations) and to mimic")
    thisalinea.textcontent.append("the eﬀects of the acceptance of the GLAD magnet [123]. The particles were also given")
    thisalinea.textcontent.append("a uniform distribution in total relativistic momentum between certain pre-speciﬁed")
    thisalinea.textcontent.append("boundaries. A VETO detector was placed between NeuLAND and the particle gun.")
    thisalinea.textcontent.append("The precise geometry of this VETO detector is discussed in Section 7.5. The simu-")
    thisalinea.textcontent.append("lations used to design the VETO were performed with the R3BRoot default physics")
    thisalinea.textcontent.append("list of Geant3 with the interaction option GCalor switched on. The interaction op-")
    thisalinea.textcontent.append("tion GCalor allows for accurate simulation of low-energy neutrons. This physics list")
    thisalinea.textcontent.append("has proven to be successful in the design of NeuLAND itself [126] and in the design")
    thisalinea.textcontent.append("of LAND, NeuLAND’s predecessor [140], which operated successfully in experiments")
    thisalinea.textcontent.append("similar to those performed in the R3B experiment [14]. The basis of this physics")
    thisalinea.textcontent.append("list is the Monte Carlo code of Kurz and Stanton [141]. This code has been further")
    thisalinea.textcontent.append("improved in [142] and tested for neutron plastic scintillation counters. It is bench-")
    thisalinea.textcontent.append("marked once more in [143]. The geometry and reference frame used for the Monte")
    thisalinea.textcontent.append("Carlo simulations to design the VETO is shown in Figure 7.3.")
    thisalinea.textcontent.append("Figure 7.3: Overview of geometry of the simulations used to design the VETO.")
    thisalinea.textcontent.append("The Monte Carlo simulations used to evaluate the performance of the VETO were")
    thisalinea.textcontent.append("performed by ﬁring the same particle gun, but now from z = −4.0 m and with a")
    thisalinea.textcontent.append("uniform distribution in the polar angle θ between 0 and 80 µrad to simulate a well-")
    thisalinea.textcontent.append("focused ion beam as produced by the Super-FRS. These simulations were performed")
    thisalinea.textcontent.append("with a Geant4 user-deﬁned physics list, which is discussed in more detail in Section")
    thisalinea.textcontent.append("7.4. The reason for using Geant4 is that Geant3 is not equipped to simulate nucleus-")
    thisalinea.textcontent.append("nucleus collisions [138], which are obviously required at the target to simulate any")
    thisalinea.textcontent.append("realistic R3B scenario. In addition to NeuLAND and the VETO detector, a physical")
    thisalinea.textcontent.append("target was added at the origin to simulate the actual collision between the beam and")
    thisalinea.textcontent.append("the target. All components and detector systems of the R3B setup as discussed in")
    thisalinea.textcontent.append("Section 7.2 were also placed in the simulation. R3BRoot has predeﬁned geometries for")
    thisalinea.textcontent.append("all these detector systems [137, 138], except for the scattering chamber. We modeled")
    thisalinea.textcontent.append("the geometry of the scattering chamber ourselves based on the technical drawings")
    thisalinea.textcontent.append("of the R3B tracking system [125]. R3BRoot also has a predeﬁned model for the")
    thisalinea.textcontent.append("magnetic ﬁeld inside the GLAD magnet, which was added to our simulations. The")
    thisalinea.textcontent.append("current through the GLAD magnet can be speciﬁed by the user to tune the magnetic")
    thisalinea.textcontent.append("ﬁeld. The total geometry used in the Monte Carlo simulations for evaluating the")
    thisalinea.textcontent.append("performance of the VETO is shown in Figure 7.4.")
    thisalinea.textcontent.append("After the Monte Carlo transport is completed, both sets of simulations follow exactly")
    thisalinea.textcontent.append("the same procedure. In this procedure, the photomultiplier signals were calculated")
    thisalinea.textcontent.append("by the NeuLAND digitizer from the Monte Carlo results saved in the active detector")
    thisalinea.textcontent.append("volumes. The NeuLAND digitizer was developed by Jan Mayer, one of the authors of")
    thisalinea.textcontent.append("Refs. [135] and [144]. We will brieﬂy discuss its operating principle here. For further")
    thisalinea.textcontent.append("details, the reader is referred to the R3BRoot source code, which is available through")
    thisalinea.textcontent.append("[138]. An overview of the Digitizers operating principle is shown in Figure 7.5.")
    thisalinea.textcontent.append("The NeuLAND digitizer processes a simulation event-by-event. The ﬁrst step in")
    thisalinea.textcontent.append("this process is to retrieve the energy deposition, position coordinates and time index")
    thisalinea.textcontent.append("for each Monte Carlo interaction point in the active volume of a scintillator bar.")
    thisalinea.textcontent.append("The fraction of the deposited energy that is converted into scintillation light is then")
    thisalinea.textcontent.append("computed for each of those Monte Carlo points using Birk’s law. The light transport")
    thisalinea.textcontent.append("through the bar is calculated by an exponential attenuation of the energy in the")
    thisalinea.textcontent.append("scintillation light with an attenuation length of λ = 125 cm. The time at which this")
    thisalinea.textcontent.append("scintillation light arrives at the photomultipliers is calculated by adding the time")
    thisalinea.textcontent.append("index of the Monte Carlo point to the light traveling time from the Monte Carlo")
    thisalinea.textcontent.append("Point to the end of the bar. The light traveling time is calculated from the distance")
    thisalinea.textcontent.append("between the Monte Carlo point and the end of the bar by an eﬀective speed of light,")
    thisalinea.textcontent.append("ceﬀ = 14.0 cm/ns. The fact that the light is reﬂected multiple times oﬀ the aluminum")
    thisalinea.textcontent.append("foil instead of traveling in a straight line is incorporated in our values for the eﬀective")
    thisalinea.textcontent.append("speed of light and attenuation length.")
    thisalinea.textcontent.append("The next step is to construct the full photomultiplier pulse per event from all individ-")
    thisalinea.textcontent.append("ual contributions of the Monte Carlo points. The energy of a single Monte Carlo point")
    thisalinea.textcontent.append("that arrived at the end of the bar contributes to the photomultiplier pulse at the time")
    thisalinea.textcontent.append("of arrival and then exponentially decays in time with a decay time of τ = 2.1 ns. In")
    thisalinea.textcontent.append("this way, all contributions from the Monte Carlo points are added to the total pulse.")
    thisalinea.textcontent.append("A random number from a Gaussian distribution with a width of σ = 150 ps is added")
    thisalinea.textcontent.append("Figure 7.4: Overview of the geometry of the simulations used to evaluate the perfor-")
    thisalinea.textcontent.append("mance of the VETO.")
    thisalinea.textcontent.append("Figure 7.5: Operating principle of the NeuLAND digitizer in R3BRoot. See the text")
    thisalinea.textcontent.append("for further details.")
    thisalinea.textcontent.append("to each arrival time to mimic the eﬀects of NeuLAND’s time resolution. The total")
    thisalinea.textcontent.append("pulse is then processed with a Constant-Fraction Discriminator (CFD). The time at")
    thisalinea.textcontent.append("which the pulse crosses the threshold is saved as the photomultiplier TDC value. The")
    thisalinea.textcontent.append("value of the integrated pulse after crossing the threshold is saved as the QDC value. A")
    thisalinea.textcontent.append("threshold pulse height of 160 was used, which corresponds to a total energy deposition")
    thisalinea.textcontent.append("in the scintillator of 1 MeV. This corresponds to a total energy loss of the particle in")
    thisalinea.textcontent.append("the bar of about 1 MeV. For a more detailed justiﬁcation of the parameters used in")
    thisalinea.textcontent.append("the digitizer, the reader is referred to Ref. [126].")
    thisalinea.textcontent.append("After the QDC and TDC values per event have been calculated for all NeuLAND")
    thisalinea.textcontent.append("photomultipliers, one has to recover the time, position and energy deposition of the")
    thisalinea.textcontent.append("hit in each bar. The hit position along the direction of the bar is calculated from the")
    thisalinea.textcontent.append("diﬀerence between the two TDC values at the endpoints of that bar. The other two")
    thisalinea.textcontent.append("position coordinates are obtained from the global position of the bar. The time of the")
    thisalinea.textcontent.append("hit is calculated from the average of the two TDC values. The energy deposition of")
    thisalinea.textcontent.append("the hit is calculated from the geometrical mean of the two QDC values. The hit-points")
    thisalinea.textcontent.append("are reconstructed in this way for all bars where the photomultiplier pulse crossed the")
    thisalinea.textcontent.append("threshold on both endpoints. All other bars are assumed not to have any hit-point at")
    thisalinea.textcontent.append("all.")
    thisalinea.textcontent.append("Therefore, after the digitizer processed a simulation event, we know for that event")
    thisalinea.textcontent.append("which bar gave a signal within that event. For the bars that gave a signal, we know")
    thisalinea.textcontent.append("the raw QDC and TDC values of the photomultipliers and the time, position and")
    thisalinea.textcontent.append("energy deposition of hit-point of the signal in that bar. At this point, we would like")
    thisalinea.textcontent.append("to refer back to Figure 7.2 to emphasize that the digitizer outcomes are exactly the")
    thisalinea.textcontent.append("same as when we would have unpacked experimental data.")
    thisalinea.textcontent.append("After the digitizer calculated NeuLAND’s response to the Monte Carlo simulation, the")
    thisalinea.textcontent.append("data analysis begins. We would like to refer back to Section 7.2, where it was stated")
    thisalinea.textcontent.append("that our goal is to reconstruct the time and position of the ﬁrst hadronic interaction")
    thisalinea.textcontent.append("of all incoming neutrons.")
    thisalinea.textcontent.append("The ﬁrst step in the data analysis is to use a cluster ﬁnding algorithm (called the")
    thisalinea.textcontent.append("NeuLAND Clusterﬁnder) to group the hit-points together. Remember that each bar")
    thisalinea.textcontent.append("either has a single hit-point reconstructed from the photomultiplier TDC and QDC,")
    thisalinea.textcontent.append("or has no hit-point at all. The cluster ﬁnding algorithm groups hit-points together")
    thisalinea.textcontent.append("if their position diﬀerence is less than 7.5 cm and if their time diﬀerence is less than")
    thisalinea.textcontent.append("1 ns. These parameter choices are further discussed in Ref. [126]. For each cluster,")
    thisalinea.textcontent.append("the hit-point with the shortest time is considered to be the start of the cluster and")
    thisalinea.textcontent.append("the hit-point with the longest time is considered to be the end of the cluster.")
    thisalinea.textcontent.append("The ﬁnal step is to reconstruct the ﬁrst hadronic interaction points from the clusters.")
    thisalinea.textcontent.append("The software that performs this reconstruction is called the R3BNeutronTracker.")
    thisalinea.textcontent.append("However, before the R3BNeutronTracker can perform this reconstruction, the neutron")
    thisalinea.textcontent.append("multiplicity per event has to be known. The neutron multiplicity is the total number")
    thisalinea.textcontent.append("of incoming neutrons per event. Since a single neutron can create an almost arbitrary")
    thisalinea.textcontent.append("number of clusters [126], one cannot directly obtain the neutron multiplicity from the")
    thisalinea.textcontent.append("detector response alone.")
    thisalinea.textcontent.append("The neutron multiplicity was determined with D. Kresan’s method for multi-neutron")
    thisalinea.textcontent.append("simulations [126, 138]. This method uses the fact that the neutron kinetic energy is")
    thisalinea.textcontent.append("approximately known beforehand. In almost all R3B experiments, the neutrons will")
    thisalinea.textcontent.append("have a kinetic energy roughly equal to the beam kinetic energy per nucleon. Knowing")
    thisalinea.textcontent.append("the approximate neutron energy, one can perform simulations according to Figure 7.3")
    thisalinea.textcontent.append("for all neutron multiplicities from 1 up to 5 for 50000 events. Next, each of these")
    thisalinea.textcontent.append("simulations is processed up to the level of the NeuLAND Clusterﬁnder (see Figure")
    thisalinea.textcontent.append("7.2). Finally, the total number of clusters per event is plotted as a function of the")
    thisalinea.textcontent.append("total energy deposition per event. An example of such plots is given in Figure 7.6 for")
    thisalinea.textcontent.append("a neutron energy of 600 ± 1 MeV and for the ﬁrst 4 neutron multiplicities.")
    thisalinea.textcontent.append("Figure 7.6: Number of clusters as a function of energy deposited for diﬀerent neutron")
    thisalinea.textcontent.append("multiplicities and for a neutron energy of 600 ± 1 MeV. Each single count corresponds")
    thisalinea.textcontent.append("to a single event. 50000 events were simulated per plot.")
    thisalinea.textcontent.append("The key in Kresan’s method is to deﬁne diagonal lines in the plots of Figure 7.6. All")
    thisalinea.textcontent.append("lines are given the same slope, but diﬀerent positions. If an event from a simulation or")
    thisalinea.textcontent.append("from a measurement is located below the lowest line, that event is assumed to have a")
    thisalinea.textcontent.append("neutron multiplicity of 1. If it is located between the lowest and the second-to-lowest")
    thisalinea.textcontent.append("line, the event is assumed to have a neutron multiplicity of 2, and so on. All events")
    thisalinea.textcontent.append("that are above the highest line, are assumed to have the highest simulated neutron")
    thisalinea.textcontent.append("multiplicity. This highest multiplicity shown in Figure 7.6 is 4, but in our simulations")
    thisalinea.textcontent.append("we went up to 5. If an event has a total energy deposition below 1 MeV, it is assumed")
    thisalinea.textcontent.append("to have a multiplicity of zero.")
    thisalinea.textcontent.append("The slope and positions of the lines (or cuts, as they are called in Ref. [126]) are")
    thisalinea.textcontent.append("computed by minimizing the squared wasted eﬃciency, deﬁned as:")
    thisalinea.textcontent.append("Ewasted =")
    thisalinea.textcontent.append("(cid:88)")
    thisalinea.textcontent.append("(1 − (cid:15)i)2,")
    thisalinea.textcontent.append("(7.1)")
    thisalinea.textcontent.append("where (cid:15)1 is the number of events below the lowest line divided by the total number")
    thisalinea.textcontent.append("of events in the 1-neutron plot of Figure 7.6. Likewise, (cid:15)2 is the number of events")
    thisalinea.textcontent.append("between the lines divided by the total number of events in the 2-neutron plot of")
    thisalinea.textcontent.append("Figure 7.6 and so on. Hence, minimizing Ewasted will ensure that the largest number")
    thisalinea.textcontent.append("of events is assigned its correct multiplicity. The optimized (cid:15)i are indicated by red")
    thisalinea.textcontent.append("numbers in Figure 7.6.")
    thisalinea.textcontent.append("We would like to emphasize that a lot of events will be assigned incorrect multiplicities")
    thisalinea.textcontent.append("by Kresan’s method. However, given the enormous complexity of determining the")
    thisalinea.textcontent.append("neutron multiplicity, the results of Figure 7.6 are actually very good and a better")
    thisalinea.textcontent.append("alternative is hard to come by [126].")
    thisalinea.textcontent.append("Once each event is assigned a neutron multiplicity according to Kresan’s method,")
    thisalinea.textcontent.append("the R3B NeutronTracker can reconstruct the time and space coordinates of the ﬁrst")
    thisalinea.textcontent.append("hadronic interaction between the neutrons and NeuLAND. These coordinates are")
    thisalinea.textcontent.append("called reconstructed ﬁrst hits. To perform this reconstruction, each pair of clusters")
    thisalinea.textcontent.append("in the event is ﬁrst subjected to a kinematic test. The reason for this test is that")
    thisalinea.textcontent.append("a cluster in NeuLAND can be created in two diﬀerent ways. The ﬁrst one is that a")
    thisalinea.textcontent.append("neutron indeed undergoes its ﬁrst hadronic interaction at the start-point of the cluster")
    thisalinea.textcontent.append("and knocks out a charged particle. This charged particle then produces a track of")
    thisalinea.textcontent.append("scintillation light, which is processed to be the cluster. The second way is that the")
    thisalinea.textcontent.append("neutron has already been scattered by a previous hadronic interaction and now knocks")
    thisalinea.textcontent.append("out a second charged particle, producing another cluster. Clusters produced in the")
    thisalinea.textcontent.append("second way do not carry any information about the neutrons ﬁrst hadronic interaction")
    thisalinea.textcontent.append("and should, therefore, be eliminated. By subjecting each pair of clusters within an")
    thisalinea.textcontent.append("event to a kinematic test, one can determine whether one of those two clusters comes")
    thisalinea.textcontent.append("from a neutron scattered by the other cluster or not.")
    thisalinea.textcontent.append("During the next phase of the reconstruction, a neutron kinetic energy is calculated")
    thisalinea.textcontent.append("for each remaining cluster by calculating the travel time and distance from the target")
    thisalinea.textcontent.append("to the start-point of that cluster. Those clusters are then ordered according to this")
    thisalinea.textcontent.append("assigned kinetic energy. Finally, the start-point of the cluster with a kinetic energy")
    thisalinea.textcontent.append("closest to the beam kinetic energy per nucleon is deﬁned as the reconstructed ﬁrst hit")
    thisalinea.textcontent.append("of the ﬁrst incoming neutron. The start-point of the second cluster in the ordering")
    thisalinea.textcontent.append("is deﬁned as the reconstructed ﬁrst hit of the second incoming neutron, and so on,")
    thisalinea.textcontent.append("until we run out of clusters, or until we run out of lines in Figure 7.6. The reason for")
    thisalinea.textcontent.append("choosing this procedure is that during typical R3B experiments, the neutron energy")
    thisalinea.textcontent.append("is close to the beam energy [126]. Hence, by selecting the reconstructed ﬁrst hits this")
    thisalinea.textcontent.append("way, one has a reasonable probability to obtain the correct reconstructed ﬁrst hits.")
    thisalinea.textcontent.append("At this point, the neutron reconstructed ﬁrst hits are obtained (see Figure 7.2). How-")
    thisalinea.textcontent.append("ever, to assess the quality of a VETO detector, a method is needed to compare")
    thisalinea.textcontent.append("the obtained reconstructed ﬁrst hits with the true physical ﬁrst hadronic interaction")
    thisalinea.textcontent.append("points of the neutrons (or other particles). This comparison is the last step in the")
    thisalinea.textcontent.append("ﬂowchart of Figure 7.2: the VETO analysis. Applying the actual VETO condition is")
    thisalinea.textcontent.append("not part of this step. Therefore, the actual VETO condition is discussed in the fol-")
    thisalinea.textcontent.append("lowing sections. Here, we only discuss the comparison method between reconstructed")
    thisalinea.textcontent.append("and physical ﬁrst hits.")
    thisalinea.textcontent.append("Obviously, such a comparison can never be made for experimental data, since the")
    thisalinea.textcontent.append("physical ﬁrst interactions are unknown in that situation. All information that is")
    thisalinea.textcontent.append("available are the reconstructed ﬁrst hits and one hopes that they accurately represent")
    thisalinea.textcontent.append("the physical ﬁrst hits. However, for a Monte Carlo simulation all interactions are")
    thisalinea.textcontent.append("known and such a comparison can be made. The idea of this comparison is outlined")
    thisalinea.textcontent.append("in Figure 7.7.")
    thisalinea.textcontent.append("Figure 7.7: Schematic overview of the neutron reconstruction procedure and the")
    thisalinea.textcontent.append("comparison procedure in the VETO analysis.")
    thisalinea.textcontent.append("To identify all incoming tracks, an imaginary box volume is created around NeuLAND")
    thisalinea.textcontent.append("and the VETO detector. This volume is called the primary volume and it extends")
    thisalinea.textcontent.append("5 cm beyond NeuLAND and, therefore, covers both detector volumes and the space")
    thisalinea.textcontent.append("between them.")
    thisalinea.textcontent.append("A straight line is computed from each Monte Carlo point in the entire experimental")
    thisalinea.textcontent.append("cave to its previous point, which is identiﬁed through the Geant4 or Geant3 MotherID")
    thisalinea.textcontent.append("[145]. If the Monte Carlo point is located inside the primary volume, but its previous")
    thisalinea.textcontent.append("point is located outside the primary volume, the particle track is identiﬁed as an")
    thisalinea.textcontent.append("incoming particle track to NeuLAND. The Monte Carlo point is in this case marked")
    thisalinea.textcontent.append("as the true ﬁrst hadronic interaction point of that track, and is referred to as the")
    thisalinea.textcontent.append("Monte Carlo ﬁrst hit. The previous point is in this case marked as the production")
    thisalinea.textcontent.append("point of the track. If both points are inside the primary volume, the track is not")
    thisalinea.textcontent.append("counted as an incoming track. If both points are outside, the track is only counted")
    thisalinea.textcontent.append("as incoming track if it passed through the primary volume.")
    thisalinea.textcontent.append("Since R3BRoot does not store Monte Carlo interaction points outside active volumes")
    thisalinea.textcontent.append("when no new particles are created, the method above will not correctly identify all")
    thisalinea.textcontent.append("incoming tracks for elastic collisions. In order to identify the missing incoming tracks,")
    thisalinea.textcontent.append("all Monte Carlo points stored in NeuLAND’s active volumes are traced back through")
    thisalinea.textcontent.append("their MotherID until they leave the primary volume. Our simulations show that with")
    thisalinea.textcontent.append("this addition, errors are reduced below 1%, which is negligible compared to the errors")
    thisalinea.textcontent.append("introduced by Kresan’s method.")
    thisalinea.textcontent.append("Once all incoming particle tracks per event have been identiﬁed, one can compare them")
    thisalinea.textcontent.append("to the reconstructed ﬁrst hits. Obviously, incoming background particles that are not")
    thisalinea.textcontent.append("detected can be ignored in this comparison, since those particles cannot contribute")
    thisalinea.textcontent.append("to any cluster and can, therefore, not spoil the neutron reconstruction. An incoming")
    thisalinea.textcontent.append("track is deﬁned as ‘detected’ if in at least one bar of NeuLAND, the Monte Carlo")
    thisalinea.textcontent.append("point with the smallest time index traces back to that incoming track through the")
    thisalinea.textcontent.append("MotherID. Incoming neutrons that are not detected should also be ignored in this")
    thisalinea.textcontent.append("comparison to correctly mimic the eﬀect that NeuLAND has an overall eﬃciency of")
    thisalinea.textcontent.append("about 95%, not 100% [126].")
    thisalinea.textcontent.append("To compare Monte Carlo ﬁrst hits with reconstructed ﬁrst hits, the Euclidean space-")
    thisalinea.textcontent.append("time distance (∆(cid:126)x)2 + c2(∆t)2 is computed for all possible pairs of Monte Carlo ﬁrst")
    thisalinea.textcontent.append("hits and reconstructed ﬁrst hits (our simulations show that c = ceﬀ = 14.0 m/s gives")
    thisalinea.textcontent.append("the best results). For the pair with the overall minimum distance, the reconstructed")
    thisalinea.textcontent.append("ﬁrst hit is linked to the corresponding incoming particle track. Next, the linked Monte")
    thisalinea.textcontent.append("Carlo ﬁrst hit (with incoming particle track) and the linked reconstructed ﬁrst hit are")
    thisalinea.textcontent.append("eliminated from the search process and one starts again to look for the overall mini-")
    thisalinea.textcontent.append("mum to provide another link. This linking process continues until one either runs out")
    thisalinea.textcontent.append("of incoming particle tracks, or out of reconstructed ﬁrst hits.")
    thisalinea.textcontent.append("As a ﬁnal remark, we wish to emphasize that a reconstructed ﬁrst hit is what one")
    thisalinea.textcontent.append("can measure. The comparison procedure in the VETO analysis tells us whether such")
    thisalinea.textcontent.append("a reconstructed ﬁrst hit corresponds to a neutron track (which is what we hope),")
    thisalinea.textcontent.append("or to another particle track (in which case it contributes to the background). If")
    thisalinea.textcontent.append("the reconstructed ﬁrst hit corresponds to a neutron track, it is also known from the")
    thisalinea.textcontent.append("comparison whether this neutron track has its production point at the target, or")
    thisalinea.textcontent.append("that its production point is somewhere else (in which case it also contributes to the")
    thisalinea.textcontent.append("background). It is now our goal in the upcoming sections to design and evaluate a")
    thisalinea.textcontent.append("VETO detector that can correctly identify these background contributions.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.4 Choice of the Geant4 Physics List"
    thisalinea.nativeID = 61
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "The Geant4 physics list used in the simulations to evaluate the performance of the VETO was constructed with a physics list builder [145]. The basis of this physics list is the Bertini cascade model and the quark gluon string model [146]. This model was chosen because the energy range of our simulations is between 0 and 1.5 GeV/u, the Super-FRS energy range [30]. The IonINCL++ module was added to our physics list to simulate the required nucleus-nucleus interactions [138, 146]. Furthermore, the Geant4 Low Energy QED module, the Geant4 particle decay module, the Geant4 Gamma-nuclear module [145] and the Geant4 "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The Geant4 physics list used in the simulations to evaluate the performance of the")
    thisalinea.textcontent.append("VETO was constructed with a physics list builder [145]. The basis of this physics")
    thisalinea.textcontent.append("list is the Bertini cascade model and the quark gluon string model [146]. This model")
    thisalinea.textcontent.append("was chosen because the energy range of our simulations is between 0 and 1.5 GeV/u,")
    thisalinea.textcontent.append("the Super-FRS energy range [30]. The IonINCL++ module was added to our physics")
    thisalinea.textcontent.append("list to simulate the required nucleus-nucleus interactions [138, 146]. Furthermore, the")
    thisalinea.textcontent.append("Geant4 Low Energy QED module, the Geant4 particle decay module, the Geant4")
    thisalinea.textcontent.append("Gamma-nuclear module [145] and the Geant4 module for elastic hadron collisions")
    thisalinea.textcontent.append("were added to provide as a complete physics list as possible for the R3B experiment.")
    thisalinea.textcontent.append("No benchmarks are available on how suitable this physics list is for the R3B experi-")
    thisalinea.textcontent.append("ment, since the R3B setup is still in its development phase [125]. Therefore, we chose")
    thisalinea.textcontent.append("to provide our own experimental veriﬁcation of this Geant4 physics list [135, 144] by")
    thisalinea.textcontent.append("benchmarking it against the S438 experiment.")
    thisalinea.textcontent.append("We chose the S438 experiment performed at GSI in April 2014 (discussed below) for")
    thisalinea.textcontent.append("our physics list veriﬁcation, since this is one of the very few experiments that can be")
    thisalinea.textcontent.append("simulated in R3BRoot and where a prototype of NeuLAND was used. No speciﬁc pa-")
    thisalinea.textcontent.append("pers have been published on this experiment, but the experiment is brieﬂy discussed")
    thisalinea.textcontent.append("in Ref. [147]. This experiment uses two diﬀerent setups: S438a and S438b. Both")
    thisalinea.textcontent.append("setups are slight variants of the old LAND-R3B setup with the detectors placed at")
    thisalinea.textcontent.append("diﬀerent positions. For our experimental veriﬁcation, we reconstructed both geome-")
    thisalinea.textcontent.append("tries in R3BRoot based on the technical drawings of the experiment. Our simulation")
    thisalinea.textcontent.append("geometry of S438a (S438b) is illustrated in Figure 7.8 (7.9).")
    thisalinea.textcontent.append("Figure 7.8: Overview of our simulation geometry in R3BRoot of the S438a setup.")
    thisalinea.textcontent.append("Figure 7.9: Overview of our simulation geometry in R3BRoot of the S438b setup.")
    thisalinea.textcontent.append("In the S438a setup, a 58Ni-beam of 700 MeV/u was impinged on a 6 mm thick lead")
    thisalinea.textcontent.append("target. In the S438b setup, a 48Ca-beam of 550 MeV/u was used with two diﬀerent")
    thisalinea.textcontent.append("targets (one at a time): a 2.2 g/cm2 lead target and a 4.4 mm thick carbon target.")
    thisalinea.textcontent.append("None of the targets were isotopically enriched.")
    thisalinea.textcontent.append("Experimental data on one million measured events were used for each of the three")
    thisalinea.textcontent.append("measurements discussed above. Our Geant4 physics list was used to simulate three")
    thisalinea.textcontent.append("million events per measurement to reduce statistical errors in the simulated data as")
    thisalinea.textcontent.append("much as possible. The simulation results were processed with the NeuLAND digi-")
    thisalinea.textcontent.append("tizer to compare them with the detector output of the NeuLAND prototype in the")
    thisalinea.textcontent.append("experiment.")
    thisalinea.textcontent.append("The comparison is made by creating a single histogram of 50 bins for a single Neu-")
    thisalinea.textcontent.append("LAND plane (which contains 50 bars). If a scintillator bar produced a signal within an")
    thisalinea.textcontent.append("event, a single count is added to the corresponding bin in the histogram. The counts")
    thisalinea.textcontent.append("of all 106 beam particles are collected in a single histogram [144], called content his-")
    thisalinea.textcontent.append("togram. The content histograms of the experimental data and of our simulated data")
    thisalinea.textcontent.append("are placed on top of each other with the proper normalization to verify our physics")
    thisalinea.textcontent.append("list.")
    thisalinea.textcontent.append("The veriﬁcation was done once with all data and once with the restriction that counts")
    thisalinea.textcontent.append("corresponding to a speciﬁc event are only added to the content histograms if the")
    thisalinea.textcontent.append("preceding NeuLAND plane gave no signal at all during that event. This restriction")
    thisalinea.textcontent.append("is called a Naive VETO condition, since charged particles will always be detected by")
    thisalinea.textcontent.append("both planes of the scintillators while neutrons have a reasonable probability to pass")
    thisalinea.textcontent.append("a scintillator without undergoing hadronic scattering [144]. In the S438a setup, the")
    thisalinea.textcontent.append("second NeuLAND plane was chosen for the veriﬁcation and the ﬁrst NeuLAND plane")
    thisalinea.textcontent.append("was used for the Naive VETO condition. However, in the S438b setup, the fourth")
    thisalinea.textcontent.append("NeuLAND plane was used for the veriﬁcation and the third one was used for the")
    thisalinea.textcontent.append("Naive VETO condition. This was done because no experimental data were available")
    thisalinea.textcontent.append("for the ﬁrst two NeuLAND planes in the S438b setup, since they were used at that")
    thisalinea.textcontent.append("time to test new electronics.")
    thisalinea.textcontent.append("Dividing the content histogram of the simulated data by 3 and placing the unnor-")
    thisalinea.textcontent.append("malized content histogram of the experimental data on top of it results in Figure")
    thisalinea.textcontent.append("7.10. The division by 3 is necessary because we simulated three times more beam")
    thisalinea.textcontent.append("particles than the available number of measured beam particles. The experimental")
    thisalinea.textcontent.append("results are shown as a red line histogram. Our simulations are shown in various colors")
    thisalinea.textcontent.append("to illustrate which type of particle caused the hit (determined by tracing back the hit")
    thisalinea.textcontent.append("though the Geant4 MotherID). The blue line histograms indicate previous simulation")
    thisalinea.textcontent.append("attempts with an outdated physics list (which was used in Ref. [147]).")
    thisalinea.textcontent.append("Figure 7.10: Comparison between the experimental data and our simulation by con-")
    thisalinea.textcontent.append("tent histograms with a normalization to the number of beam particles. The source of")
    thisalinea.textcontent.append("the experimental data is the S438 experiment [147].")
    thisalinea.textcontent.append("From Figure 7.10, it becomes evident that our simulation produces too few particles")
    thisalinea.textcontent.append("for the 58Ni reaction and too many particles for both 48Ca reactions. In order to")
    thisalinea.textcontent.append("circumvent this disagreement, we change the normalization of our simulated data.")
    thisalinea.textcontent.append("The new normalization is chosen in such a way that, without any VETO condition,")
    thisalinea.textcontent.append("our simulation matches the experimental data as well as possible. Subsequently, the")
    thisalinea.textcontent.append("same normalization factor is also used for the case where a Naive VETO condition")
    thisalinea.textcontent.append("was used. This new normalization is displayed in Figure 7.11. The outdated blue")
    thisalinea.textcontent.append("simulation in Figure 7.10 was also renormalized for comparison in Figure 7.11. We")
    thisalinea.textcontent.append("call this new normalization ‘normalization to the Unvetoed data’.")
    thisalinea.textcontent.append("Figure 7.11: Same as Figure 7.10, but now with the simulated data normalized to the")
    thisalinea.textcontent.append("experimental data (one normalization per reaction) [144].")
    thisalinea.textcontent.append("With the normalization to the Unvetoed data, it is clear from Figure 7.11 that for both")
    thisalinea.textcontent.append("also very good for the Naive VETO condition. Since only a single renormalization (per")
    thisalinea.textcontent.append("reaction) was used to accomplished this, one is forced to conclude that the production")
    thisalinea.textcontent.append("ratio between the charged and uncharged particles was simulated with reasonable")
    thisalinea.textcontent.append("accuracy [144]. For the 58Ni reaction, the agreement between our simulation and the")
    thisalinea.textcontent.append("experimental data is less good than for the other two reactions.")
    thisalinea.textcontent.append("The reason that it is so important to accurately simulate the production ratio of")
    thisalinea.textcontent.append("charged and uncharged particles is simply based on the following argument. In the")
    thisalinea.textcontent.append("hypothetical situation that only neutrons would enter NeuLAND’s volume, it would")
    thisalinea.textcontent.append("be better to have no VETO at all. In that case, the 2% neutron loss (see Section")
    thisalinea.textcontent.append("7.5) would be avoided. In another hypothetical situation where each event would")
    thisalinea.textcontent.append("contain both neutrons and charged particles, a VETO detector would obviously be")
    thisalinea.textcontent.append("required. A realistic situation is now always a superposition of these two hypothetical")
    thisalinea.textcontent.append("situations. The ratio of these two hypothetical situations is then determined by the")
    thisalinea.textcontent.append("production ratio of charged and uncharged particles. It is also the ratio between")
    thisalinea.textcontent.append("these two hypothetical situations that determines how useful a VETO detector is,")
    thisalinea.textcontent.append("and whether the 2% neutron loss outweighs the gain from utilizing a VETO detector.")
    thisalinea.textcontent.append("Figure 7.11 shows that, at least for both 48Ca reactions, the production ratio was")
    thisalinea.textcontent.append("simulated with reasonable accuracy, we conclude that our physics list can be used")
    thisalinea.textcontent.append("to evaluate the performance of the VETO detector in Section 7.6, if we use similar")
    thisalinea.textcontent.append("reactions for this.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.5 The Detector Design"
    thisalinea.nativeID = 62
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 4
    thisalinea.summary = "The design of the veto detector is based on a single wall of non-overlapping thin scintillator bars [135]. We will ﬁrst optimize this design and justify the choice for a scintillator wall it in the end of this section. As discussed in Section 7.2, the VETO detector should give a signal for each charged particle entering NeuLAND’s volume (see Figure 7.7) and should give no signal for neutrons [135, 144]. Therefore, it is easy to understand that the VETO scintillator wall should cover the entire front area of NeuLAND. To design the veto scintillator wall, we take inspiration from the "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The design of the veto detector is based on a single wall of non-overlapping thin")
    thisalinea.textcontent.append("scintillator bars [135]. We will ﬁrst optimize this design and justify the choice for a")
    thisalinea.textcontent.append("scintillator wall it in the end of this section.")
    thisalinea.textcontent.append("As discussed in Section 7.2, the VETO detector should give a signal for each charged")
    thisalinea.textcontent.append("particle entering NeuLAND’s volume (see Figure 7.7) and should give no signal for")
    thisalinea.textcontent.append("neutrons [135, 144]. Therefore, it is easy to understand that the VETO scintillator")
    thisalinea.textcontent.append("wall should cover the entire front area of NeuLAND.")
    thisalinea.textcontent.append("To design the veto scintillator wall, we take inspiration from the VETO geometry of")
    thisalinea.textcontent.append("the NeuLAND demonstrator at the SAMURAI setup [129]. This VETO geometry")
    thisalinea.textcontent.append("is composed of 8 slightly overlapping vertically oriented scintillator bars with the")
    thisalinea.textcontent.append("dimensions of 190 cm × 32 cm × 1.0 cm [130]. This VETO wall was placed 33 cm in")
    thisalinea.textcontent.append("front of the NeuLAND demonstrator [147].")
    thisalinea.textcontent.append("To make this geometry consistent with our initial assumptions, we slightly change this")
    thisalinea.textcontent.append("geometry to a wall of 8 non-overlapping vertically-oriented bars with the dimensions")
    thisalinea.textcontent.append("of 250 cm × 31.25 cm × 1.2 cm as the starting point for our optimizations. Just like")
    thisalinea.textcontent.append("for the NeuLAND geometry, the outer 1 mm layer of each bar is modeled as aluminum")
    thisalinea.textcontent.append("foil, tape and air (see Section 7.3). This causes the pure scintillator elements to have")
    thisalinea.textcontent.append("dimensions of 249.8 cm × 31.05 cm × 1.0 cm.")
    thisalinea.textcontent.append("The VETO detector response in our simulations is calculated with the same digitizer")
    thisalinea.textcontent.append("as for NeuLAND (see Section 7.3). To account for the fact that a thinner scintillator")
    thisalinea.textcontent.append("usually gives a worse time resolution, the VETO time resolution was assumed to be")
    thisalinea.textcontent.append("σ = 300 ps in the digitizer.")
    thisalinea.textcontent.append("The parameters that should be optimized in the design are the scintillator thickness,")
    thisalinea.textcontent.append("the total number of bars in the wall and the distance of the wall to the front of")
    thisalinea.textcontent.append("NeuLAND. These parameters will be optimized one at a time [135].")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "7.5.1 The optimal distance between the VETO and NeuLAND"
    thisalinea.nativeID = 63
    thisalinea.parentID = 62
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "The ﬁrst parameter that was optimized is the distance between the VETO wall and NeuLAND. If the wall is too far away from NeuLAND, charged particles may cir- cumvent it. However, if the VETO is too close to NeuLAND, back-scattered charged particles from an interaction between NeuLAND and a neutron might ﬁre the VETO detector. This will in turn cause the neutron to be wrongly eliminated. To ﬁnd the optimal distance, particles with an energy of 1000 ± 1 MeV were ﬁred onto NeuLAND for diﬀerent VETO-detector distances according to the procedure of Figure 7.3. We simulated 25000 events per "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The ﬁrst parameter that was optimized is the distance between the VETO wall and")
    thisalinea.textcontent.append("NeuLAND. If the wall is too far away from NeuLAND, charged particles may cir-")
    thisalinea.textcontent.append("cumvent it. However, if the VETO is too close to NeuLAND, back-scattered charged")
    thisalinea.textcontent.append("particles from an interaction between NeuLAND and a neutron might ﬁre the VETO")
    thisalinea.textcontent.append("detector. This will in turn cause the neutron to be wrongly eliminated.")
    thisalinea.textcontent.append("To ﬁnd the optimal distance, particles with an energy of 1000 ± 1 MeV were ﬁred")
    thisalinea.textcontent.append("onto NeuLAND for diﬀerent VETO-detector distances according to the procedure")
    thisalinea.textcontent.append("of Figure 7.3. We simulated 25000 events per run and 1 particle per event. The")
    thisalinea.textcontent.append("percentage of these events that ﬁred at least one bar in the VETO wall were plotted")
    thisalinea.textcontent.append("against the diﬀerent VETO distances. These plots are presented in Figure 7.12 for")
    thisalinea.textcontent.append("diﬀerent particle types.")
    thisalinea.textcontent.append("Figure 7.12: Simulation results for diﬀerent the VETO-wall distances to NeuLAND;")
    thisalinea.textcontent.append("ﬁgure used with permission [135]. For the explanation of the curves, see the text.")
    thisalinea.textcontent.append("The black curves in Figure 7.12 show all events where the VETO ﬁred. The red")
    thisalinea.textcontent.append("curves show the fraction of events where the VETO wall ﬁred due to backscattered")
    thisalinea.textcontent.append("particles. This information was obtained by tracking the Monte Carlo hit-points in")
    thisalinea.textcontent.append("the VETO wall back to the origin of the particle gun through the MotherID [145].")
    thisalinea.textcontent.append("If at least one of those tracks went through the volume of NeuLAND, the event is")
    thisalinea.textcontent.append("said to contain back-scattering and it contributes to the red curves. The gray curves")
    thisalinea.textcontent.append("show the diﬀerence between the black and red curves. The green curves present the")
    thisalinea.textcontent.append("fraction of events that ﬁred the VETO wall and where at least one Monte Carlo point")
    thisalinea.textcontent.append("has a time index smaller than the smallest time index of all NeuLAND Monte Carlo")
    thisalinea.textcontent.append("points. The blue curves show the fraction of events where the VETO wall ﬁred and")
    thisalinea.textcontent.append("the VETO-wall Time of Flight (from the digitizer) is smaller than the NeuLAND")
    thisalinea.textcontent.append("time of ﬂight (from the digitizer). The turquoise curves are a coincidence of events")
    thisalinea.textcontent.append("residing in the blue and the gray curves. The violet curves are a coincidence of events")
    thisalinea.textcontent.append("residing in the gray and the green curves.")
    thisalinea.textcontent.append("We would like to emphasize that the energy threshold was lowered from 1 MeV depo-")
    thisalinea.textcontent.append("sition to 160 keV deposition during the simulations of Figure 7.12. The reason for this")
    thisalinea.textcontent.append("is that we would like to ﬁnd an optimal distance independent of the energy threshold.")
    thisalinea.textcontent.append("Therefore, an extremely low energy threshold of 160 keV was selected as a worst-case")
    thisalinea.textcontent.append("scenario. If we can ﬁnd an optimal distance for this threshold with good results, it")
    thisalinea.textcontent.append("will also provide good results for any higher threshold (since back-scattering is less of")
    thisalinea.textcontent.append("a problem with a higher threshold).")
    thisalinea.textcontent.append("It is clear from Figure 7.12 that the VETO wall responds in nearly 100% of all charged")
    thisalinea.textcontent.append("particle events, as it should. However, in 5% − 7% of all neutron events, the VETO")
    thisalinea.textcontent.append("wall also ﬁres. Since one of the design goals of NeuLAND is to eﬃciently detect")
    thisalinea.textcontent.append("multiple neutrons at the same time [126], this percentage is too high. If 5% − 7% of")
    thisalinea.textcontent.append("all neutrons were blocked by the VETO wall during, say, a tetra neutron experiment")
    thisalinea.textcontent.append("[148], such a 4 neutron event would only come clean through the VETO wall in")
    thisalinea.textcontent.append("75% − 81% of the cases. Such percentages might seem reasonable, but one has to")
    thisalinea.textcontent.append("consider that on top of this eﬃciency, the event would only be assigned the correct")
    thisalinea.textcontent.append("multiplicity in about 60% of the events (see Figure 7.6 and Ref. [126]). This would")
    thisalinea.textcontent.append("result in an overall detection eﬃciency below 50%. Such eﬃciencies are undesirable")
    thisalinea.textcontent.append("for very rare events like a tetra neutron [148].")
    thisalinea.textcontent.append("Hence, we propose to only veto those events where the VETO wall ﬁred before Neu-")
    thisalinea.textcontent.append("LAND. We call this a Time-of-Flight VETO condition (TOF VETO condition). This")
    thisalinea.textcontent.append("corresponds to the blue curves in Figure 7.12. The turquoise curve is the fraction of")
    thisalinea.textcontent.append("the blue curve where the VETO signal is not the result from back-scattering. From")
    thisalinea.textcontent.append("Figure 7.12a, it is clear that, at suﬃcient distance, this condition correctly picks out")
    thisalinea.textcontent.append("those few events where the neutron itself interacted with the VETO and eﬀectively")
    thisalinea.textcontent.append("ignores the back-scattering events. Figures 7.12b, 7.12c and 7.12d show that this")
    thisalinea.textcontent.append("condition requires a distance between the VETO and NeuLAND of at least 30 cm in")
    thisalinea.textcontent.append("order to still detect all charged particles.")
    thisalinea.textcontent.append("The 2% of neutron events that are still eliminated with this condition cannot be")
    thisalinea.textcontent.append("avoided, since the VETO detector must have a certain thickness. This thickness will")
    thisalinea.textcontent.append("always result in a ﬁnite probability for the neutron to undergo a hadron collision")
    thisalinea.textcontent.append("within the VETO detector.")
    thisalinea.textcontent.append("The fact that below 30 cm not all charged particles can be detected is due to the")
    thisalinea.textcontent.append("overlapping time resolutions of NeuLAND and the VETO. At those distances, the")
    thisalinea.textcontent.append("time resolutions are not good enough to distinguish between a back-scattering and a")
    thisalinea.textcontent.append("real primary interaction. Hence, the VETO wall will mistake some charged particles")
    thisalinea.textcontent.append("for back-scattering events. It is important to note that when we are dealing with")
    thisalinea.textcontent.append("lower-energy particles than the 1000 MeV of Figure 7.12, the time resolutions will")
    thisalinea.textcontent.append("have less overlap. Hence, the distance of 30 cm will work for all energies below")
    thisalinea.textcontent.append("1000 MeV as well.")
    thisalinea.textcontent.append("Therefore, we conclude that with a typical time resolution of 300 ps, the ideal distance")
    thisalinea.textcontent.append("between NeuLAND and the VETO wall would be 30 cm [135].")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "7.5.2 The optimal bar thickness"
    thisalinea.nativeID = 64
    thisalinea.parentID = 62
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "The second parameter that was optimized was the thickness of the scintillator bars. From the previous discussion, it is evident that the VETO wall should be as thin as possible under the restriction that it can detect all charged particles. In order to ﬁnd this thickness, 1000 MeV protons and electrons were ﬁred onto NeuLAND for diﬀerent VETO-wall thickness according to the procedure of Figure 7.3. We simulated 25000 events per run and 1 particle per event. The results are displayed in Figure 7.13. Figure 7.13: Simulation results for varying the VETO-wall thickness; ﬁgure used with permission [135]. Figure 7.13 "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The second parameter that was optimized was the thickness of the scintillator bars.")
    thisalinea.textcontent.append("From the previous discussion, it is evident that the VETO wall should be as thin as")
    thisalinea.textcontent.append("possible under the restriction that it can detect all charged particles. In order to ﬁnd")
    thisalinea.textcontent.append("this thickness, 1000 MeV protons and electrons were ﬁred onto NeuLAND for diﬀerent")
    thisalinea.textcontent.append("VETO-wall thickness according to the procedure of Figure 7.3. We simulated 25000")
    thisalinea.textcontent.append("events per run and 1 particle per event. The results are displayed in Figure 7.13.")
    thisalinea.textcontent.append("Figure 7.13: Simulation results for varying the VETO-wall thickness; ﬁgure used with")
    thisalinea.textcontent.append("permission [135].")
    thisalinea.textcontent.append("Figure 7.13 shows that the smallest thickness that can detect all charged particles is")
    thisalinea.textcontent.append("1.3 cm. We would like to emphasize that the total thickness of the scintillation bar,")
    thisalinea.textcontent.append("including tape and aluminum reﬂective foil, is plotted on the x-axis in Figure 7.13.")
    thisalinea.textcontent.append("Hence, the active scintillator thickness is always 2 mm less than the total thickness.")
    thisalinea.textcontent.append("According to the Bethe-Bloch energy loss formula, Eloss ∝ Z 2. So, if 1.3 cm works")
    thisalinea.textcontent.append("for the simulated Z = 1 particles in Figure 7.13, the same thickness will also work for")
    thisalinea.textcontent.append("any ion. The ion simply deposits more energy than the proton or electron, and will,")
    thisalinea.textcontent.append("therefore, give a larger signal.")
    thisalinea.textcontent.append("Again, according to the Bethe-Bloch formula, Eloss ∝ 1/β2 and, the obtained thick-")
    thisalinea.textcontent.append("ness will, therefore, also work for any particle with a smaller kinetic energy than")
    thisalinea.textcontent.append("1000 MeV.")
    thisalinea.textcontent.append("In short, a thickness of 1.3 cm is the optimal VETO-detector thickness. This corre-")
    thisalinea.textcontent.append("sponds to an active scintillator thickness of 1.1 cm [135].")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "7.5.3 The optimal number of scintillator bars"
    thisalinea.nativeID = 65
    thisalinea.parentID = 62
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 2
    thisalinea.summary = "The last parameter that was optimized is the number of individual scintillator bars in the VETO wall. For this parameter, it is important to notice that for single parti- cle events, 30 cm distance, 1.1 cm active scintillator thickness and a TOF condition already give a nearly perfect result. We discussed that the remaining elimination of 2% of the neutrons is unavoidable. Our simulations also show that this result (for simulations of 1 particle per event) is almost independent of the number of bars in the VETO wall. This was shown by repeating the simulations of Figure 7.12a for diﬀerent "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("The last parameter that was optimized is the number of individual scintillator bars")
    thisalinea.textcontent.append("in the VETO wall. For this parameter, it is important to notice that for single parti-")
    thisalinea.textcontent.append("cle events, 30 cm distance, 1.1 cm active scintillator thickness and a TOF condition")
    thisalinea.textcontent.append("already give a nearly perfect result. We discussed that the remaining elimination of")
    thisalinea.textcontent.append("2% of the neutrons is unavoidable. Our simulations also show that this result (for")
    thisalinea.textcontent.append("simulations of 1 particle per event) is almost independent of the number of bars in")
    thisalinea.textcontent.append("the VETO wall. This was shown by repeating the simulations of Figure 7.12a for")
    thisalinea.textcontent.append("diﬀerent numbers of bars.")
    thisalinea.textcontent.append("Therefore, the optimal number of bars should be obtained by simulating more than")
    thisalinea.textcontent.append("1 particle per event. The simplest situation with multiple particles is to ﬁre 1 proton")
    thisalinea.textcontent.append("and 1 neutron onto NeuLAND in coincidence. Such a simple case is preferred for")
    thisalinea.textcontent.append("optimization problems so that the results are well understood.")
    thisalinea.textcontent.append("Our task is now to use the VETO detector to disentangle the proton and the neutron")
    thisalinea.textcontent.append("signals and to eliminate the proton while keeping the neutron. We chose to simu-")
    thisalinea.textcontent.append("late the worst-case scenario where the particles have identical energy and identical")
    thisalinea.textcontent.append("arrival times. This means that the spatial coordinates of the interactions are the only")
    thisalinea.textcontent.append("parameters with which we can distinguish them.")
    thisalinea.textcontent.append("However, before the number of bars can be optimized, another problem needs to be")
    thisalinea.textcontent.append("solved ﬁrst. For a proton and a neutron in coincidence, vetoing entire events cannot")
    thisalinea.textcontent.append("be used to disentangle the proton and the neutron. Therefore, some part of the")
    thisalinea.textcontent.append("data within one event has to be vetoed and another part of the data has to be kept.")
    thisalinea.textcontent.append("Combining this knowledge with Figure 7.2 now highlights our problem: at which level")
    thisalinea.textcontent.append("in the diagram should we veto a part of the data? In order to answer this question,")
    thisalinea.textcontent.append("three simple VETO conditions were designed and tested against each other. For this")
    thisalinea.textcontent.append("test, a reference VETO detector of 16 bars was used. The test was performed with")
    thisalinea.textcontent.append("1000 ± 1 MeV protons and neutrons and with 25000 events per run.")
    thisalinea.textcontent.append("The ﬁrst condition that was tested is the bar condition: the spatial coordinates of all")
    thisalinea.textcontent.append("NeuLAND and VETO hit-points (as reconstructed by the digitizer) are projected onto")
    thisalinea.textcontent.append("the xy-plane (see Figure 7.3) and a NeuLAND hit-point is eliminated if its distance")
    thisalinea.textcontent.append("to a VETO hit-point in this xy-plane is smaller than 25.5 cm. To account for the")
    thisalinea.textcontent.append("back-scattering, only NeuLAND hit-points with a time index larger than the time")
    thisalinea.textcontent.append("index of the VETO hit-point are eliminated. To evaluate the result of this VETO")
    thisalinea.textcontent.append("condition, all uneliminated hit-points are traced back to one of the incoming particle")
    thisalinea.textcontent.append("tracks through the Geant4 MotherID in the same way as discussed in Section 7.4.")
    thisalinea.textcontent.append("Next, all deposited energy per hit-point is accumulated per incoming particle track.")
    thisalinea.textcontent.append("If the particle track has an energy deposition below 185 MeV, it is vetoed. The values")
    thisalinea.textcontent.append("of 25.5 cm and 185 MeV were optimized to keep as many neutrons as possible while")
    thisalinea.textcontent.append("vetoing as many protons as possible at the same time.")
    thisalinea.textcontent.append("Obviously, this bar condition can never be applied in practice, since it requires the")
    thisalinea.textcontent.append("Geant4 MotherID information. However, for the purpose of determining at which")
    thisalinea.textcontent.append("level in Figure 7.2 a VETO condition is most beneﬁcial, it can be used.")
    thisalinea.textcontent.append("The second VETO condition that was tested, is the cluster condition. The cluster")
    thisalinea.textcontent.append("condition is applied in the same way as the bar condition, except that it operates on")
    thisalinea.textcontent.append("clusters instead of individual hit-points. Hence, the hit-point in the cluster with the")
    thisalinea.textcontent.append("smallest time index is now used to determine the fate of the entire cluster.")
    thisalinea.textcontent.append("The third condition that was tested is the tracker condition. The tracker condition")
    thisalinea.textcontent.append("constructs lines between the target and all reconstructed ﬁrst hits. The reconstructed")
    thisalinea.textcontent.append("hit with its line passing closest to the VETO hit-point, is eliminated. This process is")
    thisalinea.textcontent.append("then repeated for all VETO signals. To account for the back-scattering problem, the")
    thisalinea.textcontent.append("closest reconstructed ﬁrst hit (in NeuLAND) is only vetoed if its time index is larger")
    thisalinea.textcontent.append("than the time index of the VETO hit-point. Otherwise, no reconstructed ﬁrst hit is")
    thisalinea.textcontent.append("vetoed for that VETO hit-point.")
    thisalinea.textcontent.append("The results for the three conditions are shown in Table 7.1. The number of fully")
    thisalinea.textcontent.append("reconstructed events in Table 7.1 is the number of events where the total number")
    thisalinea.textcontent.append("of reconstructed hits is equal to two (one proton and one neutron) and where the")
    thisalinea.textcontent.append("neutron is kept and the proton is vetoed.")
    thisalinea.textcontent.append("Table 7.1: Comparison between diﬀerent VETO conditions. The simulations were")
    thisalinea.textcontent.append("done with 1000 ± 1 MeV particles.")
    thisalinea.textcontent.append("Comparison Bar condition Cluster condition Tracker condition")
    thisalinea.textcontent.append("% vetoed protons 84.8% 83.7% 88.2%")
    thisalinea.textcontent.append("% vetoed neutrons 31.2% 20.3% 5.7%")
    thisalinea.textcontent.append("% Fully reconstructed events 42.5% 50.8% 67.8%")
    thisalinea.textcontent.append("From Table 7.1, we conclude that the tracker VETO condition is the best solution.")
    thisalinea.textcontent.append("Since for the situation of Table 7.1, the correct multiplicity of two can only be as-")
    thisalinea.textcontent.append("signed 72% of the time, an overall success rate of 67.8% is actually a very good result.")
    thisalinea.textcontent.append("Moreover, since the tracker condition does not use information like the Geant4 Moth-")
    thisalinea.textcontent.append("erID, it can be applied in real experiments without further modiﬁcations. Therefore,")
    thisalinea.textcontent.append("we chose to use this condition in the remainder of this Chapter.")
    thisalinea.textcontent.append("One important reﬁnement was added to the tracker VETO condition. A diﬀerent")
    thisalinea.textcontent.append("picture like Figure 7.6 (up to 5 neutrons) was computed for each number of VETO")
    thisalinea.textcontent.append("signals to determine the neutron multiplicity. A proton was added for each VETO")
    thisalinea.textcontent.append("signal to the simulations of Figure 7.6. For the results in this section, this proton was")
    thisalinea.textcontent.append("simulated at the same energy as the neutrons, but in Section 7.6, it was simulated")
    thisalinea.textcontent.append("at half of the neutron energy to account for the fact that the protons typically come")
    thisalinea.textcontent.append("from secondary scatterings while the neutrons of interest do not.")
    thisalinea.textcontent.append("We also would like to emphasize that this method for determining multiplicities as-")
    thisalinea.textcontent.append("sumes each charged particle to be a proton. Obviously, this is not the case in a realistic")
    thisalinea.textcontent.append("situation. However, a simple VETO detector like the one we are discussing cannot")
    thisalinea.textcontent.append("identify diﬀerent types of background charged particles. Therefore, an assumption")
    thisalinea.textcontent.append("has to be made on the type of background particles and our simulations show that")
    thisalinea.textcontent.append("most particles of the charged-particle background are protons.")
    thisalinea.textcontent.append("Having established the tracker VETO condition as our preferred method of separating")
    thisalinea.textcontent.append("the proton and the neutron, the optimal number of scintillator bars in the VETO")
    thisalinea.textcontent.append("wall can now be determined. As discussed before, 1 proton and 1 neutron will be")
    thisalinea.textcontent.append("ﬁred in coincidence onto NeuLAND and the VETO wall to optimize the number")
    thisalinea.textcontent.append("of bars. During the ﬁrst run, 25000 events were simulated for a VETO wall that")
    thisalinea.textcontent.append("consisted of a single 2.5 m × 2.5 m scintillator with a photomultiplier on the top and")
    thisalinea.textcontent.append("bottom. After every successive run, the number of bars was doubled until we reached")
    thisalinea.textcontent.append("256 bars of roughly 1 cm width. The simulation is performed for 3 characteristic")
    thisalinea.textcontent.append("energies of 200 ± 1 MeV, 600 ± 1 MeV and 1000 ± 1 MeV. The results are displayed")
    thisalinea.textcontent.append("in Figure 7.14, which shows that the best results are achieved for 16 bars, although")
    thisalinea.textcontent.append("the distributions are rather ﬂat around this number. Our simulations also show that")
    thisalinea.textcontent.append("for higher neutron multiplicities, 16 bars also provides a good separation between")
    thisalinea.textcontent.append("neutrons and protons.")
    thisalinea.textcontent.append("To the left of the optima in Figure 7.14, eﬃciencies are decreasing because the hor-")
    thisalinea.textcontent.append("izontal position of the proton is known with insuﬃcient accuracy to disentangle it")
    thisalinea.textcontent.append("from the neutron. However, to the right of the optima, the position of the proton is")
    thisalinea.textcontent.append("known more accurately. However, between each two neighbouring bars there is tape,")
    thisalinea.textcontent.append("reﬂective foil and mechanical imperfections. Therefore, there is a small gap between")
    thisalinea.textcontent.append("the active scintillators. Hence, a proton ﬂying through one of these gaps will not be")
    thisalinea.textcontent.append("detected. Having a VETO with a lot of distinct non-overlapping bars causes necessar-")
    thisalinea.textcontent.append("ily a lot of gaps between the bars. This causes the detection eﬃciency of the proton")
    thisalinea.textcontent.append("to drop at the right of the optima.")
    thisalinea.textcontent.append("Figure 7.14: Simulations for the optimization of the number of bars in the VETO")
    thisalinea.textcontent.append("detector; ﬁgure based on Ref. [135]")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 3
    thisalinea.texttitle = "7.5.4 Other options for a VETO detector"
    thisalinea.nativeID = 66
    thisalinea.parentID = 62
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 3
    thisalinea.summary = "In this section, we will discuss why we chose to design our VETO detector as a single wall of non-overlapping thin scintillators. It was shown in Subsection 7.5.1 that a time resolution for the VETO detector of σ = 300 ps and a distance between NeuLAND and the VETO detector of 30 cm are required to accurately distinguish back-scattering from incoming particles. This distinction could, in theory, also be made with a worse time resolution, but that would require a larger distance between NeuLAND and the VETO wall. However, such a large distance is unacceptable, be- cause this would allow "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this section, we will discuss why we chose to design our VETO detector as a")
    thisalinea.textcontent.append("single wall of non-overlapping thin scintillators. It was shown in Subsection 7.5.1")
    thisalinea.textcontent.append("that a time resolution for the VETO detector of σ = 300 ps and a distance between")
    thisalinea.textcontent.append("NeuLAND and the VETO detector of 30 cm are required to accurately distinguish")
    thisalinea.textcontent.append("back-scattering from incoming particles. This distinction could, in theory, also be")
    thisalinea.textcontent.append("made with a worse time resolution, but that would require a larger distance between")
    thisalinea.textcontent.append("NeuLAND and the VETO wall. However, such a large distance is unacceptable, be-")
    thisalinea.textcontent.append("cause this would allow a lot of charged particles produced by secondary scatterings")
    thisalinea.textcontent.append("with the beam to enter NeuLAND through its front side without hitting the VETO")
    thisalinea.textcontent.append("detector. Hence, a time resolution in the order of 300 ps is required for the VETO")
    thisalinea.textcontent.append("detector. Such Time resolutions can only be achieved by scintillators or by the Multi-")
    thisalinea.textcontent.append("wire Resistive Plate Chamber (MRPC) technology [149]. This limits our options for")
    thisalinea.textcontent.append("the VETO detector to a scintillator wall or an MRPC wall [135].")
    thisalinea.textcontent.append("The full surface density of our designed scintillator wall is about 1.31 g/cm2 (when")
    thisalinea.textcontent.append("the VETO wall is built from BC408, like NeuLAND). This surface density causes")
    thisalinea.textcontent.append("about 2% of all neutrons to be detected by the VETO detector. However, in order")
    thisalinea.textcontent.append("to obtain the required time resolution, granularity and eﬃciency (about 100% for")
    thisalinea.textcontent.append("charged particles), a VETO MRPC wall would have to be constructed of multiple")
    thisalinea.textcontent.append("gaps or sub-gaps (see Ref. [150] and references therein). The cathode and anode")
    thisalinea.textcontent.append("planes of these gaps would then all act as converter material for the neutrons [149].")
    thisalinea.textcontent.append("Since these cathode and anode planes would have to be built from glass or plastic")
    thisalinea.textcontent.append("[151], the total surface density of the entire VETO MRPC wall would be bigger than")
    thisalinea.textcontent.append("the 1.31 g/cm2 we obtained with our scintillator wall. Therefore, a VETO MRPC")
    thisalinea.textcontent.append("wall would cause more than 2% of all neutrons to convert [135]. This is unacceptable")
    thisalinea.textcontent.append("for the multi neutron detection of NeuLAND. Hence, the MRPC technology is ruled")
    thisalinea.textcontent.append("out as an option for the VETO wall.")
    thisalinea.textcontent.append("The same argument can also be used to show why the scintillators of the VETO wall")
    thisalinea.textcontent.append("should not overlap. If the scintillator bars would overlap, the VETO wall would be")
    thisalinea.textcontent.append("twice as thick in the overlapping regions, providing a double probability for neutrons")
    thisalinea.textcontent.append("to be detected by the VETO detector there, which is is unacceptable for multi neutron")
    thisalinea.textcontent.append("detection. On the other hand, the gaps between the scintillator bars in our VETO")
    thisalinea.textcontent.append("detector provide only a small drop in overall eﬃciency. Since the tracker VETO con-")
    thisalinea.textcontent.append("dition had a success rate of 67.8% in Subsection 7.5.3, while the maximum success")
    thisalinea.textcontent.append("rate was 72%, we conclude that VETO eﬃciency drops due to gaps must be small.")
    thisalinea.textcontent.append("The diﬀerence between 72% and 67.8% contains a contribution of 2% of accidentally")
    thisalinea.textcontent.append("eliminated neutrons (see Figure 7.12a), a contribution from the gaps and a contribu-")
    thisalinea.textcontent.append("tion from misidentifying the proton. Hence, the contribution from the gaps must be")
    thisalinea.textcontent.append("below 2.2%.")
    thisalinea.textcontent.append("Hence, the VETO detector should be designed as a single 2.5 m × 2.5 m wall of thin")
    thisalinea.textcontent.append("non-overlapping scintillators (preferably made from BC408) with an active scintillator")
    thisalinea.textcontent.append("thickness of 1.1 cm and a distance to NeuLAND of 30 cm. The wall should consist of")
    thisalinea.textcontent.append("16 distinct scintillators with a time resolution better than σ = 300 ps and an energy")
    thisalinea.textcontent.append("deposition threshold of 1 MeV.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.6 Eﬃciency of the VETO detector"
    thisalinea.nativeID = 67
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 5
    thisalinea.summary = "In this section, the eﬃciency of the VETO designed in Section 7.5 will be evaluated for some realistic situations. The simulations will be performed according to Figure 7.4 with the Geant4 physics list discussed in Section 7.4. The reaction of a 48Ca- beam on a 4.4 mm thick carbon target was selected, because for this case our physics list has proven to simulate the production ratio of charged and unchanged particles with reasonable accuracy. Moreover, this reaction produces a lot of target neutrons. Hence, less CPU time is needed to gather enough statistics. We simulated one million events. A slightly "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("In this section, the eﬃciency of the VETO designed in Section 7.5 will be evaluated")
    thisalinea.textcontent.append("for some realistic situations. The simulations will be performed according to Figure")
    thisalinea.textcontent.append("7.4 with the Geant4 physics list discussed in Section 7.4. The reaction of a 48Ca-")
    thisalinea.textcontent.append("beam on a 4.4 mm thick carbon target was selected, because for this case our physics")
    thisalinea.textcontent.append("list has proven to simulate the production ratio of charged and unchanged particles")
    thisalinea.textcontent.append("with reasonable accuracy. Moreover, this reaction produces a lot of target neutrons.")
    thisalinea.textcontent.append("Hence, less CPU time is needed to gather enough statistics. We simulated one million")
    thisalinea.textcontent.append("events. A slightly higher beam energy of 600 ± 1 MeV/u was selected instead of the")
    thisalinea.textcontent.append("550 ± 1 MeV/u in Section 7.4 to make the simulation results of this section suitable")
    thisalinea.textcontent.append("for comparison with Ref. [126]. In the remainder of this section, we will refer to this")
    thisalinea.textcontent.append("reaction as the Ca48C-reaction.")
    thisalinea.textcontent.append("When the simulation is performed for the Ca48C-reaction, a huge neutron background")
    thisalinea.textcontent.append("is observed. The x and z coordinates of the production points of all Monte Carlo")
    thisalinea.textcontent.append("neutrons tracks entering NeuLAND’s primary volume are plotted in Figure 7.15.")
    thisalinea.textcontent.append("Figure 7.15: x and z coordinates of the production points of the Monte Carlo neutron")
    thisalinea.textcontent.append("tracks in the Ca48C-reaction.")
    thisalinea.textcontent.append("From Figure 7.15, it is clear that there are a lot of neutron tracks that are not pro-")
    thisalinea.textcontent.append("duced at the target. Since we are not interested in these neutron tracks, some method")
    thisalinea.textcontent.append("is required to eliminate these neutrons. Without such a method, the performance of")
    thisalinea.textcontent.append("NeuLAND will not be good, regardless of the use of the VETO detector. There-")
    thisalinea.textcontent.append("fore, the VETO-detector eﬃciency cannot be evaluated without ﬁrst eliminating the")
    thisalinea.textcontent.append("neutron background [144].")
    thisalinea.textcontent.append("To eliminate the neutron background, we propose to apply time cuts [135, 144, 152]: to")
    thisalinea.textcontent.append("only use those hit-points that have their hit time between two pre-speciﬁed boundaries")
    thisalinea.textcontent.append("in the consecutive analysis of Figure 7.2. For a beam energy of 600 MeV/u, the")
    thisalinea.textcontent.append("preferred boundaries are 52 ns and 72 ns after the target collision. This is because")
    thisalinea.textcontent.append("NeuLAND will usually be used to detect neutrons with energies close to the beam")
    thisalinea.textcontent.append("energy [126]. Since a neutron with exactly the beam energy will need 59 ns to reach")
    thisalinea.textcontent.append("NeuLAND, these boundaries seem reasonable. Figure 7.16 shows the number of counts")
    thisalinea.textcontent.append("versus the hit time of the Monte Carlo ﬁrst hits in NeuLAND for the Ca48C-reaction.")
    thisalinea.textcontent.append("Our simulations show that a more narrow time window than indicated in Figure 7.16")
    thisalinea.textcontent.append("will cut out some neutrons from the target. This is unacceptable for the multi-neutron")
    thisalinea.textcontent.append("detection of NeuLAND.")
    thisalinea.textcontent.append("Figure 7.16: Arrival times of the Monte Carlo ﬁrst hits with respect to the generation")
    thisalinea.textcontent.append("time of the beam particles (4 m before the target) in the Ca48C-reaction.")
    thisalinea.textcontent.append("Figure 7.17: Same as Figure 7.15, but with the time cuts shown in Figure 7.16 applied")
    thisalinea.textcontent.append("[144].")
    thisalinea.textcontent.append("Upon applying these time boundaries to the events shown in Figure 7.15, one would")
    thisalinea.textcontent.append("end up with events shown in Figure 7.17. From these two ﬁgures, it is clear that")
    thisalinea.textcontent.append("the time cuts of Figure 7.16 signiﬁcantly reduce the neutron background. The total")
    thisalinea.textcontent.append("reduction in number of tracks is a factor 3.7 [144, 152].")
    thisalinea.textcontent.append("Figures 7.18 and 7.19 show that these time cuts can also be used to reduce the amount")
    thisalinea.textcontent.append("of charged particles entering NeuLAND from the side. The total reduction in number")
    thisalinea.textcontent.append("of charged tracks is a factor of 5.7 [144, 152].")
    thisalinea.textcontent.append("Figure 7.18: x and z coordinates of the production points of the Monte Carlo charged-")
    thisalinea.textcontent.append("particle tracks in the Ca48C-reaction.")
    thisalinea.textcontent.append("Figure 7.19 also shows that there are still some charged particles left from the target")
    thisalinea.textcontent.append("region and from the end of the scattering chamber. The full simulation results, includ-")
    thisalinea.textcontent.append("ing the neutron reconstruction, the comparison procedure of Section 7.3, the tracker")
    thisalinea.textcontent.append("VETO condition and the time cuts are listed in Table 7.2 for the Ca48C-reaction.")
    thisalinea.textcontent.append("The ‘Mult.’-column in Table 7.2 is the neutron multiplicity, which is equivalent to")
    thisalinea.textcontent.append("the number of reconstructed ﬁrst hits that are not vetoed. The ‘Observed’-column")
    thisalinea.textcontent.append("is the number of events in the simulation for which we detected a certain neutron")
    thisalinea.textcontent.append("multiplicity. The ‘Cont.’-Column is the fraction of events that were counted in the")
    thisalinea.textcontent.append("‘Total’-column where at least one charged-particle track was detected by NeuLAND")
    thisalinea.textcontent.append("(that the track triggered at least one scintillator of NeuLAND). The abbreviation")
    thisalinea.textcontent.append("‘Cont.’ means ‘contaminated with charged-particle tracks’ and this column is shown")
    thisalinea.textcontent.append("because of our speciﬁc interest in the reduction of the charged-particle component of")
    thisalinea.textcontent.append("the background.")
    thisalinea.textcontent.append("The ‘Analyzed OK’-column is the fraction of events in the ‘Observed’-column after")
    thisalinea.textcontent.append("the following conditions were applied: 1) each non-vetoed reconstructed ﬁrst hit was")
    thisalinea.textcontent.append("Figure 7.19: x and z coordinates of the production points of the Monte Carlo-charged")
    thisalinea.textcontent.append("particle tracks in the Ca48C-reaction with the time cuts shown in Figure 7.16.")
    thisalinea.textcontent.append("Table 7.2: Final results of the Ca48C-reaction (with time cuts) [144].")
    thisalinea.textcontent.append("Observed Analyzed OK s/n-ratio")
    thisalinea.textcontent.append("Use of VETO Mult. Total Cont. Total Cont.")
    thisalinea.textcontent.append("No VETO condition, 0n 71 0 0 0 0")
    thisalinea.textcontent.append("but with time cuts 1n 13779 2091 3097 0 29%")
    thisalinea.textcontent.append("2n 9167 483 2848 0 45%")
    thisalinea.textcontent.append("3n 8253 552 2226 0 37%")
    thisalinea.textcontent.append("4n 5932 490 1500 0 34%")
    thisalinea.textcontent.append("5n 5669 543 1056 0 23%")
    thisalinea.textcontent.append("Tracker VETO condition 0n 465 256 157 148 51%")
    thisalinea.textcontent.append("and time cuts 1n 13939 2167 3126 66 29%")
    thisalinea.textcontent.append("2n 9316 542 2850 50 44%")
    thisalinea.textcontent.append("3n 8243 520 2176 33 36%")
    thisalinea.textcontent.append("4n 5955 512 1463 23 33%")
    thisalinea.textcontent.append("5n 5239 292 1018 10 24%")
    thisalinea.textcontent.append("Perfect VETO condition 0n 277 206 152 152 122%")
    thisalinea.textcontent.append("and time cuts 1n 13841 2153 3187 90 30%")
    thisalinea.textcontent.append("2n 9248 564 2944 96 47%")
    thisalinea.textcontent.append("3n 8230 529 2297 71 39%")
    thisalinea.textcontent.append("4n 5942 500 1549 49 35%")
    thisalinea.textcontent.append("5n 5450 324 1075 19 25%")
    thisalinea.textcontent.append("linked to a neutron from the target, 2) the neutron multiplicity is identical to the")
    thisalinea.textcontent.append("total number of incoming neutron tracks from the target, and 3) no uneliminated")
    thisalinea.textcontent.append("charged-particle tracks were detected by NeuLAND. Hence, in short, the ‘Analyzed")
    thisalinea.textcontent.append("OK’-column contains the events where all neutrons from the target were correctly")
    thisalinea.textcontent.append("detected by NeuLAND.")
    thisalinea.textcontent.append("‘No VETO condition’ in Table 7.2 means that the VETO detector was present in the")
    thisalinea.textcontent.append("simulation, but that its signals were simply ignored. No reconstructed ﬁrst hits are")
    thisalinea.textcontent.append("vetoed there. The ‘Tracker VETO’ condition was discussed in Section 7.5. The ‘Per-")
    thisalinea.textcontent.append("fect VETO’ condition vetoes every reconstructed ﬁrst hit that is linked to a charged")
    thisalinea.textcontent.append("particle and is, therefore, the theoretical maximum of what a VETO could achieve.")
    thisalinea.textcontent.append("The sum of the ‘Observed’-‘Total’ column over diﬀerent multiplicities is less than one")
    thisalinea.textcontent.append("million, because the events where the beam did not undergo a reaction with the target")
    thisalinea.textcontent.append("were eliminated from the table. To reproduce the experimental conditions as much")
    thisalinea.textcontent.append("as possible, this elimination was done by simulating a trigger signal. This simulated")
    thisalinea.textcontent.append("trigger signal was a coincidence of 3 conditions. The ﬁrst condition is that there is a")
    thisalinea.textcontent.append("beam particle. This is of course always the case in a simulation and was conﬁrmed by")
    thisalinea.textcontent.append("a Monte Carlo energy loss per event of at least 1 MeV is the ﬁrst two PSP detectors.")
    thisalinea.textcontent.append("The second condition is that there is at least one hit-point in NeuLAND. The third")
    thisalinea.textcontent.append("condition is that there is at least a 1 MeV Monte Carlo energy loss in the TOF wall.")
    thisalinea.textcontent.append("Only events that fulﬁlled all three conditions are listed in Table 7.2.")
    thisalinea.textcontent.append("Since no VETO detector was exploited for the simulations shown in the ﬁrst row of Ta-")
    thisalinea.textcontent.append("ble 7.2, the ‘Analyzed OK’-‘Cont.’-column should contain only zeros there. The reason")
    thisalinea.textcontent.append("for this is that the ‘Cont.’-Column contains only events where charged-particle tracks")
    thisalinea.textcontent.append("were detected by NeuLAND and the ‘Analyzed OK’-column is subjected to condition")
    thisalinea.textcontent.append("3) of the previous paragraph. Therefore, the ‘Analyzed OK’-‘Cont.’-column can only")
    thisalinea.textcontent.append("contain events where all detected charged-particle tracks were correctly eliminated by")
    thisalinea.textcontent.append("the VETO detector. Obviously, this is zero when no VETO was used.")
    thisalinea.textcontent.append("Only the results from the ‘Observed’-‘Total’-column can be measured during an ex-")
    thisalinea.textcontent.append("periment. A reconstructed ﬁrst hit is nothing more than a (t, x, y, z)-coordinate, so")
    thisalinea.textcontent.append("the conditions imposed on all of the other columns require information that can only")
    thisalinea.textcontent.append("be obtained from the Monte Carlo tracks. On the other hand, the ‘Analyzed OK’-")
    thisalinea.textcontent.append("‘Total’-column contains the events of interest: the events where all the reconstructed")
    thisalinea.textcontent.append("ﬁrst hits represent all of the neutrons from the target. Hence, the signal-to-noise ra-")
    thisalinea.textcontent.append("tio (s/n-ratio) can be deﬁned as the ratio between the ‘Analyzed OK’-‘Total’-column")
    thisalinea.textcontent.append("(signal) and the diﬀerence between the ‘Observed’-‘Total’-column and the ‘Analyzed")
    thisalinea.textcontent.append("OK’-‘Total’-column (noise).")
    thisalinea.textcontent.append("Table 7.2 shows considerably less events in the ‘Analyzed OK’-‘Total’-column than in")
    thisalinea.textcontent.append("the ‘Observed’-‘Total’-column. Without using the time cuts, more than 87% of this")
    thisalinea.textcontent.append("diﬀerence is caused by mis-identiﬁcation of the neutron multiplicity or by linking the")
    thisalinea.textcontent.append("reconstructed ﬁrst hits to the wrong incoming Monte Carlo tracks. When using the")
    thisalinea.textcontent.append("time cuts, this number increases to 92%. However, it was already known that these")
    thisalinea.textcontent.append("issues pose some limitations on the neutron detection [126]. New methods to improve")
    thisalinea.textcontent.append("the identiﬁcation of the neutron multiplicity and of the neutrons from the target are")
    thisalinea.textcontent.append("currently under investigation [153].")
    thisalinea.textcontent.append("As can be seen in Table 7.2, the tracker VETO condition can save 73% of the 1n")
    thisalinea.textcontent.append("events, 52% of the 2n events, 46% of the 3n events and 47% of the 4n events from all")
    thisalinea.textcontent.append("‘Contaminated’-‘Analyzed OK’ events. The 5n events should be ignored because any")
    thisalinea.textcontent.append("number of neutron tracks from the target above 4 is assigned a multiplicity of 5. It is")
    thisalinea.textcontent.append("to be expected that the VETO eﬃciency drops at higher multiplicities because these")
    thisalinea.textcontent.append("events are more diﬃcult to reconstruct (see [126] and Figure 7.6).")
    thisalinea.textcontent.append("It is also clear from Table 7.2 that the total number of ‘Analyzed OK’ events slightly")
    thisalinea.textcontent.append("beneﬁts from the VETO for a 1n multiplicity, that the total number of 2n events stays")
    thisalinea.textcontent.append("about the same and that the total number of 3n and 4n events drops because of the")
    thisalinea.textcontent.append("VETO detector being used. This is because about 1% of the neutrons are detected")
    thisalinea.textcontent.append("by the VETO detector. This lower number compared to the 2% in Subsection 7.5.1")
    thisalinea.textcontent.append("is partially due to the diﬀerence in the PMT energy thresholds of the VETO detector")
    thisalinea.textcontent.append("and partially due to the diﬀerent neutron energies. The detection of 1% of all neutrons")
    thisalinea.textcontent.append("can exactly explain the drop in non-contaminated events in Table 7.2.")
    thisalinea.textcontent.append("Therefore, it seems from Table 7.2 that although the VETO detector successfully")
    thisalinea.textcontent.append("saves a considerable fraction of the contaminated events of interest, it is not very")
    thisalinea.textcontent.append("useful. Also, the signal-to-noise ratio does not beneﬁt much from the presence of")
    thisalinea.textcontent.append("the VETO detector. For the ‘Tracker VETO’, the signal-to-noise ratio drops on all")
    thisalinea.textcontent.append("multiplicities except 0n and 5n. But 0n is not useful for a neutron detector and the")
    thisalinea.textcontent.append("5n results are biased because everything bigger than 4 was assigned 5.")
    thisalinea.textcontent.append("The reason that the VETO detector does not seem very useful is contained in Figure")
    thisalinea.textcontent.append("7.19. There are so few charged particles in the background that the 1% of neutron")
    thisalinea.textcontent.append("loss outweights the 46%-73% gain of contaminated events [144]. At this point we")
    thisalinea.textcontent.append("would also like to refer to Figure 7.10. The fact that the physics list produces a little")
    thisalinea.textcontent.append("too many particles in the Ca48C-reaction is just an overall factor in Table 7.2. It is")
    thisalinea.textcontent.append("the production ratio of charged and uncharged particles that determines that the 1%")
    thisalinea.textcontent.append("of neutron loss outweights the 46%-73% gain of contaminated events.")
    thisalinea.textcontent.append("From Table 7.2 one might also ask the question how to extract the ‘Analyzed OK’")
    thisalinea.textcontent.append("events from the observed ones in a real experiment. After all, in this situation the")
    thisalinea.textcontent.append("Monte Carlo information is not available. Typical methods are to impose cuts on")
    thisalinea.textcontent.append("the reconstructed energy of the neutrons and to impose coincidence requirements")
    thisalinea.textcontent.append("with other detectors in the R3B setup . However, the precise implementation of such")
    thisalinea.textcontent.append("requirements and cuts depends heavily on the speciﬁc experiment under analysis.")
    thisalinea.textcontent.append("Moreover, such experiment-speciﬁc analysis lies outside the scope of this Chapter.")
    thisalinea.textcontent.append("Therefore, we chose not to implement such conditions in our simulations.")
    thisalinea.textcontent.append("However, in addition to Ca48C-reaction, some other reactions were investigated too.")
    thisalinea.textcontent.append("The reaction of a 48Ca-beam of 600 ± 1 MeV/u on a 2.2 g/cm2 thick lead target")
    thisalinea.textcontent.append("was selected, because also for this reaction our physics list has proven to simulate")
    thisalinea.textcontent.append("the production ratio of charged and unchanged particles with reasonable accuracy.")
    thisalinea.textcontent.append("Moreover, this reaction is suitable to see the eﬀects of the VETO detector in the case")
    thisalinea.textcontent.append("of few target neutrons. Again, 106 events were simulated. We will call this case the")
    thisalinea.textcontent.append("Ca48Pb-reaction. The results are displayed in Table 7.3.")
    thisalinea.textcontent.append("Table 7.3: Same as Table 7.2, but now for the Ca48Pb-reaction [144].")
    thisalinea.textcontent.append("Observed Analyzed OK s/n-ratio")
    thisalinea.textcontent.append("Use of VETO Mult. Total Cont. Total Cont.")
    thisalinea.textcontent.append("No VETO condition, 0n 103 3 0 0 0")
    thisalinea.textcontent.append("but with time cuts 1n 11713 2231 691 0 6%")
    thisalinea.textcontent.append("2n 1978 165 384 0 24%")
    thisalinea.textcontent.append("3n 1331 127 212 0 19%")
    thisalinea.textcontent.append("4n 657 71 97 0 17%")
    thisalinea.textcontent.append("5n 375 50 48 0 15%")
    thisalinea.textcontent.append("Tracker VETO condition 0n 418 243 146 127 54%")
    thisalinea.textcontent.append("and time cuts 1n 11579 2113 691 9 6%")
    thisalinea.textcontent.append("2n 1949 129 379 3 24%")
    thisalinea.textcontent.append("3n 1254 84 207 4 20%")
    thisalinea.textcontent.append("4n 653 66 93 0 17%")
    thisalinea.textcontent.append("5n 311 16 48 0 18%")
    thisalinea.textcontent.append("From Table 7.3 it is clear that the same conclusions can be drawn as from Table 7.2,")
    thisalinea.textcontent.append("only with less statistics [144]. The reaction of a 208Pb-beam of 1000 ± 1 MeV/u on")
    thisalinea.textcontent.append("a 500 mg/cm2 thick lead target was also investigated as a worst-case scenario with")
    thisalinea.textcontent.append("respect to background. We simulated 250000 events for this reaction due to memory")
    thisalinea.textcontent.append("and CPU limitations. We call this the Pb208Pb-reaction. The results are summarized")
    thisalinea.textcontent.append("in Table 7.4.")
    thisalinea.textcontent.append("From Table 7.4, it can be concluded that the VETO detector signiﬁcantly reduces the")
    thisalinea.textcontent.append("signal-to-noise ratio. This can be understood by realizing that vetoing a reconstructed")
    thisalinea.textcontent.append("ﬁrst hit in a high multiplicity event will reduce the multiplicity. Hence, many 5n")
    thisalinea.textcontent.append("background events will be mistaken for lower multiplicities.")
    thisalinea.textcontent.append("From the three reactions investigated, we conclude that a VETO detector does not")
    thisalinea.textcontent.append("appear to be very useful in the R3B experiment [144]. This is despite the fact that the")
    thisalinea.textcontent.append("VETO detector does exactly what it should do: it saves 46%-73% of all contaminated")
    thisalinea.textcontent.append("events at the cost of a few percent of clean events. This is because the charged particle")
    thisalinea.textcontent.append("background comes mainly from the TOF wall, which is at the side of NeuLAND, and")
    thisalinea.textcontent.append("is mostly eliminated by the time cuts (see Figures 7.18 and 7.19).")
    thisalinea.textcontent.append("The simulation of the Pb208Pb case was also repeated with air inside the scattering")
    thisalinea.textcontent.append("chamber. The results are shown in Table 7.5. The ‘Naive VETO’ condition in this")
    thisalinea.textcontent.append("table means that the entire event is vetoed if only a single signal is observed in the")
    thisalinea.textcontent.append("VETO detector.")
    thisalinea.textcontent.append("Table 7.4: Same as Tables 7.2 and 7.3, but now for the Pb208Pb-reaction [144].")
    thisalinea.textcontent.append("Observed Analyzed OK s/n-ratio")
    thisalinea.textcontent.append("Use of VETO Mult. Total Cont. Total Cont.")
    thisalinea.textcontent.append("No VETO condition, 0n 47 0 0 0 0")
    thisalinea.textcontent.append("but with time cuts 1n 8139 2755 52 0 1%")
    thisalinea.textcontent.append("2n 323 167 44 0 16%")
    thisalinea.textcontent.append("3n 175 63 30 0 21%")
    thisalinea.textcontent.append("4n 128 27 22 0 21%")
    thisalinea.textcontent.append("5n 3533 1261 29 0 0.8%")
    thisalinea.textcontent.append("Tracker VETO condition 0n 226 163 29 28 15%")
    thisalinea.textcontent.append("and time cuts 1n 8105 2730 53 0 6%")
    thisalinea.textcontent.append("2n 264 111 41 1 19%")
    thisalinea.textcontent.append("3n 327 159 29 0 10%")
    thisalinea.textcontent.append("4n 1103 549 20 0 2%")
    thisalinea.textcontent.append("5n 2445 609 28 0 1.2%")
    thisalinea.textcontent.append("Table 7.5: Same as Table 7.4, but with air in the scattering chamber [144].")
    thisalinea.textcontent.append("Observed Analyzed OK s/n-ratio")
    thisalinea.textcontent.append("Use of VETO Mult. Total Cont. Total Cont.")
    thisalinea.textcontent.append("No VETO condition, 0n 97 1 0 0 0")
    thisalinea.textcontent.append("but with time cuts 1n 24556 11308 49 0 0.2%")
    thisalinea.textcontent.append("2n 6957 5992 46 0 0.7%")
    thisalinea.textcontent.append("3n 3197 2754 23 0 0.7%")
    thisalinea.textcontent.append("4n 1506 1239 23 0 1.6%")
    thisalinea.textcontent.append("5n 8113 3990 23 0 0.3%")
    thisalinea.textcontent.append("Tracker VETO condition 0n 5606 4989 958 890 21%")
    thisalinea.textcontent.append("and time cuts 1n 24194 11383 49 0 0.2%")
    thisalinea.textcontent.append("2n 4832 3911 46 1 1.0%")
    thisalinea.textcontent.append("3n 2331 1780 22 0 1.0%")
    thisalinea.textcontent.append("4n 3152 2035 21 0 0.7%")
    thisalinea.textcontent.append("5n 4777 1548 23 0 0.5%")
    thisalinea.textcontent.append("Naive VETO condition 0n 21434 17852 4675 3592 28%")
    thisalinea.textcontent.append("and time cuts 1n 18207 6110 47 0 0.3%")
    thisalinea.textcontent.append("2n 1891 1107 44 0 2.4%")
    thisalinea.textcontent.append("3n 530 176 20 0 3.9%")
    thisalinea.textcontent.append("4n 261 56 20 0 8.3%")
    thisalinea.textcontent.append("5n 2577 352 20 0 0.8%")
    thisalinea.textcontent.append("From Table 7.5 we conclude that the VETO detector is very useful. The absolute")
    thisalinea.textcontent.append("amount of ‘Analyzed OK’ events does not increase, but the signal-to-noise ratio im-")
    thisalinea.textcontent.append("proves considerably (relative to the situation of have no VETO condition). Moreover,")
    thisalinea.textcontent.append("the more stringent the VETO condition, the better the signal-to-noise ratio while the")
    thisalinea.textcontent.append("number of ‘Analyzed OK’ events only drops slightly. Therefore, we conclude that")
    thisalinea.textcontent.append("with air in the chamber, the VETO detector is very useful and that the most strict")
    thisalinea.textcontent.append("VETO condition gives the best results [144, 152].")
    thisalinea.textcontent.append("There are two reasons why the ‘Naive VETO’ condition performs so well in this")
    thisalinea.textcontent.append("situation. The ﬁrst one is, that the charged-particle background produced in coinci-")
    thisalinea.textcontent.append("dence with the reaction at the target, is slowed down by the air inside the chamber.")
    thisalinea.textcontent.append("Therefore, it now arrives at NeuLAND outside the allowed time window. This is")
    thisalinea.textcontent.append("why the number of ‘Analyzed OK’ events only drops slightly. The second reason is,")
    thisalinea.textcontent.append("that a large background is produced by the unreacted beam interacting with the air")
    thisalinea.textcontent.append("within the chamber. Therefore, most of the background is completely uncorrelated to")
    thisalinea.textcontent.append("the collision at the target. Hence, the VETO should not try to disentangle charged")
    thisalinea.textcontent.append("particles and neutrons, but decide whether there was a target collision or not [144].")
    thisalinea.textcontent.append("As a ﬁnal issue, we would like to discuss the time cuts of Figure 7.16 in some more")
    thisalinea.textcontent.append("detail. Speciﬁcally, we would like to address the question how useful these time cuts")
    thisalinea.textcontent.append("really are and where they should be applied in the scheme of Figure 7.2. To solve")
    thisalinea.textcontent.append("these issues, the Ca48C-reaction was simulated without any time cuts, with the time")
    thisalinea.textcontent.append("cuts as we proposed (at the raw data level) and with the time cuts applied at the level")
    thisalinea.textcontent.append("of the reconstructed ﬁrst hits. The time cuts at the raw data level were discussed in")
    thisalinea.textcontent.append("the beginning of this section. Applying time cuts at the level of the reconstructed")
    thisalinea.textcontent.append("ﬁrst hits means that the entire neutron reconstruction is performed without any time")
    thisalinea.textcontent.append("cuts and that in the end, the reconstructed ﬁrst hits are eliminated if they fall outside")
    thisalinea.textcontent.append("the time window of Figure 7.16. The results are displayed in Table 7.6")
    thisalinea.textcontent.append("From Table 7.6, it is clear that time cuts at the raw level signiﬁcantly improve both")
    thisalinea.textcontent.append("the signal-to-noise ratio and the absolute number of ‘Analyzed OK’ events. Time")
    thisalinea.textcontent.append("cuts at the level of the reconstructed ﬁrst hits seem to reduce the signal-to-noise ratio")
    thisalinea.textcontent.append("(except for 1n) and they also reduce the number of ‘Analyzed OK’ events. Therefore,")
    thisalinea.textcontent.append("it seems like applying time cuts early in the diagram of Figure 7.2 is the best option.")
    thisalinea.textcontent.append("Therefore, we conclude that time cuts are a very useful method in eliminating the")
    thisalinea.textcontent.append("background of NeuLAND [135, 144, 152]. The time cuts can be applied at any point")
    thisalinea.textcontent.append("in the diagram of Figure 7.2, but applying the time cuts at the raw data level gives")
    thisalinea.textcontent.append("the best results. For the reactions investigated, a VETO detector does not seem to")
    thisalinea.textcontent.append("be very useful for reducing the background of NeuLAND in the new R3B setup as")
    thisalinea.textcontent.append("long as the scattering chamber is placed under vacuum. When the chamber contains")
    thisalinea.textcontent.append("air with 1 bar pressure, a VETO detector is very useful in reducing this background.")
    thisalinea.textcontent.append("In this case, the most strict VETO condition gives the best results.")
    thisalinea.textcontent.append("Table 7.6: Comparison between diﬀerent time cuts for the Ca48C-reaction. No VETO")
    thisalinea.textcontent.append("condition was applied. Part of this table comes from Ref. [144]. The middle group of")
    thisalinea.textcontent.append("rows is duplicated from Table 7.2 for comparison purposes.")
    thisalinea.textcontent.append("Observed Analyzed OK s/n-ratio")
    thisalinea.textcontent.append("Time cut use Mult. Total Cont. Total Cont.")
    thisalinea.textcontent.append("No time 0n 224 0 0 0 0")
    thisalinea.textcontent.append("cuts 1n 50148 20430 2476 0 5%")
    thisalinea.textcontent.append("2n 8387 887 2313 0 38%")
    thisalinea.textcontent.append("3n 7164 701 1869 0 35%")
    thisalinea.textcontent.append("4n 6169 676 1424 0 30%")
    thisalinea.textcontent.append("5n 9088 1043 1508 0 23%")
    thisalinea.textcontent.append("Time cuts 0n 71 0 0 0 0")
    thisalinea.textcontent.append("at the raw 1n 13779 2091 3097 0 29%")
    thisalinea.textcontent.append("data level 2n 9167 483 2848 0 45%")
    thisalinea.textcontent.append("3n 8253 552 2226 0 37%")
    thisalinea.textcontent.append("4n 5932 490 1500 0 34%")
    thisalinea.textcontent.append("5n 5669 543 1056 0 23%")
    thisalinea.textcontent.append("Time cuts 0n 39740 18523 0 0 0")
    thisalinea.textcontent.append("at the level of 1n 11844 2250 2336 0 25%")
    thisalinea.textcontent.append("reconstructed 2n 7950 694 2220 0 39%")
    thisalinea.textcontent.append("ﬁrst hits 3n 7037 673 1776 0 34%")
    thisalinea.textcontent.append("4n 6189 685 1374 0 29%")
    thisalinea.textcontent.append("5n 8461 943 1415 0 20%")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "7.7 Conclusion"
    thisalinea.nativeID = 68
    thisalinea.parentID = 57
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 6
    thisalinea.summary = "Our simulations show that the best VETO for NeuLAND is a single wall of thin verti- cally oriented non-overlapping scintillator bars made of light plastic (like NeuLAND’s scintillators). The entire VETO wall should have a size of 2.5 m × 2.5 m. The opti- mal distance between NeuLAND and the VETO wall is 30 cm for a time resolution of σ = 300 ps. In order to successfully eliminate the back-scattering, the VETO time resolution should not be larger than 300 ps. The required active scintillator thickness is 1.1 cm for an energy deposition threshold of 1 MeV. The optimal "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Our simulations show that the best VETO for NeuLAND is a single wall of thin verti-")
    thisalinea.textcontent.append("cally oriented non-overlapping scintillator bars made of light plastic (like NeuLAND’s")
    thisalinea.textcontent.append("scintillators). The entire VETO wall should have a size of 2.5 m × 2.5 m. The opti-")
    thisalinea.textcontent.append("mal distance between NeuLAND and the VETO wall is 30 cm for a time resolution")
    thisalinea.textcontent.append("of σ = 300 ps. In order to successfully eliminate the back-scattering, the VETO time")
    thisalinea.textcontent.append("resolution should not be larger than 300 ps. The required active scintillator thickness")
    thisalinea.textcontent.append("is 1.1 cm for an energy deposition threshold of 1 MeV. The optimal number of bars")
    thisalinea.textcontent.append("is 16. The best VETO condition to disentangle neutrons from charged particles is the")
    thisalinea.textcontent.append("tracker VETO condition of Subsection 7.5.3 that vetoes reconstructed ﬁrst hits.")
    thisalinea.textcontent.append("This optimal VETO wall design is, however, not very useful for the reactions investi-")
    thisalinea.textcontent.append("gated in Section 7.6. A more eﬀective alternative to this VETO detector in reducing")
    thisalinea.textcontent.append("the background is the use of time cuts. When the Scattering chamber is not placed")
    thisalinea.textcontent.append("under vacuum, the VETO detector becomes extremely useful. In this situation, the")
    thisalinea.textcontent.append("VETO detector should, however, not disentangle charged particles from neutrons, but")
    thisalinea.textcontent.append("decide whether there was a collision at the target. For this purpose, the most naive")
    thisalinea.textcontent.append("and strict VETO condition serves best.")
    thisalinea.textcontent.append("The source code for all simulations performed in this Chapter is available in the")
    thisalinea.textcontent.append("GitHub Veto-branch of the R3BRoot source code [138]. The Veto-branch can be")
    thisalinea.textcontent.append("accessed through [154].")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "8 Conclusions and Outlook"
    thisalinea.nativeID = 69
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 9
    thisalinea.summary = "This thesis was divided into three separate topics. The ﬁrst topic was the study of the Gamow-Teller strength distributions in the 116,122Sn → 116,122Sb transitions using the (3He, t) charge-exchange reaction at 140 MeV/u. The measurements performed for this study were given in Tables 5.1 and 5.2 for the individual states in the re- gion of low excitation energy. The results for higher excitation energies were given in Figure 5.4. We discussed in Section 5.2 that our data agrees to the previous mea- surements of Ref. [28] when the same analysis procedure is followed. However, this procedure includes the subtraction "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "8.1 The topics of this work"
    thisalinea.nativeID = 70
    thisalinea.parentID = 69
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 0
    thisalinea.summary = "This thesis was divided into three separate topics. The ﬁrst topic was the study of the Gamow-Teller strength distributions in the 116,122Sn → 116,122Sb transitions using the (3He, t) charge-exchange reaction at 140 MeV/u. The measurements performed for this study were given in Tables 5.1 and 5.2 for the individual states in the re- gion of low excitation energy. The results for higher excitation energies were given in Figure 5.4. We discussed in Section 5.2 that our data agrees to the previous mea- surements of Ref. [28] when the same analysis procedure is followed. However, this procedure includes the subtraction "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("This thesis was divided into three separate topics. The ﬁrst topic was the study of")
    thisalinea.textcontent.append("the Gamow-Teller strength distributions in the 116,122Sn → 116,122Sb transitions using")
    thisalinea.textcontent.append("the (3He, t) charge-exchange reaction at 140 MeV/u. The measurements performed")
    thisalinea.textcontent.append("for this study were given in Tables 5.1 and 5.2 for the individual states in the re-")
    thisalinea.textcontent.append("gion of low excitation energy. The results for higher excitation energies were given")
    thisalinea.textcontent.append("in Figure 5.4. We discussed in Section 5.2 that our data agrees to the previous mea-")
    thisalinea.textcontent.append("surements of Ref. [28] when the same analysis procedure is followed. However, this")
    thisalinea.textcontent.append("procedure includes the subtraction of the quasi-free charge-exchange background and")
    thisalinea.textcontent.append("does not subtract the higher multipolarity contributions. Omitting the subtraction of")
    thisalinea.textcontent.append("the higher multipolarity contributions will result in an overestimate of the Gamow-")
    thisalinea.textcontent.append("Teller strength, because Gamow-Teller is, by deﬁnition, only a ∆L = 0 transition.")
    thisalinea.textcontent.append("Moreover, including the subtraction of the quasi-free charge-exchange background is")
    thisalinea.textcontent.append("also incorrect due to the lack of knowledge regarding the normalization of this back-")
    thisalinea.textcontent.append("ground [5]. It is, therefore, better to omit the subtraction altogether [93]. The yellow")
    thisalinea.textcontent.append("histograms in Figure 5.4 show the results for our own data when both of these prob-")
    thisalinea.textcontent.append("lems are corrected for (these corrections were not applied to the data in Ref. [28]).")
    thisalinea.textcontent.append("The other two problems discussed in Section 5.4 could be solved for both our data and")
    thisalinea.textcontent.append("for Ref. [28]. Hence, we may conclude that we have improved the analysis methods")
    thisalinea.textcontent.append("and the uncertainties of the previous measurements in Ref. [28].")
    thisalinea.textcontent.append("Following our yellow results of Figure 5.4 (the correct procedure), 38 ± 7% of the")
    thisalinea.textcontent.append("Gamow-Teller strength according to the Ikeda sum-rule could be deduced in the re-")
    thisalinea.textcontent.append("gion below 28 MeV excitation energy for the 116Sn → 116Sb transitions. For the 122Sn")
    thisalinea.textcontent.append("→ 122Sb transitions, this result was 48 ± 6%. For the 122Sn → 122Sb transitions, this")
    thisalinea.textcontent.append("percentage agrees with other recent results on diﬀerent isotopes and with the general")
    thisalinea.textcontent.append("quenching phenomenon of Gamow-Teller strength [97]. However, the percentage for")
    thisalinea.textcontent.append("the 116Sn → 116Sb transitions is lower. When the cyan result of Figure 5.4 is used,")
    thisalinea.textcontent.append("namely where the quasi-free charge-exchange background is subtracted, the percent-")
    thisalinea.textcontent.append("ages are 29 ± 7% for 116Sn → 116Sb and 35 ± 5% for 122Sn → 122Sb.")
    thisalinea.textcontent.append("Our yellow results were also compared to QRPA+QPVC calculations [102, 104] in")
    thisalinea.textcontent.append("Figure 5.13. The QRPA+QPVC calculations were performed up to an excitation")
    thisalinea.textcontent.append("energy of about 22 MeV. The calculations were scaled to include a total Gamow-")
    thisalinea.textcontent.append("Teller strength of (0.75)2 · 3|N − Z|, in agreement with Ref. [92]. The comparison")
    thisalinea.textcontent.append("revealed that the used theoretical model could reasonably predict the Gamow-Teller")
    thisalinea.textcontent.append("strength around the region of the IAS, as well as that of the Gamow-Teller resonance.")
    thisalinea.textcontent.append("However, the model predicts a large, broad peak in Gamow-Teller strength in the")
    thisalinea.textcontent.append("region near 3 − 5 MeV excitation energy, which was not observed experimentally.")
    thisalinea.textcontent.append("Possible improvements of the theoretical model are under investigation [104].")
    thisalinea.textcontent.append("The fact that the same QRPA+QPVC model could reasonably predict the Gamow-")
    thisalinea.textcontent.append("Teller resonance for both 116,122Sn → 116,122Sb transitions suggests that the region")
    thisalinea.textcontent.append("between 19 MeV and 28 MeV excitation energy is responsible for ﬁnding a lower")
    thisalinea.textcontent.append("percentage of Gamow-Teller strength for the 116Sn → 116Sb transition. The fact that")
    thisalinea.textcontent.append("the total Gamow-Teller strength located below an excitation energy of 19 MeV was")
    thisalinea.textcontent.append("about the same for these two isotopes and that this also agrees with other isotopes [92],")
    thisalinea.textcontent.append("supports this conclusion (see Figure 5.11). Based on this conclusion, the diﬀerence")
    thisalinea.textcontent.append("in the percentages of Gamow-Teller strength found for our two studied isotopes was")
    thisalinea.textcontent.append("attributed to diﬀerent contributions of the quasi-free charge-exchange background")
    thisalinea.textcontent.append("(which was not subtracted for obtaining these percentages). The fact that the B(GT )")
    thisalinea.textcontent.append("spectrum of the 116Sn → 116Sb transitions (see Figure 5.13a) has a zero-point, while")
    thisalinea.textcontent.append("that of the 122Sn → 122Sb transition (see Figure 5.13b) has not, suggests that the")
    thisalinea.textcontent.append("contribution from this background is very small for the 116Sn → 116Sb transitions,")
    thisalinea.textcontent.append("while it may be larger for the 122Sn → 122Sb transitions.")
    thisalinea.textcontent.append("In order to further investigate this diﬀerence, we have proposed to repeat our study")
    thisalinea.textcontent.append("of the 116,122Sn → 116,122Sb transitions using the (3He, t) charge-exchange reaction at")
    thisalinea.textcontent.append("140 MeV/u while simultaneously measuring the decay protons of the recoil nucleus.")
    thisalinea.textcontent.append("This technique has already been employed in Ref. [5], where it was shown that the")
    thisalinea.textcontent.append("quasi-free charge-exchange background will be eﬃciently reduced by requiring a co-")
    thisalinea.textcontent.append("incidence between an emitted proton at large backward angles and an ejected triton.")
    thisalinea.textcontent.append("With this technique, one could determine whether the quasi-free charge-exchange")
    thisalinea.textcontent.append("background is indeed responsible for the diﬀerence in percentages. However, since")
    thisalinea.textcontent.append("the technique will also suppress the part of the Gamow-Teller strength that comes")
    thisalinea.textcontent.append("from states that cannot decay by proton emission, this technique cannot produce the")
    thisalinea.textcontent.append("general quenching phenomenon of Gamow-Teller strength, which is believed to be")
    thisalinea.textcontent.append("50% − 60% [5, 94, 97, 98].")
    thisalinea.textcontent.append("A comparison to accurate theoretical calculations (like QRPA+QPVC) could also help")
    thisalinea.textcontent.append("to investigate a possible excitation-energy dependence of the Gamow-Teller unit cross")
    thisalinea.textcontent.append("section. Such a dependence might also (partially) explain the diﬀerence in observed")
    thisalinea.textcontent.append("quenching between the 116Sn → 116Sb and 122Sn → 122Sb transitions. However, this")
    thisalinea.textcontent.append("requires good agreement between the theoretical calculation and the experimental")
    thisalinea.textcontent.append("data in the low excitation-energy region (where the unit cross section is known to")
    thisalinea.textcontent.append("be constant). Moreover, it also requires one to either include the quasi-free charge-")
    thisalinea.textcontent.append("exchange background in the calculation, or to limit the calculations to states of the")
    thisalinea.textcontent.append("recoil nucleus that can decay by proton emission. Hence, it is important to further")
    thisalinea.textcontent.append("develope the used QRPA+QPVC model in this region as much as possible.")
    thisalinea.textcontent.append("The second topic of this thesis was a safety study of the X-slit system, which will be")
    thisalinea.textcontent.append("used in the future Super-FRS of FAIR, presently under construction. These studies")
    thisalinea.textcontent.append("were made by using thermal simulations. From these simulations and from the exper-")
    thisalinea.textcontent.append("imental veriﬁcation, we concluded that, thanks to the passive cooling with stainless")
    thisalinea.textcontent.append("steel ribs, the X-slit system can be used safely inside the pre-separator of the Super-")
    thisalinea.textcontent.append("FRS.")
    thisalinea.textcontent.append("The third topic of this thesis is the design of the VETO detector for the NeuLAND")
    thisalinea.textcontent.append("neutron detector. This detector is part of the R3B experimental setup being con-")
    thisalinea.textcontent.append("structed for the FAIR facility. Through Monte-Carlo simulations (which were bench-")
    thisalinea.textcontent.append("marked against experimental data), we have determined that the optimal geometry")
    thisalinea.textcontent.append("of this VETO detector is a single wall made of 16 non-overlapping scintillator bars")
    thisalinea.textcontent.append("with a total surface of 2.5 m × 2.5 m and an active thickness of 1.1 cm. The energy")
    thisalinea.textcontent.append("deposition threshold of the detector should be between 160 keV and 1 MeV and the")
    thisalinea.textcontent.append("time resolution should be better than σ = 300 ps. The optimal distance between this")
    thisalinea.textcontent.append("VETO detector and NeuLAND is 30 cm. Our developed Tracker VETO condition")
    thisalinea.textcontent.append("was found to be an eﬀective software method to use this VETO for disentangling")
    thisalinea.textcontent.append("incoming neutrons from incoming charged particles.")
    thisalinea.textcontent.append("However, this optimal VETO detector is not a useful tool in reducing the back-")
    thisalinea.textcontent.append("ground, except for experiments that require atmosphere in the vacuum scattering")
    thisalinea.textcontent.append("chamber (and the adjoint pipe). The reason for this is that the amount of produced")
    thisalinea.textcontent.append("charged-particle background in the setup is very low (when the scattering chamber")
    thisalinea.textcontent.append("is evacuated). Hence, the accidental elimination of some good neutrons is more dis-")
    thisalinea.textcontent.append("advantageous than trying to get rid of a few produced background charged particles.")
    thisalinea.textcontent.append("Eliminating raw data by applying time cuts seemed like a more eﬀective method to")
    thisalinea.textcontent.append("reduce the background in NeuLAND. With this knowledge, new analysis techniques")
    thisalinea.textcontent.append("for NeuLAND are currently under investigation [153].")
    thisalinea.textcontent.append("The purpose of pursuing these three topics in our thesis is to pave the way for mea-")
    thisalinea.textcontent.append("surements on Gamow-Teller strength in highly unstable nuclei important for nucle-")
    thisalinea.textcontent.append("osynthesis processes. With the safe operation of the X-slit system and a better")
    thisalinea.textcontent.append("understanding of background reduction techniques in NeuLAND, the possibilities to")
    thisalinea.textcontent.append("perform such measurements with FAIR in the future have come two steps closer to")
    thisalinea.textcontent.append("reality. Moreover, with our measurements of Gamow-Teller strength in 116,122Sn →")
    thisalinea.textcontent.append("experiments. Our measurements have helped to indicate possible reﬁnements of ex-")
    thisalinea.textcontent.append("isting QRPA+QPVC models and have improved the experimental knowledge of the")
    thisalinea.textcontent.append("Gamow-Teller strength in the isotopes measured. Our measurements have also indi-")
    thisalinea.textcontent.append("cated the need for a better understanding and for better elimination techniques of")
    thisalinea.textcontent.append("the quasi-free charge-exchange background. Hence, as an overall conclusion of this")
    thisalinea.textcontent.append("thesis, we can state that we have successfully taken three important steps towards the")
    thisalinea.textcontent.append("study of one of the important giant resonances in nature, namely the Gamow-Teller")
    thisalinea.textcontent.append("resonance.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 2
    thisalinea.texttitle = "8.2 Suggestions for follow-up experiments"
    thisalinea.nativeID = 71
    thisalinea.parentID = 69
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 1
    thisalinea.summary = "As explained in Chapter 1, it is important to have a thorough knowledge of B(GT ) values for many diﬀerent nuclei (especially if one is interested in understanding nucle- osynthesis). Moreover, we have also indicated the need for additional measurements where the quasi-free charge-exchange background is suppressed. Hence, our exper- iment will probably not be the last to measure B(GT ) values. For this reason, we discuss, in this section, some of the problems we encountered during our experiment and the subsequent data analysis so that these problems can be avoided in the future. The main limitation that we encountered "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("As explained in Chapter 1, it is important to have a thorough knowledge of B(GT )")
    thisalinea.textcontent.append("values for many diﬀerent nuclei (especially if one is interested in understanding nucle-")
    thisalinea.textcontent.append("osynthesis). Moreover, we have also indicated the need for additional measurements")
    thisalinea.textcontent.append("where the quasi-free charge-exchange background is suppressed. Hence, our exper-")
    thisalinea.textcontent.append("iment will probably not be the last to measure B(GT ) values. For this reason, we")
    thisalinea.textcontent.append("discuss, in this section, some of the problems we encountered during our experiment")
    thisalinea.textcontent.append("and the subsequent data analysis so that these problems can be avoided in the future.")
    thisalinea.textcontent.append("The main limitation that we encountered during our data analysis was the accuracy")
    thisalinea.textcontent.append("of the sieve-slit correction. This accuracy was limited due to several reasons. The ﬁrst")
    thisalinea.textcontent.append("reason is that data were only available for 5 distinct holes in the horizontal direction.")
    thisalinea.textcontent.append("Therefore, the knowledge on how to construct the horizontal scattering angle θt was")
    thisalinea.textcontent.append("limited, which was demonstrated very well by the curls in Figures 4.6a and 4.6b at")
    thisalinea.textcontent.append("the extremes of θt. However, from Figure 4.5a it is clear that the horizontal angular")
    thisalinea.textcontent.append("resolution could easily allow for a greater number of holes in the sieve slit in the")
    thisalinea.textcontent.append("horizontal direction. Hence, we recommend that during future follow-up experiments")
    thisalinea.textcontent.append("at Grand Raiden, at least 7 or 8 holes in the horizontal direction are drilled into the")
    thisalinea.textcontent.append("sieve slit in the region of −0.85◦ ≤ θt ≤ 0.85◦.")
    thisalinea.textcontent.append("The second reason is that sieve-slit data were only taken in the 0◦ mode. One could")
    thisalinea.textcontent.append("argue that the optical properties of Grand Raiden in other modes are identical to")
    thisalinea.textcontent.append("the 0◦ mode, but the kinematics of the reaction at the target are not. Therefore,")
    thisalinea.textcontent.append("the trajectories of ions will always be diﬀerent for diﬀerent angular modes, which")
    thisalinea.textcontent.append("will result in slight diﬀerences in how ion tracks should be traced back to the target.")
    thisalinea.textcontent.append("Hence, 0◦ sieve-slit data can never truly replace sieve-slit data taken in some other")
    thisalinea.textcontent.append("mode. This is also illustrated in Figures 4.6a and 4.6b. The data from the 2.5◦")
    thisalinea.textcontent.append("mode are slightly skewed, even though we did correct for the diﬀerence in kinematics.")
    thisalinea.textcontent.append("Hence, we recommend that for future experiments, independent sieve-slit data be")
    thisalinea.textcontent.append("taken for all angular modes that will be used during the experiment.")
    thisalinea.textcontent.append("The third reason is the beam tuning between diﬀerent experimental runs. During")
    thisalinea.textcontent.append("our experiment, the angle between the beam and the target was slightly changed")
    thisalinea.textcontent.append("each time the beam was tuned, and no record was available about the exact beam")
    thisalinea.textcontent.append("angles per run. Hence, we were forced to use the 3He+ peak to determine these")
    thisalinea.textcontent.append("properties. Fortunately, this works very well for 0◦ runs. However, for other runs,")
    thisalinea.textcontent.append("we were forced to assume the same beam angles as the last 0◦ run without any clue")
    thisalinea.textcontent.append("whether this was correct or not. Moreover, even for the 0◦ runs, beam angles could")
    thisalinea.textcontent.append("only be reconstructed from the 3He+ peak after the sieve-slit correction was done,")
    thisalinea.textcontent.append("while those same angles are needed for the kinematics of that sieve-slit correction.")
    thisalinea.textcontent.append("Hence, as a crude approximation to these angles, we assumed a perpendicular beam")
    thisalinea.textcontent.append("during the sieve-slit correction.")
    thisalinea.textcontent.append("For 0◦ runs, it would be possible to improve our crude approximation by an iterative")
    thisalinea.textcontent.append("procedure, but this procedure would be very costly in terms of CPU-time. Our anal-")
    thisalinea.textcontent.append("ysis software would require about 10 hours on a Personal Computer with a 3.0 GHz")
    thisalinea.textcontent.append("CPU for performing a single iteration of this type. Moreover, such an iterative pro-")
    thisalinea.textcontent.append("cedure would not help to improve our crude approximation of using the beam angles")
    thisalinea.textcontent.append("of the last 0◦ run for the runs where another spectrometer angle was used. It would")
    thisalinea.textcontent.append("also not solve inaccuracies due to the lack of horizontal sieve-slit holes or due to a")
    thisalinea.textcontent.append("lack of sieve-slit data in non-0◦ modes. This is why we chose to omit such an iterative")
    thisalinea.textcontent.append("procedure. Instead, we chose to solve all of the three problems discussed above to")
    thisalinea.textcontent.append("the best of our abilities by applying manual corrections to the data after the optical")
    thisalinea.textcontent.append("coeﬃcients were applied (see Figure 4.6). We know that E∗ should not be correlated")
    thisalinea.textcontent.append("with the scattering angle, so this knowledge could be used to simply force the spec-")
    thisalinea.textcontent.append("trum into the right shape. The positions of the states near a scattering angle of zero")
    thisalinea.textcontent.append("were not changed to keep an original reference point for the excitation energy. From")
    thisalinea.textcontent.append("Tables 5.1 and 5.2, it is clear that after the manual corrections, the diﬀerence between")
    thisalinea.textcontent.append("the measured excitation energy and that quoted in the literature is always smaller")
    thisalinea.textcontent.append("than the systematic uncertainty of the calibration (which is about 40 keV FWHM,")
    thisalinea.textcontent.append("see the end of Section 5.2), which is, together with Figure 4.6, a good indication that")
    thisalinea.textcontent.append("the correct manual corrections were applied. In addition, we also shifted the events")
    thisalinea.textcontent.append("by the position of the 3He+ peak and of the IAS before they were added for the")
    thisalinea.textcontent.append("calculation of the cross sections. This also provided a correction for the beam tuning")
    thisalinea.textcontent.append("(see Section 4.4).")
    thisalinea.textcontent.append("Hence, for future experiments, we recommend that an accurate record of the beam")
    thisalinea.textcontent.append("tuning is kept and published for each individual experimental run, including precise")
    thisalinea.textcontent.append("information about the angles between the beam and the target.")
    thisalinea.textcontent.append("Another issue is the lack of methods to subtract the instrumental background from")
    thisalinea.textcontent.append("the data. From Figures 5.1a and 5.1b, one can see that the level of instrumental")
    thisalinea.textcontent.append("background is very small for our experiment. One can see this by looking at the region")
    thisalinea.textcontent.append("between the 3He+ peak and the ground state. This was also conﬁrmed by taking data")
    thisalinea.textcontent.append("without any target. These observations are the reason that it was decided that no")
    thisalinea.textcontent.append("special treatment of the instrumental background was necessary. However, it would")
    thisalinea.textcontent.append("be nice if this observation could be extended to higher excitation energies as well")
    thisalinea.textcontent.append("(which obviously cannot be done without a target). However, for reasons discussed")
    thisalinea.textcontent.append("below, there simply is not enough information to do this for our experiment.")
    thisalinea.textcontent.append("In Ref. [73], a method for accurate subtraction of the instrumental background is")
    thisalinea.textcontent.append("described. There, the instrumental background was determined from the vertical")
    thisalinea.textcontent.append("position coordinate at the focal plane, yfp. For the experiment of Ref. [73], some")
    thisalinea.textcontent.append("region of the detector acceptance in yfp existed where no ejectiles from the target")
    thisalinea.textcontent.append("were passing. Therefore, that region could be used to measure the instrumental")
    thisalinea.textcontent.append("background directly. This could be done for each bin in E∗ separately. The reason")
    thisalinea.textcontent.append("that this region in yfp was available is that in Ref. [73], only a mild under-focus")
    thisalinea.textcontent.append("mode of Grand Raiden was used (see Figure 3.7). However, our experiment needed a")
    thisalinea.textcontent.append("powerful over-focus mode to accurately determine the vertical scattering angle φt by")
    thisalinea.textcontent.append("measuring yfp. Therefore, no region in yfp was available where no triton tracks from")
    thisalinea.textcontent.append("the target were passing. Due to initial observations of the region between the ground")
    thisalinea.textcontent.append("state and the 3He+ peak, it was decided at the time of the experiment that good")
    thisalinea.textcontent.append("resolution in the vertical scattering angle was more important than having a region")
    thisalinea.textcontent.append("in yfp for instrumental background subtraction.")
    thisalinea.textcontent.append("We dealt with the total background (which is a sum of the instrumental background")
    thisalinea.textcontent.append("and of the physical background, see the end of Subsection 4.4.2 for a discussion on")
    thisalinea.textcontent.append("the sources of the physical background) by simply ﬁtting a piecewise linear function")
    thisalinea.textcontent.append("through the excitation-energy spectrum (see Figure 4.9). However, it would obviously")
    thisalinea.textcontent.append("be better if the method of Ref. [73] could be used to remove the (relatively small)")
    thisalinea.textcontent.append("instrumental component beforehand. On the other hand, reducing the over-focus")
    thisalinea.textcontent.append("mode might worsen the vertical-angle resolution in φt (which is the reason why the")
    thisalinea.textcontent.append("method of Ref. [73] was not considered for our experiment). A consequence of this")
    thisalinea.textcontent.append("reduction in vertical-angle resolution is that less holes could be drilled into the sieve")
    thisalinea.textcontent.append("slit in the vertical direction, because in this direction, the number of holes is already")
    thisalinea.textcontent.append("at the detection limit (see Figure 4.5a). Hence, we recommend that a detailed study is")
    thisalinea.textcontent.append("made about how far the over-focus mode could be reduced without compromising the")
    thisalinea.textcontent.append("vertical-angle resolution and the number of sieve-slit holes and whether this would be")
    thisalinea.textcontent.append("enough to apply the background subtraction method of Ref. [73]. With our previous")
    thisalinea.textcontent.append("discussion about the number of holes in the sieve slit in the horizontal direction kept")
    thisalinea.textcontent.append("in mind, we recommend to keep the number of vertical holes to at least 9 or 10 (in")
    thisalinea.textcontent.append("this work, it was 13).")
    thisalinea.textcontent.append("We would like to emphasize that, if all of the above improvements would be made,")
    thisalinea.textcontent.append("one might no longer need the Gaussian tails of equation (4.7) to ﬁt the high-statistics")
    thisalinea.textcontent.append("states like the IAS. If a pure Gaussian ﬁt could be made for such states, the width")
    thisalinea.textcontent.append("of the states could be extracted much more accurately and an interpolation of these")
    thisalinea.textcontent.append("widths like we did in Subsection 4.4.2 might no longer be necessary. Hence, the width")
    thisalinea.textcontent.append("of our states would then be much more reliable, which would greatly enhance our")
    thisalinea.textcontent.append("ability to disentangle nuclear states that lie close to each other.")
    thisalinea.textcontent.append("The ﬁnal problem we would like to address is the variation in the angular beam proﬁle.")
    thisalinea.textcontent.append("When the beam was tuned between experimental runs, not only the mean position")
    thisalinea.textcontent.append("and angle at which it hit the target were changed, but also the angular spread of the")
    thisalinea.textcontent.append("beam. This is illustrated in Figure 8.1 for two diﬀerent runs.")
    thisalinea.textcontent.append("Figure 8.1: Angular spread of the 3He+ peak for two diﬀerent experimental runs.")
    thisalinea.textcontent.append("Changes in the angular spread of the beam cannot be corrected for. This spread")
    thisalinea.textcontent.append("determines the energy and angular resolutions of our measurements. The worse an-")
    thisalinea.textcontent.append("gular spread of Figure 8.1b is the reason that we had to smear our theoretical angular")
    thisalinea.textcontent.append("distributions with σ = 0.3◦ for the analysis of the 122Sn(3He, t)122Sb reaction. Since")
    thisalinea.textcontent.append("all of our other 0◦ runs had a spread more like Figure 8.1a, we could keep σ = 0.2◦ for")
    thisalinea.textcontent.append("the 116Sn(3He, t)116Sb reaction. Elimination of run 5047 from the data to improve the")
    thisalinea.textcontent.append("angular resolution for the 122Sn(3He, t)122Sb reaction has been considered. However,")
    thisalinea.textcontent.append("run 5047 contained more than half of the total amount of measured events in the 0◦")
    thisalinea.textcontent.append("mode for the 122Sn(3He, t)122Sb reaction and could not be discarded.")
    thisalinea.textcontent.append("We, therefore, recommend that for future experiments, the angular spread of the")
    thisalinea.textcontent.append("beam proﬁle is kept constant during the entire experiment and that it is kept as small")
    thisalinea.textcontent.append("as possible.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "Nederlandse Samenvatting"
    thisalinea.nativeID = 72
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 10
    thisalinea.summary = ""
    thisalinea.sum_CanbeEmpty = True
    thisalinea.textcontent.clear()
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "1 Inleiding"
    thisalinea.nativeID = 73
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 11
    thisalinea.summary = "De toegestane β-overgangen in atoomkernen bestaan uit twee klassen: Fermi over- gangen en Gamow-Teller overgangen. Beide types overgangen worden gekenmerkt door een isospin verandering ∆Tz = 1 en een impulsmoment verandering ∆L = 0. Een Fermi overgang heeft echter een verandering in de kernspin van ∆S = 0, terwijl een Gamow-Teller overgang gekenmerkt wordt door ∆S = 1. Het berekenen van meetbare eigenschappen van Fermi overgangen is daardoor eenvoudig, terwijl zulke berekening- en voor Gamow-Teller veranderingen vandaag de dag nog altijd problematisch zijn [12]. Een nauwkeurige beschrijving van Gamow-Teller overgangen is echter zeer belangrijk voor diverse subdisciplines in de natuurkunde. "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("De toegestane β-overgangen in atoomkernen bestaan uit twee klassen: Fermi over-")
    thisalinea.textcontent.append("gangen en Gamow-Teller overgangen. Beide types overgangen worden gekenmerkt")
    thisalinea.textcontent.append("door een isospin verandering ∆Tz = 1 en een impulsmoment verandering ∆L = 0. Een")
    thisalinea.textcontent.append("Fermi overgang heeft echter een verandering in de kernspin van ∆S = 0, terwijl een")
    thisalinea.textcontent.append("Gamow-Teller overgang gekenmerkt wordt door ∆S = 1. Het berekenen van meetbare")
    thisalinea.textcontent.append("eigenschappen van Fermi overgangen is daardoor eenvoudig, terwijl zulke berekening-")
    thisalinea.textcontent.append("en voor Gamow-Teller veranderingen vandaag de dag nog altijd problematisch zijn")
    thisalinea.textcontent.append("[12].")
    thisalinea.textcontent.append("Een nauwkeurige beschrijving van Gamow-Teller overgangen is echter zeer belangrijk")
    thisalinea.textcontent.append("voor diverse subdisciplines in de natuurkunde. Zulke kennis kan ons helpen om theo-")
    thisalinea.textcontent.append("retische methodes voor het oplossen van de Sch¨odingervergelijking voor veel-deeltjes")
    thisalinea.textcontent.append("systemen te testen en te verﬁjnen [7, 12]. Kennis over Gamow-Teller overgangen kan")
    thisalinea.textcontent.append("ook gebruikt worden voor het ontwikkelen van nieuwe detectietechnieken van in de")
    thisalinea.textcontent.append("zon geproduceerde neutrinos [20] en voor het berekenen van dubbel β-verval waar-")
    thisalinea.textcontent.append("bij geen neutrinos worden uitgezonden [16, 18]. Gamow-teller overgangen zijn ook")
    thisalinea.textcontent.append("een vitaal onderdeel van alle modellen die de synthese beschrijven van atoomkernen")
    thisalinea.textcontent.append("zwaarder dan ijzer [7].")
    thisalinea.textcontent.append("De meeste van elementen zwaarder dan ijzer worden echter geproduceerd als bijzon-")
    thisalinea.textcontent.append("der instabiele isotopen [7]. Vandaag de dag is het niet mogelijk om Gamow-Teller")
    thisalinea.textcontent.append("overgangen te meten in deze instabiele atoomkernen. Met de nieuwe generatie van")
    thisalinea.textcontent.append("deeltjesversnellers voor atoomkernen wordt dit echter wel mogelijk gemaakt [7]. We")
    thisalinea.textcontent.append("hebben ervoor gekozen om drie hieraan gerelateerde onderwerpen te bestuderen.")
    thisalinea.textcontent.append("Het eerste onderwerp is een meting van de Gamow-Teller overgangen in 116Sn → 116Sb")
    thisalinea.textcontent.append("en 122Sn → 122Sb. Deze Sn-isotopen zijn stabiel, wat deze meting met de beschikbare")
    thisalinea.textcontent.append("meetopstellingen mogelijk maakt. Bovendien zijn deze isotopen belangrijke referen-")
    thisalinea.textcontent.append("tiepunten voor het testen van theoretische modellen voor nucleosynthese.")
    thisalinea.textcontent.append("Het tweede onderwerp is de controle van de passieve koeling van het X-slit systeem.")
    thisalinea.textcontent.append("Het X-slit systeem is een collimator voor radioactieve bundels. Een collimator houdt")
    thisalinea.textcontent.append("de ionen in een bundel tegen die niet gebruikt worden in het experiment, zodat uitein-")
    thisalinea.textcontent.append("delijk een zuivere bundel van slechts een enkel type ion overblijft [135]. Het X-slit")
    thisalinea.textcontent.append("systeem zal worden gebruikt in de Super-FRagment Separator [30] (Super-FRS) van")
    thisalinea.textcontent.append("de toekomstige deeltjesversneller FAIR (Facility for Antiproton and Ion Research) in")
    thisalinea.textcontent.append("Darmstadt in Duitsland [29].")
    thisalinea.textcontent.append("Het derde onderwerp is het ontwerp van de VETO detector voor NeuLAND. Neu-")
    thisalinea.textcontent.append("LAND is de neutron detector in de R3B meetopstelling [126]. R3B is een meetop-")
    thisalinea.textcontent.append("stelling waarmee Reacties met Radioactieve Relativistische Bundels (R3B) worden")
    thisalinea.textcontent.append("bestudeerd. De bundel wordt geproduceerd met de Super-FRS van FAIR. E´en van de")
    thisalinea.textcontent.append("toepassingen voor de R3B meetopstelling is het meten van Gamow-Teller overgangen")
    thisalinea.textcontent.append("in (zeer) instabiele atoomkernen [10]. Onze bijdrages aan het X-slit systeem en aan")
    thisalinea.textcontent.append("de VETO detector kunnen dus gebruikt worden om in de toekomst Gamow-Teller")
    thisalinea.textcontent.append("overgangen in (zeer) instabiele atoomkernen te meten.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "2 Bepaling van de Gamow-Teller overgangen in Sn- isotopen"
    thisalinea.nativeID = 74
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 12
    thisalinea.summary = "De waarschijnlijkheid van een Gamow-Teller overgang wordt beschreven door een enkel dimensieloos getal: een zogenaamde B(GT )-waarde [11]. Een B(GT )-waarde is formeel gedeﬁnieerd als (2j + 1) · B(GT ) = | (cid:104)Ψf |στ |Ψi(cid:105) |2. Hier is j het kwant- um getal van het totale impulsmoment van de nucleus voor de overgang. Ψi (Ψf ) is de golﬀunctie die de toestand van de atoomkern beschrijft voor (na) de overgang. στ is de Gamow-Teller operator (opgeteld over alle nucleonen in de atoomkern). De waarschijnlijkheid van elke Gamow-Teller toestand in het energiespectrum van de desbetreﬀende atoomkern wordt beschreven door zijn "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("De waarschijnlijkheid van een Gamow-Teller overgang wordt beschreven door een")
    thisalinea.textcontent.append("enkel dimensieloos getal: een zogenaamde B(GT )-waarde [11]. Een B(GT )-waarde")
    thisalinea.textcontent.append("is formeel gedeﬁnieerd als (2j + 1) · B(GT ) = | (cid:104)Ψf |στ |Ψi(cid:105) |2. Hier is j het kwant-")
    thisalinea.textcontent.append("um getal van het totale impulsmoment van de nucleus voor de overgang. Ψi (Ψf )")
    thisalinea.textcontent.append("is de golﬀunctie die de toestand van de atoomkern beschrijft voor (na) de overgang.")
    thisalinea.textcontent.append("στ is de Gamow-Teller operator (opgeteld over alle nucleonen in de atoomkern).")
    thisalinea.textcontent.append("De waarschijnlijkheid van elke Gamow-Teller toestand in het energiespectrum van")
    thisalinea.textcontent.append("de desbetreﬀende atoomkern wordt beschreven door zijn eigen B(GT )-waarde. De")
    thisalinea.textcontent.append("golﬀunctie is voor elke toestand in dit spectrum immers verschillend. De waarschijn-")
    thisalinea.textcontent.append("lijkheid van een Fermi overgang wordt analoog beschreven met een zogenaamde B(F )-")
    thisalinea.textcontent.append("waarde. De Fermi operator bevat echter alleen de isospin operator τ .")
    thisalinea.textcontent.append("In het huidige experiment, zijn de Gamow-Teller overgangen in 116Sn → 116Sb en")
    thisalinea.textcontent.append("van 140 MeV/u [13]. In zulke reacties is B(GT ) recht evenredig met de diﬀerenti¨ele")
    thisalinea.textcontent.append("dwarsdoorsnede van de reactie bij een verstrooiingshoek van nul graden en bij een im-")
    thisalinea.textcontent.append("pulsoverdracht van nul. De evenredigheidsconstante heet de eenheidsdwarsdoorsnede")
    thisalinea.textcontent.append("ˆσ. De eenheidsdwarsdoorsnede is dezelfde voor alle toestanden in het energiespect-")
    thisalinea.textcontent.append("rum, maar verschillend voor Fermi overgangen en voor Gamow-Teller overgangen. De")
    thisalinea.textcontent.append("Fermi en Gamow-Teller eenheidsdwarsdoorsneden worden beschreven in Ref. [35] met")
    thisalinea.textcontent.append("de fenomenologische modellen ˆσGT = 109 mb/sr · A−0.65 en ˆσF = 72 mb/sr · A−1.06")
    thisalinea.textcontent.append("(A is het massagetal van de atoomkern).")
    thisalinea.textcontent.append("De kernreacties zijn uitgevoerd en gemeten met de Grand Raiden spectrometer [64]")
    thisalinea.textcontent.append("in RCNP [65], Osaka, Japan. Een 3He2+-bundel van 140 MeV/u werd afgevuurd op")
    thisalinea.textcontent.append("een trefplaat van het desbetreﬀende Sn-isotoop (meer dan 95% verrijkt). Vervolgens")
    thisalinea.textcontent.append("werden de trajecten van de 3H-kernen gemeten en gereconstrueerd met de detectoren")
    thisalinea.textcontent.append("in het brandvlak van de spectrometer. Deze trajecten zijn vervolgens terug naar")
    thisalinea.textcontent.append("de trefplaat ge¨extrapoleerd door middel van een SieveSlit analyse [73, 90]. Hier-")
    thisalinea.textcontent.append("door was de relativistische 4-impuls vector van zowel de 3H-kernen als van de 3He-")
    thisalinea.textcontent.append("kernen bekend en kon het energiespectrum van de Sb-kern worden gereconstrueerd.")
    thisalinea.textcontent.append("Het bundelproﬁel was zo ontworpen dat er gecorrigeerd werd voor zowel de dispersie")
    thisalinea.textcontent.append("in energie als de dispersie in verstrooiingshoek van Grand Raiden [70]. Daarnaast")
    thisalinea.textcontent.append("werd ook de overfocus modus [80] gebruikt tijdens het experiment. Hierdoor hadden")
    thisalinea.textcontent.append("onze metingen een goede energieresolutie van σ ≈ 30 keV en een goede resolutie in")
    thisalinea.textcontent.append("verstrooiingshoek van σ ≈ 0.18◦.")
    thisalinea.textcontent.append("De diﬀerenti¨ele dwarsdoorsnedes zijn vervolgens bepaald voor de verschillende toe-")
    thisalinea.textcontent.append("standen in het energiespectrum en voor verschillende verstrooiingshoeken. Deze data")
    thisalinea.textcontent.append("zijn vervolgens ge¨extrapoleerd naar een verstrooiingshoek van nul graden en een")
    thisalinea.textcontent.append("impulsoverdracht van nul met behulp van een theoretisch model. Dit theoretische")
    thisalinea.textcontent.append("model is berekend met een zogenaamde double-folding berekening [11, 35] en met de")
    thisalinea.textcontent.append("Distorted-Wave Born Approximation (DWBA) methode [5]. De ∆L = 0 component")
    thisalinea.textcontent.append("in de diﬀerenti¨ele dwarsdoorsnede is bepaald door middel van de Multipole Decompo-")
    thisalinea.textcontent.append("sition Analysis (MDA) methode, nadat er gecorrigeerd was voor de achtergrond van")
    thisalinea.textcontent.append("de quasi-vrije ladingsuitwisseling [28].")
    thisalinea.textcontent.append("Bij (3He, t) reacties bevat het energiespectrum altijd een enkele scherpe toestand die")
    thisalinea.textcontent.append("de waarschijnlijkheid van de volledige Fermi somregel bevat. Deze toestand heet de")
    thisalinea.textcontent.append("Isobaric Analogue State (IAS). De Fermi somregel is (cid:80) B(F ) = |N − Z| [13], waarbij")
    thisalinea.textcontent.append("de som wordt genomen over alle toestanden in het energiespectrum van de atoomkern.")
    thisalinea.textcontent.append("N en Z zijn het aantal protonen en neutronen in die atoomkern. De IAS is gemakkelijk")
    thisalinea.textcontent.append("te herkennen, omdat de piek in het spectrum bijzonder groot is. Wanneer de ∆L = 0")
    thisalinea.textcontent.append("component van een toestand in het spectrum is bepaald, weten we dus onmiddellijk")
    thisalinea.textcontent.append("of deze component een Fermi toestand is of een Gamow-Teller toestand.")
    thisalinea.textcontent.append("Met onze energieresolutie konden alleen de toestanden in de laagste regio (de eerste")
    thisalinea.textcontent.append("paar MeV) van het energiespectrum duidelijk van elkaar worden onderscheiden. Voor")
    thisalinea.textcontent.append("de rest van het spectrum is daarom niet een MDA per toestand uitgevoerd, maar per")
    thisalinea.textcontent.append("bin van 200 keV. De op deze manier verkregen spectra van B(GT )-waarden staan in")
    thisalinea.textcontent.append("de ﬁguren 9.1a en 9.1b. Het resultaat van een Quasi-particle Random Phase Approx-")
    thisalinea.textcontent.append("imation (QRPA) berekening volgens de procedures van Ref. [102] is ter vergelijking")
    thisalinea.textcontent.append("aan deze ﬁguren toegevoegd. Het resultaat van deze QRPA berekening is verkregen")
    thisalinea.textcontent.append("via Ref. [104] en is genormeerd op (0.75)2 maal de uitkomst van de Ikeda somregel. De")
    thisalinea.textcontent.append("Ikeda somregel stelt dat (cid:80)(B(GT+) − (cid:80) B(GT−) = 3|N − Z|, waar (cid:80)(B(GT+) de")
    thisalinea.textcontent.append("som van alle B(GT ) waarden aanduidt voor neutron-proton transities en (cid:80)(B(GT−)")
    thisalinea.textcontent.append("de som van alle B(GT ) waarden aanduidt voor proton-neutron transities (kleiner dan")
    thisalinea.textcontent.append("5% van het totaal voor ons experiment). De normering op (0.75)2 · 3|N − Z| is in")
    thisalinea.textcontent.append("overeenstemming met Ref. [92].")
    thisalinea.textcontent.append("Uit Figuren 9.1a en 9.1b kan worden afgelezen dat onze meetresultaten redelijk over-")
    thisalinea.textcontent.append("eenkomen met de QRPA berekening rond het gebied van de IAS en tot aan een")
    thisalinea.textcontent.append("excitatie energie van 22 MeV (het resultaat van de QRPA berekening ging niet verder")
    thisalinea.textcontent.append("dan deze energie). Echter, in het gebied rond 3 MeV − 5 MeV voorspelt de QRPA")
    thisalinea.textcontent.append("berekening een grote piek. Deze piek wordt niet teruggevonden in de meetresultaten.")
    thisalinea.textcontent.append("Dit is een bekende tekortkoming in het QRPA model van Ref. [102] en mogelijkheden")
    thisalinea.textcontent.append("om het model te verﬁjnen worden op dit moment onderzocht [104]. De integraal")
    thisalinea.textcontent.append("van het gemeten spectrum in Figuur 9.1a is 38 ± 7% van de Ikeda somregel. Voor")
    thisalinea.textcontent.append("het spectrum in Figuur 9.1b is dit 48 ± 6%. Deze resultaten komen overeen met het")
    thisalinea.textcontent.append("Figuur 9.1: Verkregen spectrum van B(GT )-waardes vergeleken met een QRPA")
    thisalinea.textcontent.append("berekening volgens Ref. [104].")
    thisalinea.textcontent.append("bekende phenomeen van quenching van de Ikeda somregel [92, 94]. Als de quasi-vrije")
    thisalinea.textcontent.append("achtergrond wordt verwijderd in overeenstemming met Ref. [28], dan komen onze")
    thisalinea.textcontent.append("meetresultaten ook overeen met de resultaten van dit artikel, hoewel onze resultaten")
    thisalinea.textcontent.append("kleinere fouten bevatten. Echter, de integraal van 38 ± 7% (116Sn → 116Sb) is wat")
    thisalinea.textcontent.append("aan de lage kant. Het verschil met Figuur 9.1b komt mogelijk door een verschil in de")
    thisalinea.textcontent.append("bijdrage van de quasi-vrije achtergrond. Ons voorstel is om dit verder te bestuderen")
    thisalinea.textcontent.append("door middel van een vervolgexperiment zoals beschreven in Ref. [5].")
    thisalinea.textcontent.append("We concluderen daarom, dat met onze resultaten de experimentele kennis van Gamow-")
    thisalinea.textcontent.append("Teller transities is verbeterd voor de gemeten isotopen. Daarnaast hebben onze meet-")
    thisalinea.textcontent.append("resultaten geholpen bij het verﬁjnen van het QRPA model van Ref. [102], wat ons kan")
    thisalinea.textcontent.append("helpen om Gamow-Teller transities beter te begrijpen.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "3 Controle van de passieve koeling van het X-slit systeem"
    thisalinea.nativeID = 75
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 13
    thisalinea.summary = "Het X-slit systeem (zie Figuur 9.2) is een collimator gemaakt van twee blokken Den- simet. Densimet is en legering van 97% wolfraam, 2% nikkel and 1% ijzer [111]. In totaal bevat de Super-FRS 6 van zulke collimators in de verticale richting en 11 in de horizontale richting. De collimator waar wij in ge¨ınteresseerd zijn, het X-slit sys- teem, is de eerste collimator (een horizontale) waar de bundel doorheen gaat. Het X-slit systeem bevindt zich in de zogenaamde pre-separator van de Super-FRS [30]. In het gebied van de pre-separator wordt het materiaal van de collimators dusdanig geactiveerd door de bundel dat "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("Het X-slit systeem (zie Figuur 9.2) is een collimator gemaakt van twee blokken Den-")
    thisalinea.textcontent.append("simet. Densimet is en legering van 97% wolfraam, 2% nikkel and 1% ijzer [111]. In")
    thisalinea.textcontent.append("totaal bevat de Super-FRS 6 van zulke collimators in de verticale richting en 11 in")
    thisalinea.textcontent.append("de horizontale richting. De collimator waar wij in ge¨ınteresseerd zijn, het X-slit sys-")
    thisalinea.textcontent.append("teem, is de eerste collimator (een horizontale) waar de bundel doorheen gaat. Het")
    thisalinea.textcontent.append("X-slit systeem bevindt zich in de zogenaamde pre-separator van de Super-FRS [30].")
    thisalinea.textcontent.append("In het gebied van de pre-separator wordt het materiaal van de collimators dusdanig")
    thisalinea.textcontent.append("geactiveerd door de bundel dat het zelfs wanneer de bundel uitstaat in dit gebied niet")
    thisalinea.textcontent.append("veilig is voor mensen [111].")
    thisalinea.textcontent.append("Figuur 9.2: Computermodel van het X-")
    thisalinea.textcontent.append("slit systeem [111]; ﬁguur gebruikt met")
    thisalinea.textcontent.append("permissie.")
    thisalinea.textcontent.append("Figuur 9.3: Siemens NX simula-")
    thisalinea.textcontent.append("tieresultaat [111]; ﬁguur gebruikt")
    thisalinea.textcontent.append("met permissie.")
    thisalinea.textcontent.append("Ons probleem is dat de ionen die door de collimator worden opgevangen het X-slit")
    thisalinea.textcontent.append("systeem mogelijk zo erg verhitten, dat de motoren en elektronica van het X-slit sys-")
    thisalinea.textcontent.append("teem beschadigd kan raken. Aangezien mensen geen reparaties kunnen uitvoeren aan")
    thisalinea.textcontent.append("het X-slit system in de pre-separator, moet zulke schade worden voorkomen. Een")
    thisalinea.textcontent.append("actief koelsysteem is echter geen ideale oplossing, omdat zo’n systeem relatief makke-")
    thisalinea.textcontent.append("lijk storingen geeft die ook niet door mensen kunnen worden gerepareerd. In plaats")
    thisalinea.textcontent.append("daarvan worden de Densimet blokken van het X-slit systeem uitgerust met ribben")
    thisalinea.textcontent.append("van roestvrij staal, zodat de infrarood emissie toeneemt [111]. De eﬀecten van deze")
    thisalinea.textcontent.append("passieve koelmethode zijn onderzocht met simulaties. Deze simulaties werden uit-")
    thisalinea.textcontent.append("gevoerd met het computerprogramma Siemens NX 9.0 [113]. Voor deze simulaties is")
    thisalinea.textcontent.append("uitgegaan van de meest energierijke bundel die kan voorkomen in de pre-separator:")
    thisalinea.textcontent.append("een 238U90+-bundel met een energie per deeltje van 1.3 GeV/u en een totaal vermogen")
    thisalinea.textcontent.append("van 500 W [111]. Het resultaat van deze simulaties wordt getoond in Figuur 9.3.")
    thisalinea.textcontent.append("Het belangrijkste punt in onze simulaties is de temperatuur van de bovenplaat van")
    thisalinea.textcontent.append("de vacu¨umkamer (bruin in Figuur 9.2 en blauw in Figuur 9.3). De motoren en de")
    thisalinea.textcontent.append("elektronica die niet beschadigd mogen raken zijn gemonteerd op deze plaat, aan de")
    thisalinea.textcontent.append("lucht-zijde. Volgens onze simulaties wordt de temperatuur van de bovenplaat niet")
    thisalinea.textcontent.append("hoger dan 35 ◦C.")
    thisalinea.textcontent.append("Twee vergelijkingen tussen onze simulatie procedure en experimentele data zijn uit-")
    thisalinea.textcontent.append("gevoerd. Voor de eerste vergelijking is een test setup met kleine blokjes Densimet")
    thisalinea.textcontent.append("gebruikt en een 20Ne5+-bundel met een energie per deeltje van 30 MeV/u en een")
    thisalinea.textcontent.append("totaal vermogen van 21.6 W. Deze bundel is geproduceerd met de AGOR [119] ver-")
    thisalinea.textcontent.append("sneller op het KVI-CART in Nederland [111]. Voor de tweede vergelijking is het")
    thisalinea.textcontent.append("X-slit systeem verhit met hitte-elementen [115]. De temperaturen zijn gemeten met")
    thisalinea.textcontent.append("type-K thermocouples. Het verschil tussen experiment en simulatie was bij beide")
    thisalinea.textcontent.append("vergelijkingen minder dan 20 ◦C.")
    thisalinea.textcontent.append("Het is daarom redelijk om aan te nemen dat de temperatuur van de bovenplaat in")
    thisalinea.textcontent.append("werkelijkheid beneden 35 ◦C + 20 ◦C = 55 ◦C zal blijven. Aangezien de maximale")
    thisalinea.textcontent.append("temperatuur die de motoren en de elektronica kunnen verdragen ongeveer 80 ◦C is")
    thisalinea.textcontent.append("[115], kunnen we concluderen dat het X-slit systeem veilig in de pre-separator kan")
    thisalinea.textcontent.append("worden gebruikt.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "4 Het ontwerp van de NeuLAND VETO detector"
    thisalinea.nativeID = 76
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 14
    thisalinea.summary = "NeuLAND bestaat uit 3000 plastic scintillatoren. Elke scintillator is uitgerust met twee photomultipliers aan de uiteinden. De scintillatoren zijn gerangschikt in 60 vlakken van elk 50 parallelle scintillatoren. Deze vlakken hebben afwisselend een horizontale en verticale ori¨entatie. De afmetingen van NeuLAND zijn 2.5 m × 2.5 m × 3 m. Wanneer een neutron NeuLAND binnen vliegt, is er een waarschijnlijkheid dat dit neutron hadronische interacties ondergaat met het scintillatormateriaal en daarbij geladen deeltjes produceert. Deze geladen deeltjes kunnen dan worden gemeten via hun scintillatielicht [126]. Elk neutron zal signalen in (veel) verschillende scintillatoren produceren. Met behulp van een oﬄine analyse "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("NeuLAND bestaat uit 3000 plastic scintillatoren. Elke scintillator is uitgerust met")
    thisalinea.textcontent.append("twee photomultipliers aan de uiteinden. De scintillatoren zijn gerangschikt in 60")
    thisalinea.textcontent.append("vlakken van elk 50 parallelle scintillatoren. Deze vlakken hebben afwisselend een")
    thisalinea.textcontent.append("horizontale en verticale ori¨entatie. De afmetingen van NeuLAND zijn 2.5 m × 2.5 m")
    thisalinea.textcontent.append("× 3 m. Wanneer een neutron NeuLAND binnen vliegt, is er een waarschijnlijkheid dat")
    thisalinea.textcontent.append("dit neutron hadronische interacties ondergaat met het scintillatormateriaal en daarbij")
    thisalinea.textcontent.append("geladen deeltjes produceert. Deze geladen deeltjes kunnen dan worden gemeten via")
    thisalinea.textcontent.append("hun scintillatielicht [126].")
    thisalinea.textcontent.append("Elk neutron zal signalen in (veel) verschillende scintillatoren produceren. Met behulp")
    thisalinea.textcontent.append("van een oﬄine analyse kan het allereerste signaal van de eerste hadronische interactie")
    thisalinea.textcontent.append("worden teruggevonden. Het op deze manier gevonden signaal heet een gereconstrueerd")
    thisalinea.textcontent.append("eerste punt. Met behulp van de gereconstrueerde eerste punten en de tijd en locatie")
    thisalinea.textcontent.append("van de reactie in de trefplaat kunnen de relativistische 4-impuls vectoren van de")
    thisalinea.textcontent.append("neutronen worden berekend.")
    thisalinea.textcontent.append("NeuLAND is onderdeel van de R3B meetopstelling van FAIR. De totale R3B meetop-")
    thisalinea.textcontent.append("stelling bestaat uit veel verschillende detectoren, zodat de 4-impuls vectoren van alle")
    thisalinea.textcontent.append("reactieproducten kunnen worden bepaald [10]. Wanneer de bundel of zijn reactiepro-")
    thisalinea.textcontent.append("ducten deze detectoren raken, kunnen er echter geladen deeltjes worden geproduceerd")
    thisalinea.textcontent.append("die NeuLAND ook binnen kunnen vliegen. Deze geladen deeltjes vormen dan een")
    thisalinea.textcontent.append("mogelijk signiﬁcante achtergrond voor de signalen van de neutronen.")
    thisalinea.textcontent.append("De voorgestelde oplossing om deze achtergrond te onderdrukken is om een dunne")
    thisalinea.textcontent.append("VETO detector (vlak) voor NeuLAND te plaatsen in de R3B meetopstelling. Omdat")
    thisalinea.textcontent.append("deze detector dun is, zal hij alleen geladen deeltjes detecteren. De achtergrond van")
    thisalinea.textcontent.append("geladen deeltjes in NeuLAND kan dan worden verwijderd door de co¨ıncidentiesigna-")
    thisalinea.textcontent.append("len tussen NeuLAND en de VETO te elimineren. In dit proefschrift bestuderen we")
    thisalinea.textcontent.append("het optimale ontwerp en de gevolgen van deze VETO detector.")
    thisalinea.textcontent.append("Ons ontwerp voor de VETO detector is gebaseerd op Monte Carlo simulaties. Deze si-")
    thisalinea.textcontent.append("mulaties zijn uitgevoerd met R3BRoot [137]. R3BRoot is een verenigd software pakket")
    thisalinea.textcontent.append("van Geant3 en Geant4 [139], ROOT [87] en analyse software voor elke detector in de")
    thisalinea.textcontent.append("R3B meetopstelling. Voor het ontwerp van de VETO zijn de simulaties uitgevoerd")
    thisalinea.textcontent.append("met Geant3. Dezelfde natuurkundige processen zijn meegenomen in de simulaties als")
    thisalinea.textcontent.append("in Ref. [140]. Voor het bestuderen van de gevolgen van de VETO zijn de simula-")
    thisalinea.textcontent.append("ties uitgevoerd met Geant4, omdat de reacties in de trefplaat niet konden worden")
    thisalinea.textcontent.append("gesimuleerd met Geant3. De lijst van natuurkundige processen in deze simulaties is")
    thisalinea.textcontent.append("geveriﬁeerd met behulp van de data van het S438 experiment uitgevoerd op GSI in")
    thisalinea.textcontent.append("april 2014 [147].")
    thisalinea.textcontent.append("Met onze simulaties is het optimale ontwerp van de VETO vastgesteld. Dit optimale")
    thisalinea.textcontent.append("ontwerp bestaat uit een enkele muur van 16 niet-overlappende scintillatoren met een")
    thisalinea.textcontent.append("totale oppervlakte van 2.5 m × 2.5 m. De optimale dikte van de scintillatoren is")
    thisalinea.textcontent.append("1.1 cm en de optimale afstand tussen de VETO en NeuLAND is 30 cm. De tijdsre-")
    thisalinea.textcontent.append("solutie van de VETO moet onder σ = 300 ps liggen en de energie depositie drempel")
    thisalinea.textcontent.append("van de scintillatoren moet tussen de 160 keV en 1 MeV liggen [135, 144].")
    thisalinea.textcontent.append("De optimale methode voor het elimineren van de achtergrond is het berekenen van")
    thisalinea.textcontent.append("rechte lijnen tussen de gereconstrueerde eerste punten en de reactie in de trefplaat.")
    thisalinea.textcontent.append("Voor elk signaal in de VETO kan dan het gereconstrueerde punt worden ge¨elimineerd")
    thisalinea.textcontent.append("wiens lijn het dichtste (in zowel afstand als tijd) bij het VETO signaal in de buurt")
    thisalinea.textcontent.append("komt. Het gereconstrueerde punt moet echter alleen worden ge¨elimineerd als zijn")
    thisalinea.textcontent.append("tijdsco¨ordinaat later is dan die van het VETO signaal. Met deze methode kunnen")
    thisalinea.textcontent.append("signalen van protonen en neutronen in NeuLAND van elkaar worden onderscheiden")
    thisalinea.textcontent.append("[135, 144].")
    thisalinea.textcontent.append("De Geant4 simulaties onthulden echter een achtergrond van neutronsignalen bovenop")
    thisalinea.textcontent.append("de verwachtte achtergrond van signalen van geladen deeltjes. De achtergrond van")
    thisalinea.textcontent.append("neutronsignalen was zelfs 1.5 keer groter dan de achtergrond van signalen van geladen")
    thisalinea.textcontent.append("deeltjes. Aangezien de VETO ontworpen is om neutronen ongehinderd door te laten,")
    thisalinea.textcontent.append("is er dus een andere extra methode nodig om de achtergrond van neutronsignalen")
    thisalinea.textcontent.append("te verwijderen. Volgens Ref. [135] is het een mogelijk oplossing om alle data buiten")
    thisalinea.textcontent.append("een bepaald tijdsinterval te elimineren. Hiermee werden slechts 4% van de neutron-")
    thisalinea.textcontent.append("en afkomstig van de trefplaat ge¨elimineerd, terwijl de achtergrond van signalen van")
    thisalinea.textcontent.append("geladen deeltjes gereduceerd werd met een factor 5.7 en de achtergrond van neutron-")
    thisalinea.textcontent.append("signalen gereduceerd werd met een factor 3.7.")
    thisalinea.textcontent.append("Met het gebruik van dit tijdsinterval was het netto eﬀect van de VETO detector")
    thisalinea.textcontent.append("een kleine afname in het aantal gedetecteerde neutronen. Omdat er in het grootste")
    thisalinea.textcontent.append("gedeelte van de R3B meetopstelling een vacu¨um heerst, is de achtergrond van geladen")
    thisalinea.textcontent.append("deeltjes sowieso klein. Daar komt dan vervolgens nog de reductie door het tijdsinterval")
    thisalinea.textcontent.append("bij, terwijl er wel een kans is van ongeveer 1% dat een neutron van de trefplaat per")
    thisalinea.textcontent.append("ongeluk wordt gedetecteerd door de VETO en daardoor wordt ge¨elimineerd. Hier-")
    thisalinea.textcontent.append("door is de winst van het elimineren van de achtergrond van signalen van geladen")
    thisalinea.textcontent.append("deeltjes kleiner dan het verlies van 1% van de neutronen van de trefplaat. Wanneer")
    thisalinea.textcontent.append("er geen vacu¨um heerst in the R3B meetopstelling, levert het gebruik van de VETO")
    thisalinea.textcontent.append("echter wel een signiﬁcante verbetering op in de anders zeer slechte signaal-achtergrond")
    thisalinea.textcontent.append("verhouding [135, 144].")
    thisalinea.textcontent.append("We concluderen dus dat het gebruik van een tijdsinterval een zeer eﬀectieve manier is")
    thisalinea.textcontent.append("om de achtergrond in NeuLAND te reduceren. We concluderen ook dat het gebruik")
    thisalinea.textcontent.append("van een VETO detector niet erg zinvol is om de achtergrond van signalen van geladen")
    thisalinea.textcontent.append("deeltjes in NeuLAND te reduceren. Wanneer er echter geen vacu¨um heerst in de R3B")
    thisalinea.textcontent.append("meetopstelling, is een VETO detector wel noodzakelijk ter verbetering van de anders")
    thisalinea.textcontent.append("zeer slechte signaal-achtergrond verhouding.")
    alineas.append(thisalinea)

    thisalinea = textalinea()
    thisalinea.textlevel = 1
    thisalinea.texttitle = "Acknowledgements"
    thisalinea.nativeID = 77
    thisalinea.parentID = 0
    thisalinea.alineatype = texttype.HEADLINES
    thisalinea.enumtype = enum_type.UNKNOWN
    thisalinea.horizontal_ordering = 15
    thisalinea.summary = "I would like to thank prof. dr. N. Kalantar-Nayestanaki for supervising this PhD thesis. I learned a lot from you on many diﬀerent physics topics and on how the funding of science works. Thank you for all of your time and for sharing your expertise! I also would like to thank prof. dr. M. N. Harakeh for all the time he has invested in guiding me though the data analysis of the Gamow-Teller states and for sharing his experience with me about optical potentials. The contribution of dr. C. E. Rigollet to this thesis should not be overlooked. For 4 "
    thisalinea.sum_CanbeEmpty = False
    thisalinea.textcontent.clear()
    thisalinea.textcontent.append("I would like to thank prof. dr. N. Kalantar-Nayestanaki for supervising this PhD")
    thisalinea.textcontent.append("thesis. I learned a lot from you on many diﬀerent physics topics and on how the")
    thisalinea.textcontent.append("funding of science works. Thank you for all of your time and for sharing your expertise!")
    thisalinea.textcontent.append("I also would like to thank prof. dr. M. N. Harakeh for all the time he has invested in")
    thisalinea.textcontent.append("guiding me though the data analysis of the Gamow-Teller states and for sharing his")
    thisalinea.textcontent.append("experience with me about optical potentials.")
    thisalinea.textcontent.append("The contribution of dr. C. E. Rigollet to this thesis should not be overlooked. For")
    thisalinea.textcontent.append("4 years, she has done the ﬁrst round of corrections to all of my writings. Since my")
    thisalinea.textcontent.append("manuscripts usually tend to be on the long side, I owe her my thanks for all the time")
    thisalinea.textcontent.append("she has invested in teaching me how to write proper scientiﬁc documents.")
    thisalinea.textcontent.append("I also would like to express my gratitude to the members of my reading committee,")
    thisalinea.textcontent.append("prof. dr. O. Scholten, prof. dr. R. G. T. Zegers and prof. dr. A. Tamii, for carefully")
    thisalinea.textcontent.append("reading my thesis and providing adequate feedback.")
    thisalinea.textcontent.append("I also really appreciated the teachings of prof. dr. R. G. T. Zegers about how to use")
    thisalinea.textcontent.append("the FOLD-program. Thanks to your help, I have been able to calculate the theoretical")
    thisalinea.textcontent.append("models for the diﬀerential cross sections of the Gamow-Teller states investigated in")
    thisalinea.textcontent.append("this thesis!")
    thisalinea.textcontent.append("I also would like express my gratitude to the people from the NeuLAND working")
    thisalinea.textcontent.append("group and, especially, dr. K. Boretzky, dr. I. Gasparic, dr. D. Kresan and dr. J.")
    thisalinea.textcontent.append("Mayer, for all of their help in teaching me the operating principles of the NeuLAND")
    thisalinea.textcontent.append("detector and the use of the associated simulation software.")
    thisalinea.textcontent.append("The people of the KVI-CART technical design group and, especially, O. J. Kuiken, H.")
    thisalinea.textcontent.append("Moeini, M. F. Lindemulder, H. A. J. Smit and H. J. Timersma also made important")
    thisalinea.textcontent.append("contributions to this thesis. The design and thermal simulations of the X-slit system")
    thisalinea.textcontent.append("were a proud result of this group. I have very much enjoyed working with you!")
    thisalinea.textcontent.append("Dr. M. A. Najaﬁ, dr. J. Gellanki and B. Malheiros deserve a special mention here")
    thisalinea.textcontent.append("for providing key simulation results regarding the X-slit system. I owe my thanks to")
    thisalinea.textcontent.append("dr. M. A. Najaﬁ for providing the simulation results of Figure 6.11 and to dr. J.")
    thisalinea.textcontent.append("Gellanki for providing the simulation results of Figure 6.6. The results of Section 6.7")
    thisalinea.textcontent.append("were provided by B. Malheiros.")
    thisalinea.textcontent.append("Prof. dr. G. Col`o and dr. Y. Niu deserve a special mention as well, since they provided")
    thisalinea.textcontent.append("the theoretical calculations (the QRPA+QPVC results) to compare my measurements")
    thisalinea.textcontent.append("with in Figure 5.13 of Section 5.5. Without your contribution, I would not have been")
    thisalinea.textcontent.append("able to compare my measurements to a theoretical model, so thank you for your")
    thisalinea.textcontent.append("eﬀorts!")
    thisalinea.textcontent.append("I would like to thank prof. H. Ejiri and prof. H. Akimune for the opportunity to join")
    thisalinea.textcontent.append("the E452 experiment at RCNP. The data on Gamow-Teller states in this thesis comes")
    thisalinea.textcontent.append("from this experiment. I also would like to thank the people from the RCNP group")
    thisalinea.textcontent.append("and associated groups for teaching me the operating principles of the equipment and")
    thisalinea.textcontent.append("associated software. Especially prof. A. Tamii, dr. M. Holl and dr. G. Guillaume")
    thisalinea.textcontent.append("have spent a lot of time to teach me the details of the analysis software. Thank you")
    thisalinea.textcontent.append("for your eﬀorts!")
    thisalinea.textcontent.append("I would like to thank prof. T. Nakamura for the opportunity to present my work at")
    thisalinea.textcontent.append("the SAMURAI workshop in the summer of 2017. I would also like to thank all the")
    thisalinea.textcontent.append("people from the SAMURAI collaboration for giving me the opportunity to participate")
    thisalinea.textcontent.append("in some of their experiments. I learned a lot from those experiences!")
    thisalinea.textcontent.append("Finally, I would like to thank my wife and family for supporting me through the 4")
    thisalinea.textcontent.append("years of my PhD thesis.")
    alineas.append(thisalinea)

    return alineas
